SystemOrganization addCategory: #'RKA24-System'!

!PTAjax methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:55'!
triggerForms: aCollection
	aCollection do: [ :each | self triggerForm: each ]! !

!WARequestContext methodsFor: '*RKA24-System' stamp: 'sabineknoefel 9/2/2013 17:24'!
ipAddressString
	^ self  request headers  
		at: 'x-forwarded-for'
		ifAbsent: [ self  request remoteAddress ]! !

WAHtmlErrorHandler subclass: #RKAHtmlErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAHtmlErrorHandler class methodsFor: 'api' stamp: 'sabineknoefel 9/3/2013 13:55'!
session: aRKASession stack: aStack exception: anException ip: anIPAdressString view: aString
	"Create an error and return its creationTimestamp.
Send a mail"

	| theStream theStackString theError thePerson thePersonName |
	thePerson := aRKASession currentPerson.
	thePersonName := thePerson isNil
		ifTrue: [ 'unbekannt' ]
		ifFalse: [ thePerson contactDataString ].
	theStream := ReadWriteStream on: ''.
	thisContext stack asStringOn: theStream delimiter: '<br/>'.
	theStackString := theStream contents.
	theError := RKAError new
		ip: anIPAdressString;
		wholeName: thePersonName;
		view: aString;
		stack: theStackString;
		description: anException description;
		receiver: anException receiver printString.
	theError saveError.
	(RKAMailSender new subject: ('Fehler in {1} ({2})' format: {(aString). (theError creationTimestamp)});
		mailHeading: anException description;
		mailText1: thePersonName;
		mailText2: theStackString) sendWalkbackMail.
	^ theError creationTimestamp! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/3/2013 14:06'!
handleDefault: anException
	"write error entry into database and send mail"

	self requestContext
		respond: [ :response | |theCreationTimestamp|
			theCreationTimestamp := self class  
				session: self requestContext session
				stack: thisContext stack
				exception: anException
				ip: self ipAddressString
				view: anException signaler class printString.
			response
				internalError;
				contentType: WAMimeType textHtml;
				nextPutAll:
						(self rendererClass builder
								fullDocument: true;
								rootBlock: [ :root | self updateHtmlRoot: root forException: anException ];
								render: [ :html | self renderContentFor: theCreationTimestamp on: html ]) ]! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/2/2013 17:25'!
ipAddressString
	^ self requestContext ipAddressString! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/3/2013 14:25'!
renderContentFor: aString on: html
	html heading 
		level1; 
		style: 'margin:0;padding:0; font-family:Verdana;font-size:20px;line-height:26px;color:#2c2c2c;'; 
		with: 'Es ist ein Fehler aufgetreten'.
	html paragraph
			style: 'margin:0;padding:0; font-family:Verdana;font-size:20px;line-height:22px;color:#2c2c2c;'; 
			with: ('Fehlercode: ',aString).
	html paragraph
			style: 'margin:0;padding:0; font-family:Verdana;font-size:20px;line-height:28px;color:#2c2c2c;'; 
			with: ('Bitte melden Sie sich neu an').	
	html break.		
	html break.			
 	html html:( '<a href="{1}" style="font-family:Verdana;border:4px solid transparent;border-radius:4px;background-color:#1b8bbf;color:#FFF;text-decoration:none;padding:5px 7px;font-weight:bold;text-shadow:1px 1px 1px #333;font-size:22px;">Login</a>' format: {RKAConfiguration loginUrl }).
 ! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/2/2013 15:11'!
renderContentForException: anException on: html
	html heading level1; with: 'Es ist ein Fehler aufgetreten'.
	html paragraph: anException description.
	html paragraph: 'Bitte melden Sie sie neu an:'.
	html html:( '<a href="{1}" style="font-family:arial;border:4px solid transparent;border-radius:4px;background-color:#1b8bbf;color:#FFF;text-decoration:none;padding:5px 7px;font-weight:bold;text-shadow:1px 1px 1px #333;font-size:12px;">Login</a>' format: {RKAConfiguration loginUrl })! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/2/2013 14:51'!
rendererClass
	^ WAHtmlCanvas! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/2/2013 14:50'!
titleForException: anException
	^ anException description! !

!RKAHtmlErrorHandler methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/2/2013 14:51'!
updateHtmlRoot: anHtmlRoot forException: anException
	anHtmlRoot title: (self titleForException: anException)! !

WATask subclass: #RKATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKATask class methodsFor: 'as yet unclassified' stamp: 'sabine 9/11/2012 08:58'!
canBeRoot
	^ true! !

!RKATask methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/23/2013 14:21'!
go
	| theLoginAnswer |  
"	RKAConfiguration setTimeZone."
	theLoginAnswer := self call: RKALoginView new.
	theLoginAnswer = # maintenance
		ifTrue: [ theLoginAnswer := self call: RKAInfoView new initializeForMaintenance  ].
	theLoginAnswer = #registerPerson
		ifTrue: [ theLoginAnswer := self call: RKARegisterPersonView new ].
	theLoginAnswer = #logoff
		ifTrue: [ theLoginAnswer := self call: RKALoginView new ].
	theLoginAnswer isPerson
		ifTrue: [ self call: RKALayoutView new ].
 
	theLoginAnswer =#failedNoPerson
		ifTrue: [ theLoginAnswer := self call: (RKARegisterPersonView new addValidationError: 'Die angegebene Email Adresse ist nicht bekannt. Bitte neu registrieren.' ) ].
		
	theLoginAnswer =#failedWrongPassword
		ifTrue: [ theLoginAnswer := self call: (RKARegisterPersonView new addValidationError: 'Die angegebene Email Adresse/Passwort Kombination ist falsch. Bitte neu registrieren oder Passwort zusenden lassen.' ) ].
! !

WAFileLibrary subclass: #RKALibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKALibrary class methodsFor: 'uploaded' stamp: 'SabineKnoefel 6/11/2013 19:23'!
sflJpg
	^ #(255 216 255 224 0 16 74 70 73 70 0 1 1 1 0 96 0 96 0 0 255 236 0 17 68 117 99 107 121 0 1 0 4 0 0 0 100 0 0 255 219 0 67 0 2 1 1 2 1 1 2 2 2 2 2 2 2 2 3 5 3 3 3 3 3 6 4 4 3 5 7 6 7 7 7 6 7 7 8 9 11 9 8 8 10 8 7 7 10 13 10 10 11 12 12 12 12 7 9 14 15 13 12 14 11 12 12 12 255 219 0 67 1 2 2 2 3 3 3 6 3 3 6 12 8 7 8 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 255 192 0 17 8 0 95 1 110 3 1 34 0 2 17 1 3 17 1 255 196 0 31 0 0 1 5 1 1 1 1 1 1 0 0 0 0 0 0 0 0 1 2 3 4 5 6 7 8 9 10 11 255 196 0 181 16 0 2 1 3 3 2 4 3 5 5 4 4 0 0 1 125 1 2 3 0 4 17 5 18 33 49 65 6 19 81 97 7 34 113 20 50 129 145 161 8 35 66 177 193 21 82 209 240 36 51 98 114 130 9 10 22 23 24 25 26 37 38 39 40 41 42 52 53 54 55 56 57 58 67 68 69 70 71 72 73 74 83 84 85 86 87 88 89 90 99 100 101 102 103 104 105 106 115 116 117 118 119 120 121 122 131 132 133 134 135 136 137 138 146 147 148 149 150 151 152 153 154 162 163 164 165 166 167 168 169 170 178 179 180 181 182 183 184 185 186 194 195 196 197 198 199 200 201 202 210 211 212 213 214 215 216 217 218 225 226 227 228 229 230 231 232 233 234 241 242 243 244 245 246 247 248 249 250 255 196 0 31 1 0 3 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 1 2 3 4 5 6 7 8 9 10 11 255 196 0 181 17 0 2 1 2 4 4 3 4 7 5 4 4 0 1 2 119 0 1 2 3 17 4 5 33 49 6 18 65 81 7 97 113 19 34 50 129 8 20 66 145 161 177 193 9 35 51 82 240 21 98 114 209 10 22 36 52 225 37 241 23 24 25 26 38 39 40 41 42 53 54 55 56 57 58 67 68 69 70 71 72 73 74 83 84 85 86 87 88 89 90 99 100 101 102 103 104 105 106 115 116 117 118 119 120 121 122 130 131 132 133 134 135 136 137 138 146 147 148 149 150 151 152 153 154 162 163 164 165 166 167 168 169 170 178 179 180 181 182 183 184 185 186 194 195 196 197 198 199 200 201 202 210 211 212 213 214 215 216 217 218 226 227 228 229 230 231 232 233 234 242 243 244 245 246 247 248 249 250 255 218 0 12 3 1 0 2 17 3 17 0 63 0 253 252 174 23 227 255 0 237 59 240 231 246 83 240 108 62 33 248 151 227 143 10 248 15 68 184 184 91 72 111 53 221 78 43 24 167 153 129 34 36 50 48 222 248 12 219 87 39 10 199 160 36 119 85 252 248 255 0 193 241 190 38 188 127 21 126 206 58 47 154 203 167 199 105 175 222 249 64 144 175 43 62 158 155 152 103 7 106 174 7 25 27 223 212 208 7 237 231 193 111 219 143 224 191 237 31 44 113 252 63 248 181 240 223 198 151 18 16 4 26 47 137 44 239 103 82 64 33 90 56 228 46 173 200 224 128 121 233 94 165 95 203 191 192 207 248 52 91 226 103 237 77 251 30 124 56 248 173 240 255 0 226 215 129 166 155 226 7 135 236 245 211 164 107 250 125 214 156 182 30 124 66 67 16 158 31 180 121 155 115 141 198 52 207 160 169 163 255 0 130 94 127 193 87 63 224 159 211 51 120 23 90 248 145 169 104 246 92 42 248 87 199 73 169 88 200 7 76 88 75 48 102 233 198 109 248 28 113 156 80 7 245 5 70 107 249 135 179 255 0 131 142 191 224 162 159 176 189 210 89 252 96 240 89 212 163 181 96 146 143 30 120 2 125 34 71 66 64 24 146 216 90 130 72 32 43 144 192 228 19 187 60 201 226 191 248 59 15 246 212 253 169 245 25 52 159 132 254 3 240 174 135 63 240 47 134 124 45 117 174 234 73 159 95 57 230 140 251 126 228 126 52 1 253 58 87 27 241 115 246 138 248 125 240 3 79 23 126 60 241 215 131 124 19 106 201 230 9 181 253 106 219 77 140 175 76 238 153 212 99 131 207 181 127 52 247 127 5 127 224 175 159 240 80 97 55 246 179 124 118 211 180 251 204 27 152 47 245 72 124 15 104 202 220 252 246 219 237 3 40 235 176 70 113 143 187 145 93 23 194 255 0 248 51 59 246 150 248 165 170 54 169 241 19 226 71 195 127 12 53 227 134 184 115 123 121 173 106 36 247 102 2 36 141 142 58 126 248 231 28 227 173 0 127 66 63 179 199 237 215 240 95 246 182 214 53 29 63 225 143 197 63 1 248 247 80 210 35 19 222 218 232 122 221 189 236 246 209 150 10 36 100 70 44 19 113 3 118 54 228 129 156 215 171 215 242 183 255 0 6 217 120 18 243 246 115 255 0 131 137 23 225 252 58 179 223 71 225 247 241 79 134 174 238 146 47 33 117 40 237 33 184 80 198 60 182 208 210 91 199 38 221 199 4 14 78 51 95 213 37 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 20 81 69 0 21 252 240 255 0 193 241 95 242 85 63 103 111 251 5 107 159 250 58 198 191 161 234 254 120 127 224 248 191 249 42 159 179 183 253 130 181 207 253 29 99 64 31 175 223 240 69 47 249 68 127 236 229 255 0 100 255 0 73 255 0 210 100 175 168 43 229 255 0 248 34 151 252 162 67 246 113 255 0 178 127 164 255 0 233 50 87 229 183 252 29 69 255 0 5 41 248 221 251 6 127 193 66 190 14 159 133 255 0 17 60 75 225 141 38 31 11 193 173 93 104 214 215 142 186 110 169 60 122 149 199 252 124 192 14 201 85 150 53 70 12 57 81 138 0 253 230 184 183 142 242 222 72 102 141 36 138 69 40 232 235 185 93 79 4 17 220 31 74 173 161 248 119 79 240 190 154 150 122 101 141 158 157 103 31 220 130 214 21 134 52 250 42 128 5 121 175 236 63 251 93 120 103 246 239 253 148 124 17 241 103 194 82 103 70 241 150 156 183 126 73 109 210 88 206 164 199 113 108 231 251 241 76 146 70 221 137 66 71 4 87 97 241 159 226 255 0 135 255 0 103 255 0 132 190 36 241 199 139 53 24 116 159 13 120 79 78 159 84 212 174 229 56 88 32 137 11 185 247 108 12 5 28 177 32 12 146 40 3 166 163 173 127 59 95 240 68 31 248 43 207 199 79 248 40 231 252 23 177 166 214 252 113 226 139 127 134 186 244 90 222 169 23 130 255 0 180 223 251 39 76 180 75 73 22 214 33 14 118 51 70 76 57 96 50 207 185 250 147 95 209 40 160 15 230 7 254 8 145 255 0 43 87 120 171 254 198 175 28 255 0 43 250 254 159 171 249 129 255 0 130 36 127 202 213 222 42 255 0 177 171 199 63 202 254 191 167 227 64 30 125 251 67 254 214 31 12 191 100 159 10 195 173 124 78 241 247 132 252 7 165 221 57 138 218 125 115 83 138 207 237 110 49 148 136 59 6 149 128 32 149 64 72 28 227 21 224 31 240 255 0 143 216 219 254 142 19 225 255 0 254 4 75 255 0 196 87 243 151 251 91 143 137 31 240 93 223 248 47 38 191 224 75 61 126 47 181 107 222 44 212 124 53 225 166 190 145 254 197 161 104 218 121 184 96 86 49 208 45 189 188 147 50 168 6 73 25 207 5 201 175 188 237 255 0 224 198 89 30 8 204 223 181 2 71 41 80 93 83 225 206 229 83 220 2 117 49 145 239 129 244 20 1 250 131 255 0 15 248 253 141 191 232 225 62 31 255 0 224 68 191 252 69 125 117 167 106 16 234 214 16 93 91 200 179 91 220 198 178 197 34 244 116 97 144 71 212 26 252 7 255 0 136 24 241 255 0 55 69 255 0 152 223 255 0 190 149 251 219 225 93 21 124 39 225 45 55 78 105 132 203 166 218 69 108 102 43 176 56 141 2 238 198 78 51 140 227 39 20 1 163 69 115 255 0 240 182 124 43 255 0 67 55 135 255 0 240 99 15 255 0 21 87 52 79 28 104 190 37 186 104 52 221 99 75 212 39 84 243 26 59 107 168 229 117 80 64 220 66 146 113 146 6 125 197 0 106 81 70 107 51 91 241 174 141 225 155 132 135 82 213 180 205 62 89 23 122 165 205 210 68 204 189 50 3 17 199 7 154 0 211 162 176 237 62 39 120 110 254 234 56 45 252 65 161 205 60 206 35 142 56 239 226 102 145 137 192 0 6 201 36 241 129 91 153 160 2 138 200 213 190 32 104 58 5 243 90 223 107 122 69 149 202 0 90 41 239 35 142 69 4 100 101 88 131 200 170 223 240 182 124 43 255 0 67 55 135 255 0 240 99 15 255 0 21 64 29 5 21 79 70 215 236 124 71 103 246 141 62 246 210 250 220 49 67 37 188 203 42 6 29 70 84 145 158 71 30 245 95 91 241 198 139 225 171 181 183 212 181 141 47 79 157 144 72 177 220 221 199 19 178 146 70 64 98 14 50 8 207 177 160 13 74 43 14 211 226 119 134 239 238 163 130 15 16 232 115 79 51 136 227 142 59 248 153 228 98 112 0 1 178 73 60 96 86 225 52 0 81 89 250 239 139 116 175 11 249 95 218 122 150 159 167 121 249 242 254 213 112 144 249 152 198 113 184 140 227 35 56 245 21 159 255 0 11 103 194 191 244 51 120 127 255 0 6 48 255 0 241 84 1 208 87 51 241 103 227 79 131 254 2 120 58 111 17 120 231 197 126 27 240 110 131 110 66 203 169 107 154 148 58 125 164 100 244 6 89 89 87 39 28 12 228 215 73 20 203 113 18 201 27 43 198 224 50 178 156 134 7 161 6 191 147 175 248 45 159 197 79 136 255 0 240 86 223 248 46 206 173 240 119 67 212 26 226 223 68 241 111 252 43 175 9 105 151 23 44 44 52 183 138 85 183 186 184 96 185 219 186 120 229 150 87 10 95 98 42 224 249 106 160 3 250 13 212 63 224 189 95 177 206 153 123 37 188 159 180 55 195 150 146 35 181 140 87 173 50 31 163 162 149 111 168 38 161 255 0 135 252 254 198 223 244 112 159 15 255 0 240 34 95 254 34 191 46 180 207 248 49 158 230 109 62 22 188 253 167 32 183 187 100 6 104 225 248 120 102 141 31 28 133 115 169 41 96 15 66 85 73 244 21 63 252 64 199 143 249 186 47 252 198 255 0 253 244 160 15 222 15 133 223 19 252 63 241 171 225 214 139 226 239 10 234 150 186 231 134 252 69 103 30 161 166 106 22 196 152 111 45 228 80 201 34 18 1 218 65 4 86 245 120 239 236 121 240 143 71 253 136 127 101 143 134 191 8 111 124 97 166 106 215 94 3 240 253 158 134 151 179 132 176 147 81 242 99 17 137 68 6 71 41 188 175 221 222 216 233 147 94 197 64 5 21 75 91 241 38 157 225 155 116 155 82 191 178 211 226 145 182 43 220 206 177 43 55 92 2 196 100 251 84 250 126 163 111 171 89 71 115 107 60 55 86 243 13 209 203 19 135 71 30 160 142 15 225 64 19 81 88 250 167 196 61 3 67 191 146 214 251 92 209 236 238 162 198 248 103 188 142 57 19 32 17 149 36 17 144 65 250 26 138 223 226 135 134 111 46 35 134 31 17 104 82 203 43 4 68 75 248 153 157 143 0 1 187 146 79 106 0 242 171 31 248 41 103 192 125 79 246 157 111 130 246 255 0 19 188 51 47 197 37 188 125 60 248 109 101 127 182 137 210 51 43 71 141 184 220 17 75 117 232 43 220 171 249 154 240 46 169 109 163 127 193 231 23 151 87 151 16 90 219 69 227 253 68 188 179 72 35 141 7 246 68 227 150 60 14 181 253 34 143 139 62 21 31 243 51 120 127 255 0 6 48 255 0 241 84 1 208 81 84 116 79 19 233 190 38 134 73 52 221 66 199 80 142 35 181 218 218 117 152 33 244 37 73 197 90 187 188 138 194 214 75 137 228 142 24 33 67 36 146 72 193 82 53 3 36 146 120 0 14 114 104 2 74 43 159 255 0 133 179 225 95 250 25 188 63 255 0 131 24 127 248 170 116 63 20 252 49 113 42 199 31 136 244 25 36 114 21 85 117 8 137 98 122 0 55 80 6 245 20 81 64 5 127 60 63 240 124 95 252 149 79 217 219 254 193 90 231 254 142 177 175 232 122 191 158 31 248 62 47 254 74 167 236 237 255 0 96 173 115 255 0 71 88 208 7 235 247 252 17 75 254 81 31 251 57 127 217 63 210 127 244 153 43 241 7 254 15 103 255 0 147 250 248 81 255 0 100 253 127 244 227 121 95 183 223 240 69 47 249 68 127 236 229 255 0 100 255 0 73 255 0 210 100 175 200 111 248 61 187 246 103 241 2 252 72 248 59 241 138 20 19 248 86 93 50 111 7 92 178 161 205 149 226 75 45 220 91 207 76 75 28 147 109 3 167 217 159 61 69 0 120 119 252 27 49 255 0 5 219 240 143 252 19 90 15 28 124 55 248 203 170 234 118 63 12 245 210 53 205 26 242 222 210 107 230 210 181 33 178 57 98 242 163 86 127 46 120 246 177 96 48 175 110 56 253 225 35 210 191 224 228 111 248 56 131 225 239 237 205 251 50 232 63 8 62 1 235 250 182 165 225 255 0 16 94 253 191 198 87 211 233 147 233 254 108 54 236 143 109 100 171 50 171 50 180 223 189 114 0 0 193 16 201 203 10 252 67 233 71 122 0 253 62 255 0 131 67 255 0 229 50 90 47 253 138 186 199 254 138 74 254 175 186 87 243 11 255 0 6 103 254 205 126 32 248 129 255 0 5 18 241 55 196 187 120 204 62 23 248 123 225 153 237 47 110 25 9 19 93 223 17 28 16 41 233 157 145 207 33 60 224 70 6 62 96 71 244 245 64 31 204 15 252 17 35 254 86 174 241 87 253 141 94 57 254 87 245 253 63 87 243 3 255 0 4 72 255 0 149 171 188 85 255 0 99 87 142 127 149 253 127 79 212 1 252 130 254 205 159 29 45 255 0 224 147 159 240 113 37 215 140 62 37 89 95 89 233 190 1 248 129 175 90 107 33 45 218 73 98 181 188 75 203 79 180 162 3 151 81 21 210 204 187 115 185 112 70 236 128 127 161 139 111 248 57 39 246 35 185 183 142 69 248 245 161 5 145 67 0 250 62 168 140 1 231 149 54 192 131 236 70 69 107 127 193 75 63 224 131 191 179 231 252 21 47 90 143 196 30 61 208 245 93 15 198 208 192 182 171 226 127 13 221 45 150 163 44 74 48 137 48 116 120 103 11 192 6 72 217 149 70 213 101 28 87 197 111 255 0 6 75 252 3 216 118 252 88 248 188 27 28 18 218 113 3 255 0 37 168 3 244 227 246 76 255 0 130 137 124 15 253 186 173 47 36 248 75 241 51 194 190 54 155 78 27 238 237 44 174 118 95 90 161 56 15 37 180 129 102 68 39 128 204 129 73 4 2 112 107 241 39 254 15 7 253 178 190 36 120 191 246 184 248 127 251 52 248 79 84 212 244 255 0 11 106 26 37 166 169 125 167 218 220 253 157 60 65 168 94 93 207 4 49 204 65 27 226 141 98 77 170 228 46 249 92 145 242 171 15 207 255 0 219 143 246 125 241 119 252 27 231 255 0 5 92 182 211 126 31 120 246 239 86 213 188 18 108 117 253 31 88 72 13 148 183 22 243 166 230 182 185 141 89 149 149 135 153 20 138 9 89 16 228 129 184 162 253 129 255 0 7 57 241 255 0 7 11 124 35 255 0 176 87 133 255 0 244 235 115 64 26 250 55 252 25 27 241 122 231 73 182 146 255 0 227 71 195 155 91 231 137 90 226 24 116 251 201 163 137 241 243 42 185 10 88 3 144 24 170 231 174 7 74 249 195 254 10 121 255 0 4 25 248 181 255 0 4 54 248 107 224 191 140 241 124 86 209 181 25 165 241 60 90 53 149 231 135 126 213 167 106 90 85 235 91 207 115 20 177 185 231 27 109 166 5 149 129 7 111 4 49 199 245 173 95 144 63 240 122 183 252 162 203 192 63 246 85 116 239 253 52 107 20 1 115 227 215 252 22 131 199 218 7 252 27 13 225 111 218 26 195 80 183 181 248 175 227 107 8 60 49 14 171 20 104 162 45 72 94 205 99 115 120 177 182 23 205 217 105 115 42 170 169 85 144 130 23 98 145 95 151 31 240 78 159 248 55 63 227 71 252 22 55 224 44 223 29 181 31 138 218 46 151 31 137 53 91 171 120 110 124 68 247 122 166 167 171 52 47 178 91 137 100 201 60 200 29 70 230 44 74 49 32 13 164 250 223 237 45 255 0 42 92 254 207 127 246 80 46 255 0 244 239 226 10 242 255 0 216 143 254 14 101 241 71 252 19 195 254 9 157 225 47 129 223 11 60 3 99 123 227 125 62 227 81 154 231 196 154 220 166 107 75 86 185 188 150 88 214 222 210 60 25 88 36 131 230 145 213 67 140 121 110 57 32 29 23 237 149 255 0 6 147 252 67 253 140 63 102 95 24 124 78 213 62 54 124 48 184 181 240 118 157 46 164 109 110 132 218 97 190 49 169 127 34 41 165 59 60 247 0 136 208 227 123 149 92 140 230 189 123 254 9 31 255 0 5 136 248 197 165 255 0 193 6 191 107 40 230 241 46 165 170 248 171 224 46 159 166 47 133 53 221 70 83 115 119 167 91 234 210 75 106 145 171 185 37 205 179 65 36 145 111 200 93 200 188 162 133 30 79 240 167 254 8 223 251 123 127 193 116 252 125 103 227 175 142 222 34 241 15 132 188 47 114 226 72 245 79 27 171 219 24 34 60 147 167 232 209 132 216 8 57 24 72 34 112 196 135 60 215 234 71 133 127 224 218 175 4 254 205 127 240 75 127 142 255 0 5 62 24 248 155 89 212 60 113 241 155 71 180 143 80 241 6 189 40 88 46 239 44 36 123 139 56 196 49 174 219 120 60 199 117 98 3 184 89 73 44 229 84 80 7 226 255 0 252 18 171 254 13 252 248 153 255 0 5 166 248 55 226 207 139 150 191 20 52 13 13 108 252 79 62 137 119 38 186 151 87 250 134 163 120 182 246 247 83 76 238 58 130 46 163 249 153 139 51 111 206 48 9 250 128 127 193 144 255 0 21 63 232 184 124 63 255 0 193 77 223 248 215 206 191 178 47 197 15 248 40 215 252 17 96 248 155 225 223 130 126 22 124 68 211 116 157 75 81 109 66 243 76 185 240 44 186 222 157 45 222 196 133 174 109 238 35 141 149 183 36 81 169 104 165 40 194 53 234 64 53 234 158 36 255 0 131 154 191 224 160 223 179 149 254 151 173 252 69 240 14 159 165 232 111 114 35 242 124 69 224 11 173 38 215 80 56 36 196 37 38 54 221 140 159 145 178 49 156 17 144 64 62 203 248 195 240 247 226 39 252 27 55 255 0 6 248 248 215 195 186 79 140 116 173 107 226 7 137 188 100 109 116 125 123 77 181 146 56 244 195 127 28 74 242 42 201 147 230 199 13 164 229 88 240 29 144 243 140 31 207 47 248 39 87 252 27 101 241 163 254 10 227 251 60 71 241 219 80 248 157 161 104 118 190 47 212 110 150 206 227 95 55 90 150 165 172 121 18 180 19 92 200 227 39 30 116 114 32 220 197 137 141 137 192 198 126 222 255 0 130 249 254 222 254 30 255 0 130 151 127 193 184 159 15 254 47 120 118 198 109 30 63 16 120 243 79 134 255 0 74 154 95 58 77 38 246 24 111 227 158 220 190 23 122 171 174 85 246 174 228 100 109 170 73 81 241 215 236 139 255 0 7 63 120 163 246 7 255 0 130 93 124 53 248 15 240 151 192 54 55 62 56 240 218 106 105 127 226 93 125 140 246 144 181 214 169 121 117 24 181 180 137 129 145 132 119 9 243 202 225 67 169 30 91 175 36 2 223 237 175 255 0 6 153 124 64 253 136 255 0 101 239 25 124 82 213 190 54 124 51 186 180 240 94 157 46 166 108 230 73 244 249 47 252 165 46 96 130 73 62 86 184 117 86 17 199 213 223 106 142 77 125 121 255 0 6 248 127 193 96 126 33 205 255 0 4 120 253 166 175 188 89 172 92 120 203 94 253 154 116 57 53 127 14 220 106 142 211 220 60 19 89 93 201 107 107 60 132 238 146 52 184 179 112 11 18 202 143 183 59 85 20 124 159 240 151 254 8 177 251 120 255 0 193 114 60 115 97 227 207 142 254 38 215 188 39 225 153 255 0 125 109 170 120 229 157 36 134 25 27 44 44 52 136 246 152 148 140 48 82 150 241 184 193 14 107 244 175 199 223 240 70 127 134 127 240 71 223 248 34 135 237 97 166 248 23 82 241 39 136 53 207 26 248 2 233 252 67 172 106 243 169 107 214 181 181 185 16 172 80 198 170 144 198 166 226 114 0 220 223 62 25 223 104 192 7 227 119 252 19 171 254 9 51 241 211 254 14 24 241 231 196 111 136 218 183 196 235 8 238 116 59 184 98 213 117 223 20 77 113 121 117 127 115 56 146 69 138 24 208 16 177 198 171 202 229 21 3 162 162 145 144 191 84 222 255 0 193 145 63 22 163 178 153 173 190 54 124 58 154 225 81 140 73 46 155 121 26 59 99 128 204 3 21 4 245 33 78 61 15 74 250 23 254 12 134 255 0 147 89 248 225 255 0 99 85 143 254 146 26 253 190 160 15 231 35 254 13 61 253 168 62 40 126 207 255 0 240 82 47 28 126 203 126 38 215 110 245 111 9 90 217 106 208 157 45 175 30 226 207 70 213 116 235 128 175 45 174 238 18 57 0 153 88 40 80 228 198 199 149 231 228 255 0 12 124 108 240 183 236 227 255 0 7 67 120 187 199 62 54 213 225 208 124 39 225 159 142 222 36 188 212 245 9 99 121 18 210 17 169 222 130 197 81 89 143 36 116 4 243 95 68 255 0 193 5 255 0 229 104 207 138 223 246 21 241 183 254 150 75 95 35 124 86 253 149 173 255 0 109 255 0 248 56 139 226 135 194 91 173 106 111 14 219 248 235 227 103 137 180 201 53 40 173 133 203 217 134 213 47 27 120 140 178 134 251 189 11 14 180 1 253 28 127 196 72 95 177 47 253 23 207 15 255 0 224 167 83 255 0 228 106 63 226 36 47 216 151 254 139 223 135 255 0 240 83 169 255 0 242 53 124 1 255 0 16 58 248 87 254 142 39 196 31 248 72 67 255 0 201 116 127 196 14 190 21 255 0 163 137 241 7 254 18 16 255 0 242 93 0 124 185 255 0 7 10 252 90 240 239 199 159 248 46 47 192 79 26 120 71 83 139 90 240 191 138 60 57 225 45 75 75 191 141 29 18 238 222 93 74 225 146 64 174 21 128 42 65 195 0 125 171 250 129 175 229 95 254 11 87 251 57 67 251 32 255 0 193 90 191 102 31 133 182 250 180 186 237 191 128 124 25 224 205 14 61 70 88 5 187 222 172 26 132 232 36 49 134 96 165 177 156 6 56 245 175 234 162 128 63 24 127 224 246 127 249 48 111 132 255 0 246 80 7 254 155 175 43 135 253 164 63 110 79 27 126 194 159 240 105 95 192 61 83 225 238 171 121 225 255 0 18 248 242 45 63 194 17 235 22 114 121 119 122 92 51 37 253 204 210 194 227 148 145 163 180 104 195 175 204 158 105 101 42 192 48 238 63 224 246 143 249 48 95 133 31 246 80 23 255 0 77 215 149 242 255 0 252 21 119 254 85 32 253 143 127 236 107 210 191 244 219 174 208 7 137 255 0 193 61 127 224 214 255 0 139 95 240 82 159 217 95 65 248 212 223 19 188 37 225 171 63 28 75 115 113 103 111 169 67 115 123 125 60 113 220 73 11 77 51 47 1 158 72 220 129 150 59 118 146 65 36 15 168 191 102 175 248 51 107 226 103 192 191 218 51 192 30 54 187 248 205 224 91 235 95 7 120 147 78 215 38 182 135 75 186 89 46 18 218 234 57 153 20 147 128 204 16 128 79 25 53 250 83 255 0 6 222 255 0 202 18 254 1 255 0 216 42 247 255 0 78 119 117 246 253 0 127 33 255 0 240 82 239 217 79 196 223 183 23 252 28 99 241 71 225 63 131 228 211 161 241 23 141 188 117 37 141 164 215 242 152 173 109 241 2 201 36 178 50 171 48 68 141 29 142 213 102 33 112 1 36 3 245 151 252 65 15 241 83 254 139 135 195 255 0 252 20 221 255 0 141 115 255 0 13 63 229 116 107 159 251 40 26 151 254 154 39 175 233 122 128 63 144 175 218 131 246 93 248 229 255 0 6 199 126 222 254 1 214 180 159 28 105 186 150 165 121 100 154 213 149 246 143 36 176 217 235 22 171 49 142 230 194 238 7 25 42 118 225 148 238 82 178 35 43 7 31 39 216 255 0 240 120 175 237 133 227 111 29 124 119 248 55 240 83 68 212 181 29 55 193 250 247 132 109 124 93 117 166 69 114 98 139 85 187 189 188 184 183 133 110 0 32 56 132 90 101 119 112 12 204 122 242 51 255 0 224 247 143 249 58 143 129 255 0 246 42 94 255 0 233 96 175 84 255 0 131 158 63 224 145 63 23 127 106 177 240 127 227 175 194 63 14 235 94 56 184 240 239 130 236 252 51 172 232 218 52 70 125 74 206 56 100 150 234 222 234 8 87 247 147 101 174 165 70 88 195 58 149 140 128 65 98 160 30 79 105 255 0 6 68 252 88 123 88 218 127 141 159 14 227 157 144 25 18 61 50 241 213 91 28 128 196 2 64 61 240 51 232 58 87 81 240 115 254 12 190 248 157 240 203 226 247 133 124 73 113 241 167 192 119 80 120 127 88 180 212 164 134 61 42 237 94 85 134 100 144 168 36 224 18 23 31 141 121 87 132 191 224 184 159 240 84 175 8 120 102 199 74 155 225 223 140 181 105 52 248 86 220 222 106 63 10 46 158 238 227 104 198 233 89 97 80 207 234 118 130 122 156 156 154 246 255 0 248 38 55 252 29 79 241 145 255 0 109 61 15 225 15 237 69 225 77 38 198 215 197 26 172 26 39 219 225 210 37 209 117 79 14 94 92 50 164 38 230 7 109 173 1 103 77 217 84 116 87 47 185 128 216 64 63 160 1 69 20 80 1 95 207 15 252 31 23 255 0 37 83 246 118 255 0 176 86 185 255 0 163 172 107 250 30 175 231 135 254 15 138 255 0 146 169 251 59 127 216 43 92 255 0 209 214 52 1 250 253 255 0 4 82 255 0 148 71 254 206 95 246 79 244 159 253 38 74 220 255 0 130 167 254 195 186 127 252 20 91 246 12 248 137 240 158 237 97 93 67 94 211 140 250 37 204 152 31 98 213 32 34 107 73 119 117 11 231 34 171 227 4 198 242 47 70 53 135 255 0 4 82 255 0 148 72 126 206 95 246 79 244 159 253 38 74 250 128 208 7 240 35 226 127 13 106 30 12 241 46 161 163 234 182 179 88 234 154 77 204 150 119 150 210 141 178 91 205 27 20 116 97 217 149 129 4 122 138 162 43 245 123 254 14 224 255 0 130 123 255 0 195 44 127 193 65 35 248 167 161 233 230 223 193 255 0 27 161 125 78 70 138 61 176 219 107 48 237 91 212 227 161 151 116 87 25 110 89 231 155 28 41 199 140 127 193 183 255 0 240 79 111 248 120 7 252 20 215 194 150 250 181 151 218 188 15 240 227 30 46 241 30 238 35 153 45 221 126 205 108 123 55 155 114 97 12 189 76 75 49 31 118 128 63 162 159 248 55 207 254 9 234 191 240 78 191 248 38 151 131 52 29 74 195 236 126 56 241 146 127 194 85 226 162 232 86 100 187 185 85 49 219 184 60 169 130 220 67 17 94 155 210 70 31 120 215 219 148 10 40 3 249 129 255 0 130 36 127 202 213 222 42 255 0 177 171 199 63 202 254 191 167 234 254 96 127 224 137 31 242 181 119 138 191 236 106 241 207 242 191 175 233 250 128 63 60 188 101 255 0 7 74 126 198 126 2 241 126 171 161 234 127 16 181 232 117 45 22 242 107 27 168 215 194 186 139 170 75 19 148 112 24 67 131 134 82 50 56 53 155 255 0 17 96 126 196 191 244 81 188 65 255 0 132 150 167 255 0 198 107 198 190 36 127 193 153 223 2 190 37 252 67 215 188 73 119 241 75 226 213 189 215 136 53 27 141 74 104 162 109 63 203 141 230 149 164 101 92 219 147 180 22 32 100 147 138 197 255 0 136 38 62 1 255 0 209 88 248 193 255 0 125 233 223 252 141 64 31 144 95 240 88 175 218 235 79 255 0 130 201 127 193 87 102 215 190 19 104 122 212 150 190 42 58 95 133 60 61 109 123 24 75 205 78 85 219 10 57 141 75 121 123 229 115 133 36 144 184 39 4 149 31 80 255 0 193 216 126 56 143 225 151 252 23 47 192 190 36 154 221 238 162 240 247 133 244 13 73 224 70 218 211 44 55 247 114 21 4 240 9 219 140 251 215 236 175 252 19 107 254 13 232 253 157 63 224 152 222 52 79 23 120 75 73 215 60 91 227 168 99 104 237 188 69 226 155 168 239 46 180 224 192 135 251 52 113 199 28 48 150 4 174 240 134 77 164 174 252 51 3 248 217 255 0 7 93 120 38 223 226 95 252 23 75 192 62 27 187 154 107 123 95 16 120 103 195 250 108 210 195 143 50 52 155 80 187 141 153 114 8 220 3 18 50 8 205 0 126 211 120 55 254 14 32 253 140 252 105 225 107 13 90 63 143 30 19 211 210 254 21 155 236 186 138 92 90 221 91 147 213 36 137 227 12 172 14 65 29 56 200 36 96 159 204 31 248 58 231 254 10 227 251 63 254 218 63 177 167 129 126 26 252 40 248 129 97 227 191 17 90 248 218 223 196 151 141 166 65 49 181 178 181 134 194 250 223 231 153 209 84 187 189 218 109 85 44 64 71 45 183 229 221 238 95 241 4 199 192 63 250 42 255 0 24 63 239 189 59 255 0 145 171 208 191 102 207 248 51 227 246 93 248 27 241 34 195 196 158 32 212 190 32 252 76 93 54 101 158 29 35 94 189 181 77 46 102 94 71 157 20 16 35 202 1 0 237 50 108 97 195 43 2 65 0 248 255 0 246 186 253 155 60 73 225 239 248 51 35 224 204 18 88 93 121 158 28 213 109 124 95 122 141 31 205 21 141 254 167 168 73 12 152 207 221 35 82 183 57 244 96 78 57 196 31 240 108 223 237 101 251 7 126 204 159 179 124 58 207 196 235 175 5 248 75 246 130 211 117 59 163 117 173 120 150 198 105 231 107 127 48 53 180 182 83 50 60 80 1 27 4 97 17 73 11 70 197 129 82 172 127 127 254 35 248 107 194 122 215 195 123 255 0 15 120 170 207 65 155 194 122 181 171 105 119 118 26 146 69 246 27 152 29 10 24 25 31 228 42 87 35 111 76 87 229 47 196 159 248 51 147 246 85 248 183 226 41 181 223 6 248 203 226 103 133 116 187 201 93 151 79 210 245 139 77 67 79 183 231 132 133 230 130 73 64 83 144 119 203 33 233 200 199 32 31 95 127 195 254 63 99 95 250 56 79 135 255 0 248 17 47 255 0 17 93 135 128 127 224 175 95 179 71 197 31 135 190 48 241 103 135 254 49 248 63 86 240 239 195 251 123 123 175 17 95 193 52 134 29 38 41 229 242 161 121 73 76 128 242 13 163 25 230 191 60 127 226 9 143 128 127 244 86 62 48 127 223 122 119 255 0 35 87 179 254 207 63 240 107 143 194 31 217 207 246 112 248 213 240 207 75 248 133 241 34 251 73 248 223 167 105 218 110 171 117 116 214 95 104 176 75 43 163 115 27 65 182 0 187 153 142 14 240 195 29 48 121 160 15 119 255 0 135 252 126 198 223 244 112 159 15 255 0 240 34 95 254 34 190 4 255 0 131 149 63 224 176 255 0 179 79 237 59 255 0 4 185 241 23 195 223 135 159 20 180 15 28 120 195 196 90 190 154 246 86 90 84 82 204 97 72 46 163 154 89 100 114 129 99 80 136 84 100 229 139 128 1 27 136 221 63 240 100 199 192 63 250 42 255 0 24 63 239 189 59 255 0 145 170 231 128 255 0 224 205 95 217 119 195 159 18 45 109 245 175 137 127 20 188 69 45 188 66 249 244 39 213 52 251 87 186 132 56 93 207 229 219 137 68 37 178 165 144 169 201 192 96 104 3 243 234 223 225 39 136 175 191 224 207 201 53 104 244 219 169 52 251 127 140 199 94 105 2 49 85 177 9 246 3 48 227 238 139 163 176 145 198 115 206 114 43 232 111 248 54 159 246 186 253 130 127 102 15 217 107 73 214 254 33 93 120 39 193 127 180 54 155 123 123 22 171 173 120 138 218 226 123 169 225 51 179 91 205 103 43 163 197 2 249 15 28 69 97 42 229 161 118 96 119 2 127 116 52 47 217 79 225 207 135 63 102 216 126 15 217 248 63 69 79 134 80 233 7 65 95 14 188 62 109 147 89 21 42 209 50 182 75 238 4 146 204 75 51 18 196 150 36 215 230 87 197 175 248 51 31 246 97 241 207 139 46 53 47 14 248 171 226 199 130 237 110 100 103 58 93 166 165 107 121 105 110 14 48 177 25 237 218 96 163 159 191 35 147 199 35 28 128 125 109 255 0 15 248 253 141 179 255 0 39 9 240 255 0 255 0 2 37 255 0 226 43 206 127 224 160 127 240 80 207 130 159 183 7 252 18 127 246 166 181 248 75 241 27 195 190 59 184 240 239 195 189 70 93 73 52 201 29 141 154 203 111 40 140 190 229 31 120 163 129 254 233 175 153 255 0 226 9 143 128 127 244 86 62 48 127 223 90 119 255 0 35 87 208 63 177 231 252 27 81 240 167 246 51 248 25 241 199 192 122 15 143 62 33 106 154 111 199 127 14 175 134 245 123 139 246 179 243 244 248 84 78 4 144 108 133 87 127 239 219 239 134 28 14 40 3 229 239 248 50 27 254 77 103 227 135 253 141 86 63 250 72 107 246 251 53 242 79 252 18 91 254 9 5 224 159 248 36 31 195 207 23 120 111 193 62 38 241 87 137 173 124 97 168 195 169 92 203 174 24 12 144 60 113 121 97 83 201 141 6 210 57 228 19 154 250 218 128 63 154 31 248 32 191 252 173 25 241 91 254 194 190 54 255 0 210 201 107 199 255 0 102 175 249 91 127 82 255 0 179 128 241 31 254 156 175 171 247 35 246 57 255 0 131 126 190 26 254 197 255 0 240 80 159 17 254 209 154 15 141 60 115 170 248 163 196 151 58 181 204 250 101 251 90 253 130 38 212 37 105 101 11 178 37 147 10 88 133 203 30 58 230 184 207 132 127 240 110 87 193 173 43 254 10 40 223 181 102 133 241 43 198 218 198 189 168 120 211 80 241 178 89 195 113 99 54 144 247 55 55 51 203 36 74 201 22 243 26 188 174 163 231 220 54 224 156 230 128 63 74 104 205 20 80 7 243 43 255 0 7 97 234 146 124 37 255 0 130 225 252 49 241 134 169 101 121 253 141 103 225 157 7 83 89 35 76 253 166 59 109 74 237 165 84 36 128 88 109 198 9 24 202 231 0 131 95 176 122 79 252 28 167 251 18 106 218 101 189 210 252 118 209 237 197 196 107 39 149 62 139 169 199 44 121 25 195 41 182 200 97 220 87 171 255 0 193 71 127 224 148 127 6 127 224 169 254 0 211 116 63 138 218 13 221 197 214 132 210 62 143 173 105 151 63 100 213 52 147 38 223 48 69 46 25 74 190 197 202 72 142 132 170 157 185 0 143 207 125 67 254 12 155 253 158 228 189 145 173 126 41 124 102 134 220 159 145 37 159 77 145 212 122 22 22 138 15 224 162 128 62 95 255 0 131 171 255 0 224 175 95 1 63 111 63 217 207 225 159 129 126 15 248 218 63 28 106 122 95 137 36 215 181 25 237 108 46 173 237 236 33 75 89 96 68 102 158 36 12 238 211 18 2 110 192 140 150 198 229 206 239 252 21 171 225 55 136 44 127 224 210 47 217 81 100 211 110 71 246 14 173 160 107 90 135 200 127 209 45 46 116 253 77 97 149 253 3 53 229 186 243 222 85 21 246 15 236 231 255 0 6 123 126 203 31 4 252 121 167 248 131 196 58 135 196 95 137 77 166 206 39 77 47 94 212 109 163 210 231 43 130 162 88 173 224 141 228 0 140 149 105 54 48 225 148 140 131 250 83 241 55 225 231 129 126 42 120 50 235 225 151 138 244 191 14 107 26 47 137 180 169 161 147 195 119 169 27 71 125 99 17 138 57 118 192 121 49 196 211 64 11 40 196 109 36 92 169 43 64 31 146 191 240 111 135 252 23 63 246 103 248 63 255 0 4 190 248 123 240 219 226 23 196 141 43 192 30 50 240 10 93 216 94 217 107 17 202 137 114 143 121 60 241 77 12 170 133 29 89 37 80 87 33 149 149 129 24 195 55 221 190 13 255 0 130 228 254 201 63 16 188 95 165 104 26 47 199 143 2 234 58 206 185 121 14 159 97 105 12 242 25 46 167 149 196 113 198 191 39 222 102 96 7 185 175 140 254 41 127 193 152 63 179 31 140 188 91 115 168 248 123 197 223 22 188 31 101 117 35 56 210 237 181 43 75 203 91 80 122 36 77 61 187 77 180 115 254 178 73 24 250 211 190 10 127 193 157 63 3 190 7 124 102 240 143 141 180 255 0 137 255 0 21 175 53 15 7 235 86 122 221 180 23 13 167 249 51 75 109 58 76 136 251 109 193 218 89 0 56 32 224 156 17 64 31 12 252 52 255 0 149 209 174 127 236 160 106 95 250 104 158 191 165 236 215 193 58 15 252 27 243 240 215 195 255 0 240 85 73 63 107 56 252 105 227 153 60 103 38 181 62 182 116 118 107 95 236 191 54 91 103 182 100 255 0 85 230 237 10 228 143 159 57 3 156 87 221 90 199 136 116 255 0 15 27 95 183 223 89 216 253 186 225 45 45 190 209 50 197 246 137 159 59 98 77 196 110 118 193 194 140 147 138 0 254 115 127 224 247 143 249 58 127 129 255 0 246 42 94 255 0 233 88 175 218 111 136 255 0 240 83 191 128 63 177 102 149 224 239 11 124 84 248 165 225 127 3 248 134 255 0 195 86 90 173 189 142 165 43 172 178 218 184 104 150 81 181 79 202 94 25 87 175 84 53 229 191 240 86 159 248 32 175 195 159 248 43 231 196 79 8 248 147 198 222 49 241 183 134 110 188 31 167 75 166 219 69 161 181 168 142 100 146 95 48 179 249 209 57 220 15 28 16 49 92 207 252 20 223 254 13 195 248 91 255 0 5 71 248 203 225 127 26 248 191 199 94 63 240 253 255 0 133 124 41 105 225 43 120 52 118 180 16 205 111 111 61 204 203 35 249 176 185 243 11 92 184 56 32 97 87 142 185 0 245 15 248 127 191 236 108 127 230 225 62 31 255 0 224 68 191 252 69 126 8 255 0 193 102 255 0 106 255 0 135 223 240 80 31 248 47 183 195 93 115 224 222 169 31 140 52 149 188 240 207 135 214 254 202 217 209 53 75 228 191 201 242 183 42 180 152 243 99 140 54 48 197 48 164 168 4 254 136 127 196 19 31 0 191 232 171 252 96 255 0 190 244 239 254 70 175 164 191 224 156 31 240 109 15 236 239 255 0 4 224 248 189 105 241 11 74 62 42 241 247 141 180 178 205 165 234 30 39 185 130 88 180 119 32 169 146 222 8 98 141 4 155 78 3 201 189 148 242 165 77 0 126 134 81 69 20 0 117 175 201 63 248 58 159 254 9 13 241 55 254 10 49 240 203 225 239 141 190 18 216 199 226 47 17 124 49 77 66 27 239 15 9 86 59 173 78 210 231 236 237 230 91 22 33 90 72 218 3 152 201 12 226 79 151 44 161 91 245 178 138 0 254 90 255 0 224 148 223 240 115 15 197 207 248 37 209 177 248 59 241 159 194 186 159 140 62 29 248 76 141 41 116 219 139 111 236 255 0 18 248 77 35 56 242 99 243 2 137 21 57 30 68 225 88 97 64 150 53 27 79 244 83 251 17 127 193 67 126 15 255 0 193 68 190 25 175 138 62 19 120 211 77 241 45 172 106 191 109 177 13 228 234 90 83 159 224 185 182 108 73 17 200 32 18 54 182 9 86 97 205 121 215 252 20 171 254 8 187 240 39 254 10 147 225 153 87 226 7 134 83 79 241 132 112 136 172 60 95 163 4 181 214 172 246 253 197 105 54 145 60 67 36 121 83 43 168 4 149 218 216 97 252 245 126 219 63 240 68 127 218 187 254 8 97 241 73 190 42 252 52 215 53 237 115 194 122 11 52 214 222 58 240 127 153 111 113 167 67 187 149 212 45 84 179 195 25 0 111 221 230 91 176 33 89 206 118 208 7 244 245 251 80 126 199 95 11 255 0 109 79 5 88 248 119 226 175 130 116 63 28 104 186 109 232 212 109 109 117 56 75 173 189 192 71 140 72 164 16 65 218 238 56 60 131 89 191 178 175 236 21 240 119 246 30 183 214 163 248 75 240 243 195 190 3 95 17 180 45 169 157 50 2 141 122 98 223 229 111 98 73 33 124 199 192 206 6 246 245 175 199 175 248 37 159 252 30 49 163 248 130 219 79 240 135 237 77 165 255 0 99 234 10 162 36 241 222 135 102 210 89 206 120 193 188 178 140 23 137 186 230 75 112 234 73 31 186 140 2 107 220 63 224 163 63 240 119 103 192 207 217 219 193 127 97 248 26 203 241 159 198 215 177 230 41 124 155 139 29 15 75 255 0 106 121 36 68 146 102 232 68 112 174 8 200 105 35 56 4 3 245 15 227 167 199 223 4 254 204 159 12 245 15 25 124 66 241 70 137 224 255 0 11 233 107 186 231 82 213 110 150 222 20 39 238 160 44 126 103 110 138 139 150 99 192 4 241 95 130 159 240 85 207 248 60 51 84 241 64 212 188 23 251 44 88 75 163 233 236 90 9 188 121 172 217 143 182 78 188 130 214 54 146 2 34 7 140 73 112 11 224 159 221 70 192 48 248 171 193 191 9 191 109 79 248 57 127 227 241 214 47 46 117 79 16 232 186 125 201 137 245 109 68 182 157 225 15 10 43 16 76 113 42 169 64 225 74 229 34 89 46 28 109 45 187 239 87 238 175 252 18 163 254 13 167 248 27 255 0 4 223 125 59 197 26 213 186 124 86 248 167 106 86 101 215 245 171 69 251 38 151 40 193 205 141 161 44 145 21 32 17 43 153 37 7 37 93 1 218 0 62 2 255 0 131 92 127 224 144 63 28 180 191 219 26 223 246 164 248 169 166 234 254 21 208 225 178 191 147 79 93 120 48 214 60 83 117 125 28 145 61 195 68 255 0 189 72 177 36 146 25 101 0 200 204 133 67 171 51 15 232 92 81 138 40 0 162 138 40 0 175 205 15 248 41 215 252 27 181 255 0 15 28 255 0 130 133 248 71 227 207 252 46 15 248 67 127 225 21 180 210 237 127 176 255 0 225 20 254 209 251 87 216 174 164 184 221 246 143 182 69 183 127 153 183 30 89 219 140 252 217 197 126 151 209 64 5 20 81 64 31 37 255 0 193 90 53 15 8 233 94 29 248 33 115 227 205 14 79 18 248 70 15 137 214 207 169 233 169 225 203 143 17 53 204 99 71 213 241 254 131 111 12 210 207 134 218 196 44 77 180 46 227 128 164 143 41 253 147 126 54 252 33 248 87 241 27 226 31 199 175 0 248 103 80 248 91 251 51 235 30 22 209 227 75 255 0 248 71 46 52 93 59 198 154 204 183 114 44 23 122 102 146 34 89 228 119 138 104 32 18 165 186 61 211 203 18 168 151 203 4 125 85 251 85 124 46 215 190 36 120 207 224 173 222 139 99 246 203 127 8 252 64 139 91 213 159 206 142 63 178 89 174 149 169 219 153 112 236 11 226 91 136 87 106 110 111 159 56 192 36 124 169 251 79 127 193 60 190 32 125 167 88 240 87 131 124 53 255 0 9 71 194 123 31 21 90 124 87 240 230 148 158 36 254 196 251 22 162 183 46 53 79 15 36 177 200 146 219 197 112 46 100 190 180 150 60 71 13 192 149 36 104 227 242 168 3 232 223 3 255 0 193 65 188 35 241 31 197 90 135 132 30 199 198 63 15 60 111 253 139 115 173 105 122 119 141 124 49 117 166 157 78 218 20 6 73 237 195 109 75 161 17 116 50 195 28 130 84 4 110 84 4 53 101 248 107 254 10 39 225 189 7 194 159 13 244 253 97 60 79 227 175 22 120 159 193 186 79 138 245 89 252 21 224 221 70 246 214 202 210 244 8 227 212 36 183 65 44 214 246 243 76 179 152 227 99 36 161 96 151 32 136 157 171 199 254 13 126 203 16 120 223 227 53 175 136 52 255 0 217 235 226 39 128 237 252 43 161 106 102 203 88 248 131 241 10 125 79 81 77 82 234 209 173 68 22 54 73 169 222 192 99 48 205 58 201 60 204 131 37 68 97 198 93 120 191 140 95 179 87 197 31 14 252 17 248 107 166 248 119 224 239 196 11 63 140 126 23 248 87 163 248 119 195 126 63 240 63 141 44 44 91 73 213 32 182 196 154 126 183 20 215 17 69 62 157 21 192 89 54 249 119 209 186 180 229 21 36 40 28 3 234 255 0 138 95 240 80 223 3 252 52 241 254 189 225 219 125 23 226 47 140 238 252 32 19 254 18 57 252 37 225 43 237 110 215 195 236 232 178 8 167 146 4 96 103 17 58 200 96 139 204 153 81 145 138 0 233 187 200 124 121 251 107 124 51 248 123 251 88 91 252 97 187 241 69 165 215 128 117 31 131 182 247 186 101 245 146 181 196 154 207 218 53 113 246 104 45 97 81 230 77 113 51 50 162 66 170 93 157 130 227 57 199 155 222 126 198 154 183 193 15 136 255 0 18 155 196 31 3 126 41 124 91 190 241 183 136 239 124 83 163 235 126 2 248 137 38 135 97 113 45 225 89 36 180 190 183 151 85 179 22 173 20 197 212 77 28 114 171 192 136 196 249 131 202 47 241 79 252 18 47 196 90 247 196 239 132 126 37 240 174 155 161 124 49 241 79 193 159 4 125 175 194 247 54 247 210 107 154 14 155 226 73 111 165 158 238 206 120 174 91 237 55 86 211 37 197 194 153 202 172 170 37 47 27 163 141 164 3 234 127 136 223 183 215 133 254 24 221 248 103 71 188 240 207 196 93 75 199 30 39 209 151 95 95 7 104 222 30 147 84 214 244 187 35 242 153 175 18 220 188 54 234 178 102 44 188 160 60 129 149 55 149 108 69 169 255 0 193 71 62 25 197 240 159 195 254 42 210 230 241 39 137 31 197 26 212 222 27 211 116 13 43 66 186 151 196 18 234 112 71 52 183 54 82 88 50 44 208 77 4 86 243 188 171 50 167 150 177 146 72 220 187 188 167 194 90 247 198 111 130 31 28 60 65 241 99 86 248 15 226 47 17 71 241 59 67 211 116 239 16 104 94 26 214 244 139 189 95 195 122 150 150 247 81 33 133 174 46 173 226 186 211 110 82 224 73 19 9 18 120 152 185 150 4 243 24 71 195 248 159 246 108 241 150 161 224 191 20 120 219 226 39 192 191 16 120 162 243 226 111 196 95 248 77 36 240 247 130 60 91 111 97 226 143 134 166 29 30 211 74 177 187 180 185 91 139 104 229 188 104 237 25 174 100 183 187 82 62 211 229 175 218 35 86 52 1 234 218 215 252 20 5 239 63 110 175 130 190 20 211 116 127 137 145 248 71 226 23 129 53 189 94 226 210 95 2 223 194 194 243 251 75 64 130 202 123 134 146 220 75 108 182 241 220 223 44 219 138 71 24 185 137 165 31 52 38 183 117 63 248 42 199 194 157 46 107 187 246 143 199 51 120 23 78 191 109 50 243 199 112 248 86 245 252 41 105 58 74 208 200 94 255 0 203 217 228 71 42 148 123 165 6 217 8 59 165 24 98 57 15 217 111 224 39 198 39 248 135 240 87 196 31 20 23 84 184 190 208 126 31 120 243 64 214 53 27 157 78 210 93 75 79 254 209 215 116 25 244 123 107 137 45 200 89 111 6 157 98 235 52 240 43 69 231 91 72 119 252 241 151 249 195 225 191 252 19 211 84 248 71 251 56 233 63 4 238 63 102 223 31 120 195 196 218 62 157 31 134 71 136 223 226 181 221 143 128 117 187 53 95 32 234 23 17 199 170 125 170 21 146 47 158 91 56 236 9 243 29 163 64 99 253 232 0 251 31 226 247 252 20 251 225 175 193 175 137 222 48 240 173 237 135 196 45 98 239 225 221 181 189 255 0 139 47 52 79 8 223 234 90 127 134 237 103 129 110 35 158 226 120 163 41 180 196 197 200 140 187 170 198 236 84 42 147 95 64 104 122 229 159 137 180 91 61 75 78 186 183 190 211 245 8 18 230 214 230 9 4 145 92 68 234 25 29 24 112 202 202 65 4 112 65 175 2 248 77 251 56 234 223 15 252 77 251 67 91 199 162 37 175 135 252 93 53 132 62 25 140 220 199 34 222 91 65 225 219 27 13 184 46 89 66 203 11 199 251 220 19 183 60 169 12 123 111 217 71 225 134 171 224 79 216 183 225 175 130 252 65 20 250 78 185 163 120 39 75 209 53 40 225 157 26 91 43 136 172 98 134 85 89 16 178 22 71 86 1 148 178 146 50 9 20 1 201 120 63 254 10 65 224 63 136 222 58 181 210 252 55 163 252 71 241 14 133 123 172 157 2 31 22 233 222 16 190 184 240 219 222 137 76 44 162 245 99 218 209 9 129 140 220 168 54 225 242 60 222 14 60 195 246 61 253 172 252 41 251 54 126 195 255 0 9 180 221 94 61 127 90 241 39 139 37 213 35 209 124 63 225 253 42 109 87 86 212 196 55 243 180 210 36 17 2 86 24 131 167 153 52 133 34 67 34 6 112 93 65 213 253 139 188 93 241 83 246 107 248 95 240 223 224 110 183 240 39 196 215 82 248 26 202 199 194 237 227 29 35 83 210 19 194 183 90 109 170 173 186 234 67 125 210 222 71 35 67 24 118 181 251 41 113 35 109 12 201 251 234 241 55 255 0 130 126 248 163 192 218 111 194 31 24 120 159 225 167 138 188 120 158 24 240 222 177 225 125 123 195 190 21 241 127 246 62 187 165 253 163 86 251 109 189 229 188 145 94 219 65 117 17 80 203 52 13 112 172 51 11 32 118 70 74 0 250 187 225 23 252 20 111 225 127 198 79 137 58 95 130 236 175 181 237 31 198 186 149 197 213 147 248 127 93 209 46 180 189 66 194 234 222 218 59 167 183 158 57 145 118 59 219 185 154 34 9 89 163 138 103 141 157 98 114 186 95 17 191 111 111 134 191 11 174 188 101 111 169 106 154 140 215 158 8 213 44 52 11 203 93 63 75 184 190 185 189 213 111 96 91 139 125 54 210 40 81 158 234 237 161 120 228 48 196 25 145 36 87 109 171 150 31 46 199 251 6 106 222 37 248 23 241 11 198 222 11 248 79 169 124 44 248 161 99 170 105 94 36 240 28 94 37 241 124 250 246 185 168 220 232 203 52 182 145 234 14 215 119 80 91 199 57 187 191 181 242 161 154 77 176 94 200 88 135 109 137 39 139 255 0 224 155 30 39 143 246 84 248 63 123 170 232 109 241 3 226 7 134 124 101 117 241 27 199 218 70 153 174 203 161 94 120 143 82 213 109 47 98 212 5 141 234 207 8 138 91 119 189 85 128 73 44 113 60 22 162 22 104 195 2 160 31 65 105 95 240 82 159 134 255 0 240 142 120 234 243 196 16 120 203 192 186 135 195 159 13 93 120 199 90 209 188 77 225 219 173 63 82 93 30 217 25 229 190 130 54 82 46 162 93 165 73 129 156 171 225 24 43 48 7 187 253 155 255 0 105 157 23 246 160 240 173 214 181 161 232 158 55 209 236 96 149 4 45 226 63 13 222 104 199 80 134 72 214 72 174 45 197 194 47 153 19 163 2 8 249 148 252 174 168 220 87 196 94 48 253 136 181 15 141 255 0 4 254 60 92 120 71 246 127 241 175 130 53 141 91 225 31 137 60 31 225 41 252 119 227 199 212 245 253 87 80 212 172 222 54 183 134 7 212 174 237 109 45 93 226 129 90 73 165 141 217 194 29 171 26 239 63 164 93 5 0 120 127 197 239 219 251 193 127 9 190 37 234 126 15 135 73 248 129 227 95 16 120 118 8 110 181 251 111 8 120 86 247 92 255 0 132 122 41 148 60 70 233 160 66 171 35 199 243 172 42 90 102 65 184 70 65 4 252 235 227 143 248 41 87 194 127 16 126 215 159 179 191 197 77 15 84 215 60 75 225 127 26 120 19 226 47 135 124 55 30 143 160 94 222 106 58 253 252 26 247 133 225 146 11 123 68 139 206 39 54 55 79 185 149 84 71 11 72 204 168 11 87 161 104 183 31 19 191 98 127 140 255 0 22 35 210 254 14 248 163 226 231 133 254 38 248 149 188 93 163 106 126 23 212 180 168 46 172 174 230 179 181 183 150 199 80 142 254 238 216 170 171 218 238 142 226 51 34 8 153 17 130 180 96 63 139 252 44 248 57 251 68 124 15 241 111 192 207 136 215 191 3 244 173 123 82 240 203 252 84 151 198 126 29 209 53 253 55 237 26 100 122 255 0 138 236 245 11 51 165 201 113 44 81 79 51 193 27 74 60 199 132 24 150 100 145 162 149 210 38 0 250 134 31 248 41 127 194 203 63 133 62 62 241 94 185 117 226 63 9 47 194 216 162 159 197 122 62 185 160 221 89 235 58 52 50 156 67 51 90 20 50 75 12 191 54 201 97 18 70 251 28 43 18 140 6 114 127 193 80 60 11 52 90 93 156 126 19 248 192 254 46 214 188 233 109 60 36 124 9 168 199 174 189 172 94 73 123 215 129 227 85 142 211 247 241 40 158 71 88 204 133 162 4 203 28 145 175 140 252 106 253 159 62 42 254 217 87 159 19 190 33 92 124 57 191 240 43 106 158 19 211 60 27 225 159 12 106 218 149 139 107 58 180 113 234 233 127 115 121 122 96 158 75 88 21 64 11 12 94 115 190 12 229 182 23 9 91 31 182 71 236 133 112 127 109 155 175 139 183 159 14 62 32 124 90 240 223 137 60 35 167 120 98 230 203 193 222 48 151 68 214 60 57 53 141 221 244 233 42 197 246 235 40 238 173 103 23 228 58 249 173 36 79 110 25 81 132 174 84 3 218 163 255 0 130 142 252 40 255 0 133 17 121 241 2 109 99 87 180 211 244 253 101 124 53 115 163 207 161 222 39 136 32 214 88 170 166 148 116 207 43 237 102 241 247 161 88 132 100 186 58 200 185 140 135 175 11 253 180 127 110 63 14 107 254 0 240 30 189 168 120 87 226 151 134 127 225 11 248 167 225 199 189 211 117 143 6 223 195 168 93 137 205 194 193 246 56 82 55 251 99 72 224 160 88 11 176 127 149 130 146 43 39 194 127 177 151 139 188 11 225 175 12 252 86 240 151 193 113 225 255 0 25 120 103 226 35 120 178 95 4 106 126 54 125 99 88 241 6 152 116 123 157 29 77 197 245 212 242 219 69 170 71 13 220 146 198 139 112 109 213 99 88 76 223 49 145 125 91 198 250 231 196 47 218 246 15 2 221 175 193 223 26 124 63 177 240 143 196 29 19 88 101 241 62 161 165 37 237 213 172 66 224 221 76 33 181 187 157 86 56 179 16 0 201 230 72 89 182 199 181 67 48 6 213 239 252 21 51 225 95 134 190 20 252 66 241 103 137 215 198 158 13 143 225 92 118 51 248 159 74 215 60 51 121 107 170 233 208 95 74 97 179 157 109 194 51 79 20 206 178 42 188 38 64 90 41 20 144 200 202 58 15 132 63 183 247 128 254 42 222 235 246 151 214 254 44 248 127 125 225 189 27 254 18 75 203 95 27 232 115 248 126 65 165 12 238 191 83 112 21 90 4 42 68 132 54 98 56 18 4 44 185 241 31 248 40 143 236 121 227 223 142 126 57 248 155 168 248 79 195 113 234 127 240 146 120 55 193 218 61 148 194 242 214 221 238 167 211 252 81 113 168 92 196 124 201 20 129 21 188 190 96 45 133 59 200 82 91 43 90 159 240 80 31 216 115 197 255 0 181 223 199 125 82 223 76 142 214 203 195 94 34 248 23 226 255 0 2 73 171 221 204 173 109 107 170 106 23 250 52 150 145 203 10 184 157 163 100 181 184 102 100 92 5 70 27 149 153 1 0 244 47 1 255 0 193 77 62 29 120 231 196 254 27 178 147 77 248 137 225 189 47 198 215 113 216 248 103 95 241 7 132 47 244 189 31 196 19 203 254 162 40 110 38 140 4 105 135 48 137 132 102 97 143 47 113 32 26 54 159 240 85 159 133 87 126 55 212 52 191 39 199 144 233 26 63 139 38 240 54 161 226 137 124 39 125 31 135 172 53 168 239 90 192 218 75 122 99 242 215 55 33 99 19 115 8 105 16 25 20 156 87 132 252 62 253 148 23 226 79 141 124 21 163 234 31 179 7 196 175 13 92 104 186 205 134 167 226 29 75 198 31 21 174 117 47 13 233 230 210 69 184 73 108 18 29 90 226 75 233 68 209 70 208 137 109 162 85 33 90 95 45 135 150 125 35 86 253 149 188 113 119 255 0 4 230 248 143 224 53 208 21 188 87 226 15 136 62 41 215 108 172 126 217 111 254 145 105 121 227 107 237 82 214 95 51 127 150 187 236 229 138 93 172 193 151 118 214 10 224 168 0 251 11 52 81 69 0 20 81 69 0 20 214 65 34 21 96 25 88 96 131 220 83 168 160 15 203 63 248 42 7 252 26 165 240 63 246 226 212 111 60 85 240 230 72 190 9 248 250 224 180 147 190 149 96 178 104 122 164 135 146 211 89 2 130 55 39 254 90 64 201 212 179 36 134 188 79 246 0 255 0 131 51 188 11 240 127 226 10 120 143 227 215 141 211 226 117 189 139 135 179 240 222 145 107 46 157 167 76 192 130 26 234 98 254 108 171 215 247 105 229 142 6 89 129 43 95 183 20 80 6 63 128 62 30 232 63 10 60 27 167 248 119 194 250 38 147 225 207 15 233 49 8 44 116 221 50 210 59 75 75 56 193 39 100 113 70 2 34 228 147 128 7 90 216 162 138 0 40 162 138 0 40 162 138 0 40 162 138 0 40 162 138 0 40 197 20 80 1 69 20 80 1 69 20 80 1 138 58 81 69 0 20 81 69 0 20 98 138 40 0 197 24 162 138 0 49 70 40 162 128 10 49 69 20 0 98 140 81 69 0 20 81 69 0 24 162 138 40 0 162 138 40 0 197 20 81 64 5 20 81 64 31 255 217) asByteArray! !

!RKALibrary methodsFor: 'add css files' stamp: 'sabineknoefel 8/31/2013 09:05'!
addCssFiles

RKALibrary addAllFilesIn: 'C:\Users\Sabine\Daten\entwicklung\addfiles new'.  


RKALibrary addFileAt: 'C:\Users\Sabine\Daten\entwicklung\Spesenfuchs\Grafiken\Logo\aktuell\anwendung\berichte\sfl.jpg'.  
RKALibrary addFileAt: 'C:\Users\User\Dropbox\entwicklung\images\logo.png'.  

GRPlatform current ensureExistenceOfFolder: self default name.
 
	"RKALibrary default fileSelectors"
	
	
	"in den generierten Files localhost entfernen!!"
	"code ist in RKASystemConfiguration "
	#(#manjquerycssCss #mancssCss  #manuijqgridCss #labelinsideCss #labelinsidefJs #rkaJs  ) do: [ :each | 
		GRPlatform current 
			write: (self default perform: each)
			toFile: (self default asFilename: each)
			inFolder: self default name ]! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 5/16/2013 10:53'!
datePickerCssOLD
	"RKALibrary deployFiles writes the files to disk.
	They have to be copied to servers wwwroot(htdocs)/RKALibrary.
	So, in production, this method is NOT called!!"
	"copy from SUComponentLibrary>>datePickerCss"

	^ '.calendar {font-family:Arial;font-size:10px;width:150px;z-index:999}
	.calendar .day {text-align:center;border:1px solid #ccc}
	.calendar .main {border:1px solid black;background:#fff}
	.calendar .daySelected {background:#e0e0e0;font-weight:bold}
	.calendar a {text-decoration:none;color:black;}
	.calendar .day a {color:#336699;display:block;width:16px}
	.calendar .day a:hover {background:#aaa;color:white}
	.calendar .monthTable {width:100%}
	.calendar .monthRow {background:#e0e0e0}
	.calendar .calendarTitle {background-color:#f0f0f0}
	.calendar .monthCurrent {font-size:12px;font-family:verdana;width:100%}
	.calendar .yearTable {width:100%;border-top:1px solid #ccc}
	.calendar .year {font-size:10px;font-family:verdana;text-align:center}
	.calendar .year a:hover {background:#aaa;color:white}
	.calendar .yearCurrent {background:#e0e0e0;font-weight:bold}
	.calendar .day a.today {text-decoration:underline;font-weight:bold}
	.calendar .weekDay {text-align:center}
	.calendar .time {border:1px solid #ccc}
	.calendar .time input.text {width:18px}
	.calendar .time a.button {border:1px solid #aaa;background:#ccc;padding:2px;-moz-border-radius:5px;border-radius:5px}
	.calendar .time a.button:hover {background:#69c}'! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 1/22/2013 16:28'!
jQueryUiComplexCss
	"copy from http://layout.jquery-dev.net/demos/jquery.layout.js"

	^ '/*
*	STYLES FOR: complex.html
*
*	Created with ThemeRoller...
*	http://ui.jquery.com/themeroller/?bgColorDefault=e0e0e0&bgTextureDefault=02_glass.png&bgImgOpacityDefault=80&borderColorDefault=cccccc&fcDefault=444444&iconColorDefault=888888&bgColorHover=d8d8d8&bgTextureHover=02_glass.png&bgImgOpacityHover=90&borderColorHover=888888&fcHover=111111&iconColorHover=222222&bgColorActive=8ab9ff&bgTextureActive=02_glass.png&bgImgOpacityActive=50&borderColorActive=2694e8&fcActive=000000&iconColorActive=ffffff&bgColorContent=f3f3f3&fcContent=362b36&ffDefault=Lucida%20Grande,%20Lucida%20Sans,%20Arial,%20sans-serif&fwDefault=normal&fsDefault=1.2&fsDefaultUnit=em#bgColorDefault=d6d6d6&bgTextureDefault=02_glass.png&bgImgOpacityDefault=80&borderColorDefault=bbbbbb&fcDefault=000000&iconColorDefault=444444&bgColorHover=eeeeee&bgTextureHover=02_glass.png&bgImgOpacityHover=90&borderColorHover=cccccc&fcHover=000066&iconColorHover=000066&bgColorActive=80ade5&bgTextureActive=04_highlight_hard.png&bgImgOpacityActive=100&borderColorActive=266cc0&fcActive=000000&iconColorActive=ffffff&bgColorContent=D1E6FC&bgTextureContent=10_dots_medium.png&bgImgOpacityContent=90&borderColorContent=bbbbbb&fcContent=000000&iconColorContent=222222&ffDefault=Lucida+Grande%2C+Lucida+Sans%2C+Arial%2C+sans-serif&fwDefault=normal&fsDefault=1&fsDefaultUnit=em
*/

/*
*	GENERAL COSMETICS
*/
body {
	font-family: Lucida Grande, Lucida Sans, Arial, Helvetica, sans-serif;
	font-size: 100%;
	background-color: #EEE;
}
h1 {
	font-size: 2em;
	font-weight: normal;
	margin: 1em 0 0.75em;
	page-break-after: avoid;
}
h2 {
	color: navy;
	font-size: 1.2em;
	font-weight: bold;
	margin: 1.25em 0 0.75em;
	page-break-after: avoid;
}
h3 {
	font-size: 1.2em;
	font-weight: bold;
	margin: 0 0 1ex;
	white-space: nowrap;
	page-break-after: avoid;
}
p {
	margin: 1ex 0;
}

code {
	font-size: 1.1em;
	margin: 0;
	}
	pre {
		margin: 1em 0 1em 1em;
	}

ul {
	padding: 0;
	padding-bottom: 20px; /* give whitespace at bottom for FF */
	margin: 0;
	list-style-type: square;
	}
	li {
		padding: 0;
		margin: 0;
		margin: 0.5ex 0 0.5ex 1.2em;
	}

table {
	border-color: #666;
	}
	th {
		background-color: #EEE;
		padding: 4px 7px 5px;
		border-color: #666;
		text-align: left;
	}
	td {
		padding: 2px 7px 3px;
		border-color: #666 #CCC;
		vertical-align: top;
	}


/*
*	COMMON LAYOUT PANE FORMATTING
*/
.pane ,				/* outer pane class */
.ui-layout-pane {	/* inner pane class */
	background-color: #FFF;
	border: 1px solid #777;
	padding: 0;/* alignment & padding is on the inner-divs */
	overflow: auto; /* will be auto-set to ''hidden'' for any pane with a ''scrolling content div'' */
}


/*
*	OUTER-LAYOUT PANE FORMATTING
*/
.pane-north ,
.pane-south ,
.pane-west ,
.pane-east {
	overflow:		hidden;
}
.pane-north {
	border-bottom:	none;
	}
	.pane-north .content ,
	.pane-south .content {
		text-align: center;
	}
.pane-center {
	/* show off the inner-layout inside the outer-center-pane*/
	background-color: #F6F6F6;
	padding: 15px; /* for outer layout */
}

/* inner divs inside Outer East/West panes */
.header { 
	background: #80ade5 url(../img/80ade5_40x100_textures_04_highlight_hard_100.png) 0 50% repeat-x;
	border-bottom: 1px solid #777;
	font-weight: bold;
	text-align: center;
	padding: 2px 0 4px;
	position: relative;
	overflow: hidden;
}
.subhead ,
.footer {
	background: #d6d6d6 url(../img/d6d6d6_40x100_textures_02_glass_80.png) 0 50% repeat-x;
	padding: 3px 10px;
	font-size: 0.85em;
	position: relative;
	overflow: hidden;
	white-space: nowrap;
}
.subhead { border-bottom: 1px solid #777; }
.footer  { border-top: 1px solid #777; }
#mainContent .footer  { border-top: 1px solid #BBB; }
.content {
	padding:	10px;
	position:	relative;
	overflow:	auto;
}


/*
*	INNER-LAYOUT PANE FORMATTING
*/

#mainContent .ui-layout-pane {
	padding: 10px;
}
#mainContent .ui-layout-north ,
#mainContent .ui-layout-south {
	text-align: center;
}
#mainContent .ui-layout-center {
	padding: 0 !!important; /* inner divs have padding */
}
#mainContent .ui-layout-content {
	padding: 10px;
}
#mainContent .ui-layout-center h3 {
	font-size: 1em;
	padding: 5px;
	margin: 0;
}


/*
*	OUTER LAYOUT RESIZERS & TOGGLERS
*/

/* north-pane is not resizable
.resizer-north-dragging ,
.resizer-north:hover		{ background: url(../img/resizable-n.gif) repeat-x center; }*/
.resizer-south-dragging ,
.resizer-south:hover		{ background: url(../img/resizable-s.gif) repeat-x center; }
	
.resizer-west-dragging ,
.resizer-west-open:hover	{ background: url(../img/resizable-w.gif) repeat-y center; }
.resizer-east-dragging ,
.resizer-east-open:hover	{ background: url(../img/resizable-e.gif) repeat-y center; }

.resizer-west-open ,
.resizer-east-open {
	background-color: #999;
	opacity: 0.1;
	filter: alpha(opacity=10);
}
.resizer-west-open:hover ,
.resizer-east-open:hover {
	opacity: 1;
	filter: alpha(opacity=100);
}
.resizer-dragging {
	/* see draggable.opacity option
	opacity: 0.5;
	filter: alpha(opacity=50);
	*/
}
.resizer-dragging-limit	{ background: #FF3300 !!important; }

/* IE6 * HACK - always show resizer graphics because IE6 cannot understand elem:hover */
/** html .resizer-north		{ background: url(../img/resizable-n.gif) repeat-x center !!important; } */
* html .resizer-south		{ background: url(../img/resizable-s.gif) repeat-x center !!important; }
* html .resizer-west-open	{ background: url(../img/resizable-w.gif) repeat-y center !!important; }
* html .resizer-east-open	{ background: url(../img/resizable-e.gif) repeat-y center !!important; }
/** html .resizer-north , */
* html .resizer-south ,
* html .resizer-west-open ,
* html .resizer-east-open {
	opacity: 0.1 !!important;
	filter: alpha(opacity=10) !!important;
}

/*
*	SIMPLE TOGGLER BUTTONS (used on Outer Layout North/South only)
*/

.toggler-north-open ,
.toggler-south-closed 		{ background: url(../img/toggle-up.gif) no-repeat center bottom; }
.toggler-north-closed ,
.toggler-south-open   		{ background: url(../img/toggle-dn.gif) no-repeat center top; }
/*
.toggler-east-closed ,
.toggler-west-open    { background: url(../img/toggle-lt.gif) no-repeat center right; }
.toggler-west-closed ,
.toggler-east-open    { background: url(../img/toggle-rt.gif) no-repeat center left; }
*/

/*
*	extJS-STYLE RESIZER/SLIDER-BAR (CLOSED)
*/
.resizer-west-closed ,
.resizer-east-closed {
	background: #D1E6FC url(../img/D1E6FC_40x100_textures_10_dots_medium_90.png) 0 0 repeat;
	border-top: 1px solid #777;
	border-bottom: 1px solid #777;
}
.resizer-west-closed:hover ,
.resizer-east-closed:hover {
	background: #D1E6FC;
}

/*
*	NORTH PANE TOOLBAR & BUTTONS
*/

ul.toolbar {
	position:	relative;
	overflow:	hidden; /* required to CONTAINER ''floating li'' in FF */
	height:		auto;
	margin:		0;
	padding:	2px;
	width:		100%;
	list-style:	none;
	text-align: left;
	background: #D6D6D6 url(../img/d6d6d6_40x100_textures_02_glass_80.png) 0 50% repeat-x;
	border-top: 1px solid #BBB;
	}
	ul.toolbar li {
		font-size: 0.9em;
		margin: 0;
		padding: 2px 7px;
		float: left;
		color: #000;
		border: 1px solid transparent;
		border-right-color: #BBB;
		cursor: pointer;
	}
	ul.toolbar li:hover {
		color: #005;
		background: #EEE url(../img/eeeeee_40x100_textures_02_glass_90.png) 0 50% repeat-x;
		border-top-color: #BBB;
		border-bottom-color: #BBB;
	}
	ul.toolbar li.first:hover {
		border-left-color: #BBB;
		}
		ul.toolbar li span {
			/* icons in toolbar */
			width: 			15px;
			height:			15px;
			margin-left:	-3px;
			margin-right:	0.75ex;
			vertical-align:	middle;
			opacity:		0.6;
			filter:			alpha(opacity=60);
			display:		block;
			display:		inline-block;
		}
		ul.toolbar li:hover span {
			opacity: 1;
			filter: alpha(opacity=100);
		}
		li.button-toggle-north span	,
		li.button-open-south span	{ background: url(../img/go-up-on.gif) no-repeat center; }
		li.button-close-south span	{ background: url(../img/go-dn-on.gif) no-repeat center; }
		li.button-pin-up span		{ background: url(../img/pin-up-on.gif) no-repeat center; }
		li.button-pin-down span		{ background: url(../img/pin-dn-on.gif) no-repeat center; }

/*
 *	extJS-STYLE TOGGLE & PIN BUTTONS
 *
 *	these extra buttons are INSIDE the east/west panes
 */

/* CUSTOM pin/close buttons */
span.button-pin ,
span.button-close {
	position:	absolute;
	top:		0;
	width: 		20px;
	height:		20px;
	z-index:	2;
	display:	block;
	cursor: 	pointer;
}
span.button-close-west	{ left:	 0; }
span.button-close-east	{ right: 0; }
span.button-pin-west	{ right: 1px; }
span.button-pin-east	{ left:	 1px; }

/* CUSTOM pin-buttons */
span.button-pin-up 		  		{ background: url(../img/pin-up-off.gif) no-repeat center; }
span.button-pin-up:hover   		{ background: url(../img/pin-up-on.gif)  no-repeat center; }
span.button-pin-down 	  		{ background: url(../img/pin-dn-off.gif) no-repeat center; }
span.button-pin-down:hover 		{ background: url(../img/pin-dn-on.gif)  no-repeat center; }

/* CUSTOM close-buttons */
span.button-close-west			{ background: url(../img/go-lt-off.gif) no-repeat center; }
span.button-close-west:hover	{ background: url(../img/go-lt-on.gif)  no-repeat center; }
span.button-close-east			{ background: url(../img/go-rt-off.gif) no-repeat center; }
span.button-close-east:hover	{ background: url(../img/go-rt-on.gif)  no-repeat center; }

/* STANDARD toggler-buttons - when the east/west panes are closed */
.toggler-west-closed		{ background: url(../img/go-rt-off.gif) no-repeat center; }
.toggler-west-closed:hover	{ background: url(../img/go-rt-on.gif)  no-repeat center; }
.toggler-east-closed		{ background: url(../img/go-lt-off.gif) no-repeat center; }
.toggler-east-closed:hover	{ background: url(../img/go-lt-on.gif)  no-repeat center; }


/*
*	INNER LAYOUT RESIZERS & TOGGLERS
*
*	These styles target children of center pane, so only affect the Inner Layout
*	This layout has applyDefaultCSS=true, so use !!important to override defaults 
*/

#mainContent .ui-layout-resizer-closed:hover	{ background: #FFEDCA !!important; }
#mainContent .ui-layout-resizer-open:hover ,
#mainContent .ui-layout-resizer-dragging		{ background: #C4E1A4 !!important; }
#mainContent .ui-layout-resizer-dragging-limit	{ background: #FF3300 !!important; }

#mainContent .ui-layout-resizer-north ,
#mainContent .ui-layout-resizer-south		{ border-left:  1px solid #BBB !!important;
											  border-right: 1px solid #BBB !!important; }
#mainContent .ui-layout-resizer-north-closed{ border-top:   1px solid #BBB !!important; }
#mainContent .ui-layout-resizer-south-closed{ border-bottom:1px solid #BBB !!important; }
#mainContent .ui-layout-resizer-west-closed	{ border-left:  1px solid #BBB !!important; }
#mainContent .ui-layout-resizer-east-closed	{ border-right: 1px solid #BBB !!important; }

#mainContent .ui-layout-resizer:hover .ui-layout-toggler {
	opacity: 0.4;
	filter: alpha(opacity=40);
}
#mainContent .ui-layout-resizer:hover .ui-layout-toggler:hover {
	opacity: 1;
	filter: alpha(opacity=100);
	background: #FD9 !!important;
	border-color: #CB7 !!important;
}

#mainContent .ui-layout-resizer-sliding {
	opacity: 0.3;
	filter: alpha(opacity=30);
}
#mainContent .ui-layout-resizer-sliding:hover {
	opacity: 1;
	filter: alpha(opacity=100);
}
#mainContent .ui-layout-resizer-sliding .ui-layout-toggler {
	display: none !!important;
}
#mainContent .ui-layout-resizer-sliding:hover .ui-layout-toggler {
	display: block !!important;
}




'! !

!RKALibrary methodsFor: 'css' stamp: 'SabineKnoefel 4/8/2013 13:20'!
jQueryUiCss
	"RKALibrary deployFiles writes the files to disk.
	They have to be copied to servers wwwroot(htdocs)/RKALibrary.
	So, in production, this method is NOT called!!"
	"copy from http://layout.jquery-dev.net/demos/jquery.layout.js"

	^ '/*
 * jquery.layout 1.2.0
 *
 * Copyright (c) 2008 
 *   Fabrizio Balliano (http://www.fabrizioballiano.net)
 *   Kevin Dalman (http://allpro.net)
 *
 * Dual licensed under the GPL (http://www.gnu.org/licenses/gpl.html)
 * and MIT (http://www.opensource.org/licenses/mit-license.php) licenses.
 *
 * $Date: 2008-12-27 02:17:22 +0100 (sab, 27 dic 2008) $
 * $Rev: 203 $
 * 
 * NOTE: For best code readability, view this with a fixed-space font and tabs equal to 4-chars
 */
(function($) {

$.fn.layout = function (opts) {

/*
 * ###########################
 *   WIDGET CONFIG & OPTIONS
 * ###########################
 */

	// DEFAULTS for options
	var 
		prefix = "ui-layout-" // prefix for ALL selectors and classNames
	,	defaults = { //	misc default values
			paneClass:				prefix+"pane"		// ui-layout-pane
		,	resizerClass:			prefix+"resizer"	// ui-layout-resizer
		,	togglerClass:			prefix+"toggler"	// ui-layout-toggler
		,	togglerInnerClass:		prefix+""			// ui-layout-open / ui-layout-closed
		,	buttonClass:			prefix+"button"		// ui-layout-button
		,	contentSelector:		"."+prefix+"content"// ui-layout-content
		,	contentIgnoreSelector:	"."+prefix+"ignore"	// ui-layout-mask 
		}
	;

	// DEFAULT PANEL OPTIONS - CHANGE IF DESIRED
	var options = {
		name:						""			// FUTURE REFERENCE - not used right now
	,	scrollToBookmarkOnLoad:		true		// after creating a layout, scroll to bookmark in URL (.../page.htm#myBookmark)
	,	defaults: { // default options for  all panes - will be overridden by per-pane settings 
			applyDefaultStyles: 	false		// apply basic styles directly to resizers & buttons? If not, then stylesheet must handle it
		,	closable:				true		// pane can open & close
		,	resizable:				true		// when open, pane can be resized 
		,	slidable:				true		// when closed, pane can  slide  open over other panes - closes on mouse-out
		//,	paneSelector:			[ ]			// MUST be pane-specific!!
		,	contentSelector:		defaults.contentSelector	// INNER div/element to auto-size so only it scrolls, not the entire pane!!
		,	contentIgnoreSelector:	defaults.contentIgnoreSelector	// elem(s) to  ignore when measuring content
		,	paneClass:				defaults.paneClass		// border-Pane - default: ui-layout-pane
		,	resizerClass:			defaults.resizerClass	// Resizer Bar		- default: ui-layout-resizer
		,	togglerClass:			defaults.togglerClass	// Toggler Button	- default: ui-layout-toggler
		,	buttonClass:			defaults.buttonClass	// CUSTOM Buttons	- default: ui-layout-button-toggle/-open/-close/-pin
		,	resizerDragOpacity:		1			// option for ui.draggable
		//,	resizerCursor:			""			// MUST be pane-specific - cursor when over resizer-bar
		,	maskIframesOnResize:	true		// true = all iframes OR = iframe-selector(s) - adds masking-div during resizing/dragging
		//,	size:					100			// inital size of pane - defaults are set per pane 
		,	minSize:				0			// when manually resizing a pane
		,	maxSize:				0			// ditto, 0 = no limit
		,	spacing_open:			6			// space between pane and adjacent panes - when pane is  open 
		,	spacing_closed:			6			// ditto - when pane is  closed 
		,	togglerLength_open:		50			// Length = WIDTH of toggler button on north/south edges - HEIGHT on east/west edges
		,	togglerLength_closed: 	50			// 100% OR -1 means full height/width of resizer bar - 0 means hidden
		,	togglerAlign_open:		"center"	// top/left, bottom/right, center, OR...
		,	togglerAlign_closed:	"center"	// 1 => nn = offset from top/left, -1 => -nn == offset from bottom/right
		,	togglerTip_open:		"Close"		// Toggler tool-tip (title)
		,	togglerTip_closed:		"Open"		// ditto
		,	resizerTip:				"Resize"	// Resizer tool-tip (title)
		,	sliderTip:				"Slide Open" // resizer-bar triggers sliding when pane is closed
		,	sliderCursor:			"pointer"	// cursor when resizer-bar will trigger sliding
		,	slideTrigger_open:		"click"		// click, dblclick, mouseover
		,	slideTrigger_close:		"mouseout"	// click, mouseout
		,	hideTogglerOnSlide:		false		// when pane is slid-open, should the toggler show?
		,	togglerContent_open:	""			// text or HTML to put INSIDE the toggler
		,	togglerContent_closed:	""			// ditto
		,	showOverflowOnHover:	false		// will bind allowOverflow() utility to pane.onMouseOver
		,	enableCursorHotkey:		true		// enabled cursor hotkeys
		//,	customHotkey:			""			// MUST be pane-specific - EITHER a charCode OR a character
		,	customHotkeyModifier:	"SHIFT"		// either SHIFT, CTRL or CTRL+SHIFT - NOT ALT
		//	NOTE: fxSss_open & fxSss_close options (eg: fxName_open) are auto-generated if not passed
		,	fxName:					"slide" 	// (none or blank), slide, drop, scale
		,	fxSpeed:				null		// slow, normal, fast, 200, nnn - if passed, will OVERRIDE fxSettings.duration
		,	fxSettings:				{}			// can be passed, eg: { easing: "easeOutBounce", duration: 1500 }
		,	initClosed:				false		// true = init pane as closed
		,	initHidden: 			false 		// true = init pane as hidden - no resizer or spacing
		
		/*	callback options do not have to be set - listed here for reference only
		,	onshow_start:			""			// CALLBACK when pane STARTS to Show	- BEFORE onopen/onhide_start
		,	onshow_end:				""			// CALLBACK when pane ENDS being Shown	- AFTER  onopen/onhide_end
		,	onhide_start:			""			// CALLBACK when pane STARTS to Close	- BEFORE onclose_start
		,	onhide_end:				""			// CALLBACK when pane ENDS being Closed	- AFTER  onclose_end
		,	onopen_start:			""			// CALLBACK when pane STARTS to Open
		,	onopen_end:				""			// CALLBACK when pane ENDS being Opened
		,	onclose_start:			""			// CALLBACK when pane STARTS to Close
		,	onclose_end:			""			// CALLBACK when pane ENDS being Closed
		,	onresize_start:			""			// CALLBACK when pane STARTS to be ***MANUALLY*** Resized
		,	onresize_end:			""			// CALLBACK when pane ENDS being Resized ***FOR ANY REASON***
		*/
		}
	,	north: {
			paneSelector:			"."+prefix+"north" // default = .ui-layout-north
		,	size:					"auto"
		,	resizerCursor:			"n-resize"
		}
	,	south: {
			paneSelector:			"."+prefix+"south" // default = .ui-layout-south
		,	size:					"auto"
		,	resizerCursor:			"s-resize"
		}
	,	east: {
			paneSelector:			"."+prefix+"east" // default = .ui-layout-east
		,	size:					200
		,	resizerCursor:			"e-resize"
		}
	,	west: {
			paneSelector:			"."+prefix+"west" // default = .ui-layout-west
		,	size:					200
		,	resizerCursor:			"w-resize"
		}
	,	center: {
			paneSelector:			"."+prefix+"center" // default = .ui-layout-center
		}

	};


	var effects = { // LIST *PREDEFINED EFFECTS* HERE, even if effect has no settings
		slide:	{
			all:	{ duration:  "fast"	} // eg: duration: 1000, easing: "easeOutBounce"
		,	north:	{ direction: "up"	}
		,	south:	{ direction: "down"	}
		,	east:	{ direction: "right"}
		,	west:	{ direction: "left"	}
		}
	,	drop:	{
			all:	{ duration:  "slow"	} // eg: duration: 1000, easing: "easeOutQuint"
		,	north:	{ direction: "up"	}
		,	south:	{ direction: "down"	}
		,	east:	{ direction: "right"}
		,	west:	{ direction: "left"	}
		}
	,	scale:	{
			all:	{ duration:  "fast"	}
		}
	};


	// STATIC, INTERNAL CONFIG - DO NOT CHANGE THIS!!
	var config = {
		allPanes:		"north,south,east,west,center"
	,	borderPanes:	"north,south,east,west"
	,	zIndex: { // set z-index values here
			resizer_normal:	1		// normal z-index for resizer-bars
		,	pane_normal:	2		// normal z-index for panes
		,	mask:			4		// overlay div used to mask pane(s) during resizing
		,	sliding:		100		// applied to both the pane and its resizer when a pane is slid open
		,	resizing:		10000	// applied to the CLONED resizer-bar when being dragged
		,	animation:		10000	// applied to the pane when being animated - not applied to the resizer
		}
	,	resizers: {
			cssReq: {
				position: 	"absolute"
			,	padding: 	0
			,	margin: 	0
			,	fontSize:	"1px"
			,	textAlign:	"left" // to counter-act "center" alignment!!
			,	overflow: 	"hidden" // keep toggler button from overflowing
			,	zIndex: 	1
			}
		,	cssDef: { // DEFAULT CSS - applied if: options.PANE.applyDefaultStyles=true
				background: "#DDD"
			,	border:		"none"
			}
		}
	,	togglers: {
			cssReq: {
				position: 	"absolute"
			,	display: 	"block"
			,	padding: 	0
			,	margin: 	0
			,	overflow:	"hidden"
			,	textAlign:	"center"
			,	fontSize:	"1px"
			,	cursor: 	"pointer"
			,	zIndex: 	1
			}
		,	cssDef: { // DEFAULT CSS - applied if: options.PANE.applyDefaultStyles=true
				background: "#AAA"
			}
		}
	,	content: {
			cssReq: {
				overflow:	"auto"
			}
		,	cssDef: {}
		}
	,	defaults: { // defaults for ALL panes - overridden by per-pane settings below
			cssReq: {
				position: 	"absolute"
			,	margin:		0
			,	zIndex: 	2
			}
		,	cssDef: {
				padding:	"10px"
			,	background:	"#FFF"
			,	border:		"1px solid #BBB"
			,	overflow:	"auto"
			}
		}
	,	north: {
			edge:			"top"
		,	sizeType:		"height"
		,	dir:			"horz"
		,	cssReq: {
				top: 		0
			,	bottom: 	"auto"
			,	left: 		0
			,	right: 		0
			,	width: 		"auto"
			//	height: 	DYNAMIC
			}
		}
	,	south: {
			edge:			"bottom"
		,	sizeType:		"height"
		,	dir:			"horz"
		,	cssReq: {
				top: 		"auto"
			,	bottom: 	0
			,	left: 		0
			,	right: 		0
			,	width: 		"auto"
			//	height: 	DYNAMIC
			}
		}
	,	east: {
			edge:			"right"
		,	sizeType:		"width"
		,	dir:			"vert"
		,	cssReq: {
				left: 		"auto"
			,	right: 		0
			,	top: 		"auto" // DYNAMIC
			,	bottom: 	"auto" // DYNAMIC
			,	height: 	"auto"
			//	width: 		DYNAMIC
			}
		}
	,	west: {
			edge:			"left"
		,	sizeType:		"width"
		,	dir:			"vert"
		,	cssReq: {
				left: 		0
			,	right: 		"auto"
			,	top: 		"auto" // DYNAMIC
			,	bottom: 	"auto" // DYNAMIC
			,	height: 	"auto"
			//	width: 		DYNAMIC
			}
		}
	,	center: {
			dir:			"center"
		,	cssReq: {
				left: 		"auto" // DYNAMIC
			,	right: 		"auto" // DYNAMIC
			,	top: 		"auto" // DYNAMIC
			,	bottom: 	"auto" // DYNAMIC
			,	height: 	"auto"
			,	width: 		"auto"
			}
		}
	};


	// DYNAMIC DATA
	var state = {
		// generate random ID# to identify layout - used to create global namespace for timers
		id:			Math.floor(Math.random() * 10000)
	,	container:	{}
	,	north:		{}
	,	south:		{}
	,	east:		{}
	,	west:		{}
	,	center:		{}
	};


	var 
		altEdge = {
			top:	"bottom"
		,	bottom: "top"
		,	left:	"right"
		,	right:	"left"
		}
	,	altSide = {
			north:	"south"
		,	south:	"north"
		,	east: 	"west"
		,	west: 	"east"
		}
	;


/*
 * ###########################
 *  INTERNAL HELPER FUNCTIONS
 * ###########################
 */

	/**
	 * isStr
	 *
	 * Returns true if passed param is EITHER a simple string OR a string object - otherwise returns false
	 */
	var isStr = function (o) {
		if (typeof o == "string")
			return true;
		else if (typeof o == "object") {
			try {
				var match = o.constructor.toString().match(/string/i); 
				return (match !!== null);
			} catch (e) {} 
		}
		return false;
	};

	/**
	 * str
	 *
	 * Returns a simple string if the passed param is EITHER a simple string OR a string object,
	 *  else returns the original object
	 */
	var str = function (o) {
		if (typeof o == "string" || isStr(o)) return $.trim(o); // trim converts String object to a simple string
		else return o;
	};

	/**
	 * min / max
	 *
	 * Alias for Math.min/.max to simplify coding
	 */
	var min = function (x,y) { return Math.min(x,y); };
	var max = function (x,y) { return Math.max(x,y); };

	/**
	 * transformData
	 *
	 * Processes the options passed in and transforms them into the format used by layout()
	 * Missing keys are added, and converts the data if passed in flat-format (no sub-keys)
	 * In flat-format, pane-specific-settings are prefixed like: north__optName  (2-underscores)
	 * To update effects, options MUST use nested-keys format, with an effects key
	 *
	 * @callers  initOptions()
	 * @params  JSON  d  Data/options passed by user - may be a single level or nested levels
	 * @returns JSON  Creates a data struture that perfectly matches options, ready to be imported
	 */
	var transformData = function (d) {
		var json = { defaults:{fxSettings:{}}, north:{fxSettings:{}}, south:{fxSettings:{}}, east:{fxSettings:{}}, west:{fxSettings:{}}, center:{fxSettings:{}} };
		d = d || {};
		if (d.effects || d.defaults || d.north || d.south || d.west || d.east || d.center)
			json = $.extend( json, d ); // already in json format - add to base keys
		else
			// convert flat to nest-keys format - also handles empty user-options
			$.each( d, function (key,val) {
				a = key.split("__");
				json[ a[1] ? a[0] : "defaults" ][ a[1] ? a[1] : a[0] ] = val;
			});
		return json;
	};

	/**
	 * setFlowCallback
	 *
	 * Set an INTERNAL callback to avoid simultaneous animation
	 * Runs only if needed and only if all callbacks are not already set!!
	 *
	 * @param String   action  Either open or close
	 * @pane  String   pane    A valid border-pane name, eg west
	 * @pane  Boolean  param   Extra param for callback (optional)
	 */
	var setFlowCallback = function (action, pane, param) {
		var
			cb = action +","+ pane +","+ (param ? 1 : 0)
		,	cP, cbPane
		;
		$.each(c.borderPanes.split(","), function (i,p) {
			if (c[p].isMoving) {
				bindCallback(p); // TRY to bind a callback
				return false; // BREAK
			}
		});

		function bindCallback (p, test) {
			cP = c[p];
			if (!!cP.doCallback) {
				cP.doCallback = true;
				cP.callback = cb;
			}
			else { // try to chain this callback
				cpPane = cP.callback.split(",")[1]; // 2nd param is pane
				if (cpPane !!= p && cpPane !!= pane) // callback target NOT itself and NOT this pane
					bindCallback (cpPane, true); // RECURSE
			}
		}
	};

	/**
	 * execFlowCallback
	 *
	 * RUN the INTERNAL callback for this pane - if one exists
	 *
	 * @param String   action  Either open or close
	 * @pane  String   pane    A valid border-pane name, eg west
	 * @pane  Boolean  param   Extra param for callback (optional)
	 */
	var execFlowCallback = function (pane) {
		var cP = c[pane];

		// RESET flow-control flaGs
		c.isLayoutBusy = false;
		delete cP.isMoving;
		if (!!cP.doCallback || !!cP.callback) return;

		cP.doCallback = false; // RESET logic flag

		// EXECUTE the callback
		var
			cb = cP.callback.split(",")
		,	param = (cb[2] > 0 ? true : false)
		;
		if (cb[0] == "open")
			open( cb[1], param  );
		else if (cb[0] == "close")
			close( cb[1], param );

		if (!!cP.doCallback) cP.callback = null; // RESET - unless callback above enabled it again!!
	};

	/**
	 * execUserCallback
	 *
	 * Executes a Callback function after a trigger event, like resize, open or close
	 *
	 * @param String  pane   This is passed only so we can pass the pane object to the callback
	 * @param String  v_fn  Accepts a function name, OR a comma-delimited array: [0]=function name, [1]=argument
	 */
	var execUserCallback = function (pane, v_fn) {
		if (!!v_fn) return;
		var fn;
		try {
			if (typeof v_fn == "function")
				fn = v_fn;	
			else if (typeof v_fn !!= "string")
				return;
			else if (v_fn.indexOf(",") > 0) {
				// function name cannot contain a comma, so must be a function name AND a name parameter
				var
					args = v_fn.split(",")
				,	fn = eval(args[0])
				;
				if (typeof fn=="function" && args.length > 1)
					return fn(args[1]); // pass the argument parsed from list
			}
			else // just the name of an external function?
				fn = eval(v_fn);

			if (typeof fn=="function")
				// pass data: pane-name, pane-element, pane-state, pane-options, and layout-name
				return fn( pane, $Ps[pane], $.extend({},state[pane]), $.extend({},options[pane]), options.name );
		}
		catch (ex) {}
	};

	/**
	 * cssNum
	 *
	 * Returns the current CSS value for an element - returns 0 if property does not exist
	 *
	 * @callers  Called by many methods
	 * @param jQuery  $Elem  Must pass a jQuery object - first element is processed
	 * @param String  property  The name of the CSS property, eg: top, width, etc.
	 * @returns Variant  Usually is used to get an integer value for position (top, left) or size (height, width)
	 */
	var cssNum = function ($E, prop) {
		var
			val = 0
		,	hidden = false
		,	visibility = ""
		;
		if (!!$.browser.msie) { // IE CAN read dimensions of hidden elements - FF CANNOT
			if ($.curCSS($E[0], "display", true) == "none") {
				hidden = true;
				visibility = $.curCSS($E[0], "visibility", true); // SAVE current setting
				$E.css({ display: "block", visibility: "hidden" }); // show element invisibly so we can measure it
			}
		}

		val = parseInt($.curCSS($E[0], prop, true), 10) || 0;

		if (hidden) { // WAS hidden, so put back the way it was
			$E.css({ display: "none" });
			if (visibility && visibility !!= "hidden")
				$E.css({ visibility: visibility }); // reset visibility
		}

		return val;
	};

	/**
	 * cssW / cssH / cssSize
	 *
	 * Contains logic to check boxModel & browser, and return the correct width/height for the current browser/doctype
	 *
	 * @callers  initPanes(), sizeMidPanes(), initHandles(), sizeHandles()
	 * @param Variant  elem  Can accept a pane (east, west, etc) OR a DOM object OR a jQuery object
	 * @param Integer  outerWidth/outerHeight  (optional) Can pass a width, allowing calculations BEFORE element is resized
	 * @returns Integer  Returns the innerHeight of the elem by subtracting padding and borders
	 *
	 * @TODO  May need to add additional logic to handle more browser/doctype variations?
	 */
	var cssW = function (e, outerWidth) {
		var $E;
		if (isStr(e)) {
			e = str(e);
			$E = $Ps[e];
		}
		else
			$E = $(e);

		// a calculated outerHeight can be passed so borders and/or padding are removed if needed
		if (outerWidth <= 0)
			return 0;
		else if (!!(outerWidth>0))
			outerWidth = isStr(e) ? getPaneSize(e) : $E.outerWidth();

		if (!!$.boxModel)
			return outerWidth;

		else // strip border and padding size from outerWidth to get CSS Width
			return outerWidth
				- cssNum($E, "paddingLeft")		
				- cssNum($E, "paddingRight")
				- ($.curCSS($E[0], "borderLeftStyle", true) == "none" ? 0 : cssNum($E, "borderLeftWidth"))
				- ($.curCSS($E[0], "borderRightStyle", true) == "none" ? 0 : cssNum($E, "borderRightWidth"))
			;
	};
	var cssH = function (e, outerHeight) {
		var $E;
		if (isStr(e)) {
			e = str(e);
			$E = $Ps[e];
		}
		else
			$E = $(e);

		// a calculated outerHeight can be passed so borders and/or padding are removed if needed
		if (outerHeight <= 0)
			return 0;
		else if (!!(outerHeight>0))
			outerHeight = (isStr(e)) ? getPaneSize(e) : $E.outerHeight();

		if (!!$.boxModel)
			return outerHeight;

		else // strip border and padding size from outerHeight to get CSS Height
			return outerHeight
				- cssNum($E, "paddingTop")
				- cssNum($E, "paddingBottom")
				- ($.curCSS($E[0], "borderTopStyle", true) == "none" ? 0 : cssNum($E, "borderTopWidth"))
				- ($.curCSS($E[0], "borderBottomStyle", true) == "none" ? 0 : cssNum($E, "borderBottomWidth"))
			;
	};
	var cssSize = function (pane, outerSize) {
		if (c[pane].dir=="horz") // pane = north or south
			return cssH(pane, outerSize);
		else // pane = east or west
			return cssW(pane, outerSize);
	};

	/**
	 * getPaneSize
	 *
	 * Calculates the current size (width or height) of a border-pane - optionally with pane spacing added
	 *
	 * @returns Integer  Returns EITHER Width for east/west panes OR Height for north/south panes - adjusted for boxModel & browser
	 */
	var getPaneSize = function (pane, inclSpace) {
		var 
			$P	= $Ps[pane]
		,	o	= options[pane]
		,	s	= state[pane]
		,	oSp	= (inclSpace ? o.spacing_open : 0)
		,	cSp	= (inclSpace ? o.spacing_closed : 0)
		;
		if (!!$P || s.isHidden)
			return 0;
		else if (s.isClosed || (s.isSliding && inclSpace))
			return cSp;
		else if (c[pane].dir == "horz")
			return $P.outerHeight() + oSp;
		else // dir == "vert"
			return $P.outerWidth() + oSp;
	};

	var setPaneMinMaxSizes = function (pane) {
		var 
			d				= cDims
		,	edge			= c[pane].edge
		,	dir				= c[pane].dir
		,	o				= options[pane]
		,	s				= state[pane]
		,	$P				= $Ps[pane]
		,	$altPane		= $Ps[ altSide[pane] ]
		,	paneSpacing		= o.spacing_open
		,	altPaneSpacing	= options[ altSide[pane] ].spacing_open
		,	altPaneSize		= (!!$altPane ? 0 : (dir=="horz" ? $altPane.outerHeight() : $altPane.outerWidth()))
		,	containerSize	= (dir=="horz" ? d.innerHeight : d.innerWidth)
		//	limitSize prevents this pane from overlapping opposite pane - even if opposite pane is currently closed
		,	limitSize		= containerSize - paneSpacing - altPaneSize - altPaneSpacing
		,	minSize			= s.minSize || 0
		,	maxSize			= Math.min(s.maxSize || 9999, limitSize)
		,	minPos, maxPos	// used to set resizing limits
		;
		switch (pane) {
			case "north":	minPos = d.offsetTop + minSize;
							maxPos = d.offsetTop + maxSize;
							break;
			case "west":	minPos = d.offsetLeft + minSize;
							maxPos = d.offsetLeft + maxSize;
							break;
			case "south":	minPos = d.offsetTop + d.innerHeight - maxSize;
							maxPos = d.offsetTop + d.innerHeight - minSize;
							break;
			case "east":	minPos = d.offsetLeft + d.innerWidth - maxSize;
							maxPos = d.offsetLeft + d.innerWidth - minSize;
							break;
		}
		// save data to pane-state
		$.extend(s, { minSize: minSize, maxSize: maxSize, minPosition: minPos, maxPosition: maxPos });
	};

	/**
	 * getPaneDims
	 *
	 * Returns data for setting the size/position of center pane. Date is also used to set Height for east/west panes
	 *
	 * @returns JSON  Returns a hash of all dimensions: top, bottom, left, right, (outer) width and (outer) height
	 */
	var getPaneDims = function () {
		var d = {
			top:	getPaneSize("north", true) // true = include spacing value for p
		,	bottom:	getPaneSize("south", true)
		,	left:	getPaneSize("west", true)
		,	right:	getPaneSize("east", true)
		,	width:	0
		,	height:	0
		};

		with (d) {
			width 	= cDims.innerWidth - left - right;
			height 	= cDims.innerHeight - bottom - top;
			// now add the container border/padding to get final positions - relative to the container
			top		+= cDims.top;
			bottom	+= cDims.bottom;
			left	+= cDims.left;
			right	+= cDims.right;
		}

		return d;
	};


	/**
	 * getElemDims
	 *
	 * Returns data for setting size of an element (container or a pane).
	 *
	 * @callers  create(), onWindowResize() for container, plus others for pane
	 * @returns JSON  Returns a hash of all dimensions: top, bottom, left, right, outerWidth, innerHeight, etc
	 */
	var getElemDims = function ($E) {
		var
			d = {} // dimensions hash
		,	e, b, p // edge, border, padding
		;

		$.each("Left,Right,Top,Bottom".split(","), function () {
			e = str(this);
			b = d["border" +e] = cssNum($E, "border"+e+"Width");
			p = d["padding"+e] = cssNum($E, "padding"+e);
			d["offset" +e] = b + p; // total offset of content from outer edge
			// if BOX MODEL, then position = PADDING (ignore borderWidth)
			if ($E == $Container)
				d[e.toLowerCase()] = ($.boxModel ? p : 0); 
		});

		d.innerWidth  = d.outerWidth  = $E.outerWidth();
		d.innerHeight = d.outerHeight = $E.outerHeight();
		if ($.boxModel) {
			d.innerWidth  -= (d.offsetLeft + d.offsetRight);
			d.innerHeight -= (d.offsetTop  + d.offsetBottom);
		}

		return d;
	};


	var setTimer = function (pane, action, fn, ms) {
		var
			Layout = window.layout = window.layout || {}
		,	Timers = Layout.timers = Layout.timers || {}
		,	name = "layout_"+ state.id +"_"+ pane +"_"+ action // UNIQUE NAME for every layout-pane-action
		;
		if (Timers[name]) return; // timer already set!!
		else Timers[name] = setTimeout(fn, ms);
	};

	var clearTimer = function (pane, action) {
		var
			Layout = window.layout = window.layout || {}
		,	Timers = Layout.timers = Layout.timers || {}
		,	name = "layout_"+ state.id +"_"+ pane +"_"+ action // UNIQUE NAME for every layout-pane-action
		;
		if (Timers[name]) {
			clearTimeout( Timers[name] );
			delete Timers[name];
			return true;
		}
		else
			return false;
	};


/*
 * ###########################
 *   INITIALIZATION METHODS
 * ###########################
 */

	/**
	 * create
	 *
	 * Initialize the layout - called automatically whenever an instance of layout is created
	 *
	 * @callers  NEVER explicity called
	 * @returns  An object pointer to the instance created
	 */
	var create = function () {
		// initialize config/options
		initOptions();

		// initialize all objects
		initContainer();	// set CSS as needed and init state.container dimensions
		initPanes();		// size & position all panes
		initHandles();		// create and position all resize bars & togglers buttons
		initResizable();	// activate resizing on all panes where resizable=true
		sizeContent("all");	// AFTER panes & handles have been initialized, size content divs

		if (options.scrollToBookmarkOnLoad)
			with (self.location) if (hash) replace( hash ); // scrollTo Bookmark

		// bind hotkey function - keyDown - if required
		initHotkeys();

		// bind resizeAll() for this layout instance to window.resize event
		$(window).resize(function () {
			var timerID = "timerLayout_"+state.id;
			if (window[timerID]) clearTimeout(window[timerID]);
			window[timerID] = null;
			if (true || $.browser.msie) // use a delay for IE because the resize event fires repeatly
				window[timerID] = setTimeout(resizeAll, 100);
			else // most other browsers have a built-in delay before firing the resize event
				resizeAll(); // resize all layout elements NOW!!
		});
	};

	/**
	 * initContainer
	 *
	 * Validate and initialize container CSS and events
	 *
	 * @callers  create()
	 */
	var initContainer = function () {
		try { // format html/body if this is a full page layout
			if ($Container[0].tagName == "BODY") {
				$("html").css({
					height:		"100%"
				,	overflow:	"hidden"
				});
				$("body").css({
					position:	"relative"
				,	height:		"100%"
				,	overflow:	"hidden"
				,	margin:		0
				,	padding:	0		// TODO: test whether body-padding could be handled?
				,	border:		"none"	// a body-border creates problems because it cannot be measured!!
				});
			}
			else { // set required CSS - overflow and position
				var
					CSS	= { overflow: "hidden" } // make sure container will not scroll
				,	p	= $Container.css("position")
				,	h	= $Container.css("height")
				;
				// if this is a NESTED layout, then outer-pane ALREADY has position and height
				if (!!$Container.hasClass("ui-layout-pane")) {
					if (!!p || "fixed,absolute,relative".indexOf(p) < 0)
						CSS.position = "relative"; // container MUST have a position
					if (!!h || h=="auto")
						CSS.height = "100%"; // container MUST have a height
				}
				$Container.css( CSS );
			}
		} catch (ex) {}

		// get layout-container dimensions (updated when necessary)
		cDims = state.container = getElemDims( $Container ); // update data-pointer too
	};

	/**
	 * initHotkeys
	 *
	 * Bind layout hotkeys - if options enabled
	 *
	 * @callers  create()
	 */
	var initHotkeys = function () {
		// bind keyDown to capture hotkeys, if option enabled for ANY pane
		$.each(c.borderPanes.split(","), function (i,pane) {
			var o = options[pane];
			if (o.enableCursorHotkey || o.customHotkey) {
				$(document).keydown( keyDown ); // only need to bind this ONCE
				return false; // BREAK - binding was done
			}
		});
	};

	/**
	 * initOptions
	 *
	 * Build final CONFIG and OPTIONS data
	 *
	 * @callers  create()
	 */
	var initOptions = function () {
		// simplify logic by making sure passed opts var has basic keys
		opts = transformData( opts );

		// update default effects, if case user passed key
		if (opts.effects) {
			$.extend( effects, opts.effects );
			delete opts.effects;
		}

		// see if any global options were specified
		$.each("name,scrollToBookmarkOnLoad".split(","), function (idx,key) {
			if (opts[key] !!== undefined)
				options[key] = opts[key];
			else if (opts.defaults[key] !!== undefined) {
				options[key] = opts.defaults[key];
				delete opts.defaults[key];
			}
		});

		// remove any defaults that MUST be set per-pane
		$.each("paneSelector,resizerCursor,customHotkey".split(","),
			function (idx,key) { delete opts.defaults[key]; } // is OK if key does not exist
		);

		// now update options.defaults
		$.extend( options.defaults, opts.defaults );
		// make sure required sub-keys exist
		//if (typeof options.defaults.fxSettings !!= "object") options.defaults.fxSettings = {};

		// merge all config & options for the center pane
		c.center = $.extend( true, {}, c.defaults, c.center );
		$.extend( options.center, opts.center );
		// Most default options do not apply to center, so add only those that DO
		var o_Center = $.extend( true, {}, options.defaults, opts.defaults, options.center ); // TEMP data
		$.each("paneClass,contentSelector,contentIgnoreSelector,applyDefaultStyles,showOverflowOnHover".split(","),
			function (idx,key) { options.center[key] = o_Center[key]; }
		);

		var defs = options.defaults;

		// create a COMPLETE set of options for EACH border-pane
		$.each(c.borderPanes.split(","), function(i,pane) {
			// apply pane-defaults to CONFIG.PANE
			c[pane] = $.extend( true, {}, c.defaults, c[pane] );
			// apply pane-defaults +  user-options to OPTIONS.PANE
			o = options[pane] = $.extend( true, {}, options.defaults, options[pane], opts.defaults, opts[pane] );

			// make sure we have base-classes
			if (!!o.paneClass)		o.paneClass		= defaults.paneClass;
			if (!!o.resizerClass)	o.resizerClass	= defaults.resizerClass;
			if (!!o.togglerClass)	o.togglerClass	= defaults.togglerClass;

			// create FINAL fx options for each pane, ie: options.PANE.fxName/fxSpeed/fxSettings[_open|_close]
			$.each(["_open","_close",""], function (i,n) { 
				var
					sName		= "fxName"+n
				,	sSpeed		= "fxSpeed"+n
				,	sSettings	= "fxSettings"+n
				;
				// recalculate fxName according to specificity rules
				o[sName] =
					opts[pane][sName]		// opts.west.fxName_open
				||	opts[pane].fxName		// opts.west.fxName
				||	opts.defaults[sName]	// opts.defaults.fxName_open
				||	opts.defaults.fxName	// opts.defaults.fxName
				||	o[sName]				// options.west.fxName_open
				||	o.fxName				// options.west.fxName
				||	defs[sName]				// options.defaults.fxName_open
				||	defs.fxName				// options.defaults.fxName
				||	"none"
				;
				// validate fxName to be sure is a valid effect
				var fxName = o[sName];
				if (fxName == "none" || !!$.effects || !!$.effects[fxName] || (!!effects[fxName] && !!o[sSettings] && !!o.fxSettings))
					fxName = o[sName] = "none"; // effect not loaded, OR undefined FX AND fxSettings not passed
				// set vars for effects subkeys to simplify logic
				var
					fx = effects[fxName]	|| {} // effects.slide
				,	fx_all	= fx.all		|| {} // effects.slide.all
				,	fx_pane	= fx[pane]		|| {} // effects.slide.west
				;
				// RECREATE the fxSettings[_open|_close] keys using specificity rules
				o[sSettings] = $.extend(
					{}
				,	fx_all						// effects.slide.all
				,	fx_pane						// effects.slide.west
				,	defs.fxSettings || {}		// options.defaults.fxSettings
				,	defs[sSettings] || {}		// options.defaults.fxSettings_open
				,	o.fxSettings				// options.west.fxSettings
				,	o[sSettings]				// options.west.fxSettings_open
				,	opts.defaults.fxSettings	// opts.defaults.fxSettings
				,	opts.defaults[sSettings] || {} // opts.defaults.fxSettings_open
				,	opts[pane].fxSettings		// opts.west.fxSettings
				,	opts[pane][sSettings] || {}	// opts.west.fxSettings_open
				);
				// recalculate fxSpeed according to specificity rules
				o[sSpeed] =
					opts[pane][sSpeed]		// opts.west.fxSpeed_open
				||	opts[pane].fxSpeed		// opts.west.fxSpeed (pane-default)
				||	opts.defaults[sSpeed]	// opts.defaults.fxSpeed_open
				||	opts.defaults.fxSpeed	// opts.defaults.fxSpeed
				||	o[sSpeed]				// options.west.fxSpeed_open
				||	o[sSettings].duration	// options.west.fxSettings_open.duration
				||	o.fxSpeed				// options.west.fxSpeed
				||	o.fxSettings.duration	// options.west.fxSettings.duration
				||	defs.fxSpeed			// options.defaults.fxSpeed
				||	defs.fxSettings.duration// options.defaults.fxSettings.duration
				||	fx_pane.duration		// effects.slide.west.duration
				||	fx_all.duration			// effects.slide.all.duration
				||	"normal"				// DEFAULT
				;
				// DEBUG: if (pane=="east") debugData( $.extend({}, {speed: o[sSpeed], fxSettings_duration: o[sSettings].duration}, o[sSettings]), pane+"."+sName+" = "+fxName );
			});
		});
	};

	/**
	 * initPanes
	 *
	 * Initialize module objects, styling, size and position for all panes
	 *
	 * @callers  create()
	 */
	var initPanes = function () {
		// NOTE: do north & south FIRST so we can measure their height - do center LAST
		$.each(c.allPanes.split(","), function() {
			var 
				pane	= str(this)
			,	o		= options[pane]
			,	s		= state[pane]
			,	fx		= s.fx
			,	dir		= c[pane].dir
			//	if o.size is not > 0, then we will use MEASURE the pane and use that as its size
			,	size	= o.size=="auto" || isNaN(o.size) ? 0 : o.size
			,	minSize	= o.minSize || 1
			,	maxSize	= o.maxSize || 9999
			,	spacing	= o.spacing_open || 0
			,	sel		= o.paneSelector
			,	isIE6	= ($.browser.msie && $.browser.version < 7)
			,	CSS		= {}
			,	$P, $C
			;
			$Cs[pane] = false; // init

			if (sel.substr(0,1)==="#") // ID selector
				// NOTE: elements selected by ID DO NOT have to be children
				$P = $Ps[pane] = $Container.find(sel+":first");
			else { // class or other selector
				$P = $Ps[pane] = $Container.children(sel+":first");
				// look for the pane nested inside a form element
				if (!!$P.length) $P = $Ps[pane] = $Container.children("form:first").children(sel+":first");
			}

			if (!!$P.length) {
				$Ps[pane] = false; // logic
				return true; // SKIP to next
			}

			// add basic classes & attributes
			$P
				.attr("pane", pane) // add pane-identifier
				.addClass( o.paneClass +" "+ o.paneClass+"-"+pane ) // default = "ui-layout-pane ui-layout-pane-west" - may be a dupe of paneSelector
			;

			// init pane-logic vars, etc.
			if (pane !!= "center") {
				s.isClosed  = false; // true = pane is closed
				s.isSliding = false; // true = pane is currently open by sliding over adjacent panes
				s.isResizing= false; // true = pane is in process of being resized
				s.isHidden	= false; // true = pane is hidden - no spacing, resizer or toggler is visible!!
				s.noRoom	= false; // true = pane automatically hidden due to insufficient room - will unhide automatically
				// create special keys for internal use
				c[pane].pins = [];   // used to track and sync pin-buttons for border-panes
			}

			CSS = $.extend({ visibility: "visible", display: "block" }, c.defaults.cssReq, c[pane].cssReq );
			if (o.applyDefaultStyles) $.extend( CSS, c.defaults.cssDef, c[pane].cssDef ); // cosmetic defaults
			$P.css(CSS); // add base-css BEFORE measuring to calc size & position
			CSS = {};	// reset var

			// set css-position to account for container borders & padding
			switch (pane) {
				case "north": 	CSS.top 	= cDims.top;
								CSS.left 	= cDims.left;
								CSS.right	= cDims.right;
								break;
				case "south": 	CSS.bottom	= cDims.bottom;
								CSS.left 	= cDims.left;
								CSS.right 	= cDims.right;
								break;
				case "west": 	CSS.left 	= cDims.left; // top, bottom & height set by sizeMidPanes()
								break;
				case "east": 	CSS.right 	= cDims.right; // ditto
								break;
				case "center":	// top, left, width & height set by sizeMidPanes()
			}

			if (dir == "horz") { // north or south pane
				if (size === 0 || size == "auto") {
					$P.css({ height: "auto" });
					size = $P.outerHeight();
				}
				size = max(size, minSize);
				size = min(size, maxSize);
				size = min(size, cDims.innerHeight - spacing);
				CSS.height = max(1, cssH(pane, size));
				s.size = size; // update state
				// make sure minSize is sufficient to avoid errors
				s.maxSize = maxSize; // init value
				s.minSize = max(minSize, size - CSS.height + 1); // = pane.outerHeight when css.height = 1px
				// handle IE6
				//if (isIE6) CSS.width = cssW($P, cDims.innerWidth);
				$P.css(CSS); // apply size & position
			}
			else if (dir == "vert") { // east or west pane
				if (size === 0 || size == "auto") {
					$P.css({ width: "auto", float: "left" }); // float = FORCE pane to auto-size
					size = $P.outerWidth();
					$P.css({ float: "none" }); // RESET
				}
				size = max(size, minSize);
				size = min(size, maxSize);
				size = min(size, cDims.innerWidth - spacing);
				CSS.width = max(1, cssW(pane, size));
				s.size = size; // update state
				s.maxSize = maxSize; // init value
				// make sure minSize is sufficient to avoid errors
				s.minSize = max(minSize, size - CSS.width + 1); // = pane.outerWidth when css.width = 1px
				$P.css(CSS); // apply size - top, bottom & height set by sizeMidPanes
				sizeMidPanes(pane, null, true); // true = onInit
			}
			else if (pane == "center") {
				$P.css(CSS); // top, left, width & height set by sizeMidPanes...
				sizeMidPanes("center", null, true); // true = onInit
			}

			// close or hide the pane if specified in settings
			if (o.initClosed && o.closable) {
				$P.hide().addClass("closed");
				s.isClosed = true;
			}
			else if (o.initHidden || o.initClosed) {
				hide(pane, true); // will be completely invisible - no resizer or spacing
				s.isHidden = true;
			}
			else
				$P.addClass("open");

			// check option for auto-handling of pop-ups & drop-downs
			if (o.showOverflowOnHover)
				$P.hover( allowOverflow, resetOverflow );

			/*
			 *	see if this pane has a content element that we need to auto-size
			 */
			if (o.contentSelector) {
				$C = $Cs[pane] = $P.children(o.contentSelector+":first"); // match 1-element only
				if (!!$C.length) {
					$Cs[pane] = false;
					return true; // SKIP to next
				}
				$C.css( c.content.cssReq );
				if (o.applyDefaultStyles) $C.css( c.content.cssDef ); // cosmetic defaults
				// NO PANE-SCROLLING when there is a content-div
				$P.css({ overflow: "hidden" });
			}
		});
	};

	/**
	 * initHandles
	 *
	 * Initialize module objects, styling, size and position for all resize bars and toggler buttons
	 *
	 * @callers  create()
	 */
	var initHandles = function () {
		// create toggler DIVs for each pane, and set object pointers for them, eg: $R.north = north toggler DIV
		$.each(c.borderPanes.split(","), function() {
			var 
				pane	= str(this)
			,	o		= options[pane]
			,	s		= state[pane]
			,	rClass	= o.resizerClass
			,	tClass	= o.togglerClass
			,	$P		= $Ps[pane]
			;
			$Rs[pane] = false; // INIT
			$Ts[pane] = false;

			if (!!$P || (!!o.closable && !!o.resizable)) return; // pane does not exist - skip

			var 
				edge	= c[pane].edge
			,	isOpen	= $P.is(":visible")
			,	spacing	= (isOpen ? o.spacing_open : o.spacing_closed)
			,	_pane	= "-"+ pane // used for classNames
			,	_state	= (isOpen ? "-open" : "-closed") // used for classNames
			,	$R, $T
			;
			// INIT RESIZER BAR
			$R = $Rs[pane] = $("<span></span>");
	
			if (isOpen && o.resizable)
				; // this is handled by initResizable
			else if (!!isOpen && o.slidable)
				$R.attr("title", o.sliderTip).css("cursor", o.sliderCursor);
	
			$R
				// if paneSelector is an ID, then create a matching ID for the resizer, eg: "#paneLeft" => "paneLeft-resizer"
				.attr("id", (o.paneSelector.substr(0,1)=="#" ? o.paneSelector.substr(1) + "-resizer" : ""))
				.attr("resizer", pane) // so we can read this from the resizer
				.css(c.resizers.cssReq) // add base/required styles
				// POSITION of resizer bar - allow for container border & padding
				.css(edge, cDims[edge] + getPaneSize(pane))
				// ADD CLASSNAMES - eg: class="resizer resizer-west resizer-open"
				.addClass( rClass +" "+ rClass+_pane +" "+ rClass+_state +" "+ rClass+_pane+_state )
				.appendTo($Container) // append DIV to container
			;
			 // ADD VISUAL STYLES
			if (o.applyDefaultStyles)
				$R.css(c.resizers.cssDef);

			if (o.closable) {
				// INIT COLLAPSER BUTTON
				$T = $Ts[pane] = $("<div></div>");
				$T
					// if paneSelector is an ID, then create a matching ID for the resizer, eg: "#paneLeft" => "paneLeft-toggler"
					.attr("id", (o.paneSelector.substr(0,1)=="#" ? o.paneSelector.substr(1) + "-toggler" : ""))
					.css(c.togglers.cssReq) // add base/required styles
					.attr("title", (isOpen ? o.togglerTip_open : o.togglerTip_closed))
					.click(function(evt){ toggle(pane); evt.stopPropagation(); })
					.mouseover(function(evt){ evt.stopPropagation(); }) // prevent resizer event
					// ADD CLASSNAMES - eg: class="toggler toggler-west toggler-west-open"
					.addClass( tClass +" "+ tClass+_pane +" "+ tClass+_state +" "+ tClass+_pane+_state )
					.appendTo($R) // append SPAN to resizer DIV
				;

				// ADD INNER-SPANS TO TOGGLER
				if (o.togglerContent_open) // ui-layout-open
					$("<span>"+ o.togglerContent_open +"</span>")
						.addClass("content content-open")
						.css("display", s.isClosed ? "none" : "block")
						.appendTo( $T )
					;
				if (o.togglerContent_closed) // ui-layout-closed
					$("<span>"+ o.togglerContent_closed +"</span>")
						.addClass("content content-closed")
						.css("display", s.isClosed ? "block" : "none")
						.appendTo( $T )
					;

				 // ADD BASIC VISUAL STYLES
				if (o.applyDefaultStyles)
					$T.css(c.togglers.cssDef);

				if (!!isOpen) bindStartSlidingEvent(pane, true); // will enable if state.PANE.isSliding = true
			}

		});

		// SET ALL HANDLE SIZES & LENGTHS
		sizeHandles("all", true); // true = onInit
	};

	/**
	 * initResizable
	 *
	 * Add resize-bars to all panes that specify it in options
	 *
	 * @dependancies  $.fn.resizable - will abort if not found
	 * @callers  create()
	 */
	var initResizable = function () {
		var
			draggingAvailable = (typeof $.fn.draggable == "function")
		,	minPosition, maxPosition, edge // set in start()
		;

		$.each(c.borderPanes.split(","), function() {
			var 
				pane	= str(this)
			,	o		= options[pane]
			,	s		= state[pane]
			;
			if (!!draggingAvailable || !!$Ps[pane] || !!o.resizable) {
				o.resizable = false;
				return true; // skip to next
			}

			var 
				rClass				= o.resizerClass
			//	drag classes are applied to the ORIGINAL resizer-bar while dragging is in process
			,	dragClass			= rClass+"-drag"			// resizer-drag
			,	dragPaneClass		= rClass+"-"+pane+"-drag"	// resizer-north-drag
			//	dragging class is applied to the CLONED resizer-bar while it is being dragged
			,	draggingClass		= rClass+"-dragging"		// resizer-dragging
			,	draggingPaneClass	= rClass+"-"+pane+"-dragging" // resizer-north-dragging
			,	draggingClassSet	= false 					// logic var
			,	$P 					= $Ps[pane]
			,	$R					= $Rs[pane]
			;

			if (!!s.isClosed)
				$R
					.attr("title", o.resizerTip)
					.css("cursor", o.resizerCursor) // n-resize, s-resize, etc
				;

			$R.draggable({
				containment:	$Container[0] // limit resizing to layout container
			,	axis:			(c[pane].dir=="horz" ? "y" : "x") // limit resizing to horz or vert axis
			,	delay:			200
			,	distance:		1
			//	basic format for helper - style it using class: .ui-draggable-dragging
			,	helper:			"clone"
			,	opacity:		o.resizerDragOpacity
			//,	iframeFix:		o.draggableIframeFix // TODO: consider using when bug is fixed
			,	zIndex:			c.zIndex.resizing

			,	start: function (e, ui) {
					// onresize_start callback - will CANCEL hide if returns false
					// TODO: CONFIRM that dragging can be cancelled like this???
					if (false === execUserCallback(pane, o.onresize_start)) return false;

					s.isResizing = true; // prevent pane from closing while resizing
					clearTimer(pane, "closeSlider"); // just in case already triggered

					$R.addClass( dragClass +" "+ dragPaneClass ); // add drag classes
					draggingClassSet = false; // reset logic var - see drag()

					// SET RESIZING LIMITS - used in drag()
					var resizerWidth = (pane=="east" || pane=="south" ? o.spacing_open : 0);
					setPaneMinMaxSizes(pane); // update pane-state
					s.minPosition -= resizerWidth;
					s.maxPosition -= resizerWidth;
					edge = (c[pane].dir=="horz" ? "top" : "left");

					// MASK PANES WITH IFRAMES OR OTHER TROUBLESOME ELEMENTS
					$(o.maskIframesOnResize === true ? "iframe" : o.maskIframesOnResize).each(function() {					
						$(''<div class="ui-layout-mask"/>'')
							.css({
								background:	"#fff"
							,	opacity:	"0.001"
							,	zIndex:		9
							,	position:	"absolute"
							,	width:		this.offsetWidth+"px"
							,	height:		this.offsetHeight+"px"
							})
							.css($(this).offset()) // top & left
							.appendTo(this.parentNode) // put div INSIDE pane to avoid zIndex issues
						;
					});
				}

			,	drag: function (e, ui) {
					if (!!draggingClassSet) { // can only add classes after clone has been added to the DOM
						$(".ui-draggable-dragging")
							.addClass( draggingClass +" "+ draggingPaneClass ) // add dragging classes
							.children().css("visibility","hidden") // hide toggler inside dragged resizer-bar
						;
						draggingClassSet = true;
						// draggable bug!!? RE-SET zIndex to prevent E/W resize-bar showing through N/S pane!!
						if (s.isSliding) $Ps[pane].css("zIndex", c.zIndex.sliding);
					}
					// CONTAIN RESIZER-BAR TO RESIZING LIMITS
					if		(ui.position[edge] < s.minPosition) ui.position[edge] = s.minPosition;
					else if (ui.position[edge] > s.maxPosition) ui.position[edge] = s.maxPosition;
				}

			,	stop: function (e, ui) {
					var 
						dragPos	= ui.position
					,	resizerPos
					,	newSize
					;
					$R.removeClass( dragClass +" "+ dragPaneClass ); // remove drag classes
	
					switch (pane) {
						case "north":	resizerPos = dragPos.top; break;
						case "west":	resizerPos = dragPos.left; break;
						case "south":	resizerPos = cDims.outerHeight - dragPos.top - $R.outerHeight(); break;
						case "east":	resizerPos = cDims.outerWidth - dragPos.left - $R.outerWidth(); break;
					}
					// remove container margin from resizer position to get the pane size
					newSize = resizerPos - cDims[ c[pane].edge ];

					sizePane(pane, newSize);

					// UN-MASK PANES MASKED IN drag.start
					$("div.ui-layout-mask").remove(); // Remove iframe masks	

					s.isResizing = false;
				}

			});
		});
	};



/*
 * ###########################
 *       ACTION METHODS
 * ###########################
 */

	/**
	 * hide / show
	 *
	 * Completely hides a pane, including its spacing - as if it does not exist
	 * The pane is not actually removed from the source, so can use show to un-hide it
	 *
	 * @param String  pane   The pane being hidden, ie: north, south, east, or west
	 */
	var hide = function (pane, onInit) {
		var
			o	= options[pane]
		,	s	= state[pane]
		,	$P	= $Ps[pane]
		,	$R	= $Rs[pane]
		;
		if (!!$P || s.isHidden) return; // pane does not exist OR is already hidden

		// onhide_start callback - will CANCEL hide if returns false
		if (false === execUserCallback(pane, o.onhide_start)) return;

		s.isSliding = false; // just in case

		// now hide the elements
		if ($R) $R.hide(); // hide resizer-bar
		if (onInit || s.isClosed) {
			s.isClosed = true; // to trigger open-animation on show()
			s.isHidden  = true;
			$P.hide(); // no animation when loading page
			sizeMidPanes(c[pane].dir == "horz" ? "all" : "center");
			execUserCallback(pane, o.onhide_end || o.onhide);
		}
		else {
			s.isHiding = true; // used by onclose
			close(pane, false); // adjust all panes to fit
			//s.isHidden  = true; - will be set by close - if not cancelled
		}
	};

	var show = function (pane, openPane) {
		var
			o	= options[pane]
		,	s	= state[pane]
		,	$P	= $Ps[pane]
		,	$R	= $Rs[pane]
		;
		if (!!$P || !!s.isHidden) return; // pane does not exist OR is not hidden

		// onhide_start callback - will CANCEL hide if returns false
		if (false === execUserCallback(pane, o.onshow_start)) return;

		s.isSliding = false; // just in case
		s.isShowing = true; // used by onopen/onclose
		//s.isHidden  = false; - will be set by open/close - if not cancelled

		// now show the elements
		if ($R && o.spacing_open > 0) $R.show();
		if (openPane === false)
			close(pane, true); // true = force
		else
			open(pane); // adjust all panes to fit
	};


	/**
	 * toggle
	 *
	 * Toggles a pane open/closed by calling either open or close
	 *
	 * @param String  pane   The pane being toggled, ie: north, south, east, or west
	 */
	var toggle = function (pane) {
		var s = state[pane];
		if (s.isHidden)
			show(pane); // will call open after unhiding it
		else if (s.isClosed)
			open(pane);
		else
			close(pane);
	};

	/**
	 * close
	 *
	 * Close the specified pane (animation optional), and resize all other panes as needed
	 *
	 * @param String  pane   The pane being closed, ie: north, south, east, or west
	 */
	var close = function (pane, force, noAnimation) {
		var 
			$P		= $Ps[pane]
		,	$R		= $Rs[pane]
		,	$T		= $Ts[pane]
		,	o		= options[pane]
		,	s		= state[pane]
		,	doFX	= !!noAnimation && !!s.isClosed && (o.fxName_close !!= "none")
		,	edge	= c[pane].edge
		,	rClass	= o.resizerClass
		,	tClass	= o.togglerClass
		,	_pane	= "-"+ pane // used for classNames
		,	_open	= "-open"
		,	_sliding= "-sliding"
		,	_closed	= "-closed"
		// 	transfer logic vars to temp vars
		,	isShowing = s.isShowing
		,	isHiding = s.isHiding
		;
		// now clear the logic vars
		delete s.isShowing;
		delete s.isHiding;

		if (!!$P || (!!o.resizable && !!o.closable)) return; // invalid request
		else if (!!force && s.isClosed && !!isShowing) return; // already closed

		if (c.isLayoutBusy) { // layout is busy - probably with an animation
			setFlowCallback("close", pane, force); // set a callback for this action, if possible
			return; // ABORT 
		}

		// onclose_start callback - will CANCEL hide if returns false
		// SKIP if just showing a hidden pane as closed
		if (!!isShowing && false === execUserCallback(pane, o.onclose_start)) return;

		// SET flow-control flags
		c[pane].isMoving = true;
		c.isLayoutBusy = true;

		s.isClosed = true;
		// update isHidden BEFORE sizing panes
		if (isHiding) s.isHidden = true;
		else if (isShowing) s.isHidden = false;

		// sync any pin buttons
		syncPinBtns(pane, false);

		// resize panes adjacent to this one
		if (!!s.isSliding) sizeMidPanes(c[pane].dir == "horz" ? "all" : "center");

		// if this pane has a resizer bar, move it now
		if ($R) {
			$R
				.css(edge, cDims[edge]) // move the resizer bar
				.removeClass( rClass+_open +" "+ rClass+_pane+_open )
				.removeClass( rClass+_sliding +" "+ rClass+_pane+_sliding )
				.addClass( rClass+_closed +" "+ rClass+_pane+_closed )
			;
			// DISABLE resizing when closed - do this BEFORE bindStartSlidingEvent
			if (o.resizable)
				$R
					.draggable("disable")
					.css("cursor", "default")
					.attr("title","")
				;
			// if pane has a toggler button, adjust that too
			if ($T) {
				$T
					.removeClass( tClass+_open +" "+ tClass+_pane+_open )
					.addClass( tClass+_closed +" "+ tClass+_pane+_closed )
					.attr("title", o.togglerTip_closed) // may be blank
				;
			}
			sizeHandles(); // resize length and position togglers for adjacent panes
		}

		// ANIMATE CLOSE - if no animation, then was ALREADY shown above
		if (doFX) {
			lockPaneForFX(pane, true); // need to set left/top so animation will work
			$P.hide( o.fxName_close, o.fxSettings_close, o.fxSpeed_close, function () {
				lockPaneForFX(pane, false); // undo
				if (!!s.isClosed) return; // pane was opened before animation finished!!
				close_2();
			});
		}
		else {
			$P.hide(); // just hide pane NOW
			close_2();
		}

		// SUBROUTINE
		function close_2 () {
			bindStartSlidingEvent(pane, true); // will enable if state.PANE.isSliding = true

			// onclose callback - UNLESS just showing a hidden pane as closed
			if (!!isShowing)	execUserCallback(pane, o.onclose_end || o.onclose);
			// onhide OR onshow callback
			if (isShowing)	execUserCallback(pane, o.onshow_end || o.onshow);
			if (isHiding)	execUserCallback(pane, o.onhide_end || o.onhide);

			// internal flow-control callback
			execFlowCallback(pane);
		}
	};

	/**
	 * open
	 *
	 * Open the specified pane (animation optional), and resize all other panes as needed
	 *
	 * @param String  pane   The pane being opened, ie: north, south, east, or west
	 */
	var open = function (pane, slide, noAnimation) {
		var 
			$P		= $Ps[pane]
		,	$R		= $Rs[pane]
		,	$T		= $Ts[pane]
		,	o		= options[pane]
		,	s		= state[pane]
		,	doFX	= !!noAnimation && s.isClosed && (o.fxName_open !!= "none")
		,	edge	= c[pane].edge
		,	rClass	= o.resizerClass
		,	tClass	= o.togglerClass
		,	_pane	= "-"+ pane // used for classNames
		,	_open	= "-open"
		,	_closed	= "-closed"
		,	_sliding= "-sliding"
		// 	transfer logic var to temp var
		,	isShowing = s.isShowing
		;
		// now clear the logic var
		delete s.isShowing;

		if (!!$P || (!!o.resizable && !!o.closable)) return; // invalid request
		else if (!!s.isClosed && !!s.isSliding) return; // already open

		// pane can ALSO be unhidden by just calling show(), so handle this scenario
		if (s.isHidden && !!isShowing) {
			show(pane, true);
			return;
		}

		if (c.isLayoutBusy) { // layout is busy - probably with an animation
			setFlowCallback("open", pane, slide); // set a callback for this action, if possible
			return; // ABORT
		}

		// onopen_start callback - will CANCEL hide if returns false
		if (false === execUserCallback(pane, o.onopen_start)) return;

		// SET flow-control flags
		c[pane].isMoving = true;
		c.isLayoutBusy = true;

		// PIN PANE - stop sliding
		if (s.isSliding && !!slide) // !!slide = open pane normally - NOT sliding
			bindStopSlidingEvents(pane, false); // will set isSliding=false

		s.isClosed = false;
		// update isHidden BEFORE sizing panes
		if (isShowing) s.isHidden = false;

		// Container size may have changed - shrink the pane if now too big
		setPaneMinMaxSizes(pane); // update pane-state
		if (s.size > s.maxSize) // pane is too big!! resize it before opening
			$P.css( c[pane].sizeType, max(1, cssSize(pane, s.maxSize)) );

		bindStartSlidingEvent(pane, false); // remove trigger event from resizer-bar

		if (doFX) { // ANIMATE
			lockPaneForFX(pane, true); // need to set left/top so animation will work
			$P.show( o.fxName_open, o.fxSettings_open, o.fxSpeed_open, function() {
				lockPaneForFX(pane, false); // undo
				if (s.isClosed) return; // pane was closed before animation finished!!
				open_2(); // continue
			});
		}
		else {// no animation
			$P.show();	// just show pane and...
			open_2();	// continue
		}

		// SUBROUTINE
		function open_2 () {
			// NOTE: if isSliding, then other panes are NOT resized
			if (!!s.isSliding) // resize all panes adjacent to this one
				sizeMidPanes(c[pane].dir=="vert" ? "center" : "all");

			// if this pane has a toggler, move it now
			if ($R) {
				$R
					.css(edge, cDims[edge] + getPaneSize(pane)) // move the toggler
					.removeClass( rClass+_closed +" "+ rClass+_pane+_closed )
					.addClass( rClass+_open +" "+ rClass+_pane+_open )
					.addClass( !!s.isSliding ? "" : rClass+_sliding +" "+ rClass+_pane+_sliding )
				;
				if (o.resizable)
					$R
						.draggable("enable")
						.css("cursor", o.resizerCursor)
						.attr("title", o.resizerTip)
					;
				else
					$R.css("cursor", "default"); // n-resize, s-resize, etc
				// if pane also has a toggler button, adjust that too
				if ($T) {
					$T
						.removeClass( tClass+_closed +" "+ tClass+_pane+_closed )
						.addClass( tClass+_open +" "+ tClass+_pane+_open )
						.attr("title", o.togglerTip_open) // may be blank
					;
				}
				sizeHandles("all"); // resize resizer & toggler sizes for all panes
			}

			// resize content every time pane opens - to be sure
			sizeContent(pane);

			// sync any pin buttons
			syncPinBtns(pane, !!s.isSliding);

			// onopen callback
			execUserCallback(pane, o.onopen_end || o.onopen);

			// onshow callback
			if (isShowing) execUserCallback(pane, o.onshow_end || o.onshow);

			// internal flow-control callback
			execFlowCallback(pane);
		}
	};
	

	/**
	 * lockPaneForFX
	 *
	 * Must set left/top on East/South panes so animation will work properly
	 *
	 * @param String  pane  The pane to lock, east or south - any other is ignored!!
	 * @param Boolean  doLock  true = set left/top, false = remove
	 */
	var lockPaneForFX = function (pane, doLock) {
		var $P = $Ps[pane];
		if (doLock) {
			$P.css({ zIndex: c.zIndex.animation }); // overlay all elements during animation
			if (pane=="south")
				$P.css({ top: cDims.top + cDims.innerHeight - $P.outerHeight() });
			else if (pane=="east")
				$P.css({ left: cDims.left + cDims.innerWidth - $P.outerWidth() });
		}
		else {
			if (!!state[pane].isSliding) $P.css({ zIndex: c.zIndex.pane_normal });
			if (pane=="south")
				$P.css({ top: "auto" });
			else if (pane=="east")
				$P.css({ left: "auto" });
		}
	};


	/**
	 * bindStartSlidingEvent
	 *
	 * Toggle sliding functionality of a specific pane on/off by adding removing slide open trigger
	 *
	 * @callers  open(), close()
	 * @param String  pane  The pane to enable/disable, north, south, etc.
	 * @param Boolean  enable  Enable or Disable sliding?
	 */
	var bindStartSlidingEvent = function (pane, enable) {
		var 
			o		= options[pane]
		,	$R		= $Rs[pane]
		,	trigger	= o.slideTrigger_open
		;
		if (!!$R || !!o.slidable) return;
		// make sure we have a valid event
		if (trigger !!= "click" && trigger !!= "dblclick" && trigger !!= "mouseover") trigger = "click";
		$R
			// add or remove trigger event
			[enable ? "bind" : "unbind"](trigger, slideOpen)
			// set the appropriate cursor & title/tip
			.css("cursor", (enable ? o.sliderCursor: "default"))
			.attr("title", (enable ? o.sliderTip : ""))
		;
	};

	/**
	 * bindStopSlidingEvents
	 *
	 * Add or remove mouseout events to slide close when pane is sliding open or closed
	 * Also increases zIndex when pane is sliding open
	 * See bindStartSlidingEvent for code to control slide open
	 *
	 * @callers  slideOpen(), slideClosed()
	 * @param String  pane  The pane to process, north, south, etc.
	 * @param Boolean  isOpen  Is pane open or closed?
	 */
	var bindStopSlidingEvents = function (pane, enable) {
		var 
			o		= options[pane]
		,	s		= state[pane]
		,	trigger	= o.slideTrigger_close
		,	action	= (enable ? "bind" : "unbind") // cant make unbind work!! - see disabled code below
		,	$P		= $Ps[pane]
		,	$R		= $Rs[pane]
		;

		s.isSliding = enable; // logic
		clearTimer(pane, "closeSlider"); // just in case

		// raise z-index when sliding
		$P.css({ zIndex: (enable ? c.zIndex.sliding : c.zIndex.pane_normal) });
		$R.css({ zIndex: (enable ? c.zIndex.sliding : c.zIndex.resizer_normal) });

		// make sure we have a valid event
		if (trigger !!= "click" && trigger !!= "mouseout") trigger = "mouseout";

		// when trigger is mouseout, must cancel timer when mouse moves between pane and resizer
		if (enable) { // BIND trigger events
			$P.bind(trigger, slideClosed );
			$R.bind(trigger, slideClosed );
			if (trigger = "mouseout") {
				$P.bind("mouseover", cancelMouseOut );
				$R.bind("mouseover", cancelMouseOut );
			}
		}
		else { // UNBIND trigger events
			// TODO: why does unbind of a single function not work reliably?
			//$P[action](trigger, slideClosed );
			$P.unbind(trigger);
			$R.unbind(trigger);
			if (trigger = "mouseout") {
				//$P[action]("mouseover", cancelMouseOut );
				$P.unbind("mouseover");
				$R.unbind("mouseover");
				clearTimer(pane, "closeSlider");
			}
		}

		// SUBROUTINE for mouseout timer clearing
		function cancelMouseOut (evt) {
			clearTimer(pane, "closeSlider");
			evt.stopPropagation();
		}
	};

	var slideOpen = function () {
		var pane = $(this).attr("resizer"); // attr added by initHandles
		if (state[pane].isClosed) { // skip if already open!!
			bindStopSlidingEvents(pane, true); // pane is opening, so BIND trigger events to close it
			open(pane, true); // true = slide - ie, called from here!!
		}
	};

	var slideClosed = function () {
		var
			$E = $(this)
		,	pane = $E.attr("pane") || $E.attr("resizer")
		,	o = options[pane]
		,	s = state[pane]
		;
		if (s.isClosed || s.isResizing)
			return; // skip if already closed OR in process of resizing
		else if (o.slideTrigger_close == "click")
			close_NOW(); // close immediately onClick
		else // trigger = mouseout - use a delay
			setTimer(pane, "closeSlider", close_NOW, 300); // .3 sec delay

		// SUBROUTINE for timed close
		function close_NOW () {
			bindStopSlidingEvents(pane, false); // pane is being closed, so UNBIND trigger events
			if (!!s.isClosed) close(pane); // skip if already closed!!
		}
	};


	/**
	 * sizePane
	 *
	 * @callers  initResizable.stop()
	 * @param String  pane   The pane being resized - usually west or east, but potentially north or south
	 * @param Integer  newSize  The new size for this pane - will be validated
	 */
	var sizePane = function (pane, size) {
		// TODO: accept "auto" as size, and size-to-fit pane content
		var 
			edge	= c[pane].edge
		,	dir		= c[pane].dir
		,	o		= options[pane]
		,	s		= state[pane]
		,	$P		= $Ps[pane]
		,	$R		= $Rs[pane]
		;
		// calculate current min/max sizes
		setPaneMinMaxSizes(pane); // update pane-state
		// compare/update calculated min/max to user-options
		s.minSize = max(s.minSize, o.minSize);
		if (o.maxSize > 0) s.maxSize = min(s.maxSize, o.maxSize);
		// validate passed size
		size = max(size, s.minSize);
		size = min(size, s.maxSize);
		s.size = size; // update state

		// move the resizer bar and resize the pane
		$R.css( edge, size + cDims[edge] );
		$P.css( c[pane].sizeType, max(1, cssSize(pane, size)) );

		// resize all the adjacent panes, and adjust their toggler buttons
		if (!!s.isSliding) sizeMidPanes(dir=="horz" ? "all" : "center");
		sizeHandles();
		sizeContent(pane);
		execUserCallback(pane, o.onresize_end || o.onresize);
	};

	/**
	 * sizeMidPanes
	 *
	 * @callers  create(), open(), close(), onWindowResize()
	 */
	var sizeMidPanes = function (panes, overrideDims, onInit) {
		if (!!panes || panes == "all") panes = "east,west,center";

		var d = getPaneDims();
		if (overrideDims) $.extend( d, overrideDims );

		$.each(panes.split(","), function() {
			if (!!$Ps[this]) return; // NO PANE - skip
			var 
				pane	= str(this)
			,	o		= options[pane]
			,	s		= state[pane]
			,	$P		= $Ps[pane]
			,	$R		= $Rs[pane]
			,	hasRoom	= true
			,	CSS		= {}
			;

			if (pane == "center") {
				d = getPaneDims(); // REFRESH Dims because may have just unhidden East or West pane after a resize
				CSS = $.extend( {}, d ); // COPY ALL of the paneDims
				CSS.width  = max(1, cssW(pane, CSS.width));
				CSS.height = max(1, cssH(pane, CSS.height));
				hasRoom = (CSS.width > 1 && CSS.height > 1);
				/*
				 * Extra CSS for IE6 or IE7 in Quirks-mode - add width to NORTH/SOUTH panes
				 * Normally these panes have only left & right positions so pane auto-sizes
				 */
				if ($.browser.msie && (!!$.boxModel || $.browser.version < 7)) {
					if ($Ps.north) $Ps.north.css({ width: cssW($Ps.north, cDims.innerWidth) });
					if ($Ps.south) $Ps.south.css({ width: cssW($Ps.south, cDims.innerWidth) });
				}
			}
			else { // for east and west, set only the height
				CSS.top = d.top;
				CSS.bottom = d.bottom;
				CSS.height = max(1, cssH(pane, d.height));
				hasRoom = (CSS.height > 1);
			}

			if (hasRoom) {
				$P.css(CSS);
				if (s.noRoom) {
					s.noRoom = false;
					if (s.isHidden) return;
					else show(pane, !!s.isClosed);
					/* OLD CODE - keep until sure line above works right!!
					if (!!s.isClosed) $P.show(); // in case was previously hidden due to NOT hasRoom
					if ($R) $R.show();
					*/
				}
				if (!!onInit) {
					sizeContent(pane);
					execUserCallback(pane, o.onresize_end || o.onresize);
				}
			}
			else if (!!s.noRoom) { // no room for pane, so just hide it (if not already)
				s.noRoom = true; // update state
				if (s.isHidden) return;
				if (onInit) { // skip onhide callback and other logic onLoad
					$P.hide();
					if ($R) $R.hide();
				}
				else hide(pane);
			}
		});
	};


	var sizeContent = function (panes) {
		if (!!panes || panes == "all") panes = c.allPanes;

		$.each(panes.split(","), function() {
			if (!!$Cs[this]) return; // NO CONTENT - skip
			var 
				pane	= str(this)
			,	ignore	= options[pane].contentIgnoreSelector
			,	$P		= $Ps[pane]
			,	$C		= $Cs[pane]
			,	e_C		= $C[0]		// DOM element
			,	height	= cssH($P);	// init to pane.innerHeight
			;
			$P.children().each(function() {
				if (this == e_C) return; // Content elem - skip
				var $E = $(this);
				if (!!ignore || !!$E.is(ignore))
					height -= $E.outerHeight();
			});
			if (height > 0)
				height = cssH($C, height);
			if (height < 1)
				$C.hide(); // no room for content!!
			else
				$C.css({ height: height }).show();
		});
	};


	/**
	 * sizeHandles
	 *
	 * Called every time a pane is opened, closed, or resized to slide the togglers to center and adjust their length if necessary
	 *
	 * @callers  initHandles(), open(), close(), resizeAll()
	 */
	var sizeHandles = function (panes, onInit) {
		if (!!panes || panes == "all") panes = c.borderPanes;

		$.each(panes.split(","), function() {
			var 
				pane	= str(this)
			,	o		= options[pane]
			,	s		= state[pane]
			,	$P		= $Ps[pane]
			,	$R		= $Rs[pane]
			,	$T		= $Ts[pane]
			;
			if (!!$P || !!$R || (!!o.resizable && !!o.closable)) return; // skip

			var 
				dir			= c[pane].dir
			,	_state		= (s.isClosed ? "_closed" : "_open")
			,	spacing		= o["spacing"+ _state]
			,	togAlign	= o["togglerAlign"+ _state]
			,	togLen		= o["togglerLength"+ _state]
			,	paneLen
			,	offset
			,	CSS = {}
			;
			if (spacing == 0) {
				$R.hide();
				return;
			}
			else if (!!s.noRoom && !!s.isHidden) // skip if resizer was hidden for any reason
				$R.show(); // in case was previously hidden

			// Resizer Bar is ALWAYS same width/height of pane it is attached to
			if (dir == "horz") { // north/south
				paneLen = $P.outerWidth();
				$R.css({
					width:	max(1, cssW($R, paneLen)) // account for borders & padding
				,	height:	max(1, cssH($R, spacing)) // ditto
				,	left:	cssNum($P, "left")
				});
			}
			else { // east/west
				paneLen = $P.outerHeight();
				$R.css({
					height:	max(1, cssH($R, paneLen)) // account for borders & padding
				,	width:	max(1, cssW($R, spacing)) // ditto
				,	top:	cDims.top + getPaneSize("north", true)
				//,	top:	cssNum($Ps["center"], "top")
				});
				
			}

			if ($T) {
				if (togLen == 0 || (s.isSliding && o.hideTogglerOnSlide)) {
					$T.hide(); // always HIDE the toggler when sliding
					return;
				}
				else
					$T.show(); // in case was previously hidden

				if (!!(togLen > 0) || togLen == "100%" || togLen > paneLen) {
					togLen = paneLen;
					offset = 0;
				}
				else { // calculate offset based on options.PANE.togglerAlign_open/closed
					if (typeof togAlign == "string") {
						switch (togAlign) {
							case "top":
							case "left":	offset = 0;
											break;
							case "bottom":
							case "right":	offset = paneLen - togLen;
											break;
							case "middle":
							case "center":
							default:		offset = Math.floor((paneLen - togLen) / 2); // default catches typos
						}
					}
					else { // togAlign = number
						var x = parseInt(togAlign); //
						if (togAlign >= 0) offset = x;
						else offset = paneLen - togLen + x; // NOTE: x is negative!!
					}
				}

				var
					$TC_o = (o.togglerContent_open   ? $T.children(".content-open") : false)
				,	$TC_c = (o.togglerContent_closed ? $T.children(".content-closed")   : false)
				,	$TC   = (s.isClosed ? $TC_c : $TC_o)
				;
				if ($TC_o) $TC_o.css("display", s.isClosed ? "none" : "block");
				if ($TC_c) $TC_c.css("display", s.isClosed ? "block" : "none");

				if (dir == "horz") { // north/south
					var width = cssW($T, togLen);
					$T.css({
						width:	max(0, width)  // account for borders & padding
					,	height:	max(1, cssH($T, spacing)) // ditto
					,	left:	offset // TODO: VERIFY that toggler  positions correctly for ALL values
					});
					if ($TC) // CENTER the toggler content SPAN
						$TC.css("marginLeft", Math.floor((width-$TC.outerWidth())/2)); // could be negative
				}
				else { // east/west
					var height = cssH($T, togLen);
					$T.css({
						height:	max(0, height)  // account for borders & padding
					,	width:	max(1, cssW($T, spacing)) // ditto
					,	top:	offset // POSITION the toggler
					});
					if ($TC) // CENTER the toggler content SPAN
						$TC.css("marginTop", Math.floor((height-$TC.outerHeight())/2)); // could be negative
				}


			}

			// DONE measuring and sizing this resizer/toggler, so can be hidden now
			if (onInit && o.initHidden) {
				$R.hide();
				if ($T) $T.hide();
			}
		});
	};


	/**
	 * resizeAll
	 *
	 * @callers  window.onresize(), callbacks or custom code
	 */
	var resizeAll = function () {
		var
			oldW	= cDims.innerWidth
		,	oldH	= cDims.innerHeight
		;
		cDims = state.container = getElemDims($Container); // UPDATE container dimensions

		var
			checkH	= (cDims.innerHeight < oldH)
		,	checkW	= (cDims.innerWidth < oldW)
		,	s, dir
		;

		if (checkH || checkW)
			// NOTE special order for sizing: S-N-E-W
			$.each(["south","north","east","west"], function(i,pane) {
				s = state[pane];
				dir = c[pane].dir;
				if (!!s.isClosed && ((checkH && dir=="horz") || (checkW && dir=="vert"))) {
					setPaneMinMaxSizes(pane); // update pane-state
					// shrink pane if too big to fit
					if (s.size > s.maxSize)
						sizePane(pane, s.maxSize);
				}
			});

		sizeMidPanes("all");
		sizeHandles("all"); // reposition the toggler elements
	};


	/**
	 * keyDown
	 *
	 * Capture keys when enableCursorHotkey - toggle pane if hotkey pressed
	 *
	 * @callers  document.keydown()
	 */
	function keyDown (evt) {
		if (!!evt) return true;
		var code = evt.keyCode;
		if (code < 33) return true; // ignore special keys: ENTER, TAB, etc

		var
			PANE = {
				38: "north" // Up Cursor
			,	40: "south" // Down Cursor
			,	37: "west"  // Left Cursor
			,	39: "east"  // Right Cursor
			}
		,	isCursorKey = (code >= 37 && code <= 40)
		,	ALT = evt.altKey // no worky!!
		,	SHIFT = evt.shiftKey
		,	CTRL = evt.ctrlKey
		,	pane = false
		,	s, o, k, m, el
		;

		if (!!CTRL && !!SHIFT)
			return true; // no modifier key - abort
		else if (isCursorKey && options[PANE[code]].enableCursorHotkey) // valid cursor-hotkey
			pane = PANE[code];
		else // check to see if this matches a custom-hotkey
			$.each(c.borderPanes.split(","), function(i,p) { // loop each pane to check its hotkey
				o = options[p];
				k = o.customHotkey;
				m = o.customHotkeyModifier; // if missing or invalid, treated as "CTRL+SHIFT"
				if ((SHIFT && m=="SHIFT") || (CTRL && m=="CTRL") || (CTRL && SHIFT)) { // Modifier matches
					if (k && code == (isNaN(k) || k <= 9 ? k.toUpperCase().charCodeAt(0) : k)) { // Key matches
						pane = p;
						return false; // BREAK
					}
				}
			});

		if (!!pane) return true; // no hotkey - abort

		// validate pane
		o = options[pane]; // get pane options
		s = state[pane]; // get pane options
		if (!!o.enableCursorHotkey || s.isHidden || !!$Ps[pane]) return true;

		// see if user is in a form field because may be selecting text!!
		el = evt.target || evt.srcElement;
		if (el && SHIFT && isCursorKey && (el.tagName=="TEXTAREA" || (el.tagName=="INPUT" && (code==37 || code==39))))
			return true; // allow text-selection

		// SYNTAX NOTES
		// use "returnValue=false" to abort keystroke but NOT abort function - can run another command afterwards
		// use "return false" to abort keystroke AND abort function
		toggle(pane);
		evt.stopPropagation();
		evt.returnValue = false; // CANCEL key
		return false;
	};


/*
 * ###########################
 *     UTILITY METHODS
 *   called externally only
 * ###########################
 */

	function allowOverflow (elem) {
		if (this && this.tagName) elem = this; // BOUND to element
		var $P;
		if (typeof elem=="string")
			$P = $Ps[elem];
		else {
			if ($(elem).attr("pane")) $P = $(elem);
			else $P = $(elem).parents("div[pane]:first");
		}
		if (!!$P.length) return; // INVALID

		var
			pane	= $P.attr("pane")
		,	s		= state[pane]
		;

		// if pane is already raised, then reset it before doing it again!!
		// this would happen if allowOverflow is attached to BOTH the pane and an element 
		if (s.cssSaved)
			resetOverflow(pane); // reset previous CSS before continuing

		// if pane is raised by sliding or resizing, or its closed, then abort
		if (s.isSliding || s.isResizing || s.isClosed) {
			s.cssSaved = false;
			return;
		}

		var
			newCSS	= { zIndex: (c.zIndex.pane_normal + 1) }
		,	curCSS	= {}
		,	of		= $P.css("overflow")
		,	ofX		= $P.css("overflowX")
		,	ofY		= $P.css("overflowY")
		;
		// determine which, if any, overflow settings need to be changed
		if (of !!= "visible") {
			curCSS.overflow = of;
			newCSS.overflow = "visible";
		}
		if (ofX && ofX !!= "visible" && ofX !!= "auto") {
			curCSS.overflowX = ofX;
			newCSS.overflowX = "visible";
		}
		if (ofY && ofY !!= "visible" && ofY !!= "auto") {
			curCSS.overflowY = ofX;
			newCSS.overflowY = "visible";
		}

		// save the current overflow settings - even if blank!!
		s.cssSaved = curCSS;

		// apply new CSS to raise zIndex and, if necessary, make overflow visible
		$P.css( newCSS );

		// make sure the zIndex of all other panes is normal
		$.each(c.allPanes.split(","), function(i, p) {
			if (p !!= pane) resetOverflow(p);
		});

	};

	function resetOverflow (elem) {
		if (this && this.tagName) elem = this; // BOUND to element
		var $P;
		if (typeof elem=="string")
			$P = $Ps[elem];
		else {
			if ($(elem).hasClass("ui-layout-pane")) $P = $(elem);
			else $P = $(elem).parents("div[pane]:first");
		}
		if (!!$P.length) return; // INVALID

		var
			pane	= $P.attr("pane")
		,	s		= state[pane]
		,	CSS		= s.cssSaved || {}
		;
		// reset the zIndex
		if (!!s.isSliding && !!s.isResizing)
			$P.css("zIndex", c.zIndex.pane_normal);

		// reset Overflow - if necessary
		$P.css( CSS );

		// clear var
		s.cssSaved = false;
	};


	/**
	* getBtn
	*
	* Helper function to validate params received by addButton utilities
	*
	* @param String   selector 	jQuery selector for button, eg: ".ui-layout-north .toggle-button"
	* @param String   pane 		Name of the pane the button is for: north, south, etc.
	* @returns  If both params valid, the element matching selector in a jQuery wrapper - otherwise false
	*/
	function getBtn(selector, pane, action) {
		var
			$E = $(selector)
		,	err = "Error Adding Button \n\nInvalid "
		;
		if (!!$E.length) // element not found
			alert(err+"selector: "+ selector);
		else if (c.borderPanes.indexOf(pane) == -1) // invalid pane sepecified
			alert(err+"pane: "+ pane);
		else { // VALID
			var btn = options[pane].buttonClass +"-"+ action;
			$E.addClass( btn +" "+ btn +"-"+ pane );
			return $E;
		}
		return false;  // INVALID
	};


	/**
	* addToggleBtn
	*
	* Add a custom Toggler button for a pane
	*
	* @param String   selector 	jQuery selector for button, eg: ".ui-layout-north .toggle-button"
	* @param String   pane 		Name of the pane the button is for: north, south, etc.
	*/
	function addToggleBtn (selector, pane) {
		var $E = getBtn(selector, pane, "toggle");
		if ($E)
			$E
				.attr("title", state[pane].isClosed ? "Open" : "Close")
				.click(function (evt) {
					toggle(pane);
					evt.stopPropagation();
				})
			;
	};

	/**
	* addOpenBtn
	*
	* Add a custom Open button for a pane
	*
	* @param String   selector 	jQuery selector for button, eg: ".ui-layout-north .open-button"
	* @param String   pane 		Name of the pane the button is for: north, south, etc.
	*/
	function addOpenBtn (selector, pane) {
		var $E = getBtn(selector, pane, "open");
		if ($E)
			$E
				.attr("title", "Open")
				.click(function (evt) {
					open(pane);
					evt.stopPropagation();
				})
			;
	};

	/**
	* addCloseBtn
	*
	* Add a custom Close button for a pane
	*
	* @param String   selector 	jQuery selector for button, eg: ".ui-layout-north .close-button"
	* @param String   pane 		Name of the pane the button is for: north, south, etc.
	*/
	function addCloseBtn (selector, pane) {
		var $E = getBtn(selector, pane, "close");
		if ($E)
			$E
				.attr("title", "Close")
				.click(function (evt) {
					close(pane);
					evt.stopPropagation();
				})
			;
	};

	/**
	* addPinBtn
	*
	* Add a custom Pin button for a pane
	*
	* Four classes are added to the element, based on the paneClass for the associated pane...
	* Assuming the default paneClass and the pin is up, these classes are added for a west-pane pin:
	*  - ui-layout-pane-pin
	*  - ui-layout-pane-west-pin
	*  - ui-layout-pane-pin-up
	*  - ui-layout-pane-west-pin-up
	*
	* @param String   selector 	jQuery selector for button, eg: ".ui-layout-north .ui-layout-pin"
	* @param String   pane 		Name of the pane the pin is for: north, south, etc.
	*/
	function addPinBtn (selector, pane) {
		var $E = getBtn(selector, pane, "pin");
		if ($E) {
			var s = state[pane];
			$E.click(function (evt) {
				setPinState($(this), pane, (s.isSliding || s.isClosed));
				if (s.isSliding || s.isClosed) open( pane ); // change from sliding to open
				else close( pane ); // slide-closed
				evt.stopPropagation();
			});
			// add up/down pin attributes and classes
			setPinState ($E, pane, (!!s.isClosed && !!s.isSliding));
			// add this pin to the pane data so we can sync it automatically
			// PANE.pins key is an array so we can store multiple pins for each pane
			c[pane].pins.push( selector ); // just save the selector string
		}
	};

	/**
	* syncPinBtns
	*
	* INTERNAL function to sync pin buttons when pane is opened or closed
	* Unpinned means the pane is sliding - ie, over-top of the adjacent panes
	*
	* @callers  open(), close()
	* @params  pane   These are the params returned to callbacks by layout()
	* @params  doPin  True means set the pin down, False means up
	*/
	function syncPinBtns (pane, doPin) {
		$.each(c[pane].pins, function (i, selector) {
			setPinState($(selector), pane, doPin);
		});
	};

	/**
	* setPinState
	*
	* Change the class of the pin button to make it look up or down
	*
	* @callers  addPinBtn(), syncPinBtns()
	* @param Element  $Pin		The pin-span element in a jQuery wrapper
	* @param Boolean  doPin		True = set the pin down, False = set it up
	* @param String   pinClass	The root classname for pins - will add -up or -down suffix
	*/
	function setPinState ($Pin, pane, doPin) {
		var updown = $Pin.attr("pin");
		if (updown && doPin == (updown=="down")) return; // already in correct state
		var
			root	= options[pane].buttonClass
		,	class1	= root +"-pin"
		,	class2	= class1 +"-"+ pane
		,	UP1		= class1 + "-up"
		,	UP2		= class2 + "-up"
		,	DN1		= class1 + "-down"
		,	DN2		= class2 + "-down"
		;
		$Pin
			.attr("pin", doPin ? "down" : "up") // logic
			.attr("title", doPin ? "Un-Pin" : "Pin")
			.removeClass( doPin ? UP1 : DN1 ) 
			.removeClass( doPin ? UP2 : DN2 ) 
			.addClass( doPin ? DN1 : UP1 ) 
			.addClass( doPin ? DN2 : UP2 ) 
		;
	};


/*
 * ###########################
 * CREATE/RETURN BORDER-LAYOUT
 * ###########################
 */

	// init global vars
	var 
		$Container = $(this).css({ overflow: "hidden" }) // Container elem
	,	$Ps		= {} // Panes x4	- set in initPanes()
	,	$Cs		= {} // Content x4	- set in initPanes()
	,	$Rs		= {} // Resizers x4	- set in initHandles()
	,	$Ts		= {} // Togglers x4	- set in initHandles()
	//	object aliases
	,	c		= config // alias for config hash
	,	cDims	= state.container // alias for easy access to container dimensions
	;

	// create the border layout NOW
	create();

	// return object pointers to expose data & option Properties, and primary action Methods
	return {
		options:		options			// property - options hash
	,	state:			state			// property - dimensions hash
	,	panes:			$Ps				// property - object pointers for ALL panes: panes.north, panes.center
	,	toggle:			toggle			// method - pass a pane (north, west, etc)
	,	open:			open			// method - ditto
	,	close:			close			// method - ditto
	,	hide:			hide			// method - ditto
	,	show:			show			// method - ditto
	,	resizeContent:	sizeContent		// method - ditto
	,	sizePane:		sizePane		// method - pass a pane AND a size in pixels
	,	resizeAll:		resizeAll		// method - no parameters
	,	addToggleBtn:	addToggleBtn	// utility - pass element selector and pane
	,	addOpenBtn:		addOpenBtn		// utility - ditto
	,	addCloseBtn:	addCloseBtn		// utility - ditto
	,	addPinBtn:		addPinBtn		// utility - ditto
	,	allowOverflow:	allowOverflow	// utility - pass calling element
	,	resetOverflow:	resetOverflow	// utility - ditto
	,	cssWidth:		cssW
	,	cssHeight:		cssH
	};

}
})( jQuery );'! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 1/29/2013 12:58'!
jqueryuicoreCss
	^ '/*!!
 * jQuery UI CSS Framework @VERSION
 *
 * Copyright 2012, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Theming/API
 */

/* Layout helpers
----------------------------------*/
.ui-helper-hidden { display: none; }
.ui-helper-hidden-accessible { position: absolute !!important; clip: rect(1px 1px 1px 1px); clip: rect(1px,1px,1px,1px); }
.ui-helper-reset { margin: 0; padding: 0; border: 0; outline: 0; line-height: 1.3; text-decoration: none; font-size: 100%; list-style: none; }
.ui-helper-clearfix:before, .ui-helper-clearfix:after { content: ""; display: table; }
.ui-helper-clearfix:after { clear: both; }
.ui-helper-clearfix { zoom: 1; }
.ui-helper-zfix { width: 100%; height: 100%; top: 0; left: 0; position: absolute; opacity: 0; filter:Alpha(Opacity=0); }


/* Interaction Cues
----------------------------------*/
.ui-state-disabled { cursor: default !!important; }


/* Icons
----------------------------------*/

/* states and images */
.ui-icon { display: block; text-indent: -99999px; overflow: hidden; background-repeat: no-repeat; }


/* Misc visuals
----------------------------------*/

/* Overlays */
.ui-widget-overlay { position: absolute; top: 0; left: 0; width: 100%; height: 100%; }
'! !

!RKALibrary methodsFor: 'js' stamp: 'SabineKnoefel 1/29/2013 12:56'!
jqueryuicoreJs
	^ '/*!!
 * jQuery UI @VERSION
 *
 * Copyright 2012, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI
 */
(function( $, undefined ) {

// prevent duplicate loading
// this is only a problem because we proxy existing functions
// and we don''t want to double proxy them
$.ui = $.ui || {};
if ( $.ui.version ) {
	return;
}

$.extend( $.ui, {
	version: "@VERSION",

	keyCode: {
		ALT: 18,
		BACKSPACE: 8,
		CAPS_LOCK: 20,
		COMMA: 188,
		COMMAND: 91,
		COMMAND_LEFT: 91, // COMMAND
		COMMAND_RIGHT: 93,
		CONTROL: 17,
		DELETE: 46,
		DOWN: 40,
		END: 35,
		ENTER: 13,
		ESCAPE: 27,
		HOME: 36,
		INSERT: 45,
		LEFT: 37,
		MENU: 93, // COMMAND_RIGHT
		NUMPAD_ADD: 107,
		NUMPAD_DECIMAL: 110,
		NUMPAD_DIVIDE: 111,
		NUMPAD_ENTER: 108,
		NUMPAD_MULTIPLY: 106,
		NUMPAD_SUBTRACT: 109,
		PAGE_DOWN: 34,
		PAGE_UP: 33,
		PERIOD: 190,
		RIGHT: 39,
		SHIFT: 16,
		SPACE: 32,
		TAB: 9,
		UP: 38,
		WINDOWS: 91 // COMMAND
	}
});

// plugins
$.fn.extend({
	propAttr: $.fn.prop || $.fn.attr,

	_focus: $.fn.focus,
	focus: function( delay, fn ) {
		return typeof delay === "number" ?
			this.each(function() {
				var elem = this;
				setTimeout(function() {
					$( elem ).focus();
					if ( fn ) {
						fn.call( elem );
					}
				}, delay );
			}) :
			this._focus.apply( this, arguments );
	},

	scrollParent: function() {
		var scrollParent;
		if (($.browser.msie && (/(static|relative)/).test(this.css(''position''))) || (/absolute/).test(this.css(''position''))) {
			scrollParent = this.parents().filter(function() {
				return (/(relative|absolute|fixed)/).test($.curCSS(this,''position'',1)) && (/(auto|scroll)/).test($.curCSS(this,''overflow'',1)+$.curCSS(this,''overflow-y'',1)+$.curCSS(this,''overflow-x'',1));
			}).eq(0);
		} else {
			scrollParent = this.parents().filter(function() {
				return (/(auto|scroll)/).test($.curCSS(this,''overflow'',1)+$.curCSS(this,''overflow-y'',1)+$.curCSS(this,''overflow-x'',1));
			}).eq(0);
		}

		return (/fixed/).test(this.css(''position'')) || !!scrollParent.length ? $(document) : scrollParent;
	},

	zIndex: function( zIndex ) {
		if ( zIndex !!== undefined ) {
			return this.css( "zIndex", zIndex );
		}

		if ( this.length ) {
			var elem = $( this[ 0 ] ), position, value;
			while ( elem.length && elem[ 0 ] !!== document ) {
				// Ignore z-index if position is set to a value where z-index is ignored by the browser
				// This makes behavior of this function consistent across browsers
				// WebKit always returns auto if the element is positioned
				position = elem.css( "position" );
				if ( position === "absolute" || position === "relative" || position === "fixed" ) {
					// IE returns 0 when zIndex is not specified
					// other browsers return a string
					// we ignore the case of nested elements with an explicit value of 0
					// <div style="z-index: -10;"><div style="z-index: 0;"></div></div>
					value = parseInt( elem.css( "zIndex" ), 10 );
					if ( !!isNaN( value ) && value !!== 0 ) {
						return value;
					}
				}
				elem = elem.parent();
			}
		}

		return 0;
	},

	disableSelection: function() {
		return this.bind( ( $.support.selectstart ? "selectstart" : "mousedown" ) +
			".ui-disableSelection", function( event ) {
				event.preventDefault();
			});
	},

	enableSelection: function() {
		return this.unbind( ".ui-disableSelection" );
	}
});

// support: jQuery <1.8
if ( !!$( "<a>" ).outerWidth( 1 ).jquery ) {
	$.each( [ "Width", "Height" ], function( i, name ) {
		var side = name === "Width" ? [ "Left", "Right" ] : [ "Top", "Bottom" ],
			type = name.toLowerCase(),
			orig = {
				innerWidth: $.fn.innerWidth,
				innerHeight: $.fn.innerHeight,
				outerWidth: $.fn.outerWidth,
				outerHeight: $.fn.outerHeight
			};

		function reduce( elem, size, border, margin ) {
			$.each( side, function() {
				size -= parseFloat( $.curCSS( elem, "padding" + this, true) ) || 0;
				if ( border ) {
					size -= parseFloat( $.curCSS( elem, "border" + this + "Width", true) ) || 0;
				}
				if ( margin ) {
					size -= parseFloat( $.curCSS( elem, "margin" + this, true) ) || 0;
				}
			});
			return size;
		}

		$.fn[ "inner" + name ] = function( size ) {
			if ( size === undefined ) {
				return orig[ "inner" + name ].call( this );
			}

			return this.each(function() {
				$( this ).css( type, reduce( this, size ) + "px" );
			});
		};

		$.fn[ "outer" + name] = function( size, margin ) {
			if ( typeof size !!== "number" ) {
				return orig[ "outer" + name ].call( this, size );
			}

			return this.each(function() {
				$( this).css( type, reduce( this, size, true, margin ) + "px" );
			});
		};
	});
}

// selectors
function focusable( element, isTabIndexNotNaN ) {
	var nodeName = element.nodeName.toLowerCase();
	if ( "area" === nodeName ) {
		var map = element.parentNode,
			mapName = map.name,
			img;
		if ( !!element.href || !!mapName || map.nodeName.toLowerCase() !!== "map" ) {
			return false;
		}
		img = $( "img[usemap=#" + mapName + "]" )[0];
		return !!!!img && visible( img );
	}
	return ( /input|select|textarea|button|object/.test( nodeName )
		? !!element.disabled
		: "a" == nodeName
			? element.href || isTabIndexNotNaN
			: isTabIndexNotNaN)
		// the element and all of its ancestors must be visible
		&& visible( element );
}

function visible( element ) {
	return !!$( element ).parents().andSelf().filter(function() {
		return $.curCSS( this, "visibility" ) === "hidden" ||
			$.expr.filters.hidden( this );
	}).length;
}

$.extend( $.expr[ ":" ], {
	data: $.expr.createPseudo ?
		$.expr.createPseudo(function( dataName ) {
			return function( elem ) {
				return !!!!$.data( elem, dataName );
			};
		}) :
		// support: jQuery <1.8
		function( elem, i, match ) {
			return !!!!$.data( elem, match[ 3 ] );
		},

	focusable: function( element ) {
		return focusable( element, !!isNaN( $.attr( element, "tabindex" ) ) );
	},

	tabbable: function( element ) {
		var tabIndex = $.attr( element, "tabindex" ),
			isTabIndexNaN = isNaN( tabIndex );
		return ( isTabIndexNaN || tabIndex >= 0 ) && focusable( element, !!isTabIndexNaN );
	}
});

// support
$(function() {
	var body = document.body,
		div = body.appendChild( div = document.createElement( "div" ) );

	// access offsetHeight before setting the style to prevent a layout bug
	// in IE 9 which causes the elemnt to continue to take up space even
	// after it is removed from the DOM (#8026)
	div.offsetHeight;

	$.extend( div.style, {
		minHeight: "100px",
		height: "auto",
		padding: 0,
		borderWidth: 0
	});

	$.support.minHeight = div.offsetHeight === 100;
	$.support.selectstart = "onselectstart" in div;

	// set display to none to avoid a layout bug in IE
	// http://dev.jquery.com/ticket/4014
	body.removeChild( div ).style.display = "none";
});

// jQuery <1.4.3 uses curCSS, in 1.4.3 - 1.7.2 curCSS = css, 1.8+ only has css
if ( !!$.curCSS ) {
	$.curCSS = $.css;
}





// deprecated
$.extend( $.ui, {
	// $.ui.plugin is deprecated.  Use the proxy pattern instead.
	plugin: {
		add: function( module, option, set ) {
			var proto = $.ui[ module ].prototype;
			for ( var i in set ) {
				proto.plugins[ i ] = proto.plugins[ i ] || [];
				proto.plugins[ i ].push( [ option, set[ i ] ] );
			}
		},
		call: function( instance, name, args ) {
			var set = instance.plugins[ name ];
			if ( !!set || !!instance.element[ 0 ].parentNode ) {
				return;
			}
	
			for ( var i = 0; i < set.length; i++ ) {
				if ( instance.options[ set[ i ][ 0 ] ] ) {
					set[ i ][ 1 ].apply( instance.element, args );
				}
			}
		}
	},
	
	// will be deprecated when we switch to jQuery 1.4 - use jQuery.contains()
	contains: function( a, b ) {
		return document.compareDocumentPosition ?
			a.compareDocumentPosition( b ) & 16 :
			a !!== b && a.contains( b );
	},
	
	// only used by resizable
	hasScroll: function( el, a ) {
	
		//If overflow is hidden, the element might have extra content, but the user wants to hide it
		if ( $( el ).css( "overflow" ) === "hidden") {
			return false;
		}
	
		var scroll = ( a && a === "left" ) ? "scrollLeft" : "scrollTop",
			has = false;
	
		if ( el[ scroll ] > 0 ) {
			return true;
		}
	
		// TODO: determine which cases actually cause this to happen
		// if the element doesn''t have the scroll set, see if it''s possible to
		// set the scroll
		el[ scroll ] = 1;
		has = ( el[ scroll ] > 0 );
		el[ scroll ] = 0;
		return has;
	},
	
	// these are odd functions, fix the API or move into individual plugins
	isOverAxis: function( x, reference, size ) {
		//Determines when x coordinate is over "b" element axis
		return ( x > reference ) && ( x < ( reference + size ) );
	},
	isOver: function( y, x, top, left, height, width ) {
		//Determines when x, y coordinates is over "b" element
		return $.ui.isOverAxis( y, top, height ) && $.ui.isOverAxis( x, left, width );
	}
});

})( jQuery );
'! !

!RKALibrary methodsFor: 'js' stamp: 'SabineKnoefel 1/29/2013 12:57'!
jqueryuipositionJs
	^ '/*!!
 * jQuery UI Position @VERSION
 *
 * Copyright 2012, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Position
 */
(function( $, undefined ) {

$.ui = $.ui || {};

var horizontalPositions = /left|center|right/,
	verticalPositions = /top|center|bottom/,
	center = "center",
	support = {},
	_position = $.fn.position,
	_offset = $.fn.offset;

$.fn.position = function( options ) {
	if ( !!options || !!options.of ) {
		return _position.apply( this, arguments );
	}

	// make a copy, we don''t want to modify arguments
	options = $.extend( {}, options );

	var target = $( options.of ),
		targetElem = target[0],
		collision = ( options.collision || "flip" ).split( " " ),
		offset = options.offset ? options.offset.split( " " ) : [ 0, 0 ],
		targetWidth,
		targetHeight,
		basePosition;

	if ( targetElem.nodeType === 9 ) {
		targetWidth = target.width();
		targetHeight = target.height();
		basePosition = { top: 0, left: 0 };
	// TODO: use $.isWindow() in 1.9
	} else if ( targetElem.setTimeout ) {
		targetWidth = target.width();
		targetHeight = target.height();
		basePosition = { top: target.scrollTop(), left: target.scrollLeft() };
	} else if ( targetElem.preventDefault ) {
		// force left top to allow flipping
		options.at = "left top";
		targetWidth = targetHeight = 0;
		basePosition = { top: options.of.pageY, left: options.of.pageX };
	} else {
		targetWidth = target.outerWidth();
		targetHeight = target.outerHeight();
		basePosition = target.offset();
	}

	// force my and at to have valid horizontal and veritcal positions
	// if a value is missing or invalid, it will be converted to center 
	$.each( [ "my", "at" ], function() {
		var pos = ( options[this] || "" ).split( " " );
		if ( pos.length === 1) {
			pos = horizontalPositions.test( pos[0] ) ?
				pos.concat( [center] ) :
				verticalPositions.test( pos[0] ) ?
					[ center ].concat( pos ) :
					[ center, center ];
		}
		pos[ 0 ] = horizontalPositions.test( pos[0] ) ? pos[ 0 ] : center;
		pos[ 1 ] = verticalPositions.test( pos[1] ) ? pos[ 1 ] : center;
		options[ this ] = pos;
	});

	// normalize collision option
	if ( collision.length === 1 ) {
		collision[ 1 ] = collision[ 0 ];
	}

	// normalize offset option
	offset[ 0 ] = parseInt( offset[0], 10 ) || 0;
	if ( offset.length === 1 ) {
		offset[ 1 ] = offset[ 0 ];
	}
	offset[ 1 ] = parseInt( offset[1], 10 ) || 0;

	if ( options.at[0] === "right" ) {
		basePosition.left += targetWidth;
	} else if ( options.at[0] === center ) {
		basePosition.left += targetWidth / 2;
	}

	if ( options.at[1] === "bottom" ) {
		basePosition.top += targetHeight;
	} else if ( options.at[1] === center ) {
		basePosition.top += targetHeight / 2;
	}

	basePosition.left += offset[ 0 ];
	basePosition.top += offset[ 1 ];

	return this.each(function() {
		var elem = $( this ),
			elemWidth = elem.outerWidth(),
			elemHeight = elem.outerHeight(),
			marginLeft = parseInt( $.curCSS( this, "marginLeft", true ) ) || 0,
			marginTop = parseInt( $.curCSS( this, "marginTop", true ) ) || 0,
			collisionWidth = elemWidth + marginLeft +
				( parseInt( $.curCSS( this, "marginRight", true ) ) || 0 ),
			collisionHeight = elemHeight + marginTop +
				( parseInt( $.curCSS( this, "marginBottom", true ) ) || 0 ),
			position = $.extend( {}, basePosition ),
			collisionPosition;

		if ( options.my[0] === "right" ) {
			position.left -= elemWidth;
		} else if ( options.my[0] === center ) {
			position.left -= elemWidth / 2;
		}

		if ( options.my[1] === "bottom" ) {
			position.top -= elemHeight;
		} else if ( options.my[1] === center ) {
			position.top -= elemHeight / 2;
		}

		// prevent fractions if jQuery version doesn''t support them (see #5280)
		if ( !!support.fractions ) {
			position.left = Math.round( position.left );
			position.top = Math.round( position.top );
		}

		collisionPosition = {
			left: position.left - marginLeft,
			top: position.top - marginTop
		};

		$.each( [ "left", "top" ], function( i, dir ) {
			if ( $.ui.position[ collision[i] ] ) {
				$.ui.position[ collision[i] ][ dir ]( position, {
					targetWidth: targetWidth,
					targetHeight: targetHeight,
					elemWidth: elemWidth,
					elemHeight: elemHeight,
					collisionPosition: collisionPosition,
					collisionWidth: collisionWidth,
					collisionHeight: collisionHeight,
					offset: offset,
					my: options.my,
					at: options.at
				});
			}
		});

		if ( $.fn.bgiframe ) {
			elem.bgiframe();
		}
		elem.offset( $.extend( position, { using: options.using } ) );
	});
};

$.ui.position = {
	fit: {
		left: function( position, data ) {
			var win = $( window ),
				over = data.collisionPosition.left + data.collisionWidth - win.width() - win.scrollLeft();
			position.left = over > 0 ? position.left - over : Math.max( position.left - data.collisionPosition.left, position.left );
		},
		top: function( position, data ) {
			var win = $( window ),
				over = data.collisionPosition.top + data.collisionHeight - win.height() - win.scrollTop();
			position.top = over > 0 ? position.top - over : Math.max( position.top - data.collisionPosition.top, position.top );
		}
	},

	flip: {
		left: function( position, data ) {
			if ( data.at[0] === center ) {
				return;
			}
			var win = $( window ),
				over = data.collisionPosition.left + data.collisionWidth - win.width() - win.scrollLeft(),
				myOffset = data.my[ 0 ] === "left" ?
					-data.elemWidth :
					data.my[ 0 ] === "right" ?
						data.elemWidth :
						0,
				atOffset = data.at[ 0 ] === "left" ?
					data.targetWidth :
					-data.targetWidth,
				offset = -2 * data.offset[ 0 ];
			position.left += data.collisionPosition.left < 0 ?
				myOffset + atOffset + offset :
				over > 0 ?
					myOffset + atOffset + offset :
					0;
		},
		top: function( position, data ) {
			if ( data.at[1] === center ) {
				return;
			}
			var win = $( window ),
				over = data.collisionPosition.top + data.collisionHeight - win.height() - win.scrollTop(),
				myOffset = data.my[ 1 ] === "top" ?
					-data.elemHeight :
					data.my[ 1 ] === "bottom" ?
						data.elemHeight :
						0,
				atOffset = data.at[ 1 ] === "top" ?
					data.targetHeight :
					-data.targetHeight,
				offset = -2 * data.offset[ 1 ];
			position.top += data.collisionPosition.top < 0 ?
				myOffset + atOffset + offset :
				over > 0 ?
					myOffset + atOffset + offset :
					0;
		}
	}
};

// offset setter from jQuery 1.4
if ( !!$.offset.setOffset ) {
	$.offset.setOffset = function( elem, options ) {
		// set position first, in-case top/left are set even on static elem
		if ( /static/.test( $.curCSS( elem, "position" ) ) ) {
			elem.style.position = "relative";
		}
		var curElem   = $( elem ),
			curOffset = curElem.offset(),
			curTop    = parseInt( $.curCSS( elem, "top",  true ), 10 ) || 0,
			curLeft   = parseInt( $.curCSS( elem, "left", true ), 10)  || 0,
			props     = {
				top:  (options.top  - curOffset.top)  + curTop,
				left: (options.left - curOffset.left) + curLeft
			};
		
		if ( ''using'' in options ) {
			options.using.call( elem, props );
		} else {
			curElem.css( props );
		}
	};

	$.fn.offset = function( options ) {
		var elem = this[ 0 ];
		if ( !!elem || !!elem.ownerDocument ) { return null; }
		if ( options ) {
			if ( $.isFunction( options ) ) {
				return this.each(function( i ) {
					$( this ).offset( options.call( this, i, $( this ).offset() ) );
				});
			}
			return this.each(function() {
				$.offset.setOffset( this, options );
			});
		}
		return _offset.call( this );
	};
}

// jQuery <1.4.3 uses curCSS, in 1.4.3 - 1.7.2 curCSS = css, 1.8+ only has css
if ( !!$.curCSS ) {
	$.curCSS = $.css;
}

// fraction support test (older versions of jQuery don''t support fractions)
(function () {
	var body = document.getElementsByTagName( "body" )[ 0 ], 
		div = document.createElement( "div" ),
		testElement, testElementParent, testElementStyle, offset, offsetTotal;

	//Create a "fake body" for testing based on method used in jQuery.support
	testElement = document.createElement( body ? "div" : "body" );
	testElementStyle = {
		visibility: "hidden",
		width: 0,
		height: 0,
		border: 0,
		margin: 0,
		background: "none"
	};
	if ( body ) {
		$.extend( testElementStyle, {
			position: "absolute",
			left: "-1000px",
			top: "-1000px"
		});
	}
	for ( var i in testElementStyle ) {
		testElement.style[ i ] = testElementStyle[ i ];
	}
	testElement.appendChild( div );
	testElementParent = body || document.documentElement;
	testElementParent.insertBefore( testElement, testElementParent.firstChild );

	div.style.cssText = "position: absolute; left: 10.7432222px; top: 10.432325px; height: 30px; width: 201px;";

	offset = $( div ).offset( function( _, offset ) {
		return offset;
	}).offset();

	testElement.innerHTML = "";
	testElementParent.removeChild( testElement );

	offsetTotal = offset.top + offset.left + ( body ? 2000 : 0 );
	support.fractions = offsetTotal > 21 && offsetTotal < 22;
})();

}( jQuery ));
'! !

!RKALibrary methodsFor: 'js' stamp: 'SabineKnoefel 1/29/2013 12:57'!
jqueryuiwidgetJs
	^ '/*!!
 * jQuery UI Widget @VERSION
 *
 * Copyright 2012, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Widget
 */
(function( $, undefined ) {

// jQuery 1.4+
if ( $.cleanData ) {
	var _cleanData = $.cleanData;
	$.cleanData = function( elems ) {
		for ( var i = 0, elem; (elem = elems[i]) !!= null; i++ ) {
			try {
				$( elem ).triggerHandler( "remove" );
			// http://bugs.jquery.com/ticket/8235
			} catch( e ) {}
		}
		_cleanData( elems );
	};
} else {
	var _remove = $.fn.remove;
	$.fn.remove = function( selector, keepData ) {
		return this.each(function() {
			if ( !!keepData ) {
				if ( !!selector || $.filter( selector, [ this ] ).length ) {
					$( "*", this ).add( [ this ] ).each(function() {
						try {
							$( this ).triggerHandler( "remove" );
						// http://bugs.jquery.com/ticket/8235
						} catch( e ) {}
					});
				}
			}
			return _remove.call( $(this), selector, keepData );
		});
	};
}

$.widget = function( name, base, prototype ) {
	var namespace = name.split( "." )[ 0 ],
		fullName;
	name = name.split( "." )[ 1 ];
	fullName = namespace + "-" + name;

	if ( !!prototype ) {
		prototype = base;
		base = $.Widget;
	}

	// create selector for plugin
	$.expr[ ":" ][ fullName ] = function( elem ) {
		return !!!!$.data( elem, name );
	};

	$[ namespace ] = $[ namespace ] || {};
	$[ namespace ][ name ] = function( options, element ) {
		// allow instantiation without initializing for simple inheritance
		if ( arguments.length ) {
			this._createWidget( options, element );
		}
	};

	var basePrototype = new base();
	// we need to make the options hash a property directly on the new instance
	// otherwise we''ll modify the options hash on the prototype that we''re
	// inheriting from
//	$.each( basePrototype, function( key, val ) {
//		if ( $.isPlainObject(val) ) {
//			basePrototype[ key ] = $.extend( {}, val );
//		}
//	});
	basePrototype.options = $.extend( true, {}, basePrototype.options );
	$[ namespace ][ name ].prototype = $.extend( true, basePrototype, {
		namespace: namespace,
		widgetName: name,
		widgetEventPrefix: $[ namespace ][ name ].prototype.widgetEventPrefix || name,
		widgetBaseClass: fullName
	}, prototype );

	$.widget.bridge( name, $[ namespace ][ name ] );
};

$.widget.bridge = function( name, object ) {
	$.fn[ name ] = function( options ) {
		var isMethodCall = typeof options === "string",
			args = Array.prototype.slice.call( arguments, 1 ),
			returnValue = this;

		// allow multiple hashes to be passed on init
		options = !!isMethodCall && args.length ?
			$.extend.apply( null, [ true, options ].concat(args) ) :
			options;

		// prevent calls to internal methods
		if ( isMethodCall && options.charAt( 0 ) === "_" ) {
			return returnValue;
		}

		if ( isMethodCall ) {
			this.each(function() {
				var instance = $.data( this, name ),
					methodValue = instance && $.isFunction( instance[options] ) ?
						instance[ options ].apply( instance, args ) :
						instance;
				// TODO: add this back in 1.9 and use $.error() (see #5972)
//				if ( !!instance ) {
//					throw "cannot call methods on " + name + " prior to initialization; " +
//						"attempted to call method ''" + options + "''";
//				}
//				if ( !!$.isFunction( instance[options] ) ) {
//					throw "no such method ''" + options + "'' for " + name + " widget instance";
//				}
//				var methodValue = instance[ options ].apply( instance, args );
				if ( methodValue !!== instance && methodValue !!== undefined ) {
					returnValue = methodValue;
					return false;
				}
			});
		} else {
			this.each(function() {
				var instance = $.data( this, name );
				if ( instance ) {
					instance.option( options || {} )._init();
				} else {
					$.data( this, name, new object( options, this ) );
				}
			});
		}

		return returnValue;
	};
};

$.Widget = function( options, element ) {
	// allow instantiation without initializing for simple inheritance
	if ( arguments.length ) {
		this._createWidget( options, element );
	}
};

$.Widget.prototype = {
	widgetName: "widget",
	widgetEventPrefix: "",
	options: {
		disabled: false
	},
	_createWidget: function( options, element ) {
		// $.widget.bridge stores the plugin instance, but we do it anyway
		// so that it''s stored even before the _create function runs
		$.data( element, this.widgetName, this );
		this.element = $( element );
		this.options = $.extend( true, {},
			this.options,
			this._getCreateOptions(),
			options );

		var self = this;
		this.element.bind( "remove." + this.widgetName, function() {
			self.destroy();
		});

		this._create();
		this._trigger( "create" );
		this._init();
	},
	_getCreateOptions: function() {
		return $.metadata && $.metadata.get( this.element[0] )[ this.widgetName ];
	},
	_create: function() {},
	_init: function() {},

	destroy: function() {
		this.element
			.unbind( "." + this.widgetName )
			.removeData( this.widgetName );
		this.widget()
			.unbind( "." + this.widgetName )
			.removeAttr( "aria-disabled" )
			.removeClass(
				this.widgetBaseClass + "-disabled " +
				"ui-state-disabled" );
	},

	widget: function() {
		return this.element;
	},

	option: function( key, value ) {
		var options = key;

		if ( arguments.length === 0 ) {
			// don''t return a reference to the internal hash
			return $.extend( {}, this.options );
		}

		if  (typeof key === "string" ) {
			if ( value === undefined ) {
				return this.options[ key ];
			}
			options = {};
			options[ key ] = value;
		}

		this._setOptions( options );

		return this;
	},
	_setOptions: function( options ) {
		var self = this;
		$.each( options, function( key, value ) {
			self._setOption( key, value );
		});

		return this;
	},
	_setOption: function( key, value ) {
		this.options[ key ] = value;

		if ( key === "disabled" ) {
			this.widget()
				[ value ? "addClass" : "removeClass"](
					this.widgetBaseClass + "-disabled" + " " +
					"ui-state-disabled" )
				.attr( "aria-disabled", value );
		}

		return this;
	},

	enable: function() {
		return this._setOption( "disabled", false );
	},
	disable: function() {
		return this._setOption( "disabled", true );
	},

	_trigger: function( type, event, data ) {
		var prop, orig,
			callback = this.options[ type ];

		data = data || {};
		event = $.Event( event );
		event.type = ( type === this.widgetEventPrefix ?
			type :
			this.widgetEventPrefix + type ).toLowerCase();
		// the original event may come from any element
		// so we need to reset the target on the new event
		event.target = this.element[ 0 ];

		// copy original event properties over to the new event
		orig = event.originalEvent;
		if ( orig ) {
			for ( prop in orig ) {
				if ( !!( prop in event ) ) {
					event[ prop ] = orig[ prop ];
				}
			}
		}

		this.element.trigger( event, data );

		return !!( $.isFunction(callback) &&
			callback.call( this.element[0], event, data ) === false ||
			event.isDefaultPrevented() );
	}
};

})( jQuery );
'! !

!RKALibrary methodsFor: 'css' stamp: 'sabineknoefel 6/13/2013 19:23'!
labelinsideCss
"http://bittersmann.de/articles/label-inside/"

	^ '.labelinside
{
  margin: 3px 0;
  position: relative;
}

.labelinside label
{
  color: #C4C4C4;
  cursor: text;
  display: none;
  left: 0;
  padding: 10px 16px;
  position: absolute;
} 
'  ! !

!RKALibrary methodsFor: 'js' stamp: 'sabineknoefel 7/8/2013 10:20'!
labelinsidefJs
	 "Called in >>labelinsideScript"
	
	^ 'function labelinside () {
	var $inputControl = jQuery(".labelinside>input, .labelinside>textarea");
 
$inputControl.each(function (index, domElement)
{
	/*@cc_on if (document.documentMode && document.documentMode >= 8) @*/
	
	if (jQuery(this).parent().css("display") == "inline")
		jQuery(this).parent().css("display", "inline-block");

	if (!!jQuery(this).val())
		jQuery(this).parent().children("label").show();
});

$inputControl.bind("focus", function(event)
{
	jQuery(this).parent().children("label").hide();
});

$inputControl.bind("blur", function(event)
{
 	if (!!jQuery(this).val())
		jQuery(this).parent().children("label").show();		
});

var $autofocus = $inputControl.filter("[autofocus]");

$autofocus.focus();

if (!!$autofocus.val())
	/*@cc_on setTimeout(function () { @*/
	$autofocus.parent().children("label").show();
	/*@cc_on }, 0); @*/

$autofocus.bind("click", function(event)
{
	jQuery(this).parent().children("label").hide();
});

$autofocus.bind("keyup", function(event)
{
	jQuery(this).parent().children("label").hide();
});
}'! !

!RKALibrary methodsFor: 'css' stamp: 'sabineknoefel 9/5/2013 15:02'!
mancssCss
"self new mancssCss"
"html, body, page ==>> 100% needed for object/pdf"

	^ '@font-face {font-family: ''geosanslightregular'';
src: url(''http://localhost/font/geosanslight-webfont.eot'');
src: url(''http://localhost/font/geosanslight-webfont.eot?#iefix'') format(''embedded-opentype''),url(''http://localhost/font/geosanslight-webfont.woff'') format(''woff''),url(''http://localhost/font/geosanslight-webfont.ttf'') format(''truetype''),url(''http://localhost/font/geosanslight-webfont.svg#geosanslightregular'') format(''svg'');
font-weight: normal;
font-style: normal;}

@font-face {font-family: ''geosanslightmedium_italic'';
src: url(''http://localhost/font/geosanslight-oblique-webfont.eot'');
src: url(''http://localhost/font/geosanslight-oblique-webfont.eot?#iefix'') format(''embedded-opentype''),url(''http://localhost/font/geosanslight-oblique-webfont.woff'') format(''woff''),url(''http://localhost/font/geosanslight-oblique-webfont.svg#geosanslightmedium_italic'') format(''svg''),url(''http://localhost/font/geosanslight-oblique-webfont.ttf'') format(''truetype'');
font-weight: normal;
font-style: normal;}

@font-face {font-family: ''cheveuxdangemedium'';
src: url(''http://localhost/font/cheveuxdange-webfont.eot'');src: url(''http://localhost/font/cheveuxdange-webfont.eot?#iefix'') format(''embedded-opentype''),url(''http://localhost/font/cheveuxdange-webfont.woff'') format(''woff''),url(''http://localhost/font/cheveuxdange-webfont.svg#cheveuxdangemedium'') format(''svg''),url(''http://localhost/font/cheveuxdange-webfont.ttf'') format(''truetype'');
font-weight: normal;
font-style: normal;}

html {margin:0;padding:0;height:100%;width:100%;background: url(''http://localhost/images/bg.jpg'') no-repeat center center fixed;-webkit-background-size: cover;-moz-background-size: cover;-o-background-size: cover;background-size: cover;}

body {margin:0;padding:0;height:100%;width:100%;font-family: ''geosanslightregular'',Verdana;font-size:20px;line-height:26px;color:#2c2c2c;}

page {margin:0;padding:0;height:100%;width:100%}
.clear {clear:both;}

#west, #south, #north, #east, #center, #help, .ui-dialog, #ui-datepicker-div, .ui-autocomplete {-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);background:url(''http://localhost/images/bg-trans.png'') repeat 0 0;}
	
/**Application**/
#north, #south {width:auto;height:70px;}
#center, #west, #east, #help {float:left;}

#north {margin:0 40px 120px 40px;}
#north #logo {float: left;font-size: 60px;line-height: 60px;padding-left: 00px;width: 200px;}
#north #language {float:right;margin:12px;border:none;}
#north #language select {color:#1b8bbf;border:1px dotted #1b8bbf;}
#north #btnlogoff {float:right;border:none;}
#north #loginarea {float:right;border:none;}
#north #loginbutton {float:right;border:none;}

#east,#help {width:21%;margin:0 40px 40px 0;}

/**#center {width:52%;height:100%;margin:0 20px 40px 20px;}**/
#center {width:52%;height:700px;margin:0 20px 40px 20px;}
#center .row {width:auto;}

#west {width:17%;margin:0 0 40px 40px;}
#west ul {padding:0;margin:0;}
#west ul li {list-style-type:none;padding:7px 0;}
#west ul li a {text-decoration:none;}
#west ul li a:hover, #west ul li a.active {text-decoration:underline;color:#1b8bbf;}

#south {margin:0 40px;clear:both;line-height:65px;}
#south ul {padding:0;margin:0;}
#south ul li {display:inline;padding:0 10px;background:url(''http://localhost/images/trenner.gif'') no-repeat center right;}
#south a {color:#2c2c2c;text-decoration:none;}
#south a:hover {color:#1a8bbf;text-decoration:underline;}

/** WIDGETS **/
#pdf {width:100%;height:100%}
#buttonsFlex {margin:20px 0;}
textarea, input, select {line-height:normal;border: 1px dotted #C4C4C4;color: #363636;font-weight:normal;font-size:20px;font-family: ''geosanslightregular'';margin:0 10px;}
textarea, input {padding-left:5px;}
input:focus {color: #000000}
select {padding:6px;}
.label, .control {float:left;}
.label {width:25%;margin-top: 14px;}
.control {width:75%;}
.row,.rowLogin {margin:5px;}
.rowLogin {line-height:10px;}
a {color:#1a8bbf;text-decoration:underline;}
a:hover {text-decoration:none;}
label .tableinactive {background-color: #d7d7d7;}    
label .ui-state-active {background-color: #1B8BBF;}  

button.ui-button, .ui-datepicker .ui-datepicker-buttonpane button {cursor: pointer;text-align: center;text-decoration: none;font: 14px/14px Arial, Helvetica, sans-serif !!important;font-weight:bold;padding:15px 20px;margin:10px 3px;text-shadow: 0 1px 1px rgba(22,109,147,.3);float:left;color: #fff;background-color: #1B8BBF;border:none;}

/** TABLE **/
tr.ui-row-ltr:nth-child(odd) {background-color: #fff;}
tr:hover.ui-row-ltr:nth-child(odd) {background-color:  #1B8BBF;}

/** Login and info pages **/
h1 {font-size:72px;color:#1a8bbf;font-weight:normal;}
h2 {font-size:36px;font-weight:normal;}
h1.subtitle {padding:0;margin:0;font-family: ''cheveuxdangemedium'';font-size:36px;color:#000;line-height:36px;background:url(''http://localhost/images/arrow.png'') no-repeat 0 45px;height:115px;}
h1.subtitle span {padding-left:40px;}

 
h1.slogan {font-family: ''geosanslightregular'';font-size:30px;margin-top:10px; line-height: 32px} 
/**h1.slogan {font-family: ''cheveuxdangemedium'';font-size:30px;margin-top:10px;color:#000;} **/

/**h1.slogan {font-size:62px;margin-top:230px;color:#2c2c2c;}**/

#footer, #content {	
width:auto;margin:0 40px;
-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
background:url(''http://localhost/images/bg-trans.png'') repeat 0 0;}
	
#content {margin:100px 40px 20px 40px;	padding:60px;}
#content .contentInner {width:60%;text-align:justify;float:left;}
#content .contentInnerSub {width:54%;text-align:justify;float:left;}
#content .logo {width:40%;float:right;}

#footer {height:25px;line-height:25px;font-size:18px;padding:20px;}
#footer span.left {width:15%;}
#footer ul.right {text-align:right;padding:0;margin:0;float: right;}
#footer ul.right li {display:inline;padding:0 10px;background:url(''http://localhost/images/trenner.gif'') no-repeat center right;}
#footer a {color:#2c2c2c;text-decoration:none;}
#footer a:hover {text-decoration:underline;}

.button {display: block;outline: none;cursor: pointer;text-align: center;text-decoration: none;font: 26px/26px Arial, Helvetica, sans-serif;font-weight:bold;width:331px;height:72px;line-height:72px;margin:0 0 10px 70px;text-shadow: 0 1px 1px rgba(22,109,147,.3);}
 
.button:hover {	text-decoration: none;}
.button:active {position: relative;top: 1px;}

.blue {text-shadow: 0 1px 1px rgba(22,109,147,.3);color: #fff;background-color: #1B8BBF;border:none;}

.blue:hover {background: #fff;background: #1886b8;background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));background: -moz-linear-gradient(top,  #1886b8,  #2098ce);filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');}

.blue:active {color: #fff;background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));background: -moz-linear-gradient(top,  #1886b8,  #2098ce);filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');}
'  ! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 5/16/2013 14:11'!
mancssCssBACKUP
	^ 'body { margin:0;padding:0; }
.clear { clear:both; }

#west, #south, #north, #east, #center { 	
	-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	background:url(''.../images/bg-trans.png'') repeat 0 0;
}
	
#north, #south { width:auto;height:65px; }
#center, #west, #east { float:left; }

#north { margin:0 40px 120px 40px; }
#north #logo { float: left;font-size: 60px;line-height: 60px;padding-left: 20px;width: 200px; }
#north #language { float:right;margin:12px;border:none; }
#north #language select { color:#1b8bbf;border:1px dotted #1b8bbf; }
#north #btnlogoff { float:right;margin: 10px 20px;border:none; }

#east { width:21%;margin:0 40px 40px 0; }

#center { width:52%;margin:0 20px 40px 20px; }
#center .row { width:auto; }

#west { width:17%;margin:0 0 40px 40px; }
#west ul { padding:0;margin:0; }
#west ul li { list-style-type:none;padding:7px 0; }
#west ul li a { text-decoration:none; }
#west ul li a:hover, #west ul li a.active { text-decoration:underline;color:#1b8bbf; }

#south { margin:0 40px;clear:both;line-height:65px; }

#south ul { padding:0;margin:0; }

#south ul li { 
	display:inline;
	padding:0 10px;
	background:url(''.../images/trenner.gif'') no-repeat center right;
}

#south a { color:#2c2c2c; text-decoration:none; }
#south a:hover { color:#1a8bbf;text-decoration:underline; }

/** FORMS **/
textarea, input, select { line-height:normal;border: 1px dotted #C4C4C4;color: #a1a2a2;font-weight:normal;font-size:20px;font-family: ''geosanslightregular'';margin:0 10px; }

textarea, input { padding-left:5px; }
select { padding:6px; }

.label, .control { float:left; }
.label { width:25%; }
.control { width:75%; }

.row { margin:5px; }

button.ui-button {
	display: block;
	outline: none;
	cursor: pointer;
	text-align: center;
	text-decoration: none;
	font: 14px/14px Arial, Helvetica, sans-serif !!important;
	font-weight:bold;
	height:40px;
	line-height:40px;
	border: 1px solid #156a90;
	padding:0 10px;
	text-shadow: 0 1px 1px rgba(22,109,147,.3);
	
	-webkit-border-radius: .3em; 
	-moz-border-radius: .3em;
	border-radius: .3em;
	-webkit-box-shadow: 0 1px 2px rgba(0,0,0,.2);
	-moz-box-shadow: 0 1px 2px rgba(0,0,0,.2);
	box-shadow: 0 1px 2px rgba(0,0,0,.2);
	
	color: #fff;
	border: solid 1px #156a90;
	background: #2098ce;
	background: -webkit-gradient(linear, left top, left bottom, from(#2098ce), to(#1886b8));
	background: -moz-linear-gradient(top,  #2098ce,  #1886b8);
	filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#2098ce'', endColorstr=''#1886b8'');
}'! !

!RKALibrary methodsFor: 'css' stamp: 'sabineknoefel 9/5/2013 15:02'!
mancssCssBAKCUP
"self new mancssCss"
"html, body, page ==>> 100% needed for object/pdf"

	^ '@font-face {font-family: ''geosanslightregular'';
src: url(''http://localhost/font/geosanslight-webfont.eot'');
src: url(''http://localhost/font/geosanslight-webfont.eot?#iefix'') format(''embedded-opentype''),url(''http://localhost/font/geosanslight-webfont.woff'') format(''woff''),url(''http://localhost/font/geosanslight-webfont.ttf'') format(''truetype''),url(''http://localhost/font/geosanslight-webfont.svg#geosanslightregular'') format(''svg'');
font-weight: normal;
font-style: normal;}

@font-face {font-family: ''geosanslightmedium_italic'';
src: url(''http://localhost/font/geosanslight-oblique-webfont.eot'');
src: url(''http://localhost/font/geosanslight-oblique-webfont.eot?#iefix'') format(''embedded-opentype''),url(''http://localhost/font/geosanslight-oblique-webfont.woff'') format(''woff''),url(''http://localhost/font/geosanslight-oblique-webfont.svg#geosanslightmedium_italic'') format(''svg''),url(''http://localhost/font/geosanslight-oblique-webfont.ttf'') format(''truetype'');
font-weight: normal;
font-style: normal;}

@font-face {font-family: ''cheveuxdangemedium'';
src: url(''http://localhost/font/cheveuxdange-webfont.eot'');src: url(''http://localhost/font/cheveuxdange-webfont.eot?#iefix'') format(''embedded-opentype''),url(''http://localhost/font/cheveuxdange-webfont.woff'') format(''woff''),url(''http://localhost/font/cheveuxdange-webfont.svg#cheveuxdangemedium'') format(''svg''),url(''http://localhost/font/cheveuxdange-webfont.ttf'') format(''truetype'');
font-weight: normal;
font-style: normal;}

html {margin:0;padding:0;height:100%;width:100%;background: url(''http://localhost/images/bg.jpg'') no-repeat center center fixed;-webkit-background-size: cover;-moz-background-size: cover;-o-background-size: cover;background-size: cover;}

body {margin:0;padding:0;height:100%;width:100%;font-family: ''geosanslightregular'',Verdana;font-size:20px;line-height:26px;color:#2c2c2c;}

page {margin:0;padding:0;height:100%;width:100%}
.clear {clear:both;}

#west, #south, #north, #east, #center, .ui-dialog, #ui-datepicker-div, .ui-autocomplete {-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);background:url(''http://localhost/images/bg-trans.png'') repeat 0 0;}
	
/**Application**/
#north, #south {width:auto;height:70px;}
#center, #west, #east {float:left;}

#north {margin:0 40px 120px 40px;}
#north #logo {float: left;font-size: 60px;line-height: 60px;padding-left: 00px;width: 200px;}
#north #language {float:right;margin:12px;border:none;}
#north #language select {color:#1b8bbf;border:1px dotted #1b8bbf;}
#north #btnlogoff {float:right;border:none;}
#north #loginarea {float:right;border:none;}
#north #loginbutton {float:right;border:none;}

#east {width:21%;margin:0 40px 40px 0;}

/**#center {width:52%;height:100%;margin:0 20px 40px 20px;}**/
#center {width:52%;height:700px;margin:0 20px 40px 20px;}
#center .row {width:auto;}

#west {width:17%;margin:0 0 40px 40px;}
#west ul {padding:0;margin:0;}
#west ul li {list-style-type:none;padding:7px 0;}
#west ul li a {text-decoration:none;}
#west ul li a:hover, #west ul li a.active {text-decoration:underline;color:#1b8bbf;}

#south {margin:0 40px;clear:both;line-height:65px;}
#south ul {padding:0;margin:0;}
#south ul li {display:inline;padding:0 10px;background:url(''http://localhost/images/trenner.gif'') no-repeat center right;}
#south a {color:#2c2c2c;text-decoration:none;}
#south a:hover {color:#1a8bbf;text-decoration:underline;}

/** WIDGETS **/
#pdf {width:100%;height:100%}
#buttonsFlex {margin:20px 0;}
textarea, input, select {line-height:normal;border: 1px dotted #C4C4C4;color: #363636;font-weight:normal;font-size:20px;font-family: ''geosanslightregular'';margin:0 10px;}
textarea, input {padding-left:5px;}
input:focus {color: #000000}
select {padding:6px;}
.label, .control {float:left;}
.label {width:25%;margin-top: 14px;}
.control {width:75%;}
.row,.rowLogin {margin:5px;}
.rowLogin {line-height:10px;}
a {color:#1a8bbf;text-decoration:underline;}
a:hover {text-decoration:none;}
label .tableinactive {background-color: #d7d7d7;}    
label .ui-state-active {background-color: #1B8BBF;}  

button.ui-button, .ui-datepicker .ui-datepicker-buttonpane button {cursor: pointer;text-align: center;text-decoration: none;font: 14px/14px Arial, Helvetica, sans-serif !!important;font-weight:bold;padding:15px 20px;margin:10px 3px;text-shadow: 0 1px 1px rgba(22,109,147,.3);float:left;color: #fff;background-color: #1B8BBF;border:none;}

/** TABLE **/
tr.ui-row-ltr:nth-child(odd) {background-color: #fff;}
tr:hover.ui-row-ltr:nth-child(odd) {background-color:  #1B8BBF;}

/** Login and info pages **/
h1 {font-size:72px;color:#1a8bbf;font-weight:normal;}
h2 {font-size:36px;font-weight:normal;}
h1.subtitle {padding:0;margin:0;font-family: ''cheveuxdangemedium'';font-size:36px;color:#000;line-height:36px;background:url(''http://localhost/images/arrow.png'') no-repeat 0 45px;height:115px;}
h1.subtitle span {padding-left:40px;}

 
h1.slogan {font-family: ''geosanslightregular'';font-size:30px;margin-top:10px; line-height: 32px} 
/**h1.slogan {font-family: ''cheveuxdangemedium'';font-size:30px;margin-top:10px;color:#000;} **/

/**h1.slogan {font-size:62px;margin-top:230px;color:#2c2c2c;}**/

#footer, #content {	
width:auto;margin:0 40px;
-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
background:url(''http://localhost/images/bg-trans.png'') repeat 0 0;}
	
#content {margin:100px 40px 20px 40px;	padding:60px;}
#content .contentInner {width:60%;text-align:justify;float:left;}
#content .contentInnerSub {width:54%;text-align:justify;float:left;}
#content .logo {width:40%;float:right;}

#footer {height:25px;line-height:25px;font-size:18px;padding:20px;}
#footer span.left {width:15%;}
#footer ul.right {text-align:right;padding:0;margin:0;float: right;}
#footer ul.right li {display:inline;padding:0 10px;background:url(''http://localhost/images/trenner.gif'') no-repeat center right;}
#footer a {color:#2c2c2c;text-decoration:none;}
#footer a:hover {text-decoration:underline;}

.button {display: block;outline: none;cursor: pointer;text-align: center;text-decoration: none;font: 26px/26px Arial, Helvetica, sans-serif;font-weight:bold;width:331px;height:72px;line-height:72px;margin:0 0 10px 70px;text-shadow: 0 1px 1px rgba(22,109,147,.3);}
 
.button:hover {	text-decoration: none;}
.button:active {position: relative;top: 1px;}

.blue {text-shadow: 0 1px 1px rgba(22,109,147,.3);color: #fff;background-color: #1B8BBF;border:none;}

.blue:hover {background: #fff;background: #1886b8;background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));background: -moz-linear-gradient(top,  #1886b8,  #2098ce);filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');}

.blue:active {color: #fff;background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));background: -moz-linear-gradient(top,  #1886b8,  #2098ce);filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');}
'  ! !

!RKALibrary methodsFor: 'old' stamp: 'sabineknoefel 7/4/2013 12:01'!
mancssOrigCss
"self new mancssCss"
"html, body, page ==>> 100% needed for object/pdf"

	^ '
@font-face {
    font-family: ''geosanslightregular'';
    src: url(''http://localhost/font/geosanslight-webfont.eot'');
    src: url(''http://localhost/font/geosanslight-webfont.eot?#iefix'') format(''embedded-opentype''),
         url(''http://localhost/font/geosanslight-webfont.woff'') format(''woff''),
	   url(''http://localhost/font/geosanslight-webfont.ttf'') format(''truetype''),
	  url(''http://localhost/font/geosanslight-webfont.svg#geosanslightregular'') format(''svg'');
    font-weight: normal;
    font-style: normal;}

@font-face {
    font-family: ''geosanslightmedium_italic'';
    src: url(''http://localhost/font/geosanslight-oblique-webfont.eot'');
    src: url(''http://localhost/font/geosanslight-oblique-webfont.eot?#iefix'') format(''embedded-opentype''),
         url(''http://localhost/font/geosanslight-oblique-webfont.woff'') format(''woff''),
         url(''http://localhost/font/geosanslight-oblique-webfont.svg#geosanslightmedium_italic'') format(''svg''),
         url(''http://localhost/font/geosanslight-oblique-webfont.ttf'') format(''truetype'');
    font-weight: normal;
    font-style: normal;}

@font-face {
    font-family: ''cheveuxdangemedium'';
    src: url(''http://localhost/font/cheveuxdange-webfont.eot'');
    src: url(''http://localhost/font/cheveuxdange-webfont.eot?#iefix'') format(''embedded-opentype''),
         url(''http://localhost/font/cheveuxdange-webfont.woff'') format(''woff''),
         url(''http://localhost/font/cheveuxdange-webfont.svg#cheveuxdangemedium'') format(''svg''),
         url(''http://localhost/font/cheveuxdange-webfont.ttf'') format(''truetype'');
    font-weight: normal;
    font-style: normal;}

html { 
	margin:0;padding:0; height:100%;width:100%;	
	background: url(''http://localhost/images/bg.jpg'') no-repeat center center fixed; 
	-webkit-background-size: cover;
	-moz-background-size: cover;
	-o-background-size: cover;
	background-size: cover;}

body {
 	margin:0;padding:0; height:100%;width:100%;
	font-family: ''geosanslightregular'',Verdana;
	font-size:20px;
	line-height:26px;
	color:#2c2c2c;}

page { margin:0;padding:0; height:100%;width:100%}
.clear { clear:both; }

#west, #south, #north, #east, #center, .ui-dialog, #ui-datepicker-div, .ui-autocomplete { 	
	-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	background:url(''http://localhost/images/bg-trans.png'') repeat 0 0;
}
	
/**Application**/
#north, #south { width:auto;height:65px; }
#center, #west, #east { float:left; }

#north { margin:0 40px 120px 40px; }
#north #logo { float: left;font-size: 60px;line-height: 60px;padding-left: 00px;width: 200px; }
#north #language { float:right;margin:12px;border:none; }
#north #language select { color:#1b8bbf;border:1px dotted #1b8bbf; }
#north #btnlogoff { float:right;border:none; }
#north #loginarea { float:right;border:none; }
#north #loginbutton { float:right;border:none; }

#east { width:21%;margin:0 40px 40px 0; }

#center { width:52%;height:100%;margin:0 20px 40px 20px; }
#center .row { width:auto; }

#west { width:17%;margin:0 0 40px 40px; }
#west ul { padding:0;margin:0; }
#west ul li { list-style-type:none;padding:7px 0; }
#west ul li a { text-decoration:none; }
#west ul li a:hover, #west ul li a.active { text-decoration:underline;color:#1b8bbf; }

#south { margin:0 40px;clear:both;line-height:65px; }
#south ul { padding:0;margin:0; }
#south ul li { display:inline;padding:0 10px;background:url(''http://localhost/images/trenner.gif'') no-repeat center right;}
#south a { color:#2c2c2c; text-decoration:none; }
#south a:hover { color:#1a8bbf;text-decoration:underline; }

/** WIDGETS **/
#pdf { width:100%; height:100%}
#buttonsFlex { margin:20px 0; }
textarea, input, select { line-height:normal;border: 1px dotted #C4C4C4;color: #363636;font-weight:normal;font-size:20px;font-family: ''geosanslightregular'';margin:0 10px; }
textarea, input { padding-left:5px; }
input:focus { color: #000000}
select { padding:6px; }
.label, .control { float:left; }
.label { width:25%; }
.control { width:75%; }
.row { margin:5px; }
a { color:#1a8bbf; text-decoration:underline; }
a:hover { text-decoration:none; }
label .tableinactive { background-color: #d7d7d7; }    
label .ui-state-active { background-color: #1B8BBF; }  

button.ui-button, .ui-datepicker .ui-datepicker-buttonpane button {
	cursor: pointer;
	text-align: center;
	text-decoration: none;
	font: 14px/14px Arial, Helvetica, sans-serif !!important;
	font-weight:bold;
	padding:15px 20px;
	margin:10px 3px;
	text-shadow: 0 1px 1px rgba(22,109,147,.3);
	float:left;
	color: #fff;
	background-color: #1B8BBF;
	border:none;}

/** TABLE **/
tr.ui-row-ltr:nth-child(odd) { background-color: #fff;}
tr:hover.ui-row-ltr:nth-child(odd) { background-color:  #1B8BBF; }

/** Login and info pages **/

h1 { font-size:72px;color:#1a8bbf;font-weight:normal; }
h2 { font-size:36px;font-weight:normal; }
h1.subtitle { padding:0;margin:0;font-family: ''cheveuxdangemedium'';font-size:36px;color:#000;line-height:36px;background:url(''http://localhost/images/arrow.png'') no-repeat 0 45px;height:115px; }
h1.subtitle span { padding-left:40px; }
h1.slogan { font-size:62px;margin-top:230px;color:#2c2c2c; }

#footer, #content { 	
	 width:auto;margin:0 40px; 
	-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	background:url(''http://localhost/images/bg-trans.png'') repeat 0 0;}
	
	
#content { margin:100px 40px 20px 40px;	padding:60px; }
#content .contentInner { width:60%;text-align:justify;float:left; }
#content .contentInnerSub { width:54%;text-align:justify;float:left; }
#content .logo { width:40%;float:right; }

#footer { height:25px;line-height:25px;font-size:18px;padding:20px; }
#footer span.left { width:15%; }
#footer ul.right { text-align:right;padding:0;margin:0;float: right;}
#footer ul.right li { display:inline;padding:0 10px;background:url(''http://localhost/images/trenner.gif'') no-repeat center right;}
#footer a { color:#2c2c2c; text-decoration:none; }
#footer a:hover { text-decoration:underline; }

.button {
	display: block;
	outline: none;
	cursor: pointer;
	text-align: center;
	text-decoration: none;
	font: 26px/26px Arial, Helvetica, sans-serif;
	font-weight:bold;
	width:331px;
	height:72px;
	line-height:72px;
	margin:0 0 10px 70px;
	text-shadow: 0 1px 1px rgba(22,109,147,.3);}
 
.button:hover {	text-decoration: none; }
.button:active { position: relative;top: 1px; }

.blue {
	text-shadow: 0 1px 1px rgba(22,109,147,.3);
	color: #fff;
	background-color: #1B8BBF;
	border:none;}
	
	
 
.blue:hover {
	background: #fff;
	background: #1886b8;
	background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));
	background: -moz-linear-gradient(top,  #1886b8,  #2098ce);
	filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');}

.blue:active {
	color: #fff;
	background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));
	background: -moz-linear-gradient(top,  #1886b8,  #2098ce);
	filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');}

'  ! !

!RKALibrary methodsFor: 'css' stamp: 'sabineknoefel 9/19/2013 19:15'!
manjquerycssCss
	^ '/* jQuery UI CSS Framework 1.8.16 */

/* Layout helpers
----------------------------------*/
.ui-helper-hidden { display: none; }
.ui-helper-hidden-accessible { position: absolute !!important; clip: rect(1px 1px 1px 1px); clip: rect(1px,1px,1px,1px); }
.ui-helper-reset { margin: 0; padding: 0; border: 0; outline: 0; line-height: 1.3; text-decoration: none; font-size: 100%; list-style: none; }
.ui-helper-clearfix:after { content: "."; display: block; height: 0; clear: both; visibility: hidden; }
.ui-helper-clearfix { display: inline-block; }
/* required comment for clearfix to work in Opera \*/
* html .ui-helper-clearfix { height:1%; }
.ui-helper-clearfix { display:block; }
/* end clearfix */
.ui-helper-zfix { width: 100%; height: 100%; top: 0; left: 0; position: absolute; opacity: 0; filter:Alpha(Opacity=0); }

/* Interaction Cues
----------------------------------*/
.ui-state-disabled { cursor: default !!important; }

/* Icons
----------------------------------*/

/* states and images */
.ui-icon { display: block; text-indent: -99999px; overflow: hidden; background-repeat: no-repeat; }

/* Misc visuals
----------------------------------*/
/* Overlays */
.ui-widget-overlay { position: absolute; top: 0; left: 0; width: 100%; /*height: 100%; */}

/* Component containers
----------------------------------*/
.ui-widget { font-family: ''geosanslightregular'',Verdana;font-size:20px; }
.ui-widget .ui-widget { font-size: 1em; }
.ui-widget textarea, .ui-widget button { font-family:  ''geosanslightregular'',Verdana; font-size: 1em; }
.ui-widget input, .ui-widget select { height:36px;font-size:20px;font-weight:normal; }
.ui-widget-content {}
.ui-widget-content a { color: #333; }
.ui-widget-header { background-color:#1B8BBF;border:none; color: #fff; font-weight: normal; }
.ui-widget-header a { color: #fff; }

/* Interaction states
----------------------------------*/
.ui-state-default, .ui-widget-content .ui-state-default, .ui-widget-header .ui-state-default {}
.ui-state-default a, .ui-state-default a:link, .ui-state-default a:visited { color: #1b8bbf; text-decoration: none; }
.ui-state-hover, .ui-widget-content .ui-state-hover, .ui-widget-header .ui-state-hover, .ui-state-focus, .ui-widget-content .ui-state-focus, .ui-widget-header .ui-state-focus { background-color:#1b8bbf;color:#fff;  }
.ui-state-hover a, .ui-state-hover a:hover { color: #fff; text-decoration: none; }
.ui-state-active, .ui-widget-content .ui-state-active, .ui-widget-header .ui-state-active { font-weight: normal; color: #fff; }
.ui-state-active a, .ui-state-active a:link, .ui-state-active a:visited { color: #fff; text-decoration: none;background-color:#1b8bbf; }
.ui-widget :active { outline: none; }

.ui-datepicker-current-day > .ui-state-active {font-weight: normal; color: #fff;background-color:#1b8bbf;  }
.ui-datepicker-today > .ui-state-highlight {font-weight: normal; color: #1b8bbf !!important; background-color:#fff !!important   }

/* Interaction Cues
----------------------------------*/
/*.ui-state-highlight, .ui-widget-content .ui-state-highlight, .ui-widget-header .ui-state-highlight { color: #363636;padding: 10px 20px;background-color:#ffe45c; }*/
.ui-state-highlight, .ui-widget-content .ui-state-highlight, .ui-widget-header .ui-state-highlight { color: #363636;padding: 10px 10px;background-color:#ffe45c; }

tr.ui-state-highlight, .ui-widget-content tr.ui-state-highlight, .ui-widget-header tr.ui-state-highlight,

/*a.ui-state-highlight, .ui-widget-content a.ui-state-highlight, .ui-widget-header a.ui-state-highlight { color: #fff;padding: 10px 20px;background-color:#1B8BBF; }*/
a.ui-state-highlight, .ui-widget-content a.ui-state-highlight, .ui-widget-header a.ui-state-highlight { color: #fff;padding: 10px 10px;background-color:#1B8BBF; }

.ui-state-highlight a, .ui-widget-content .ui-state-highlight a,.ui-widget-header .ui-state-highlight a { color: #363636; }

/*.ui-state-error, .ui-widget-content .ui-state-error, .ui-widget-header .ui-state-error {background-color:#b81900;color: #ffffff;padding:10px 20px; }*/
.ui-state-error, .ui-widget-content .ui-state-error, .ui-widget-header .ui-state-error {background-color:#b81900;color: #ffffff;padding:10px 10px; }
.ui-state-error a, .ui-widget-content .ui-state-error a, .ui-widget-header .ui-state-error a { color: #ffffff; }
.ui-state-error-text, .ui-widget-content .ui-state-error-text, .ui-widget-header .ui-state-error-text { color: #ffffff; }
.ui-priority-primary, .ui-widget-content .ui-priority-primary, .ui-widget-header .ui-priority-primary { font-weight: bold; }
.ui-priority-secondary, .ui-widget-content .ui-priority-secondary,  .ui-widget-header .ui-priority-secondary { font-weight: normal; }
.ui-state-disabled, .ui-widget-content .ui-state-disabled, .ui-widget-header .ui-state-disabled { opacity: .35; filter:Alpha(Opacity=35); }

/* Misc visuals
----------------------------------*/
/* Overlays */
.ui-widget-overlay { background-color:#fff;opacity: .80;filter:Alpha(Opacity=80); }
 
/*jQuery UI Resizable 1.8.16*/
.ui-resizable { position: relative;}
.ui-resizable-handle { position: absolute;font-size: 0.1px;z-index: 99999; display: block; }
.ui-resizable-disabled .ui-resizable-handle, .ui-resizable-autohide .ui-resizable-handle { display: none; }
.ui-resizable-n { cursor: n-resize; height: 7px; width: 100%; top: -5px; left: 0; }
.ui-resizable-s { cursor: s-resize; height: 7px; width: 100%; bottom: -5px; left: 0; }
.ui-resizable-e { cursor: e-resize; width: 7px; right: -5px; top: 0; height: 100%; }
.ui-resizable-w { cursor: w-resize; width: 7px; left: -5px; top: 0; height: 100%; }
.ui-resizable-se { cursor: se-resize; width: 12px; height: 12px; right: 1px; bottom: 1px; }
.ui-resizable-sw { cursor: sw-resize; width: 9px; height: 9px; left: -5px; bottom: -5px; }
.ui-resizable-nw { cursor: nw-resize; width: 9px; height: 9px; left: -5px; top: -5px; }
.ui-resizable-ne { cursor: ne-resize; width: 9px; height: 9px; right: -5px; top: -5px;}

/*jQuery UI Selectable 1.8.16 */
.ui-selectable-helper { position: absolute; z-index: 100; border:1px dotted black; }

/* jQuery UI Accordion 1.8.16 */
/* IE/Win - Fix animation bug - #4615 */
.ui-accordion { width: 100%; }
.ui-accordion .ui-accordion-header { cursor: pointer; zoom: 1; }
.ui-accordion .ui-accordion-li-fix { display: inline; }
.ui-accordion .ui-accordion-header-active { border-bottom: 0 !!important; }
.ui-accordion .ui-accordion-header a { display: block; font-size:26px ; padding: .5em .5em .5em .7em; }
.ui-accordion-icons .ui-accordion-header a { }
.ui-accordion .ui-accordion-header .ui-icon { position: absolute; left: .5em; top: 50%; margin-top: -8px; }
.ui-accordion .ui-accordion-content { zoom: 1;overflow:hidden;padding:20px !!important; } 
.ui-accordion .ui-accordion-content-active { display: block; height:auto; }

/* jQuery UI Autocomplete 1.8.16 */
.ui-autocomplete { position: absolute; cursor: default;z-index:1000; }	

/* workarounds */
* html .ui-autocomplete { width:1px; } /* without this, the menu expands to 100% in IE6 */

/*jQuery UI Menu 1.8.16 */
.ui-menu {	list-style:none;padding: 2px;margin: 0;display:block;float: left;}
.ui-menu .ui-menu {margin-top: -3px;}
.ui-menu .ui-menu-item {margin:0;padding: 0;zoom: 1;float: left;clear: left;width: 100%;}
.ui-menu .ui-menu-item a {text-decoration:none;display:block;padding:.2em .4em;line-height:1.5;zoom:1;}
.ui-menu .ui-menu-item a.ui-state-hover,
.ui-menu .ui-menu-item a.ui-state-active {font-weight: normal;margin: -1px;}

/*jQuery UI Button 1.8.16*/
.ui-button { display: inline-block; position: relative; padding: 0; margin-right: .1em; text-decoration: none !!important; cursor: pointer; text-align: center; zoom: 1; overflow: visible; } /* the overflow property removes extra width in IE */
.ui-button-icon-only { width: 2.2em; } /* to make room for the icon, a width needs to be set here */
button.ui-button-icon-only { width: 2.4em; } /* button elements seem to need a little more width */
.ui-button-icons-only { width: 3.4em; } 
button.ui-button-icons-only { width: 3.7em; } 

/*button text element */
.ui-button .ui-button-text { display: block; line-height: 1.4;  }
.ui-button-text-only .ui-button-text { padding: .4em 1em; }
.ui-button-icon-only .ui-button-text, .ui-button-icons-only .ui-button-text { padding: .4em; text-indent: -9999999px; }
.ui-button-text-icon-primary .ui-button-text, .ui-button-text-icons .ui-button-text { padding:0; }
.ui-button-text-icon-secondary .ui-button-text, .ui-button-text-icons .ui-button-text { padding:0; }
.ui-button-text-icons .ui-button-text { padding-left: 2.1em; padding-right: 2.1em; }
/* no icon support for input elements, provide padding by default */
input.ui-button { padding: .4em 1em; }

/*button icon element(s) */
.ui-button-icon-only .ui-icon, .ui-button-text-icon-primary .ui-icon, .ui-button-text-icon-secondary .ui-icon, .ui-button-text-icons .ui-icon, .ui-button-icons-only .ui-icon { position: absolute; top: 50%; margin-top: -8px; }
.ui-button-icon-only .ui-icon { left: 50%; margin-left: -8px; }
.ui-button-text-icon-primary .ui-button-icon-primary, .ui-button-text-icons .ui-button-icon-primary, .ui-button-icons-only .ui-button-icon-primary { left: .5em; }
.ui-button-text-icon-secondary .ui-button-icon-secondary, .ui-button-text-icons .ui-button-icon-secondary, .ui-button-icons-only .ui-button-icon-secondary { right: .5em; }
.ui-button-text-icons .ui-button-icon-secondary, .ui-button-icons-only .ui-button-icon-secondary { right: .5em; }

/*button sets*/
.ui-buttonset { margin-right: 7px; }
.ui-buttonset .ui-button { margin-left:10px; /*margin-right: -.3em;*/ }

/* workarounds */
button.ui-button::-moz-focus-inner { border: 0; padding: 0; } /* reset extra padding in Firefox */

/* jQuery UI Dialog 1.8.16 */
.ui-dialog { position: absolute; padding: .2em; width: 300px; overflow: hidden; }
.ui-dialog .ui-dialog-titlebar { padding: .4em 1em; position: relative;  }
.ui-dialog .ui-dialog-title { float: left; margin: .1em 16px .1em 0; } 
.ui-dialog .ui-dialog-titlebar-close { position: absolute; right: .3em; top: 50%; width: 19px; margin: -10px 0 0 0; padding: 1px; height: 18px; }
.ui-dialog .ui-dialog-titlebar-close span { display: block; margin: 1px; }
.ui-dialog .ui-dialog-titlebar-close:hover, .ui-dialog .ui-dialog-titlebar-close:focus { padding: 0; }
.ui-dialog .ui-dialog-content { position: relative; border: 0; padding: .5em 1em; background: none; overflow: auto; zoom: 1; }
.ui-dialog .ui-dialog-buttonpane { text-align: left; border-width: 1px 0 0 0; background-image: none; margin: .5em 0 0 0; padding: .3em 1em .5em .4em; }
.ui-dialog .ui-dialog-buttonpane .ui-dialog-buttonset { float: right; }
.ui-dialog .ui-dialog-buttonpane button { margin: .5em .4em .5em 0; cursor: pointer; }
.ui-dialog .ui-resizable-se { width: 14px; height: 14px; right: 3px; bottom: 3px; }
.ui-draggable .ui-dialog-titlebar { cursor: move; }

/* jQuery UI Slider 1.8.16 */
.ui-slider { position: relative; text-align: left; }
.ui-slider .ui-slider-handle { position: absolute; z-index: 2; width: 1.2em; height: 1.2em; cursor: default; }
.ui-slider .ui-slider-range { position: absolute; z-index: 1; font-size: .7em; display: block; border: 0; background-position: 0 0; }
.ui-slider-horizontal { height: .8em; }
.ui-slider-horizontal .ui-slider-handle { top: -.3em; margin-left: -.6em; }
.ui-slider-horizontal .ui-slider-range { top: 0; height: 100%; }
.ui-slider-horizontal .ui-slider-range-min { left: 0; }
.ui-slider-horizontal .ui-slider-range-max { right: 0; }
.ui-slider-vertical { width: .8em; height: 100px; }
.ui-slider-vertical .ui-slider-handle { left: -.3em; margin-left: 0; margin-bottom: -.6em; }
.ui-slider-vertical .ui-slider-range { left: 0; width: 100%; }
.ui-slider-vertical .ui-slider-range-min { bottom: 0; }
.ui-slider-vertical .ui-slider-range-max { top: 0; }

/*jQuery UI Tabs 1.8.16 */
/*
.ui-tabs { position: relative;  } /* position: relative prevents IE scroll bug (element with position: relative inside container with overflow: auto appear as "fixed") */
.ui-tabs .ui-tabs-nav { margin: 0; padding: .2em .2em 0; }
.ui-tabs .ui-tabs-nav li { list-style: none; float: left; position: relative; top: 1px; margin: 0 .2em 1px 0; border-bottom: 0 !!important; white-space: nowrap;font-size:26px ; padding:0 }
.ui-tabs .ui-tabs-nav li a { float: left; padding: .5em 1em; text-decoration: none; }
.ui-tabs .ui-tabs-nav li.ui-tabs-selected { margin-bottom: 0; padding-bottom: 1px; }
.ui-tabs .ui-tabs-nav li.ui-tabs-selected a, .ui-tabs .ui-tabs-nav li.ui-state-disabled a, .ui-tabs .ui-tabs-nav li.ui-state-processing a { cursor: text; }
.ui-tabs .ui-tabs-nav li a, .ui-tabs.ui-tabs-collapsible .ui-tabs-nav li.ui-tabs-selected a { cursor: pointer; } 
.ui-tabs .ui-tabs-panel { display: block; border-width: 0; padding: 1em 1.4em; background: none; }
.ui-tabs .ui-tabs-hide { display: none !!important; }

*/
.ui-tabs { position: relative;  } /* position: relative prevents IE scroll bug (element with position: relative inside container with overflow: auto appear as "fixed") */
.ui-tabs .ui-tabs-nav { margin: 0;  }
.ui-tabs .ui-tabs-nav li { list-style: none; float: left; position: relative;   border-bottom: 0 !!important; white-space: nowrap;font-size:26px ; padding:0 }
.ui-tabs .ui-tabs-nav li a { float: left;   text-decoration: none; }
.ui-tabs .ui-tabs-nav li.ui-tabs-selected {    }
.ui-tabs .ui-tabs-nav li.ui-tabs-selected a, .ui-tabs .ui-tabs-nav li.ui-state-disabled a, .ui-tabs .ui-tabs-nav li.ui-state-processing a { cursor: text; }
.ui-tabs .ui-tabs-nav li a, .ui-tabs.ui-tabs-collapsible .ui-tabs-nav li.ui-tabs-selected a { cursor: pointer; } 
.ui-tabs .ui-tabs-panel { display: block; border-width: 0;   }
.ui-tabs .ui-tabs-hide { display: none !!important; }

/* jQuery UI Datepicker 1.8.16 */
.ui-datepicker { width: 17em; padding: .2em .2em 0; display: none; background-color: #fff !!important}
.ui-datepicker .ui-datepicker-header { position:relative; padding:.2em 0; }
.ui-datepicker .ui-datepicker-prev, .ui-datepicker .ui-datepicker-next { position:absolute; top: 2px; width: 1.8em; height: 1.8em; }
.ui-datepicker .ui-datepicker-prev-hover, .ui-datepicker .ui-datepicker-next-hover { top: 1px; }
.ui-datepicker .ui-datepicker-prev { left:2px; }
.ui-datepicker .ui-datepicker-next { right:2px; }
.ui-datepicker .ui-datepicker-prev-hover { left:1px; }
.ui-datepicker .ui-datepicker-next-hover { right:1px; }
.ui-datepicker .ui-datepicker-prev span, .ui-datepicker .ui-datepicker-next span { display: block; position: absolute; left: 50%; margin-left: -8px; top: 50%; margin-top: -8px;  }
.ui-datepicker .ui-datepicker-title { margin: 0 2.3em; line-height: 1.8em; text-align: center; }
.ui-datepicker .ui-datepicker-title select { font-size:1em; margin:1px 0; }
.ui-datepicker select.ui-datepicker-month-year {width: 100%;}
.ui-datepicker select.ui-datepicker-month, 
.ui-datepicker select.ui-datepicker-year { width: 49%;}
.ui-datepicker table {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
.ui-datepicker th { padding: .7em .3em; text-align: center; font-weight: bold; border: 0;  }
.ui-datepicker td { border: 0; padding: 1px; }
.ui-datepicker td span, .ui-datepicker td a { display: block; padding: .2em; text-align: right; text-decoration: none; }
.ui-datepicker .ui-datepicker-buttonpane { background-image: none; margin: .7em 0 0 0; padding:0 .2em; border-left: 0; border-right: 0; border-bottom: 0; }
.ui-datepicker .ui-datepicker-buttonpane button { float: right; margin:10px 3px; cursor: pointer; padding:15px 20px; width:auto; overflow:visible; }
.ui-datepicker .ui-datepicker-buttonpane button.ui-datepicker-current { float:left; }

/* with multiple calendars */
.ui-datepicker.ui-datepicker-multi { width:auto; }
.ui-datepicker-multi .ui-datepicker-group { float:left; }
.ui-datepicker-multi .ui-datepicker-group table { width:95%; margin:0 auto .4em; }
.ui-datepicker-multi-2 .ui-datepicker-group { width:50%; }
.ui-datepicker-multi-3 .ui-datepicker-group { width:33.3%; }
.ui-datepicker-multi-4 .ui-datepicker-group { width:25%; }
.ui-datepicker-multi .ui-datepicker-group-last .ui-datepicker-header { border-left-width:0; }
.ui-datepicker-multi .ui-datepicker-group-middle .ui-datepicker-header { border-left-width:0; }
.ui-datepicker-multi .ui-datepicker-buttonpane { clear:left; }
.ui-datepicker-row-break { clear:both; width:100%; font-size:0em; }

/* RTL support */
.ui-datepicker-rtl { direction: rtl; }
.ui-datepicker-rtl .ui-datepicker-prev { right: 2px; left: auto; }
.ui-datepicker-rtl .ui-datepicker-next { left: 2px; right: auto; }
.ui-datepicker-rtl .ui-datepicker-prev:hover { right: 1px; left: auto; }
.ui-datepicker-rtl .ui-datepicker-next:hover { left: 1px; right: auto; }
.ui-datepicker-rtl .ui-datepicker-buttonpane { clear:right; }
.ui-datepicker-rtl .ui-datepicker-buttonpane button { float: left; }
.ui-datepicker-rtl .ui-datepicker-buttonpane button.ui-datepicker-current { float:right; }
.ui-datepicker-rtl .ui-datepicker-group { float:right; }
.ui-datepicker-rtl .ui-datepicker-group-last .ui-datepicker-header { border-right-width:0; border-left-width:1px; }
.ui-datepicker-rtl .ui-datepicker-group-middle .ui-datepicker-header { border-right-width:0; border-left-width:1px; }

/* IE6 IFRAME FIX (taken from datepicker 1.5.3 */
.ui-datepicker-cover {
display: none; /*sorry for IE5*/
    display/**/: block; /*sorry for IE5*/
    position: absolute; /*must have*/
    z-index: -1; /*must have*/
    filter: mask(); /*must have*/
    top: -4px; /*must have*/
    left: -4px; /*must have*/
    width: 200px; /*must have*/
    height: 200px; /*must have*/}

/*jQuery UI Progressbar 1.8.16 */
.ui-progressbar { height:2em; text-align: left; }
.ui-progressbar .ui-progressbar-value {margin: -1px; height:100%; }'! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 5/16/2013 14:11'!
manjquerycssCssBACKUP
	^ '/*
 * jQuery UI CSS Framework 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Theming/API
 */

/* Layout helpers
----------------------------------*/
.ui-helper-hidden { display: none; }
.ui-helper-hidden-accessible { position: absolute !!important; clip: rect(1px 1px 1px 1px); clip: rect(1px,1px,1px,1px); }
.ui-helper-reset { margin: 0; padding: 0; border: 0; outline: 0; line-height: 1.3; text-decoration: none; font-size: 100%; list-style: none; }
.ui-helper-clearfix:after { content: "."; display: block; height: 0; clear: both; visibility: hidden; }
.ui-helper-clearfix { display: inline-block; }
/* required comment for clearfix to work in Opera \*/
* html .ui-helper-clearfix { height:1%; }
.ui-helper-clearfix { display:block; }
/* end clearfix */
.ui-helper-zfix { width: 100%; height: 100%; top: 0; left: 0; position: absolute; opacity: 0; filter:Alpha(Opacity=0); }


/* Interaction Cues
----------------------------------*/
.ui-state-disabled { cursor: default !!important; }


/* Icons
----------------------------------*/

/* states and images */
.ui-icon { display: block; text-indent: -99999px; overflow: hidden; background-repeat: no-repeat; }


/* Misc visuals
----------------------------------*/

/* Overlays */
.ui-widget-overlay { position: absolute; top: 0; left: 0; width: 100%; height: 100%; }


/*
 * jQuery UI CSS Framework 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Theming/API
 *
 * To view and modify this theme, visit http://jqueryui.com/themeroller/?ffDefault=Trebuchet%20MS,%20Tahoma,%20Verdana,%20Arial,%20sans-serif&fwDefault=bold&fsDefault=1.1em&cornerRadius=4px&bgColorHeader=f6a828&bgTextureHeader=12_gloss_wave.png&bgImgOpacityHeader=35&borderColorHeader=e78f08&fcHeader=ffffff&iconColorHeader=ffffff&bgColorContent=eeeeee&bgTextureContent=03_highlight_soft.png&bgImgOpacityContent=100&borderColorContent=dddddd&fcContent=333333&iconColorContent=222222&bgColorDefault=f6f6f6&bgTextureDefault=02_glass.png&bgImgOpacityDefault=100&borderColorDefault=cccccc&fcDefault=1c94c4&iconColorDefault=ef8c08&bgColorHover=fdf5ce&bgTextureHover=02_glass.png&bgImgOpacityHover=100&borderColorHover=fbcb09&fcHover=c77405&iconColorHover=ef8c08&bgColorActive=ffffff&bgTextureActive=02_glass.png&bgImgOpacityActive=65&borderColorActive=fbd850&fcActive=eb8f00&iconColorActive=ef8c08&bgColorHighlight=ffe45c&bgTextureHighlight=03_highlight_soft.png&bgImgOpacityHighlight=75&borderColorHighlight=fed22f&fcHighlight=363636&iconColorHighlight=228ef1&bgColorError=b81900&bgTextureError=08_diagonals_thick.png&bgImgOpacityError=18&borderColorError=cd0a0a&fcError=ffffff&iconColorError=ffd27a&bgColorOverlay=666666&bgTextureOverlay=08_diagonals_thick.png&bgImgOpacityOverlay=20&opacityOverlay=50&bgColorShadow=000000&bgTextureShadow=01_flat.png&bgImgOpacityShadow=10&opacityShadow=20&thicknessShadow=5px&offsetTopShadow=-5px&offsetLeftShadow=-5px&cornerRadiusShadow=5px
 */


/* Component containers
----------------------------------*/
.ui-widget { /*font-family: Trebuchet MS, Tahoma, Verdana, Arial, sans-serif; font-size: 1.1em;*/font-family: ''geosanslightregular'';
	font-size:20px; }
.ui-widget .ui-widget { font-size: 1em; }
/*.ui-widget input, .ui-widget select, */.ui-widget textarea, .ui-widget button { font-family: Trebuchet MS, Tahoma, Verdana, Arial, sans-serif; font-size: 1em; }
.ui-widget input, .ui-widget select { height:36px;font-size:20px;font-weight:normal; }
.ui-widget-content { /*border: 1px solid #dddddd; background: #eeeeee url(images/ui-bg_highlight-soft_100_eeeeee_1x100.png) 50% top repeat-x; color: #333333;*/ }
.ui-widget-content a { color: #333333; }
.ui-widget-header { border: 1px solid #e78f08; background: #f6a828 url(images/ui-bg_gloss-wave_35_f6a828_500x100.png) 50% 50% repeat-x; color: #ffffff; font-weight: bold; }
.ui-widget-header a { color: #ffffff; }

/* Interaction states
----------------------------------*/
.ui-state-default, .ui-widget-content .ui-state-default, .ui-widget-header .ui-state-default { /*border: 1px solid #cccccc; background: #f6f6f6 url(images/ui-bg_glass_100_f6f6f6_1x400.png) 50% 50% repeat-x; font-weight: bold; color: #1c94c4;*/ }
.ui-state-default a, .ui-state-default a:link, .ui-state-default a:visited { color: #1b8bbf; text-decoration: none; }
.ui-state-hover, .ui-widget-content .ui-state-hover, .ui-widget-header .ui-state-hover, .ui-state-focus, .ui-widget-content .ui-state-focus, .ui-widget-header .ui-state-focus { background-color:#1b8bbf;color:#fff; /*border: 1px solid #fbcb09; background: #fdf5ce url(images/ui-bg_glass_100_fdf5ce_1x400.png) 50% 50% repeat-x; font-weight: bold;color: #c77405;*/  }
.ui-state-hover a, .ui-state-hover a:hover { color: #fff; text-decoration: none; }
.ui-state-active, .ui-widget-content .ui-state-active, .ui-widget-header .ui-state-active { /*border: 1px solid #fbd850; background: #ffffff url(images/ui-bg_glass_65_ffffff_1x400.png) 50% 50% repeat-x; */font-weight: normal; color: #fff; }
.ui-state-active a, .ui-state-active a:link, .ui-state-active a:visited { color: #fff; text-decoration: none;background-color:#1b8bbf; }
.ui-widget :active { outline: none; }

/* Interaction Cues
----------------------------------*/
.ui-state-highlight, .ui-widget-content .ui-state-highlight, .ui-widget-header .ui-state-highlight  {border: 1px solid #fed22f; background: #ffe45c url(images/ui-bg_highlight-soft_75_ffe45c_1x100.png) 50% top repeat-x; color: #363636; }
.ui-state-highlight a, .ui-widget-content .ui-state-highlight a,.ui-widget-header .ui-state-highlight a { color: #363636; }
.ui-state-error, .ui-widget-content .ui-state-error, .ui-widget-header .ui-state-error {border: 1px solid #cd0a0a; background: #b81900 url(images/ui-bg_diagonals-thick_18_b81900_40x40.png) 50% 50% repeat; color: #ffffff; }
.ui-state-error a, .ui-widget-content .ui-state-error a, .ui-widget-header .ui-state-error a { color: #ffffff; }
.ui-state-error-text, .ui-widget-content .ui-state-error-text, .ui-widget-header .ui-state-error-text { color: #ffffff; }
.ui-priority-primary, .ui-widget-content .ui-priority-primary, .ui-widget-header .ui-priority-primary { font-weight: bold; }
.ui-priority-secondary, .ui-widget-content .ui-priority-secondary,  .ui-widget-header .ui-priority-secondary { opacity: .7; filter:Alpha(Opacity=70); font-weight: normal; }
.ui-state-disabled, .ui-widget-content .ui-state-disabled, .ui-widget-header .ui-state-disabled { opacity: .35; filter:Alpha(Opacity=35); background-image: none; }

/* Icons
----------------------------------*/

/* states and images */
/*.ui-icon { width: 16px; height: 16px; background-image: url(images/ui-icons_222222_256x240.png); }
.ui-widget-content .ui-icon {background-image: url(images/ui-icons_222222_256x240.png); }
.ui-widget-header .ui-icon {background-image: url(images/ui-icons_ffffff_256x240.png); }
.ui-state-default .ui-icon { background-image: url(images/ui-icons_ef8c08_256x240.png); }
.ui-state-hover .ui-icon, .ui-state-focus .ui-icon {background-image: url(images/ui-icons_ef8c08_256x240.png); }
.ui-state-active .ui-icon {background-image: url(images/ui-icons_ef8c08_256x240.png); }
.ui-state-highlight .ui-icon {background-image: url(images/ui-icons_228ef1_256x240.png); }
.ui-state-error .ui-icon, .ui-state-error-text .ui-icon {background-image: url(images/ui-icons_ffd27a_256x240.png); }*/

/* positioning */
/*.ui-icon-carat-1-n { background-position: 0 0; }
.ui-icon-carat-1-ne { background-position: -16px 0; }
.ui-icon-carat-1-e { background-position: -32px 0; }
.ui-icon-carat-1-se { background-position: -48px 0; }
.ui-icon-carat-1-s { background-position: -64px 0; }
.ui-icon-carat-1-sw { background-position: -80px 0; }
.ui-icon-carat-1-w { background-position: -96px 0; }
.ui-icon-carat-1-nw { background-position: -112px 0; }
.ui-icon-carat-2-n-s { background-position: -128px 0; }
.ui-icon-carat-2-e-w { background-position: -144px 0; }
.ui-icon-triangle-1-n { background-position: 0 -16px; }
.ui-icon-triangle-1-ne { background-position: -16px -16px; }
.ui-icon-triangle-1-e { background-position: -32px -16px; }
.ui-icon-triangle-1-se { background-position: -48px -16px; }
.ui-icon-triangle-1-s { background-position: -64px -16px; }
.ui-icon-triangle-1-sw { background-position: -80px -16px; }
.ui-icon-triangle-1-w { background-position: -96px -16px; }
.ui-icon-triangle-1-nw { background-position: -112px -16px; }
.ui-icon-triangle-2-n-s { background-position: -128px -16px; }
.ui-icon-triangle-2-e-w { background-position: -144px -16px; }
.ui-icon-arrow-1-n { background-position: 0 -32px; }
.ui-icon-arrow-1-ne { background-position: -16px -32px; }
.ui-icon-arrow-1-e { background-position: -32px -32px; }
.ui-icon-arrow-1-se { background-position: -48px -32px; }
.ui-icon-arrow-1-s { background-position: -64px -32px; }
.ui-icon-arrow-1-sw { background-position: -80px -32px; }
.ui-icon-arrow-1-w { background-position: -96px -32px; }
.ui-icon-arrow-1-nw { background-position: -112px -32px; }
.ui-icon-arrow-2-n-s { background-position: -128px -32px; }
.ui-icon-arrow-2-ne-sw { background-position: -144px -32px; }
.ui-icon-arrow-2-e-w { background-position: -160px -32px; }
.ui-icon-arrow-2-se-nw { background-position: -176px -32px; }
.ui-icon-arrowstop-1-n { background-position: -192px -32px; }
.ui-icon-arrowstop-1-e { background-position: -208px -32px; }
.ui-icon-arrowstop-1-s { background-position: -224px -32px; }
.ui-icon-arrowstop-1-w { background-position: -240px -32px; }
.ui-icon-arrowthick-1-n { background-position: 0 -48px; }
.ui-icon-arrowthick-1-ne { background-position: -16px -48px; }
.ui-icon-arrowthick-1-e { background-position: -32px -48px; }
.ui-icon-arrowthick-1-se { background-position: -48px -48px; }
.ui-icon-arrowthick-1-s { background-position: -64px -48px; }
.ui-icon-arrowthick-1-sw { background-position: -80px -48px; }
.ui-icon-arrowthick-1-w { background-position: -96px -48px; }
.ui-icon-arrowthick-1-nw { background-position: -112px -48px; }
.ui-icon-arrowthick-2-n-s { background-position: -128px -48px; }
.ui-icon-arrowthick-2-ne-sw { background-position: -144px -48px; }
.ui-icon-arrowthick-2-e-w { background-position: -160px -48px; }
.ui-icon-arrowthick-2-se-nw { background-position: -176px -48px; }
.ui-icon-arrowthickstop-1-n { background-position: -192px -48px; }
.ui-icon-arrowthickstop-1-e { background-position: -208px -48px; }
.ui-icon-arrowthickstop-1-s { background-position: -224px -48px; }
.ui-icon-arrowthickstop-1-w { background-position: -240px -48px; }
.ui-icon-arrowreturnthick-1-w { background-position: 0 -64px; }
.ui-icon-arrowreturnthick-1-n { background-position: -16px -64px; }
.ui-icon-arrowreturnthick-1-e { background-position: -32px -64px; }
.ui-icon-arrowreturnthick-1-s { background-position: -48px -64px; }
.ui-icon-arrowreturn-1-w { background-position: -64px -64px; }
.ui-icon-arrowreturn-1-n { background-position: -80px -64px; }
.ui-icon-arrowreturn-1-e { background-position: -96px -64px; }
.ui-icon-arrowreturn-1-s { background-position: -112px -64px; }
.ui-icon-arrowrefresh-1-w { background-position: -128px -64px; }
.ui-icon-arrowrefresh-1-n { background-position: -144px -64px; }
.ui-icon-arrowrefresh-1-e { background-position: -160px -64px; }
.ui-icon-arrowrefresh-1-s { background-position: -176px -64px; }
.ui-icon-arrow-4 { background-position: 0 -80px; }
.ui-icon-arrow-4-diag { background-position: -16px -80px; }
.ui-icon-extlink { background-position: -32px -80px; }
.ui-icon-newwin { background-position: -48px -80px; }
.ui-icon-refresh { background-position: -64px -80px; }
.ui-icon-shuffle { background-position: -80px -80px; }
.ui-icon-transfer-e-w { background-position: -96px -80px; }
.ui-icon-transferthick-e-w { background-position: -112px -80px; }
.ui-icon-folder-collapsed { background-position: 0 -96px; }
.ui-icon-folder-open { background-position: -16px -96px; }
.ui-icon-document { background-position: -32px -96px; }
.ui-icon-document-b { background-position: -48px -96px; }
.ui-icon-note { background-position: -64px -96px; }
.ui-icon-mail-closed { background-position: -80px -96px; }
.ui-icon-mail-open { background-position: -96px -96px; }
.ui-icon-suitcase { background-position: -112px -96px; }
.ui-icon-comment { background-position: -128px -96px; }
.ui-icon-person { background-position: -144px -96px; }
.ui-icon-print { background-position: -160px -96px; }
.ui-icon-trash { background-position: -176px -96px; }
.ui-icon-locked { background-position: -192px -96px; }
.ui-icon-unlocked { background-position: -208px -96px; }
.ui-icon-bookmark { background-position: -224px -96px; }
.ui-icon-tag { background-position: -240px -96px; }
.ui-icon-home { background-position: 0 -112px; }
.ui-icon-flag { background-position: -16px -112px; }
.ui-icon-calendar { background-position: -32px -112px; }
.ui-icon-cart { background-position: -48px -112px; }
.ui-icon-pencil { background-position: -64px -112px; }
.ui-icon-clock { background-position: -80px -112px; }
.ui-icon-disk { background-position: -96px -112px; }
.ui-icon-calculator { background-position: -112px -112px; }
.ui-icon-zoomin { background-position: -128px -112px; }
.ui-icon-zoomout { background-position: -144px -112px; }
.ui-icon-search { background-position: -160px -112px; }
.ui-icon-wrench { background-position: -176px -112px; }
.ui-icon-gear { background-position: -192px -112px; }
.ui-icon-heart { background-position: -208px -112px; }
.ui-icon-star { background-position: -224px -112px; }
.ui-icon-link { background-position: -240px -112px; }
.ui-icon-cancel { background-position: 0 -128px; }
.ui-icon-plus { background-position: -16px -128px; }
.ui-icon-plusthick { background-position: -32px -128px; }
.ui-icon-minus { background-position: -48px -128px; }
.ui-icon-minusthick { background-position: -64px -128px; }
.ui-icon-close { background-position: -80px -128px; }
.ui-icon-closethick { background-position: -96px -128px; }
.ui-icon-key { background-position: -112px -128px; }
.ui-icon-lightbulb { background-position: -128px -128px; }
.ui-icon-scissors { background-position: -144px -128px; }
.ui-icon-clipboard { background-position: -160px -128px; }
.ui-icon-copy { background-position: -176px -128px; }
.ui-icon-contact { background-position: -192px -128px; }
.ui-icon-image { background-position: -208px -128px; }
.ui-icon-video { background-position: -224px -128px; }
.ui-icon-script { background-position: -240px -128px; }
.ui-icon-alert { background-position: 0 -144px; }
.ui-icon-info { background-position: -16px -144px; }
.ui-icon-notice { background-position: -32px -144px; }
.ui-icon-help { background-position: -48px -144px; }
.ui-icon-check { background-position: -64px -144px; }
.ui-icon-bullet { background-position: -80px -144px; }
.ui-icon-radio-off { background-position: -96px -144px; }
.ui-icon-radio-on { background-position: -112px -144px; }
.ui-icon-pin-w { background-position: -128px -144px; }
.ui-icon-pin-s { background-position: -144px -144px; }
.ui-icon-play { background-position: 0 -160px; }
.ui-icon-pause { background-position: -16px -160px; }
.ui-icon-seek-next { background-position: -32px -160px; }
.ui-icon-seek-prev { background-position: -48px -160px; }
.ui-icon-seek-end { background-position: -64px -160px; }
.ui-icon-seek-start { background-position: -80px -160px; }*/
/* ui-icon-seek-first is deprecated, use ui-icon-seek-start instead */
/*.ui-icon-seek-first { background-position: -80px -160px; }
.ui-icon-stop { background-position: -96px -160px; }
.ui-icon-eject { background-position: -112px -160px; }
.ui-icon-volume-off { background-position: -128px -160px; }
.ui-icon-volume-on { background-position: -144px -160px; }
.ui-icon-power { background-position: 0 -176px; }
.ui-icon-signal-diag { background-position: -16px -176px; }
.ui-icon-signal { background-position: -32px -176px; }
.ui-icon-battery-0 { background-position: -48px -176px; }
.ui-icon-battery-1 { background-position: -64px -176px; }
.ui-icon-battery-2 { background-position: -80px -176px; }
.ui-icon-battery-3 { background-position: -96px -176px; }
.ui-icon-circle-plus { background-position: 0 -192px; }
.ui-icon-circle-minus { background-position: -16px -192px; }
.ui-icon-circle-close { background-position: -32px -192px; }
.ui-icon-circle-triangle-e { background-position: -48px -192px; }
.ui-icon-circle-triangle-s { background-position: -64px -192px; }
.ui-icon-circle-triangle-w { background-position: -80px -192px; }
.ui-icon-circle-triangle-n { background-position: -96px -192px; }
.ui-icon-circle-arrow-e { background-position: -112px -192px; }
.ui-icon-circle-arrow-s { background-position: -128px -192px; }
.ui-icon-circle-arrow-w { background-position: -144px -192px; }
.ui-icon-circle-arrow-n { background-position: -160px -192px; }
.ui-icon-circle-zoomin { background-position: -176px -192px; }
.ui-icon-circle-zoomout { background-position: -192px -192px; }
.ui-icon-circle-check { background-position: -208px -192px; }
.ui-icon-circlesmall-plus { background-position: 0 -208px; }
.ui-icon-circlesmall-minus { background-position: -16px -208px; }
.ui-icon-circlesmall-close { background-position: -32px -208px; }
.ui-icon-squaresmall-plus { background-position: -48px -208px; }
.ui-icon-squaresmall-minus { background-position: -64px -208px; }
.ui-icon-squaresmall-close { background-position: -80px -208px; }
.ui-icon-grip-dotted-vertical { background-position: 0 -224px; }
.ui-icon-grip-dotted-horizontal { background-position: -16px -224px; }
.ui-icon-grip-solid-vertical { background-position: -32px -224px; }
.ui-icon-grip-solid-horizontal { background-position: -48px -224px; }
.ui-icon-gripsmall-diagonal-se { background-position: -64px -224px; }
.ui-icon-grip-diagonal-se { background-position: -80px -224px; }*/


/* Misc visuals
----------------------------------*/

/* Corner radius */
/*.ui-corner-all, .ui-corner-top, .ui-corner-left, .ui-corner-tl { -moz-border-radius-topleft: 4px; -webkit-border-top-left-radius: 4px; -khtml-border-top-left-radius: 4px; border-top-left-radius: 4px; }
.ui-corner-all, .ui-corner-top, .ui-corner-right, .ui-corner-tr { -moz-border-radius-topright: 4px; -webkit-border-top-right-radius: 4px; -khtml-border-top-right-radius: 4px; border-top-right-radius: 4px; }
.ui-corner-all, .ui-corner-bottom, .ui-corner-left, .ui-corner-bl { -moz-border-radius-bottomleft: 4px; -webkit-border-bottom-left-radius: 4px; -khtml-border-bottom-left-radius: 4px; border-bottom-left-radius: 4px; }
.ui-corner-all, .ui-corner-bottom, .ui-corner-right, .ui-corner-br { -moz-border-radius-bottomright: 4px; -webkit-border-bottom-right-radius: 4px; -khtml-border-bottom-right-radius: 4px; border-bottom-right-radius: 4px; }*/

/* Overlays */
/*.ui-widget-overlay { background: #666666 url(images/ui-bg_diagonals-thick_20_666666_40x40.png) 50% 50% repeat; opacity: .50;filter:Alpha(Opacity=50); }
.ui-widget-shadow { margin: -5px 0 0 -5px; padding: 5px; background: #000000 url(images/ui-bg_flat_10_000000_40x100.png) 50% 50% repeat-x; opacity: .20;filter:Alpha(Opacity=20); -moz-border-radius: 5px; -khtml-border-radius: 5px; -webkit-border-radius: 5px; border-radius: 5px; }*//*
 * jQuery UI Resizable 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Resizable#theming
 */
.ui-resizable { position: relative;}
.ui-resizable-handle { position: absolute;font-size: 0.1px;z-index: 99999; display: block; }
.ui-resizable-disabled .ui-resizable-handle, .ui-resizable-autohide .ui-resizable-handle { display: none; }
.ui-resizable-n { cursor: n-resize; height: 7px; width: 100%; top: -5px; left: 0; }
.ui-resizable-s { cursor: s-resize; height: 7px; width: 100%; bottom: -5px; left: 0; }
.ui-resizable-e { cursor: e-resize; width: 7px; right: -5px; top: 0; height: 100%; }
.ui-resizable-w { cursor: w-resize; width: 7px; left: -5px; top: 0; height: 100%; }
.ui-resizable-se { cursor: se-resize; width: 12px; height: 12px; right: 1px; bottom: 1px; }
.ui-resizable-sw { cursor: sw-resize; width: 9px; height: 9px; left: -5px; bottom: -5px; }
.ui-resizable-nw { cursor: nw-resize; width: 9px; height: 9px; left: -5px; top: -5px; }
.ui-resizable-ne { cursor: ne-resize; width: 9px; height: 9px; right: -5px; top: -5px;}/*
 * jQuery UI Selectable 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Selectable#theming
 */
.ui-selectable-helper { position: absolute; z-index: 100; border:1px dotted black; }
/*
 * jQuery UI Accordion 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Accordion#theming
 */
/* IE/Win - Fix animation bug - #4615 */
.ui-accordion { width: 100%; }
.ui-accordion .ui-accordion-header { cursor: pointer; /*position: relative; margin-top: 1px;*/ zoom: 1; }
.ui-accordion .ui-accordion-li-fix { display: inline; }
.ui-accordion .ui-accordion-header-active { border-bottom: 0 !!important; }
.ui-accordion .ui-accordion-header a { display: block; font-size:26px /*1em*/; padding: .5em .5em .5em .7em; }
.ui-accordion-icons .ui-accordion-header a { /*padding-left: 2.2em;*/ }
.ui-accordion .ui-accordion-header .ui-icon { position: absolute; left: .5em; top: 50%; margin-top: -8px; }
.ui-accordion .ui-accordion-content {/* padding: 1em 2.2em; border-top: 0; margin-top: -2px; position: relative; top: 1px; margin-bottom: 2px; overflow: auto; display: none;*/ zoom: 1;overflow:hidden;padding:20px !!important; } 
.ui-accordion .ui-accordion-content-active { display: block; height:auto; }
/*
 * jQuery UI Autocomplete 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Autocomplete#theming
 */
.ui-autocomplete { position: absolute; cursor: default; }	

/* workarounds */
* html .ui-autocomplete { width:1px; } /* without this, the menu expands to 100% in IE6 */

/*
 * jQuery UI Menu 1.8.16
 *
 * Copyright 2010, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Menu#theming
 */
.ui-menu {
	list-style:none;
	padding: 2px;
	margin: 0;
	display:block;
	float: left;
}
.ui-menu .ui-menu {
	margin-top: -3px;
}
.ui-menu .ui-menu-item {
	margin:0;
	padding: 0;
	zoom: 1;
	float: left;
	clear: left;
	width: 100%;
}
.ui-menu .ui-menu-item a {
	text-decoration:none;
	display:block;
	padding:.2em .4em;
	line-height:1.5;
	zoom:1;
}
.ui-menu .ui-menu-item a.ui-state-hover,
.ui-menu .ui-menu-item a.ui-state-active {
	font-weight: normal;
	margin: -1px;
}
/*
 * jQuery UI Button 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Button#theming
 */
.ui-button { display: inline-block; position: relative; padding: 0; margin-right: .1em; text-decoration: none !!important; cursor: pointer; text-align: center; zoom: 1; overflow: visible; } /* the overflow property removes extra width in IE */
.ui-button-icon-only { width: 2.2em; } /* to make room for the icon, a width needs to be set here */
button.ui-button-icon-only { width: 2.4em; } /* button elements seem to need a little more width */
.ui-button-icons-only { width: 3.4em; } 
button.ui-button-icons-only { width: 3.7em; } 

/*button text element */
.ui-button .ui-button-text { display: block; line-height: 1.4;  }
.ui-button-text-only .ui-button-text { padding: .4em 1em; }
.ui-button-icon-only .ui-button-text, .ui-button-icons-only .ui-button-text { padding: .4em; text-indent: -9999999px; }
.ui-button-text-icon-primary .ui-button-text, .ui-button-text-icons .ui-button-text { padding:0; /*padding: .4em 1em .4em 2.1em; */}
.ui-button-text-icon-secondary .ui-button-text, .ui-button-text-icons .ui-button-text { padding:0;/*padding: .4em 2.1em .4em 1em;*/ }
.ui-button-text-icons .ui-button-text { padding-left: 2.1em; padding-right: 2.1em; }
/* no icon support for input elements, provide padding by default */
input.ui-button { padding: .4em 1em; }

/*button icon element(s) */
.ui-button-icon-only .ui-icon, .ui-button-text-icon-primary .ui-icon, .ui-button-text-icon-secondary .ui-icon, .ui-button-text-icons .ui-icon, .ui-button-icons-only .ui-icon { position: absolute; top: 50%; margin-top: -8px; }
.ui-button-icon-only .ui-icon { left: 50%; margin-left: -8px; }
.ui-button-text-icon-primary .ui-button-icon-primary, .ui-button-text-icons .ui-button-icon-primary, .ui-button-icons-only .ui-button-icon-primary { left: .5em; }
.ui-button-text-icon-secondary .ui-button-icon-secondary, .ui-button-text-icons .ui-button-icon-secondary, .ui-button-icons-only .ui-button-icon-secondary { right: .5em; }
.ui-button-text-icons .ui-button-icon-secondary, .ui-button-icons-only .ui-button-icon-secondary { right: .5em; }

/*button sets*/
.ui-buttonset { margin-right: 7px; }
.ui-buttonset .ui-button { margin-left: 0; margin-right: -.3em; }

/* workarounds */
button.ui-button::-moz-focus-inner { border: 0; padding: 0; } /* reset extra padding in Firefox */
/*
 * jQuery UI Dialog 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Dialog#theming
 */
.ui-dialog { position: absolute; padding: .2em; width: 300px; overflow: hidden; }
.ui-dialog .ui-dialog-titlebar { padding: .4em 1em; position: relative;  }
.ui-dialog .ui-dialog-title { float: left; margin: .1em 16px .1em 0; } 
.ui-dialog .ui-dialog-titlebar-close { position: absolute; right: .3em; top: 50%; width: 19px; margin: -10px 0 0 0; padding: 1px; height: 18px; }
.ui-dialog .ui-dialog-titlebar-close span { display: block; margin: 1px; }
.ui-dialog .ui-dialog-titlebar-close:hover, .ui-dialog .ui-dialog-titlebar-close:focus { padding: 0; }
.ui-dialog .ui-dialog-content { position: relative; border: 0; padding: .5em 1em; background: none; overflow: auto; zoom: 1; }
.ui-dialog .ui-dialog-buttonpane { text-align: left; border-width: 1px 0 0 0; background-image: none; margin: .5em 0 0 0; padding: .3em 1em .5em .4em; }
.ui-dialog .ui-dialog-buttonpane .ui-dialog-buttonset { float: right; }
.ui-dialog .ui-dialog-buttonpane button { margin: .5em .4em .5em 0; cursor: pointer; }
.ui-dialog .ui-resizable-se { width: 14px; height: 14px; right: 3px; bottom: 3px; }
.ui-draggable .ui-dialog-titlebar { cursor: move; }
/*
 * jQuery UI Slider 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Slider#theming
 */
.ui-slider { position: relative; text-align: left; }
.ui-slider .ui-slider-handle { position: absolute; z-index: 2; width: 1.2em; height: 1.2em; cursor: default; }
.ui-slider .ui-slider-range { position: absolute; z-index: 1; font-size: .7em; display: block; border: 0; background-position: 0 0; }

.ui-slider-horizontal { height: .8em; }
.ui-slider-horizontal .ui-slider-handle { top: -.3em; margin-left: -.6em; }
.ui-slider-horizontal .ui-slider-range { top: 0; height: 100%; }
.ui-slider-horizontal .ui-slider-range-min { left: 0; }
.ui-slider-horizontal .ui-slider-range-max { right: 0; }

.ui-slider-vertical { width: .8em; height: 100px; }
.ui-slider-vertical .ui-slider-handle { left: -.3em; margin-left: 0; margin-bottom: -.6em; }
.ui-slider-vertical .ui-slider-range { left: 0; width: 100%; }
.ui-slider-vertical .ui-slider-range-min { bottom: 0; }
.ui-slider-vertical .ui-slider-range-max { top: 0; }/*
 * jQuery UI Tabs 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Tabs#theming
 */
.ui-tabs { position: relative; padding: .2em; zoom: 1; } /* position: relative prevents IE scroll bug (element with position: relative inside container with overflow: auto appear as "fixed") */
.ui-tabs .ui-tabs-nav { margin: 0; padding: .2em .2em 0; }
.ui-tabs .ui-tabs-nav li { list-style: none; float: left; position: relative; top: 1px; margin: 0 .2em 1px 0; border-bottom: 0 !!important; padding: 0; white-space: nowrap; }
.ui-tabs .ui-tabs-nav li a { float: left; padding: .5em 1em; text-decoration: none; }
.ui-tabs .ui-tabs-nav li.ui-tabs-selected { margin-bottom: 0; padding-bottom: 1px; }
.ui-tabs .ui-tabs-nav li.ui-tabs-selected a, .ui-tabs .ui-tabs-nav li.ui-state-disabled a, .ui-tabs .ui-tabs-nav li.ui-state-processing a { cursor: text; }
.ui-tabs .ui-tabs-nav li a, .ui-tabs.ui-tabs-collapsible .ui-tabs-nav li.ui-tabs-selected a { cursor: pointer; } /* first selector in group seems obsolete, but required to overcome bug in Opera applying cursor: text overall if defined elsewhere... */
.ui-tabs .ui-tabs-panel { display: block; border-width: 0; padding: 1em 1.4em; background: none; }
.ui-tabs .ui-tabs-hide { display: none !!important; }
/*
 * jQuery UI Datepicker 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Datepicker#theming
 */
.ui-datepicker { width: 17em; padding: .2em .2em 0; display: none; }
.ui-datepicker .ui-datepicker-header { position:relative; padding:.2em 0; }
.ui-datepicker .ui-datepicker-prev, .ui-datepicker .ui-datepicker-next { position:absolute; top: 2px; width: 1.8em; height: 1.8em; }
.ui-datepicker .ui-datepicker-prev-hover, .ui-datepicker .ui-datepicker-next-hover { top: 1px; }
.ui-datepicker .ui-datepicker-prev { left:2px; }
.ui-datepicker .ui-datepicker-next { right:2px; }
.ui-datepicker .ui-datepicker-prev-hover { left:1px; }
.ui-datepicker .ui-datepicker-next-hover { right:1px; }
.ui-datepicker .ui-datepicker-prev span, .ui-datepicker .ui-datepicker-next span { display: block; position: absolute; left: 50%; margin-left: -8px; top: 50%; margin-top: -8px;  }
.ui-datepicker .ui-datepicker-title { margin: 0 2.3em; line-height: 1.8em; text-align: center; }
.ui-datepicker .ui-datepicker-title select { font-size:1em; margin:1px 0; }
.ui-datepicker select.ui-datepicker-month-year {width: 100%;}
.ui-datepicker select.ui-datepicker-month, 
.ui-datepicker select.ui-datepicker-year { width: 49%;}
.ui-datepicker table {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
.ui-datepicker th { padding: .7em .3em; text-align: center; font-weight: bold; border: 0;  }
.ui-datepicker td { border: 0; padding: 1px; }
.ui-datepicker td span, .ui-datepicker td a { display: block; padding: .2em; text-align: right; text-decoration: none; }
.ui-datepicker .ui-datepicker-buttonpane { background-image: none; margin: .7em 0 0 0; padding:0 .2em; border-left: 0; border-right: 0; border-bottom: 0; }
.ui-datepicker .ui-datepicker-buttonpane button { float: right; margin: .5em .2em .4em; cursor: pointer; padding: .2em .6em .3em .6em; width:auto; overflow:visible; }
.ui-datepicker .ui-datepicker-buttonpane button.ui-datepicker-current { float:left; }

/* with multiple calendars */
.ui-datepicker.ui-datepicker-multi { width:auto; }
.ui-datepicker-multi .ui-datepicker-group { float:left; }
.ui-datepicker-multi .ui-datepicker-group table { width:95%; margin:0 auto .4em; }
.ui-datepicker-multi-2 .ui-datepicker-group { width:50%; }
.ui-datepicker-multi-3 .ui-datepicker-group { width:33.3%; }
.ui-datepicker-multi-4 .ui-datepicker-group { width:25%; }
.ui-datepicker-multi .ui-datepicker-group-last .ui-datepicker-header { border-left-width:0; }
.ui-datepicker-multi .ui-datepicker-group-middle .ui-datepicker-header { border-left-width:0; }
.ui-datepicker-multi .ui-datepicker-buttonpane { clear:left; }
.ui-datepicker-row-break { clear:both; width:100%; font-size:0em; }

/* RTL support */
.ui-datepicker-rtl { direction: rtl; }
.ui-datepicker-rtl .ui-datepicker-prev { right: 2px; left: auto; }
.ui-datepicker-rtl .ui-datepicker-next { left: 2px; right: auto; }
.ui-datepicker-rtl .ui-datepicker-prev:hover { right: 1px; left: auto; }
.ui-datepicker-rtl .ui-datepicker-next:hover { left: 1px; right: auto; }
.ui-datepicker-rtl .ui-datepicker-buttonpane { clear:right; }
.ui-datepicker-rtl .ui-datepicker-buttonpane button { float: left; }
.ui-datepicker-rtl .ui-datepicker-buttonpane button.ui-datepicker-current { float:right; }
.ui-datepicker-rtl .ui-datepicker-group { float:right; }
.ui-datepicker-rtl .ui-datepicker-group-last .ui-datepicker-header { border-right-width:0; border-left-width:1px; }
.ui-datepicker-rtl .ui-datepicker-group-middle .ui-datepicker-header { border-right-width:0; border-left-width:1px; }

/* IE6 IFRAME FIX (taken from datepicker 1.5.3 */
.ui-datepicker-cover {
    display: none; /*sorry for IE5*/
    display/**/: block; /*sorry for IE5*/
    position: absolute; /*must have*/
    z-index: -1; /*must have*/
    filter: mask(); /*must have*/
    top: -4px; /*must have*/
    left: -4px; /*must have*/
    width: 200px; /*must have*/
    height: 200px; /*must have*/
}/*
 * jQuery UI Progressbar 1.8.16
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Progressbar#theming
 */
.ui-progressbar { height:2em; text-align: left; }
.ui-progressbar .ui-progressbar-value {margin: -1px; height:100%; }'! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 5/16/2013 14:11'!
manloginCssBACKUP
	^ 'html { 
	background: url(''../images/bg.jpg'') no-repeat center center fixed; 
	-webkit-background-size: cover;
	-moz-background-size: cover;
	-o-background-size: cover;
	background-size: cover;
}

body {
	 font-family: ''geosanslightregular'';
	 font-size:20px;
	 line-height:26px;
	 color:#2c2c2c;
}

@font-face {
    font-family: ''geosanslightregular'';
    src: url(''../font/geosanslight-webfont.eot'');
    src: url(''../font/geosanslight-webfont.eot?#iefix'') format(''embedded-opentype''),
         url(''../font/geosanslight-webfont.woff'') format(''woff''),
         url(''../font/geosanslight-webfont.ttf'') format(''truetype''),
         url(''../font/geosanslight-webfont.svg#geosanslightregular'') format(''svg'');
    font-weight: normal;
    font-style: normal;
}

@font-face {
    font-family: ''geosanslightmedium_italic'';
    src: url(''../font/geosanslight-oblique-webfont.eot'');
    src: url(''../font/geosanslight-oblique-webfont.eot?#iefix'') format(''embedded-opentype''),
         url(''../font/geosanslight-oblique-webfont.woff'') format(''woff''),
         url(''../font/geosanslight-oblique-webfont.ttf'') format(''truetype''),
         url(''../font/geosanslight-oblique-webfont.svg#geosanslightmedium_italic'') format(''svg'');
    font-weight: normal;
    font-style: normal;
}

@font-face {
    font-family: ''cheveuxdangemedium'';
    src: url(''../font/cheveuxdange-webfont.eot'');
    src: url(''../font/cheveuxdange-webfont.eot?#iefix'') format(''embedded-opentype''),
         url(''../font/cheveuxdange-webfont.woff'') format(''woff''),
         url(''../font/cheveuxdange-webfont.ttf'') format(''truetype''),
         url(''../font/cheveuxdange-webfont.svg#cheveuxdangemedium'') format(''svg'');
    font-weight: normal;
    font-style: normal;
}

a { color:#1a8bbf; text-decoration:underline; }
a:hover { text-decoration:none; }
.clear { clear:both; }

h1 { font-size:72px;color:#1a8bbf;font-weight:normal; }
h2 { font-size:36px;font-weight:normal; }
h1.subtitle { padding:0;margin:0;font-family: ''cheveuxdangemedium'';font-size:36px;color:#000;line-height:36px;background:url(''../images/arrow.png'') no-repeat 0 45px;height:115px; }
h1.subtitle span { padding-left:40px; }
h1.slogan { font-size:62px;margin-top:230px;color:#2c2c2c; }

#content, #footer { width:auto;margin:0 40px; }

#footer, #content { 	
	-webkit-box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	box-shadow:  0px 5px 20px 0px rgba(50, 50, 50, 50);
	
	background:url(''../images/bg-trans.png'') repeat 0 0;
}
	
#footer, #content { width:auto; }

#content { 
	margin:160px 40px 20px 40px;
	padding:60px;  
}

#content .contentInner { width:60%;text-align:justify;float:left; }
#content .contentInnerSub { width:54%;text-align:justify;float:left; }
#content .logo { width:40%;float:right; }

.button {
	display: block;
	outline: none;
	cursor: pointer;
	text-align: center;
	text-decoration: none;
	font: 26px/26px Arial, Helvetica, sans-serif;
	font-weight:bold;
	width:331px;
	height:72px;
	line-height:72px;
	margin:0 0 10px 70px;
	text-shadow: 0 1px 1px rgba(22,109,147,.3);
	
	-webkit-border-radius: .3em; 
	-moz-border-radius: .3em;
	border-radius: .3em;
	-webkit-box-shadow: 0 1px 2px rgba(0,0,0,.2);
	-moz-box-shadow: 0 1px 2px rgba(0,0,0,.2);
	box-shadow: 0 1px 2px rgba(0,0,0,.2);
}

.button:hover {	text-decoration: none; }
.button:active { position: relative;top: 1px; }

.blue {
	color: #fff;
	border: solid 1px #156a90;
	background: #2098ce;
	background: -webkit-gradient(linear, left top, left bottom, from(#2098ce), to(#1886b8));
	background: -moz-linear-gradient(top,  #2098ce,  #1886b8);
	filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#2098ce'', endColorstr=''#1886b8'');
}

.blue:hover {
	background: #fff;
	background: #1886b8;
	background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));
	background: -moz-linear-gradient(top,  #1886b8,  #2098ce);
	filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');
}

.blue:active {
	color: #fff;
	background: -webkit-gradient(linear, left top, left bottom, from(#1886b8), to(#2098ce));
	background: -moz-linear-gradient(top,  #1886b8,  #2098ce);
	filter:  progid:DXImageTransform.Microsoft.gradient(startColorstr=''#1886b8'', endColorstr=''#2098ce'');
}


#footer { 
	height:25px;
	line-height:25px;
	font-size:18px;
	padding:20px;
}

#footer span.left { width:15%; }

#footer ul.right { 
	text-align:right;
	padding:0;
	margin:0; 
	float: right;
}

#footer ul.right li { 
	display:inline;
	padding:0 10px;
	background:url(''../images/trenner.gif'') no-repeat center right;
}

#footer a { color:#2c2c2c; text-decoration:none; }
#footer a:hover { text-decoration:underline; }'! !

!RKALibrary methodsFor: 'css' stamp: 'SabineKnoefel 5/24/2013 16:14'!
manuijqgridCss
	^ '.ui-jqgrid {/*font-size: 11px;*/position: relative;}
.ui-jqgrid .ui-jqgrid-view { left: 0;padding: 0;position: relative;top: 0; }
.ui-jqgrid .ui-jqgrid-titlebar {border-left: 0 none;border-right: 0 none;border-top: 0 none;padding: 0.3em 0.2em 0.2em 0.3em;position: relative;}
.ui-jqgrid .ui-jqgrid-title {float: left;margin: 0.1em 0 0.2em;}
.ui-jqgrid .ui-jqgrid-titlebar-close {height: 18px;margin: -10px 0 0;padding: 1px;position: absolute;top: 50%;width: 19px;}
.ui-jqgrid .ui-jqgrid-titlebar-close span {display: block;margin: 1px;}
.ui-jqgrid .ui-jqgrid-titlebar-close:hover {padding: 0;}
.ui-jqgrid .ui-jqgrid-hdiv {border-left: 0 none !!important;border-right: 0 none !!important;border-top: 0 none !!important;margin: 0;overflow-x: hidden;overflow-y: auto;padding: 0;position: relative;}
.ui-jqgrid .ui-jqgrid-hbox {float: left;padding-right: 20px;}
.ui-jqgrid .ui-jqgrid-htable {margin: 0;table-layout: fixed;}
.ui-jqgrid .ui-jqgrid-htable th {height: 25px;padding: 0 2px;}
.ui-jqgrid .ui-jqgrid-htable th div {height: 25px;overflow: hidden;position: relative;}

.ui-th-column, .ui-jqgrid .ui-jqgrid-htable th.ui-th-column {border-bottom: 0 none;border-top: 0 none;overflow: hidden;text-align: center;/*white-space: nowrap;*/border-bottom-color: inherit;border-bottom-style: dotted;border-bottom-width: 1px;font-weight: normal;height: 22px;padding: 0 2px;white-space: pre;border-right-color: inherit;border-right-style: dotted;border-right-width: 1px;}

.ui-th-ltr, .ui-jqgrid .ui-jqgrid-htable th.ui-th-ltr {border-left: 0 none;}
.ui-th-rtl, .ui-jqgrid .ui-jqgrid-htable th.ui-th-rtl {border-right: 0 none;}

.ui-jqgrid .ui-th-div-ie {height: 22px;white-space: nowrap;}
.ui-jqgrid .ui-jqgrid-resize {cursor: e-resize;display: inline;height: 20px !!important;overflow: hidden;position: relative;}
.ui-jqgrid .ui-grid-ico-sort {cursor: pointer !!important;display: inline;overflow: hidden;position: absolute;}
.ui-jqgrid .ui-icon-asc {height: 12px;margin-top: -3px;}
.ui-jqgrid .ui-icon-desc {height: 12px;margin-top: 3px;}
.ui-jqgrid .ui-i-asc {height: 16px;margin-top: 0;}
.ui-jqgrid .ui-i-desc {height: 16px;margin-left: 13px;margin-top: 0;}
.ui-jqgrid .ui-jqgrid-sortable {cursor: pointer;}
.ui-jqgrid tr.ui-search-toolbar th {border-top-color: inherit !!important;border-top-style: ridge !!important;border-top-width: 1px !!important;}

tr.ui-search-toolbar input {margin: 1px 0 0;}
tr.ui-search-toolbar select {margin: 1px 0 0;}

.ui-jqgrid .ui-jqgrid-bdiv {margin: 0;overflow: auto;padding: 0;position: relative;}
.ui-jqgrid .ui-jqgrid-btable {margin: 0;table-layout: fixed;}
.ui-jqgrid tr.jqgrow td {border-bottom-color: inherit;border-bottom-style: dotted;border-bottom-width: 1px;font-weight: normal;height: 22px;overflow: hidden;padding: 0 2px;white-space: pre;}
.ui-jqgrid tr.ui-row-ltr td {border-right-color: inherit;border-right-style: dotted;border-right-width: 1px;text-align: left;}
.ui-jqgrid tr.ui-row-rtl td {border-left-color: inherit;border-left-style: dotted;border-left-width: 1px;text-align: right;}
.ui-jqgrid td.jqgrid-rownum {border: 0 none;margin: 0;padding: 0 2px;}
.ui-jqgrid .ui-jqgrid-resize-mark {background-color: #777777;border: 0 none;cursor: col-resize;display: none;height: 100px;left: 0;overflow: hidden;position: absolute;top: 0;width: 2px;}
.ui-jqgrid .ui-jqgrid-sdiv {border-left: 0 none !!important;border-right: 0 none !!important;border-top: 0 none !!important;margin: 0;overflow: hidden;padding: 0;position: relative;}
.ui-jqgrid .ui-jqgrid-ftable {margin-bottom: 0;table-layout: fixed;}
.ui-jqgrid tr.footrow td {border-top-color: inherit;border-top-style: solid;border-top-width: 1px;font-weight: bold;height: 21px;overflow: hidden;padding: 0 2px;white-space: nowrap;}
.ui-jqgrid tr.footrow-ltr td {border-right-color: inherit;border-right-style: solid;border-right-width: 1px;text-align: left;}
.ui-jqgrid tr.footrow-rtl td {border-left-color: inherit;border-left-style: solid;border-left-width: 1px;text-align: right;}
.ui-jqgrid .ui-jqgrid-pager {border-bottom: 0 none !!important;border-left: 0 none !!important;border-right: 0 none !!important;height: 25px;margin: 0 !!important;overflow: hidden;padding: 0 !!important;position: relative;white-space: nowrap;}
.ui-jqgrid .ui-pager-control {position: relative;}

.ui-jqgrid .ui-pg-table {margin: 0;padding-bottom: 2px;position: relative;width: auto;}
.ui-jqgrid .ui-pg-table td {font-weight: normal;padding: 1px;vertical-align: middle;}
.ui-jqgrid .ui-pg-button {height: 19px !!important;}
.ui-jqgrid .ui-pg-button span {display: block;float: left;margin: 1px;}
.ui-jqgrid .ui-pg-button:hover {padding: 0;}

.ui-jqgrid .ui-state-disabled:hover {padding: 1px;}
.ui-jqgrid .ui-pg-input {font-size: 0.8em;height: 13px;margin: 0;}
.ui-jqgrid .ui-pg-selbox {display: block;font-size: 0.8em;height: 18px;line-height: 18px;margin: 0;}
.ui-jqgrid .ui-separator {border-left: 1px solid #CCCCCC;border-right: 1px solid #CCCCCC;float: right;height: 18px;margin: 1px;}
.ui-jqgrid .ui-paging-info {font-weight: normal;height: 19px;margin-right: 4px;margin-top: 3px;}
.ui-jqgrid .ui-jqgrid-pager .ui-pg-div {cursor: pointer;float: left;list-style: none outside none;padding: 1px 0;position: relative;}
.ui-jqgrid .ui-jqgrid-pager .ui-pg-div span.ui-icon {float: left;margin: 0 2px;}
.ui-jqgrid td input, .ui-jqgrid td select .ui-jqgrid td textarea {margin: 0;}
.ui-jqgrid td textarea {height: auto;width: auto;}
.ui-jqgrid .ui-jqgrid-toppager {border-left: 0 none !!important;border-right: 0 none !!important;border-top: 0 none !!important;height: 25px !!important;margin: 0 !!important;overflow: hidden;padding: 0 !!important;position: relative;white-space: nowrap;}
.ui-jqgrid .ui-jqgrid-btable .ui-sgcollapsed span {display: block;}
.ui-jqgrid .ui-subgrid {margin: 0;padding: 0;width: 100%;}
.ui-jqgrid .ui-subgrid table {table-layout: fixed;}
.ui-jqgrid .ui-subgrid tr.ui-subtblcell td {border-bottom-color: inherit;border-bottom-style: solid;border-bottom-width: 1px;border-right-color: inherit;border-right-style: solid;border-right-width: 1px;height: 18px;}
.ui-jqgrid .ui-subgrid td.subgrid-data {border-top: 0 none !!important;}.ui-jqgrid .ui-subgrid td.subgrid-cell {border-width: 0 0 1px;}
.ui-jqgrid .ui-th-subgrid {height: 20px;}
.ui-jqgrid .loading {border-width: 2px !!important;display: none;font-weight: bold;left: 45%;margin: 5px;padding: 6px;position: absolute;text-align: center;top: 45%;width: auto;z-index: 101;}
.ui-jqgrid .jqgrid-overlay {display: none;z-index: 100;}
* html .jqgrid-overlay {}
* .jqgrid-overlay iframe {left: 0;position: absolute;top: 0;z-index: -1;}

.ui-jqgrid .ui-userdata {border-left: 0 none;border-right: 0 none;height: 21px;overflow: hidden;}

.ui-jqdialog {display: none;font-size: 11px;overflow: visible;padding: 0.2em;position: absolute;width: 300px;}
.ui-jqdialog .ui-jqdialog-titlebar {padding: 0.3em 0.2em;position: relative;}
.ui-jqdialog .ui-jqdialog-title {margin: 0.1em 0 0.2em;}
.ui-jqdialog .ui-jqdialog-titlebar-close {height: 18px;margin: -10px 0 0;padding: 1px;position: absolute;top: 50%;width: 19px;}
.ui-jqdialog .ui-jqdialog-titlebar-close span {display: block;margin: 1px;}
.ui-jqdialog .ui-jqdialog-titlebar-close:hover, .ui-jqdialog .ui-jqdialog-titlebar-close:focus {padding: 0;}
.ui-jqdialog-content, .ui-jqdialog .ui-jqdialog-content {background: none repeat scroll 0 0 transparent;border: 0 none;height: auto;padding: 0.3em 0.2em;}
.ui-jqdialog .ui-jqconfirm {border-width: 3px;bottom: 10px;display: none;height: 80px;overflow: visible;padding: 0.4em 1em;position: absolute;right: 10px;text-align: center;width: 220px;}
.ui-jqdialog-content .FormGrid {margin: 0;}
.ui-jqdialog-content .EditTable {margin-bottom: 0;width: 100%;}
.ui-jqdialog-content .DelTable {margin-bottom: 0;width: 100%;}

.EditTable td input, .EditTable td select, .EditTable td textarea {margin: 0;}
.EditTable td textarea {height: auto;width: auto;}
.ui-jqdialog-content td.EditButton {border-left: 0 none;border-right: 0 none;border-top: 0 none;padding-bottom: 5px;padding-top: 5px;text-align: right;}
.ui-jqdialog-content td.navButton {border-left: 0 none;border-right: 0 none;border-top: 0 none;padding-bottom: 5px;padding-top: 5px;text-align: center;}
.ui-jqdialog-content .CaptionTD {border-bottom: 0 none;border-left: 0 none;border-right: 0 none;padding: 1px;text-align: left;vertical-align: top;white-space: nowrap;}
.ui-jqdialog-content .DataTD {border-bottom: 0 none;border-left: 0 none;border-right: 0 none;padding: 1px;vertical-align: top;}
.ui-jqdialog-content .form-view-data {white-space: pre;}

.fm-button {cursor: pointer;display: inline-block;margin: 0 4px 0 0;padding: 0.4em 0.5em;position: relative;text-align: center;text-decoration: none !!important;}
.fm-button-icon-left {padding-left: 1.9em;}
.fm-button-icon-right {padding-right: 1.9em;}
.fm-button-icon-left .ui-icon {left: 0.2em;margin-left: 0;margin-top: -8px;position: absolute;right: auto;top: 50%;}
.fm-button-icon-right .ui-icon {left: auto;margin-left: 0;margin-top: -8px;position: absolute;right: 0.2em;top: 50%;}

#nData, #pData {float: left;margin: 3px;padding: 0;width: 15px;}

.ui-jqgrid .selected-row, div.ui-jqgrid .selected-row td {border-left: 0 none;font-style: normal;}
.ui-jqgrid .tree-wrap {float: left;height: 18px;overflow: hidden;position: relative;white-space: nowrap;}
.ui-jqgrid .tree-minus {height: 18px;overflow: hidden;position: absolute;width: 18px;}
.ui-jqgrid .tree-plus {height: 18px;overflow: hidden;position: absolute;width: 18px;}
.ui-jqgrid .tree-leaf {height: 18px;overflow: hidden;position: absolute;width: 18px;}
.ui-jqgrid .treeclick {cursor: pointer;}

.jqmOverlay {background-color: #000000;}

* iframe.jqm {left: 0;position: absolute;top: 0;z-index: -1;}

.ui-jqgrid-dnd tr td {border-right-color: inherit;border-right-style: solid;border-right-width: 1px;height: 20px;}
.ui-jqgrid .ui-jqgrid-title-rtl {float: right;margin: 0.1em 0 0.2em;}
.ui-jqgrid .ui-jqgrid-hbox-rtl {float: right;padding-left: 20px;}
.ui-jqgrid .ui-jqgrid-resize-ltr {float: right;margin: -2px -2px -2px 0;}
.ui-jqgrid .ui-jqgrid-resize-rtl {float: left;margin: -2px 0 -1px -3px;}
.ui-jqgrid .ui-sort-rtl {left: 0;}

.ui-jqgrid .tree-wrap-ltr {float: left;}
.ui-jqgrid .tree-wrap-rtl {float: right;}
.ui-jqgrid .ui-ellipsis {-moz-binding: url("ellipsis-xbl.xml#ellipsis");text-overflow: ellipsis;}

.ui-searchFilter {display: none;overflow: visible;position: absolute;z-index: 770;}
.ui-searchFilter table {margin: 0;position: relative;width: auto;}
.ui-searchFilter table td {margin: 0;padding: 1px;}
.ui-searchFilter table td input, .ui-searchFilter table td select {margin: 0.1em;}
.ui-searchFilter .ui-state-default {cursor: pointer;}
.ui-searchFilter .divider {height: 1px;}
.ui-searchFilter .divider div {background-color: black;height: 1px;}'! !

!RKALibrary methodsFor: 'old' stamp: 'SabineKnoefel 5/16/2013 14:11'!
manuijqgridCssBACKUP
	^ '.ui-jqgrid {
    font-size: 11px;
    position: relative;
}
.ui-jqgrid .ui-jqgrid-view {
    left: 0;
    padding: 0;
    position: relative;
    top: 0;
}
.ui-jqgrid .ui-jqgrid-titlebar {
    border-left: 0 none;
    border-right: 0 none;
    border-top: 0 none;
    padding: 0.3em 0.2em 0.2em 0.3em;
    position: relative;
}
.ui-jqgrid .ui-jqgrid-title {
    float: left;
    margin: 0.1em 0 0.2em;
}
.ui-jqgrid .ui-jqgrid-titlebar-close {
    height: 18px;
    margin: -10px 0 0;
    padding: 1px;
    position: absolute;
    top: 50%;
    width: 19px;
}
.ui-jqgrid .ui-jqgrid-titlebar-close span {
    display: block;
    margin: 1px;
}
.ui-jqgrid .ui-jqgrid-titlebar-close:hover {
    padding: 0;
}
.ui-jqgrid .ui-jqgrid-hdiv {
    border-left: 0 none !!important;
    border-right: 0 none !!important;
    border-top: 0 none !!important;
    margin: 0;
    overflow-x: hidden;
    overflow-y: auto;
    padding: 0;
    position: relative;
}
.ui-jqgrid .ui-jqgrid-hbox {
    float: left;
    padding-right: 20px;
}
.ui-jqgrid .ui-jqgrid-htable {
    margin: 0;
    table-layout: fixed;
}
.ui-jqgrid .ui-jqgrid-htable th {
    height: 22px;
    padding: 0 2px;
}
.ui-jqgrid .ui-jqgrid-htable th div {
    /*height: 17px;*/
    overflow: hidden;
    position: relative;
}
.ui-th-column, .ui-jqgrid .ui-jqgrid-htable th.ui-th-column {
    border-bottom: 0 none;
    border-top: 0 none;
    overflow: hidden;
    text-align: center;
    white-space: nowrap;
}
.ui-th-ltr, .ui-jqgrid .ui-jqgrid-htable th.ui-th-ltr {
    border-left: 0 none;
}
.ui-th-rtl, .ui-jqgrid .ui-jqgrid-htable th.ui-th-rtl {
    border-right: 0 none;
}
.ui-jqgrid .ui-th-div-ie {
    height: 17px;
    white-space: nowrap;
}
.ui-jqgrid .ui-jqgrid-resize {
    cursor: e-resize;
    display: inline;
    height: 20px !!important;
    overflow: hidden;
    position: relative;
}
.ui-jqgrid .ui-grid-ico-sort {
    cursor: pointer !!important;
    display: inline;
    overflow: hidden;
    position: absolute;
}
.ui-jqgrid .ui-icon-asc {
    height: 12px;
    margin-top: -3px;
}
.ui-jqgrid .ui-icon-desc {
    height: 12px;
    margin-top: 3px;
}
.ui-jqgrid .ui-i-asc {
    height: 16px;
    margin-top: 0;
}
.ui-jqgrid .ui-i-desc {
    height: 16px;
    margin-left: 13px;
    margin-top: 0;
}
.ui-jqgrid .ui-jqgrid-sortable {
    cursor: pointer;
}
.ui-jqgrid tr.ui-search-toolbar th {
    border-top-color: inherit !!important;
    border-top-style: ridge !!important;
    border-top-width: 1px !!important;
}
tr.ui-search-toolbar input {
    margin: 1px 0 0;
}
tr.ui-search-toolbar select {
    margin: 1px 0 0;
}
.ui-jqgrid .ui-jqgrid-bdiv {
    margin: 0;
    overflow: auto;
    padding: 0;
    position: relative;
}
.ui-jqgrid .ui-jqgrid-btable {
    margin: 0;
    table-layout: fixed;
}
.ui-jqgrid tr.jqgrow td {
    border-bottom-color: inherit;
    border-bottom-style: solid;
    border-bottom-width: 1px;
    font-weight: normal;
    height: 22px;
    overflow: hidden;
    padding: 0 2px;
    white-space: pre;
}
.ui-jqgrid tr.ui-row-ltr td {
    border-right-color: inherit;
    border-right-style: solid;
    border-right-width: 1px;
    text-align: left;
}
.ui-jqgrid tr.ui-row-rtl td {
    border-left-color: inherit;
    border-left-style: solid;
    border-left-width: 1px;
    text-align: right;
}
.ui-jqgrid td.jqgrid-rownum {
    border: 0 none;
    margin: 0;
    padding: 0 2px;
}
.ui-jqgrid .ui-jqgrid-resize-mark {
    background-color: #777777;
    border: 0 none;
    cursor: col-resize;
    display: none;
    height: 100px;
    left: 0;
    overflow: hidden;
    position: absolute;
    top: 0;
    width: 2px;
}
.ui-jqgrid .ui-jqgrid-sdiv {
    border-left: 0 none !!important;
    border-right: 0 none !!important;
    border-top: 0 none !!important;
    margin: 0;
    overflow: hidden;
    padding: 0;
    position: relative;
}
.ui-jqgrid .ui-jqgrid-ftable {
    margin-bottom: 0;
    table-layout: fixed;
}
.ui-jqgrid tr.footrow td {
    border-top-color: inherit;
    border-top-style: solid;
    border-top-width: 1px;
    font-weight: bold;
    height: 21px;
    overflow: hidden;
    padding: 0 2px;
    white-space: nowrap;
}
.ui-jqgrid tr.footrow-ltr td {
    border-right-color: inherit;
    border-right-style: solid;
    border-right-width: 1px;
    text-align: left;
}
.ui-jqgrid tr.footrow-rtl td {
    border-left-color: inherit;
    border-left-style: solid;
    border-left-width: 1px;
    text-align: right;
}
.ui-jqgrid .ui-jqgrid-pager {
    border-bottom: 0 none !!important;
    border-left: 0 none !!important;
    border-right: 0 none !!important;
    height: 25px;
    margin: 0 !!important;
    overflow: hidden;
    padding: 0 !!important;
    position: relative;
    white-space: nowrap;
}
.ui-jqgrid .ui-pager-control {
    position: relative;
}
.ui-jqgrid .ui-pg-table {
    margin: 0;
    padding-bottom: 2px;
    position: relative;
    width: auto;
}
.ui-jqgrid .ui-pg-table td {
    font-weight: normal;
    padding: 1px;
    vertical-align: middle;
}
.ui-jqgrid .ui-pg-button {
    height: 19px !!important;
}
.ui-jqgrid .ui-pg-button span {
    display: block;
    float: left;
    margin: 1px;
}
.ui-jqgrid .ui-pg-button:hover {
    padding: 0;
}
.ui-jqgrid .ui-state-disabled:hover {
    padding: 1px;
}
.ui-jqgrid .ui-pg-input {
    font-size: 0.8em;
    height: 13px;
    margin: 0;
}
.ui-jqgrid .ui-pg-selbox {
    display: block;
    font-size: 0.8em;
    height: 18px;
    line-height: 18px;
    margin: 0;
}
.ui-jqgrid .ui-separator {
    border-left: 1px solid #CCCCCC;
    border-right: 1px solid #CCCCCC;
    float: right;
    height: 18px;
    margin: 1px;
}
.ui-jqgrid .ui-paging-info {
    font-weight: normal;
    height: 19px;
    margin-right: 4px;
    margin-top: 3px;
}
.ui-jqgrid .ui-jqgrid-pager .ui-pg-div {
    cursor: pointer;
    float: left;
    list-style: none outside none;
    padding: 1px 0;
    position: relative;
}
.ui-jqgrid .ui-jqgrid-pager .ui-pg-div span.ui-icon {
    float: left;
    margin: 0 2px;
}
.ui-jqgrid td input, .ui-jqgrid td select .ui-jqgrid td textarea {
    margin: 0;
}
.ui-jqgrid td textarea {
    height: auto;
    width: auto;
}
.ui-jqgrid .ui-jqgrid-toppager {
    border-left: 0 none !!important;
    border-right: 0 none !!important;
    border-top: 0 none !!important;
    height: 25px !!important;
    margin: 0 !!important;
    overflow: hidden;
    padding: 0 !!important;
    position: relative;
    white-space: nowrap;
}
.ui-jqgrid .ui-jqgrid-btable .ui-sgcollapsed span {
    display: block;
}
.ui-jqgrid .ui-subgrid {
    margin: 0;
    padding: 0;
    width: 100%;
}
.ui-jqgrid .ui-subgrid table {
    table-layout: fixed;
}
.ui-jqgrid .ui-subgrid tr.ui-subtblcell td {
    border-bottom-color: inherit;
    border-bottom-style: solid;
    border-bottom-width: 1px;
    border-right-color: inherit;
    border-right-style: solid;
    border-right-width: 1px;
    height: 18px;
}
.ui-jqgrid .ui-subgrid td.subgrid-data {
    border-top: 0 none !!important;
}
.ui-jqgrid .ui-subgrid td.subgrid-cell {
    border-width: 0 0 1px;
}
.ui-jqgrid .ui-th-subgrid {
    height: 20px;
}
.ui-jqgrid .loading {
    border-width: 2px !!important;
    display: none;
    font-weight: bold;
    left: 45%;
    margin: 5px;
    padding: 6px;
    position: absolute;
    text-align: center;
    top: 45%;
    width: auto;
    z-index: 101;
}
.ui-jqgrid .jqgrid-overlay {
    display: none;
    z-index: 100;
}
* html .jqgrid-overlay {
}
* .jqgrid-overlay iframe {
    left: 0;
    position: absolute;
    top: 0;
    z-index: -1;
}
.ui-jqgrid .ui-userdata {
    border-left: 0 none;
    border-right: 0 none;
    height: 21px;
    overflow: hidden;
}
.ui-jqdialog {
    display: none;
    font-size: 11px;
    overflow: visible;
    padding: 0.2em;
    position: absolute;
    width: 300px;
}
.ui-jqdialog .ui-jqdialog-titlebar {
    padding: 0.3em 0.2em;
    position: relative;
}
.ui-jqdialog .ui-jqdialog-title {
    margin: 0.1em 0 0.2em;
}
.ui-jqdialog .ui-jqdialog-titlebar-close {
    height: 18px;
    margin: -10px 0 0;
    padding: 1px;
    position: absolute;
    top: 50%;
    width: 19px;
}
.ui-jqdialog .ui-jqdialog-titlebar-close span {
    display: block;
    margin: 1px;
}
.ui-jqdialog .ui-jqdialog-titlebar-close:hover, .ui-jqdialog .ui-jqdialog-titlebar-close:focus {
    padding: 0;
}
.ui-jqdialog-content, .ui-jqdialog .ui-jqdialog-content {
    background: none repeat scroll 0 0 transparent;
    border: 0 none;
    height: auto;
    padding: 0.3em 0.2em;
}
.ui-jqdialog .ui-jqconfirm {
    border-width: 3px;
    bottom: 10px;
    display: none;
    height: 80px;
    overflow: visible;
    padding: 0.4em 1em;
    position: absolute;
    right: 10px;
    text-align: center;
    width: 220px;
}
.ui-jqdialog-content .FormGrid {
    margin: 0;
}
.ui-jqdialog-content .EditTable {
    margin-bottom: 0;
    width: 100%;
}
.ui-jqdialog-content .DelTable {
    margin-bottom: 0;
    width: 100%;
}
.EditTable td input, .EditTable td select, .EditTable td textarea {
    margin: 0;
}
.EditTable td textarea {
    height: auto;
    width: auto;
}
.ui-jqdialog-content td.EditButton {
    border-left: 0 none;
    border-right: 0 none;
    border-top: 0 none;
    padding-bottom: 5px;
    padding-top: 5px;
    text-align: right;
}
.ui-jqdialog-content td.navButton {
    border-left: 0 none;
    border-right: 0 none;
    border-top: 0 none;
    padding-bottom: 5px;
    padding-top: 5px;
    text-align: center;
}
.ui-jqdialog-content .CaptionTD {
    border-bottom: 0 none;
    border-left: 0 none;
    border-right: 0 none;
    padding: 1px;
    text-align: left;
    vertical-align: top;
    white-space: nowrap;
}
.ui-jqdialog-content .DataTD {
    border-bottom: 0 none;
    border-left: 0 none;
    border-right: 0 none;
    padding: 1px;
    vertical-align: top;
}
.ui-jqdialog-content .form-view-data {
    white-space: pre;
}
.fm-button {
    cursor: pointer;
    display: inline-block;
    margin: 0 4px 0 0;
    padding: 0.4em 0.5em;
    position: relative;
    text-align: center;
    text-decoration: none !!important;
}
.fm-button-icon-left {
    padding-left: 1.9em;
}
.fm-button-icon-right {
    padding-right: 1.9em;
}
.fm-button-icon-left .ui-icon {
    left: 0.2em;
    margin-left: 0;
    margin-top: -8px;
    position: absolute;
    right: auto;
    top: 50%;
}
.fm-button-icon-right .ui-icon {
    left: auto;
    margin-left: 0;
    margin-top: -8px;
    position: absolute;
    right: 0.2em;
    top: 50%;
}
#nData, #pData {
    float: left;
    margin: 3px;
    padding: 0;
    width: 15px;
}
.ui-jqgrid .selected-row, div.ui-jqgrid .selected-row td {
    border-left: 0 none;
    font-style: normal;
}
.ui-jqgrid .tree-wrap {
    float: left;
    height: 18px;
    overflow: hidden;
    position: relative;
    white-space: nowrap;
}
.ui-jqgrid .tree-minus {
    height: 18px;
    overflow: hidden;
    position: absolute;
    width: 18px;
}
.ui-jqgrid .tree-plus {
    height: 18px;
    overflow: hidden;
    position: absolute;
    width: 18px;
}
.ui-jqgrid .tree-leaf {
    height: 18px;
    overflow: hidden;
    position: absolute;
    width: 18px;
}
.ui-jqgrid .treeclick {
    cursor: pointer;
}
.jqmOverlay {
    background-color: #000000;
}
* iframe.jqm {
    left: 0;
    position: absolute;
    top: 0;
    z-index: -1;
}
.ui-jqgrid-dnd tr td {
    border-right-color: inherit;
    border-right-style: solid;
    border-right-width: 1px;
    height: 20px;
}
.ui-jqgrid .ui-jqgrid-title-rtl {
    float: right;
    margin: 0.1em 0 0.2em;
}
.ui-jqgrid .ui-jqgrid-hbox-rtl {
    float: right;
    padding-left: 20px;
}
.ui-jqgrid .ui-jqgrid-resize-ltr {
    float: right;
    margin: -2px -2px -2px 0;
}
.ui-jqgrid .ui-jqgrid-resize-rtl {
    float: left;
    margin: -2px 0 -1px -3px;
}
.ui-jqgrid .ui-sort-rtl {
    left: 0;
}
.ui-jqgrid .tree-wrap-ltr {
    float: left;
}
.ui-jqgrid .tree-wrap-rtl {
    float: right;
}
.ui-jqgrid .ui-ellipsis {
    -moz-binding: url("ellipsis-xbl.xml#ellipsis");
    text-overflow: ellipsis;
}
.ui-searchFilter {
    display: none;
    overflow: visible;
    position: absolute;
    z-index: 770;
}
.ui-searchFilter table {
    margin: 0;
    position: relative;
    width: auto;
}
.ui-searchFilter table td {
    margin: 0;
    padding: 1px;
}
.ui-searchFilter table td input, .ui-searchFilter table td select {
    margin: 0.1em;
}
.ui-searchFilter .ui-state-default {
    cursor: pointer;
}
.ui-searchFilter .divider {
    height: 1px;
}
.ui-searchFilter .divider div {
    background-color: black;
    height: 1px;
}'! !

!RKALibrary methodsFor: 'js' stamp: 'sabineknoefel 6/26/2013 11:07'!
rkaJs
	"Initial size is set in RKAView>>defaultTableWidth"
	
	^ 'jQuery(window).resize(function () {
 	jQuery("#gridID").setGridWidth(jQuery(window).width() * 0.5);
    });'! !

!RKALibrary methodsFor: 'accessing' stamp: 'sabineknoefel 7/4/2013 12:23'!
selectorsToInclude
 
	^ #( #mancssCss #manjquerycssCss #manuijqgridCss #labelinsideCss )
	
 ! !

WAFileLibrary subclass: #RKAToDo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAToDo commentStamp: '<historical>' prior: 0!
weiter mit einbau voyage,
dann auch datebnbankzugrife mit voyage laut forum organisieren damit die semaphoren nicht ausgehen
danach eingabe beleg mit kursen etc


mal wo hin gehen wo alte browser sind und testen ob meldung kommt

putzen
--------------------------------
warum   beim ffnen seite (ber accordion die callbacks zwei mal aufgerufen? halt in WAOptionTag >>value: anObject with: aListTag )
ie geht nicht abzug sachbezug button
wenn es knallt, hngt die session, das geht gar nicht!!
Ipad Login Hhe, Schriftart, anzahl spalten in tabellen
optik tabelle
manche scripts in footer: https://www.hotelbb.de/portal/de/hotels#/booking footer-scripts
wartungsseite

wenn seite geffnet wird (reisen, login, etc) dann soll auch das selektierte element in der tabelle selektiert werden. 

fachlich:
----------------------
alle buchungen, alle regelungen, Trinkgeld, storno (keine vorsteuer)

currency
-----------------
keine exchange rate zb indische ruipie-fall keine kurse was dann? 
simulieren was wre wenn url nicht geht, dann muss meldung kommen und in berichten ausgegeben und alte kurse verwendet werden

passwort und email:
------------------------------------
wenn man sich mit facebook eingeloggt hat, hat man kein passwort - nachtrglich passwort eingebbar machen oder per mail zusenden
dito wenn man nachtrglich account anlegt
email benachrichtigung passwort vergessen
account verifizieren per mail 
registrieren - wennn mail schon existiert - email zusenden anbieten

bersetzungen 
--------------------------
fehlermeldungen - fr bersetzungen irgendwie alle auf einer seite benutzen wrte und stze im bersetzungsmodus ausgeben

mongo:
----------------
Thu Jul 04 09:12:35.469 [initandlisten] **       Note that journaling defaults to off for 32 bit and is currently off.
http://docs.mongodb.org/manual/tutorial/recover-data-following-unexpected-shutdown/
http://docs.mongodb.org/manual/reference/configuration-options/#setting-journal
konfigurationfile erstellen statt start von command line
passwort machen fr login-mongo config script - http://rockmongo.com/wiki/configuration

 prfen: http://www.hongkiat.com/blog/oversized-background-image-design/ befolgt?
 !

!RKAToDo methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 7/17/2013 16:01'!
niceToHave
"======================================
Punkte die nett wren, aber die ich nicht unbeding brauche fr online gehen

computeReceipt zusammen mit mehrwertsteuer einbau baustelle, 3 mwst stze eingebbar fr einen beleg
Nacht im Flieger, Schiff einfach eintrag ermglichen - Eintrag bei den Lndern?
seite verlassen oder wechseln ohne nderungen geepeichert - meldung
wenn fehlermeldugn erscheint cursor in das entsprechende feld!!!!
=======================================
Ideen:
chrome analyse machen unten, interessant!!

Nicht in Beta:
-------------------------------------------------
individuelles hinzufgen und entfernen von belegarten?
papierkorb -> isDeleted=true trips
Workflow und Genehmigung
zahlungsarten
mehrere reisen an einem tag
zusammenfassen von reisen wenn an einem tag
breadcrumb oder alternative schnellere navigation zwischen reisen
konfigurierbar, welche spalten angezeigt werden
berichte konfigurierbar
export file und ggf. speichern in dropbox (als excel)
user sollte gleich am anfang einstellen mssen ob er unternehmer oder arbeitnehmer ist

relevant?
-------------------------------------------------
dreimonatsfrist
SSL: WAStrictTransportSecurityFilter verwenden
http://forum.world.st/Scriptaculous-vs-jQuery-td3878407.html
cloudFork nutzen
http://code.google.com/p/cloudfork/
http://blog.doit.st/2009/01/09/getting-started-with-s3-using-cloudfork/
http://jenkins.doit.st/view/Cloudfork/
magritte benutzen?

In RKALayoutView >>renderContentOn:  load scripts einbinden?!! siehe http://webkrauts.de/artikel/2008/sehr-sehr-schnelle-seiten-website-performance-best-practice-teil-2
die ganzen icons weg machen?!!

Berichte
---------------------------------
Bericht: Erluterungen zur Abrechnung
Bericht: Fakturierung reisekosten"  ! !

WASystemConfiguration subclass: #RKAConfiguration
	instanceVariableNames: ''
	classVariableNames: 'isProductive maintenance random'
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAConfiguration commentStamp: '<historical>' prior: 0!
MCHttpRepository
	location: 'http://ss3.gemtalksystems.com/ss/RKA24'
	user: 'SKNOEF'
	password: 'sgolfino'
	
MCHttpRepository
	location: 'http://smalltalkhub.com/mc/Sabine/RKA24/main'
	user: 'Sabine'
	password: 'sgolfino'
	
VORepository current reset!

!RKAConfiguration class methodsFor: 'adsense' stamp: 'sabineknoefel 9/5/2013 14:40'!
adsenseCode
^'<script type="text/javascript"><!!--
google_ad_client = "ca-pub-4996484724179988";
/* SPF3 */
google_ad_slot = "1248848338";
google_ad_width = 120;
google_ad_height = 240;
//-->
</script>
<script type="text/javascript"
src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>'! !

!RKAConfiguration class methodsFor: 'new mongo database init' stamp: 'sabineknoefel 9/20/2013 10:18'!
createNewMongoDatabaseObjects
	"When having a new mongo database, we need currencies, countries and so on.
	Create them and put them into the database"
 
	self createTransientMongoDatabaseObjects.
	
	RKACurrency saveCurrenciesToMongo. "nach mongo schreiben"
 ! !

!RKAConfiguration class methodsFor: 'new mongo database init' stamp: 'sabineknoefel 9/20/2013 10:17'!
createTransientMongoDatabaseObjects
	"When having a new mongo database, we need currencies, countries and so on.
	Create them here"
 
	RKACurrency initializeCurrencies. "im Image erstellen, nix persistenz"
	RKACountry initializeCountries. "im Image erstellen, nix persistenz"
	RKACurrency initializeCurrenciesWithCountries. "im Image erstellen, nix persistenz"
	RKACurrency setCurrencyRatesTodayFromOpenexchangerates. "im Image erstellen, nix persistenz"
 	RKACurrency setCurrencyRatesHistoricalFromOpenexchangerates. "im Image erstellen, nix persistenz"
	 ! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 9/2/2013 15:18'!
errorMailReceiverAddress
	^'sabine.knoefel@gmail.com'! !

!RKAConfiguration class methodsFor: 'library files' stamp: 'sabineknoefel 8/31/2013 09:21'!
exportLibraryFiles
	"self exportLibraryFiles"
	
	|thePathRKALibrary thePathWidgetBox|
	thePathRKALibrary := UIManager default chooseDirectory: 'Verzeichnis von RKALibrary auswhlen'.
	"in den generierten Files localhost entfernen!!"
	#(#manjquerycssCss #mancssCss  #manuijqgridCss #labelinsideCss #labelinsidefJs #rkaJs  ) do: [ :each | 
		GRPlatform current 
			write: ((RKALibrary default perform: each) copyReplaceAll: 'http://localhost' with: '..' )
			toFile: (RKALibrary default asFilename: each)
			inFolder: thePathRKALibrary"RKALibrary default name" ].
	thePathWidgetBox := UIManager default chooseDirectory: 'Verzeichnis von JQWidgetBoxDeploymentLibrary auswhlen'.		
		#(#gridlocaleenJs #jqueryjqGridminJs) do: [ :each | 
		GRPlatform current 
			write: (JQWidgetBoxDeploymentLibrary default perform: each)
			toFile: (JQWidgetBoxDeploymentLibrary default asFilename: each)
			inFolder: thePathWidgetBox"JQWidgetBoxDeploymentLibrary default name" ]! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:00'!
facebookUrl
	^'https://www.facebook.com/pages/Spesenfuchs/567166016651589'! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:00'!
forumUrl 
	^'http://forum.spesenfuchs.de'! !

!RKAConfiguration class methodsFor: 'password' stamp: 'sabineknoefel 8/22/2013 14:56'!
hashPassword: aString
	"http://www.heise.de/security/artikel/Passwoerter-unknackbar-speichern-1253931.html?artikelseite=2"
	"Pepper"
	
	aString ifNil: [^'0'].
	^ (aString 
		ifEmpty: [ 0 ] 
		ifNotEmpty: [ GRPlatform current secureHashFor: aString,'f8s9[23423f83%45GN_4Sjf9FsOxER' ]) asString! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:00'!
homepageUrl
	^'http://www.spesenfuchs.de'! !

!RKAConfiguration class methodsFor: 'accessing' stamp: 'SabineKnoefel 11/6/2012 16:36'!
isProductive
	^ isProductive! !

!RKAConfiguration class methodsFor: 'accessing' stamp: 'SabineKnoefel 11/6/2012 16:36'!
isProductive: anObject
	isProductive := anObject! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:00'!
loginUrl
	^'http://ec2-54-229-139-107.eu-west-1.compute.amazonaws.com/'! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:04'!
mailNewsHeadingString
	^'News vom Spesenfuchs'! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 9/2/2013 15:46'!
mailNewsText
	^'Spesenfuchs wird stndig weiter entwickelt. Wenn Ihnen eine bestimmte Funktionalitt fehlt, schreiben Sie uns bitte im <a href="{1}">Forum</a>.' format: {self forumUrl }! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:05'!
mailPrefix
	^'[Spesenfuchs] - '! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:02'!
mailSenderAddress
	^'mail@spesenfuchs.de'! !

!RKAConfiguration class methodsFor: 'accessing' stamp: 'sabineknoefel 7/22/2013 11:57'!
maintenance
	maintenance ifNil: [ self maintenance: false ].
	^ maintenance! !

!RKAConfiguration class methodsFor: 'accessing' stamp: 'sabineknoefel 7/22/2013 11:55'!
maintenance: aBoolean
	maintenance := aBoolean! !

!RKAConfiguration class methodsFor: 'migration' stamp: 'sabineknoefel 9/24/2013 14:42'!
migrate2013_09_24
	"Currencies keys changed from Date to ZTimestamp"

	VORepository current reset.
	RKACurrency selectAll do: [ :each | each saveCurrency ].
	self readCurrenciesCountriesAndTranslatorFromDatabase.! !

!RKAConfiguration class methodsFor: 'oauth' stamp: 'SabineKnoefel 5/23/2013 17:14'!
oauthFacebookClientId
	^ '464945600259152'! !

!RKAConfiguration class methodsFor: 'oauth' stamp: 'SabineKnoefel 5/23/2013 17:14'!
oauthFacebookClientSecret
	^ 'dc627b3d722dbbe58d19610f05c32fe8'! !

!RKAConfiguration class methodsFor: 'accessing' stamp: 'SabineKnoefel 4/4/2013 12:29'!
random
	random ifNil: [ self random: Random new ].
	^ random! !

!RKAConfiguration class methodsFor: 'accessing' stamp: 'SabineKnoefel 4/4/2013 12:28'!
random: anObject
	random := anObject! !

!RKAConfiguration class methodsFor: 'api' stamp: 'sabineknoefel 9/23/2013 14:51'!
readCurrenciesCountriesAndTranslatorFromDatabase
	RKACurrency
		currencies:
			(RKACurrency selectAll
				inject: Dictionary new
				into: [ :dict :ele | 
					dict at: ele iso4217 put: ele.
					dict ]).
	RKACountry
		countries:
			(RKACountry selectAll
				inject: Dictionary new
				into: [ :dict :ele | 
					dict at: ele iso3166 put: ele.
					dict ]).
	RKATranslator translators: nil.
	RKATranslator translators.! !

!RKAConfiguration class methodsFor: 'api' stamp: 'sabineknoefel 9/20/2013 11:45'!
recreateLibraryFiles
	(UIManager default confirm: 'css und js neu erzeugen?' label: 'Css und Js')
		ifTrue: [ self exportLibraryFiles ]! !

!RKAConfiguration class methodsFor: 'api' stamp: 'sabineknoefel 9/20/2013 11:46'!
registerApplication: isProductive

	| theApplication |
	isProductive 
		ifTrue: [  
		WAAdmin applicationDefaults removeParent: WADevelopmentConfiguration instance.
		"	WADispatcher default handlers do: [ :each | WADispatcher default unregister: each ]."
		theApplication := WAAdmin register: RKALayoutView asApplicationAt: 'RKA' "user: 'spfuchs' password: 'sgolfino'".
		theApplication exceptionHandler: RKAHtmlErrorHandler.]
	ifFalse: [ theApplication := WAAdmin register: RKALayoutView asApplicationAt: 'RKA' ].
	
	theApplication
		addLibrary: RKALibrary;
		preferenceAt: #sessionClass put: RKASession;
		preferenceAt: #rootClass put: RKATask.
	theApplication configuration
		storeExpression: 'sabine.knoefel@gmail.com'
		forAttribute: (WAConfigurationElement key: #smtpUsername).
	theApplication cache expiryPolicy configuration at: #cacheTimeout put: 6000.

	(ZnZincServerAdaptor port: 8085) start.
	WAAdmin defaultDispatcher defaultName: 'RKA'.
	JQuery functionName: 'jQuery'.
	! !

!RKAConfiguration class methodsFor: 'dev' stamp: 'sabineknoefel 9/20/2013 11:32'!
resetAllCachedpObjects
	"only for development"
	RKATranslator translators: nil.
	RKACountry countries: nil.
	RKACurrency currencies: nil.
	RKAExpensesCountry expensesCountries: nil. 
	RKAExpensesCountry expensesCountriesByName: nil. 
	RKAExpensesCountry expensesCountriesByYear: nil. 
	RKAExpensesCountry expensesCountriesByYearAndName: nil.
	RKAPaymentInKind paymentInKinds: nil.
	RKAReceiptKind receiptKinds: nil.
	RKAReceiptKind receiptKindsByNameEmployee: nil.
	RKAReceiptKind receiptKindsByNameEmployer: nil.
	RKAVat vats: nil.
	RKAVehicleKind vehicleKinds: nil. 
	RKAVehicleKind sortedVehicleKinds: nil.! !

!RKAConfiguration class methodsFor: 'deprecated' stamp: 'sabineknoefel 9/23/2013 14:21'!
setUpConfiguration
	"self setUpConfiguration"

"	self setTimeZone."
	RKACurrency initializeCurrencies.
	RKACountry initializeCountries.
	RKACurrency initializeCurrenciesWithCountries.
	RKAAccount initializeAccounts.
	RKAVat initializeVats.
	RKAReceiptKind initializeReceiptKinds.
	RKAScheduler initializeSchedulers.
	RKAExpensesCountry initializeExpensesCountries.
	RKAVehicleKind initializeVehicleKinds.
	RKAPaymentInKind initializePaymentInKinds.
	self isProductive: (UIManager default confirm: 'Ist das ein Produktivsystem?' label: 'Produktivsystem').
	self registerApplication: self isProductive! !

!RKAConfiguration class methodsFor: 'api' stamp: 'sabineknoefel 9/24/2013 12:21'!
setUpConfigurationBaseline
	"Baseline setup loads for setting WITHOUT database (e.g. for Jenkins).
	For this reason, we set up all here without objects from database. 
	In setUpForConfigurationVersion, this objects are replaced with the database objects."
	"self halt setUpConfigurationBaseline"

 
	RKACurrency initializeCurrencies.
	RKACountry initializeCountries.
	RKACurrency initializeCurrenciesWithCountries.
	RKAAccount initializeAccounts.
	RKAVat initializeVats.
	RKAReceiptKind initializeReceiptKinds.
	RKAExpensesCountry initializeExpensesCountries.
	RKAVehicleKind initializeVehicleKinds.
	RKAPaymentInKind initializePaymentInKinds.
	self isProductive: false
! !

!RKAConfiguration class methodsFor: 'api' stamp: 'sabineknoefel 9/23/2013 14:51'!
setUpConfigurationVersion
	"self setUpConfiguration"

	(VOMongoRepository host: 'localhost' database: 'spesenfuchs') enableSingleton.
	self readCurrenciesCountriesAndTranslatorFromDatabase.
	RKAScheduler initializeSchedulers.
	self isProductive: (UIManager default confirm: 'Ist das ein Produktivsystem?' label: 'Produktivsystem').
	self registerApplication: self isProductive.! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 9/3/2013 15:26'!
sloganHtmlText
	^ 'Willkommen bei Spesenfuchs!!<br/><br/>Die Anwendung befindet sich noch im Test. Die Daten werden wieder gelscht. <br/><br/>
	Wir freuen uns ber Ihr Feedback im  <a href="http://forum.spesenfuchs.de" target="_blank">Benutzerforum</a>.
	
	'! !

!RKAConfiguration class methodsFor: 'constants' stamp: 'sabineknoefel 9/5/2013 10:58'!
validUserAgentStrings
	"to be improved.... eg safari
	http://www.useragentstring.com/pages/Safari/"
	
	self toDo .

	^ #(
		#('MSIE' #(  'MSIE 10'))
		#('Chrome' #('Chrome'))
		#('Firefox' #('Firefox/16' 'Firefox/17' 'Firefox/18' 'Firefox/19' 'Firefox/20' 'Firefox/21' 'Firefox/22' 'Firefox/23' 'Firefox/24'))
		#('Safari' #('Version/5' 'Version/6')))  ! !

!RKAConfiguration class methodsFor: 'new mongo database init' stamp: 'sabineknoefel 9/20/2013 11:05'!
writeNewCurrenciesAndCountriesInDatabase
	"If we want to create a new database, we need new countries and currencies in it"

	(RKACurrency selectAll isNil or: [ RKACurrency selectAll isEmpty ])
		ifTrue: [ 
			(UIManager default confirm: 'Whrungen und Lnder in Datenbank schreiben?' label: 'Keine Whrungen und Lnder gefunden!!')
				ifTrue: [ 
					self createNewMongoDatabaseObjects.
					VORepository current reset ] ]! !

!RKAConfiguration class methodsFor: 'oauth' stamp: 'SabineKnoefel 5/23/2013 17:13'!
znOAuth2ConsumerDataKey
	^ '464945600259152'! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 4/17/2013 16:58'!
footerrow: aBoolean
	self optionAt: 'footerrow' put: aBoolean! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
gridComplete: aString
	self optionAt: 'gridComplete' put: aString! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 4/17/2013 17:04'!
grouping: aBoolean
	self optionAt: 'grouping' put: aBoolean! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 4/17/2013 17:33'!
groupingView: aBoolean
	self
		optionAt: 'groupingView'
		put:
			(Dictionary new
				add: 'groupField' -> (OrderedCollection with: 'wholeName' with: 'ip');
				add: 'groupColumnShow' -> (OrderedCollection with: true with: true);
				add: 'groupText' -> (OrderedCollection with: '<b>{0}</b>' with: '<b>{0}</b>');
				add: 'groupCollapse' -> false;
				add: 'groupOrder' -> (OrderedCollection with: 'desc' with: 'desc');
				add: 'groupSummary' -> (OrderedCollection with: true with: true);
				add: 'groupDataSorted' -> true;
				yourself)! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
height: anInteger
	self optionAt: 'height' put: anInteger! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
loadComplete: aFunction
	"http://www.trirand.com/jqgridwiki/doku.php?id=wiki:events.
	This event is executed immediately after every server request.
	data Data from the response depending on datatype grid parameter"

	self optionAt: 'loadComplete' put: (aFunction asFunction: #('data'))! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
loadonce: aBoolean
	self optionAt: 'loadonce' put: aBoolean! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
loadtext: aString
	self optionAt: 'loadtext' put: aString! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 4/18/2013 17:59'!
multiselect: aBoolean
	self optionAt: 'multiselect' put: aBoolean! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
onCellSelect: aFunction
	"http://www.trirand.com/jqgridwiki/doku.php?id=wiki:events.
	Fires when we click on particular cell in the grid.
	rowid is the id of the row
	iCol is the index of the cell,
	cellcontent is the content of the cell,
	e is the event object element where we click.
	(Note that this available when we not use cell editing module and is disabled when using cell editing)."

	self optionAt: 'onCellSelect' put: (aFunction asFunction: #('rowId' 'iCol' 'cellcontent' 'e'))! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
onSelectRow: aFunction
	"http://www.trirand.com/jqgridwiki/doku.php?id=wiki:events.
	Raised immediately after row was clicked.
	rowid is the id of the row,
	status is the status of the selection,
	e is the event object. Can be used when multiselect is set to true. true if the row is selected, false if the row is deselected.."

	self optionAt: 'onSelectRow' put: (aFunction asFunction: #('rowId' 'status' 'e'))! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
ondblClickRow: aFunction
	"http://www.trirand.com/jqgridwiki/doku.php?id=wiki:events.
	Raised immediately after row was double clicked.
	rowid is the id of the row,
	iRow is the index of the row (do not mix this with the rowid),
	iCol is the index of the cell.
	e is the event object"

	self optionAt: 'ondblClickRow' put: (aFunction asFunction: #('rowId' 'iRow' 'iCol' 'e'))! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 5/14/2013 16:16'!
options
 
	^ options ifNil: [ options := GRSmallDictionary new ]! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
scroll: anInteger
	self optionAt: 'scroll' put: anInteger! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 4/17/2013 16:39'!
sortorder: aString
	self optionAt: 'sortorder' put: aString! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'SabineKnoefel 4/17/2013 16:58'!
userDataOnFooter: aBoolean
	self optionAt: 'userDataOnFooter' put: aBoolean! !

!JQGrid methodsFor: '*RKA24-System' stamp: 'sabine 11/6/2012 11:56'!
width: anInteger
	self optionAt: 'width' put: anInteger! !

!OID class methodsFor: '*RKA24-System' stamp: 'sabineknoefel 8/31/2013 10:07'!
nextOID
	^self value: (RKAOIDGenerator getNextOID )! !

WASession subclass: #RKASession
	instanceVariableNames: 'currentPerson currentTrip currentReceipt currentCurrency isCurrentTripNew isCurrentVehicleTripNew isCurrentReceiptNew currentDay currentVehicleTrip translator menuEntries currentAccountingTrips currentAccountingMonth currentAccountingYear history panel browserWidth browserHeight login currentError creationTimestamp loginEmailAdress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKASession methodsFor: 'history' stamp: 'sabineknoefel 9/3/2013 16:03'!
accordionCategory
	|theLastViewClass|
	 
	^ self history isEmpty 
		ifTrue: [    (self currentPerson lastViewClass canUnderstand: #accordionCategory) 
			ifTrue: [self currentPerson lastViewClass ]
			ifFalse: [0 ] ]
		ifFalse: [theLastViewClass :=  self history last viewClass.
			(theLastViewClass class canUnderstand:  #accordionCategory)
				ifTrue: [theLastViewClass accordionCategory] 
				ifFalse: [0] ]! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/28/2013 14:50'!
browserHeight
	^ browserHeight! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/28/2013 14:50'!
browserHeight: anObject
	browserHeight := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/28/2013 14:50'!
browserWidth
	^ browserWidth! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/28/2013 14:50'!
browserWidth: anObject
	browserWidth := anObject! !

!RKASession methodsFor: 'login/logoff' stamp: 'sabineknoefel 9/24/2013 12:12'!
clicked
	"If the user is on the login view, the login object is not yet set"

	self login isNil
		ifTrue: [ ^ nil ].
	self login lastClick: ZTimestamp now.
 	self login saveLogin.
	self saveCurrentPerson.
	^ self login clicked! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 7/22/2013 12:33'!
creationTimestamp
	^ creationTimestamp! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 7/22/2013 12:33'!
creationTimestamp: anObject
	creationTimestamp := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/8/2013 19:11'!
currentAccountingMonth
	currentAccountingMonth ifNil: [ self currentAccountingMonth: Date today monthIndex ].
	^ currentAccountingMonth! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/8/2013 19:09'!
currentAccountingMonth: anObject
	currentAccountingMonth := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 13:32'!
currentAccountingTrips
	currentAccountingTrips ifNil: [ self setCurrentAccountingTrips: (OrderedCollection with: self currentTrip ) ].
	^ currentAccountingTrips! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/8/2013 19:10'!
currentAccountingTrips: anObject
	currentAccountingTrips := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/8/2013 19:11'!
currentAccountingYear
	currentAccountingYear ifNil: [ self currentAccountingYear: Date today year ].
	^ currentAccountingYear! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/8/2013 19:10'!
currentAccountingYear: anObject
	currentAccountingYear := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 8/26/2013 11:20'!
currentCurrency
	currentCurrency isCurrency 
		ifFalse: [  self currentCurrency: RKACurrency euro].
	^ currentCurrency! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 8/26/2013 11:05'!
currentCurrency: anObject
	currentCurrency := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/24/2012 15:45'!
currentDay
	currentDay ifNil: [ self currentDay: self currentTrip days first ].
	^ currentDay! !

!RKASession methodsFor: 'accessing' stamp: 'sabine 9/27/2012 14:42'!
currentDay: anObject
	currentDay := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 12:26'!
currentError
	^ currentError! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 12:35'!
currentError: anRKAError
	currentError := anRKAError! !

!RKASession methodsFor: 'accessing' stamp: 'sabine 9/10/2012 13:12'!
currentPerson
	^ currentPerson! !

!RKASession methodsFor: 'accessing' stamp: 'sabine 9/10/2012 13:12'!
currentPerson: anObject
	currentPerson := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 8/26/2013 11:08'!
currentReceipt
	"do NOT assign the receipt to the trip because possibly the user will not save it"

	currentReceipt
		ifNil: [ 
			self
				currentReceipt:
					(RKAReceipt
						newStartDate: self currentTrip startDate
						endDate: self currentTrip endDate
						receiptNumber: self currentTrip nextReceiptNumber
						trip: self currentTrip
						currency: self currentCurrency ).
			self isCurrentReceiptNew: true ].
	^ currentReceipt! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 6/22/2012 10:21'!
currentReceipt: anObject
	currentReceipt := anObject! !

!RKASession methodsFor: 'todo' stamp: 'sabine 9/27/2012 09:59'!
currentReceiptFromCreationTimestamp: aString
	self toDo.
	^ self receipts detect: [ :each | each creationTimestamp = aString ] ifNone: [ nil ]! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 3/6/2013 17:20'!
currentTrip
	currentTrip
		ifNil: [ 
			self setCurrentTrip: (RKATrip new: self currentPerson).
			].
	^ currentTrip! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 9/19/2013 14:25'!
currentTrip: anObject
 
	currentTrip := anObject! !

!RKASession methodsFor: 'todo' stamp: 'SabineKnoefel 3/5/2013 18:51'!
currentTripFromCreationTimestamp: aString
	"Get the proxytrip and then load the real trip and connect them both together.
	So, next time, loading is not needed."
 
	^(self currentTrips detect: [ :each | each creationTimestamp = aString ] ifNone: [ nil ])   
	"| theTripProxy theTrip |
	self halt.
	theTripProxy := self currentProxyTrips detect: [ :each | each creationTimestamp = aString ] ifNone: [ nil ].
	theTripProxy trip isNil
		ifTrue: [ 
			theTrip := self panel readTripFromDatastorage: theTripProxy.
			theTrip isNil
				ifFalse: [ 
					theTripProxy trip: theTrip.
					theTripProxy trip person: self currentPerson ] ].
	^ theTripProxy trip"! !

!RKASession methodsFor: 'accessing' stamp: 'sabine 9/14/2012 18:43'!
currentTrips
	^ self currentPerson trips! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/27/2013 11:04'!
currentVehicleTrip
	"do NOT assign the vehicletrip to the trip because possibly the user will not save it"
	
	currentVehicleTrip
		ifNil: [ 
			self currentVehicleTrip: (RKAVehicleTrip new day:  self currentTrip days first).
			self isCurrentVehicleTripNew: true ].
	^ currentVehicleTrip
	
 ! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/12/2012 09:41'!
currentVehicleTrip: anObject
	currentVehicleTrip := anObject! !

!RKASession methodsFor: 'todo' stamp: 'sabine 9/27/2012 14:24'!
currentVehicleTripFromCreationTimestamp: aString
	self toDo.
	 
	^ self currentTrip  vehicleTrips  detect: [ :each | each creationTimestamp = aString ] ifNone: [ nil ]! !

!RKASession methodsFor: 'as yet unclassified' stamp: 'sabineknoefel 9/5/2013 16:03'!
helpText
^'ddd'! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:22'!
history
	history isNil
		ifTrue: [ self history: OrderedCollection new ].
	^ history! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:22'!
history: anObject
	history := anObject! !

!RKASession methodsFor: 'printing' stamp: 'sabineknoefel 7/22/2013 14:11'!
historyString
 
	^ '{1} ({2})'
		format:
			{(self history isEmpty
				ifTrue: [ ^'-' ]
				ifFalse: [ self translator getTranslationFor:  self history last viewClass breadcrumbLabel ]).
			(self history size printString)}! !

!RKASession methodsFor: 'initialize' stamp: 'sabineknoefel 8/26/2013 11:06'!
initialize
	super initialize.
	self
		currentPerson: RKAPerson new;
		isCurrentReceiptNew: true;
		isCurrentVehicleTripNew: true;
		currentCurrency: RKACurrency euro;
		setCreationTimestamp ! !

!RKASession methodsFor: 'testing' stamp: 'SabineKnoefel 4/11/2013 17:08'!
isCurrentPersonTransient
	^ self login isCurrentPersonTransient! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/25/2012 12:05'!
isCurrentReceiptNew
	"The current receipt is new if it is not yet added to the trips receipts"

	^ isCurrentReceiptNew! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/25/2012 12:05'!
isCurrentReceiptNew: anObject
	"The current receipt is new if it is not yet added to the trips receipts"

	isCurrentReceiptNew := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 9/19/2013 11:01'!
isCurrentTripNew
	^  self currentTrip isNew! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 4/9/2013 16:19'!
isCurrentTripNew: anObject
	isCurrentTripNew := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/25/2012 12:05'!
isCurrentVehicleTripNew
	"The current vehicle trip is new if it is not yet added to the days vehicle trips"

	^ isCurrentVehicleTripNew! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/25/2012 12:06'!
isCurrentVehicleTripNew: anObject
	"The current vehicle trip is new if it is not yet added to the days vehicle trips"

	isCurrentVehicleTripNew := anObject! !

!RKASession methodsFor: 'dropbox' stamp: 'SabineKnoefel 2/12/2013 12:37'!
isDatastorageAvailable
	"Is a cloud data storage (e.g. Dropbox) available?"

	^ self panel isNil not! !

!RKASession methodsFor: 'testing' stamp: 'sabineknoefel 7/24/2013 08:48'!
isNew
	"new if just logged in"

	^ self login isNew! !

!RKASession methodsFor: 'comparing' stamp: 'sabineknoefel 7/22/2013 12:34'!
jGridTableId
	"this string is used as id in jqGrid"

	^ self creationTimestamp! !

!RKASession methodsFor: 'printing' stamp: 'sabineknoefel 7/22/2013 14:41'!
lastClickString 
	^ self login isNil
		ifTrue: [ '' ]
		ifFalse: [ self login lastClickString ]! !

!RKASession methodsFor: 'history' stamp: 'SabineKnoefel 1/30/2013 14:05'!
lastView
^RKAReceiptView ! !

!RKASession methodsFor: 'history' stamp: 'SabineKnoefel 6/4/2013 17:55'!
lastViewClass
	^ self history isEmpty  
		ifTrue: [ self currentPerson lastViewClass ]
		ifFalse: [ self history last viewClass ]! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 4/9/2013 16:19'!
login
	^ login! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 4/9/2013 16:19'!
login: anObject
	login := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 14:22'!
loginEmailAdress
	^ loginEmailAdress! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 14:22'!
loginEmailAdress: anObject
	loginEmailAdress := anObject! !

!RKASession methodsFor: 'login/logoff' stamp: 'sabineknoefel 9/24/2013 12:12'!
logoff
	self unregister.
	self login isNil ifTrue: [ ^self ].
	self login logoff: ZTimestamp now.
	self login saveLogin.
 
	
	! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/24/2012 14:33'!
menuEntries
	^ menuEntries! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/24/2012 14:33'!
menuEntries: anObject
	menuEntries := anObject! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/11/2013 15:40'!
panel
	^ panel! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 2/11/2013 15:40'!
panel: anObject
	panel := anObject! !

!RKASession methodsFor: 'printing' stamp: 'sabineknoefel 7/22/2013 12:58'!
personName
	^(  self login isNil or:[self isCurrentPersonTransient])
		ifTrue: [ 'N.N.' ]
		ifFalse: [ self currentPerson wholeNameString ]! !

!RKASession methodsFor: 'dropbox' stamp: 'SabineKnoefel 2/26/2013 15:20'!
readDataFromDropbox
	"Read person and proxy trips"
 
	self readPersonFromDropbox. ! !

!RKASession methodsFor: 'dropbox' stamp: 'SabineKnoefel 2/21/2013 18:20'!
readPersonFromDropbox
	self currentPerson: self panel readPersonFromDropbox! !

!RKASession methodsFor: 'dropbox' stamp: 'SabineKnoefel 2/20/2013 16:36'!
readTripsFromDropbox
	| theTrips |
	theTrips := self panel readTripsFromDatastorage.
	theTrips do: [ :each | each person: self currentPerson ].
	self currentPerson trips: theTrips.
	theTrips isEmpty ifFalse: [ self currentTrip: theTrips last]! !

!RKASession methodsFor: 'delegation' stamp: 'sabine 9/27/2012 09:59'!
receipts
	^ self currentTrip receipts! !

!RKASession methodsFor: 'printing' stamp: 'sabineknoefel 7/22/2013 12:50'!
resolution
	^'{1}x{2}' format:{self  browserWidth . self browserHeight } 
	
 ! !

!RKASession methodsFor: 'actions' stamp: 'sabineknoefel 8/22/2013 11:32'!
saveCurrentPerson
	"Save to database if login was not transient"

	self isCurrentPersonTransient
		ifFalse: [ self currentPerson savePerson ]! !

!RKASession methodsFor: 'actions' stamp: 'sabineknoefel 6/26/2013 11:52'!
setCurrentAccountingTrips: aCollection
 
	self currentAccountingTrips: aCollection! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 3/6/2013 17:20'!
setCurrentTrip: aTrip
	"Do also set the accounting trip"

	aTrip isNil 
		ifFalse: [self setCurrentAccountingTrips: (OrderedCollection with: aTrip)].
	self currentReceipt: nil.
	self currentVehicleTrip: nil.
	self currentDay: nil.
	self isCurrentVehicleTripNew: true.
	self isCurrentReceiptNew: true .
	self currentTrip: aTrip! !

!RKASession methodsFor: 'actions' stamp: 'sabineknoefel 7/18/2013 12:30'!
terminate
self halt.
	"self database closeMongoDB"! !

!RKASession methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 15:13'!
translator
	translator ifNil: [ self translator: self currentPerson translator  ].
	^ translator! !

!RKASession methodsFor: 'accessing' stamp: 'SabineKnoefel 7/3/2012 16:07'!
translator: anObject
	translator := anObject! !

Object subclass: #RKAHistoryEntry
	instanceVariableNames: 'viewClass timestamp ip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAHistoryEntry methodsFor: 'printing' stamp: 'SabineKnoefel 4/11/2013 18:38'!
breadcrumbLabel
	"Demo classes e.g. Demo classes do not do not understand breadcrumbLabel and I dont want to extend them"

	^ (self viewClass respondsTo: #breadcrumbLabel)
		ifTrue: [ self viewClass breadcrumbLabel ]
		ifFalse: [ self viewClass name]! !

!RKAHistoryEntry methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:24'!
ip
	^ ip! !

!RKAHistoryEntry methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:24'!
ip: anObject
	ip := anObject! !

!RKAHistoryEntry methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:24'!
timestamp
	^ timestamp! !

!RKAHistoryEntry methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:24'!
timestamp: anObject
	timestamp := anObject! !

!RKAHistoryEntry methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:24'!
viewClass
	^ viewClass! !

!RKAHistoryEntry methodsFor: 'accessing' stamp: 'SabineKnoefel 1/30/2013 11:24'!
viewClass: anObject
	viewClass := anObject! !

Object subclass: #RKAMailSender
	instanceVariableNames: 'translator receiverEmail receiverName subject mailHeading mailText1 mailText2 mailNewsHeading mailNewsText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:01'!
facebookUrl
	^RKAConfiguration facebookUrl! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:01'!
forumUrl 
	^RKAConfiguration forumUrl! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:01'!
homepageUrl
	^RKAConfiguration homepageUrl! !

!RKAMailSender methodsFor: 'formatting' stamp: 'sabineknoefel 8/31/2013 12:08'!
htmlPart
	self toDoTranslation.
	^ '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml">

<head><meta http-equiv="Content-Type" content="text/html;charset=utf-8" /><meta name="HandheldFriendly" content="true" /><meta name="viewport" content="width=600, initial-scale=1.0, user-scalable=yes"/><title>{3}</title></head>

<body style="-webkit-text-size-adjust:none;margin:0;padding:0;background-color:#FFF;">

<center>
<table border="0" cellpadding="0" cellspacing="0" width="580" style="margin:0;padding:0;background-color:#e8e8e8;width:580px !!important;padding:20px">
<tr><td>

<table border="0" cellpadding="0" cellspacing="0" width="560" style="margin:0;padding:10px;background-color:#1b8bbf;width:560px !!important;">
<tr>
<td><a href="{9}" style="display:block;text-decoration:none;font-weight:bold;font-family:Arial, sans-serif;font-size:13px;color:#FFF;padding:5px 10px;text-shadow:1px 1px 1px #444">{13}</a></td>
<td><a href="{10}" style="display:block;text-decoration:none;font-weight:bold;font-family:Arial, sans-serif;font-size:13px;color:#FFF;padding:5px 10px;text-shadow:1px 1px 1px #444">{14}</a></td>
<td><a href="{11}" style="display:block;text-decoration:none;font-weight:bold;font-family:Arial, sans-serif;font-size:13px;color:#FFF;padding:5px 10px;text-shadow:1px 1px 1px #444">{15}</a></td>
<td><a href="{12}" style="display:block;text-decoration:none;font-weight:bold;font-family:Arial, sans-serif;font-size:13px;color:#FFF;padding:5px 10px;text-shadow:1px 1px 1px #444">{16}</a></td>
</tr>
</table>

<table border="0" cellpadding="20" cellspacing="0" width="100%" style="border:6px solid transparent;background-color:#FFF;width:100%">
<tr>
<td align="center" valign="top" style="border-collapse:collapse;">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td valign="top" style="border-collapse:collapse;background-color:#FFF;">
<h1 style="color:#555;display:block;font-family:Arial;font-size:16px;font-weight:bold;line-height:120%;margin:10px 0;text-align:left;">{3}</h1>
<p style="color:#555">{4}</p>
<p style="color:#555">{5}</p>
<p style="color:#555">{6}</p>

<br/><div style="height:0;border-top:1px solid #efefef;font-size:0;"></div><br/>

<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>
<td valign="top">
<img width="140" src="http://fbcdn-sphotos-a-a.akamaihd.net/hphotos-ak-prn2/984301_585321101502747_1418279263_n.png" alt="Logo"></img>
</td>
<td valign="top">
<div style="color:#505050;font-family:Arial;font-size:14px;line-height:125%;text-align:left;">
<h2 style="color:#555;display:block;font-family:Arial;font-size:14px;font-weight:bold;line-height:100%;text-align:left;margin:0 0 5px 0;">{7}</h2>
<p>{8}</p> 
</div> </td> </tr></table>

<table height="53" width="100%" style="background-color:#e8e8e8"><tr><td align="center"><a href="{9}" style="font-family:arial;border:4px solid transparent;border-radius:4px;background-color:#1b8bbf;color:#FFF;text-decoration:none;padding:5px 7px;font-weight:bold;text-shadow:1px 1px 1px #333;font-size:12px;">{17} &rsaquo;</a></td></tr></table>

<br/><div style="height:0;border-top:1px solid #efefef;font-size:0;"></div><br/>
</td> </tr><tr><td>
  
<table border="0" cellpadding="0" cellspacing="0" width="600" style="background-color:#F5F5F5;width:100%;padding:20px 20px 30px 20px;"><tr><td width="300" style="font-size:13px"><h4 style="padding:0;margin:0;color:#555;font-size:18px;">{18}</h4><p><strong><strong>{22}: </strong>{2}<br/><strong>{23}: </strong>{1}<br/></p></td></tr></table>

</td></tr></table></td></tr></table><br/></td></tr></table>

<table width="580" style="font-size:9px;"><tr><td><br/><p style="padding:0;margin:0;color:#555;font-size:9px;">{19} (<a href="{1}">{1}</a>) {20} <a href="{10}">{21}</a>.</p></td></tr></table>

</center>
</body>
</html>
'
		format:
			{(self receiverEmail).
			(self receiverName).
			(self subject).
			(self mailHeading).
			(self mailText1).
			(self mailText2).
			(self mailNewsHeading).
			(self mailNewsText).
			(self loginUrl).
			(self forumUrl).
			(self homepageUrl).
			(self facebookUrl).
			(self translator getTranslationFor: 'labelLogin').
			'Forum besuchen'.
			'Weiterempfehlen'.
			'Facebook'.
			'Jetzt beim Spesenfuchs einloggen'.
			'Ihre Benutzerdaten'.
			'Sie bekommen diese Benachrichtigung, weil Sie oder jemand, der Zugang zu Ihrer E-Mail-Adresse'.
			'hat, sich bei Spesenfuchs angemeldet hat. Spesenfuchs wird stndig weiter entwickelt. Wenn Ihnen eine bestimmte Funktionalitt fehlt oder Sie Fragen zur Benutzung haben, schreiben Sie uns bitte auch im'.
			'Forum'.
			'Name'.
			'E-Mail'}! !

!RKAMailSender methodsFor: 'initialize' stamp: 'sabineknoefel 9/2/2013 15:48'!
initialize
self toDoTranslation .
	super initialize.
	self
		mailNewsHeading: self mailNewsHeadingString;
		mailNewsText: self mailNewsText;
		mailText2: 'Ihr Spesenfuchs' .! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:01'!
loginUrl
	^RKAConfiguration loginUrl! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:10'!
mailHeading
	^ mailHeading! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:10'!
mailHeading: anObject
	mailHeading := anObject! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:08'!
mailNewsHeading
	^ mailNewsHeading! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:08'!
mailNewsHeading: anObject
	mailNewsHeading := anObject! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:04'!
mailNewsHeadingString
	^RKAConfiguration mailNewsHeadingString ! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 9/2/2013 15:45'!
mailNewsText
	^RKAConfiguration mailNewsText ! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:08'!
mailNewsText: anObject
	mailNewsText := anObject! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:05'!
mailPrefix
	^RKAConfiguration mailPrefix ! !

!RKAMailSender methodsFor: 'constants' stamp: 'sabineknoefel 8/31/2013 12:02'!
mailSenderAddress
	^RKAConfiguration mailSenderAddress! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:10'!
mailText1
	^ mailText1! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:10'!
mailText1: anObject
	mailText1 := anObject! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:10'!
mailText2
	^ mailText2! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 15:10'!
mailText2: anObject
	mailText2 := anObject! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 11:49'!
receiverEmail
	
	^ receiverEmail! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 11:49'!
receiverEmail: anObject
	
	receiverEmail := anObject! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 11:49'!
receiverName
	
	^ receiverName! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 11:49'!
receiverName: anObject
	
	receiverName := anObject! !

!RKAMailSender methodsFor: 'mail sending' stamp: 'sabineknoefel 9/6/2013 11:13'!
sendLoginMail
	self
		receiverName: 'Admin';
		receiverEmail: RKAConfiguration errorMailReceiverAddress.
	self sendMail! !

!RKAMailSender methodsFor: 'send mail' stamp: 'sabineknoefel 8/31/2013 12:04'!
sendMail
 
	| theMailMessage |
	theMailMessage := MailMessage empty.
	theMailMessage setField: 'subject' toString: self mailPrefix , self subject.
	theMailMessage addAlternativePart: self textPart contentType: MIMEDocument contentTypePlainText.
	theMailMessage addAlternativePart: self htmlPart contentType: MIMEDocument contentTypeHtml.
	self sendUsingStratoAccountTo: self receiverEmail message: theMailMessage! !

!RKAMailSender methodsFor: 'mail sending' stamp: 'sabineknoefel 9/2/2013 15:48'!
sendPasswordMail
	| thePerson theNewPassword| 
	self toDoTranslation.
	thePerson := RKAPerson findByEmail: self receiverEmail.
	thePerson isNil ifTrue: [^self].
	theNewPassword := thePerson setNewRandomPassword.
	self 
		receiverName: thePerson wholeNameString;
		receiverEmail: thePerson email;
		subject: 'Ihr Passwort wurde zurckgesetzt'; 
		mailHeading: ('Ihr neues Passwort lautet: {1}' format: {theNewPassword}); 
		mailText1: 'Bitte ndern Sie Ihr Passwort so schnell wie mglich (unter Einstellungen -> Benutzerkonto).'.
	self sendMail! !

!RKAMailSender methodsFor: 'mail sending' stamp: 'sabineknoefel 9/2/2013 15:48'!
sendRegistrationMail
	| thePerson  |
	self toDoTranslation.
	thePerson := RKAPerson findByEmail: self receiverEmail.
	thePerson isNil ifTrue: [^self].
	 
	self 
		receiverName: thePerson wholeNameString;
		receiverEmail: thePerson email;
		subject: 'Registrierung bei Spesenfuchs'; 
		mailHeading: ('Herzlich Willkommen!! Wir freuen uns sehr, dass Sie sich fr die Nutzung von Spesenfuchs entschlossen haben.'); 
		mailText1: ('Ihre Fragen zur Benutzung werden im <a href="{1}">Forum</a> beantwortet.' format: {self forumUrl }).
	self sendMail! !

!RKAMailSender methodsFor: 'testmails' stamp: 'sabineknoefel 8/21/2013 15:11'!
sendTestMailHtml
	"self new sendTestMailHtml"

	(self  
		receiverEmail: 'sabine.knoefel@gmail.com';
		receiverName: 'Sabine Knfel';
		subject: 'Testmail';
		mailText1: 'Das ist ein test text') sendMail! !

!RKAMailSender methodsFor: 'internal' stamp: 'sabineknoefel 8/31/2013 12:06'!
sendUsingStratoAccountTo: receiverAddress message: mailMessage
	| theSmtpClient |
	(theSmtpClient := ZdcSecureSMTPClient new)
		user: self mailSenderAddress; 
		password: 'aS1DF2fgfr9'.
	theSmtpClient openOnHost: (NetNameResolver addressForName: 'smtp.strato.de') port: 465.
	mailMessage setField: 'from' toString: self mailSenderAddress.
	mailMessage setField: 'to' toString: receiverAddress.
	^ theSmtpClient 
		mailFrom: self mailSenderAddress to: { receiverAddress } text: mailMessage text;
		quit; 
		close;
		yourself
! !

!RKAMailSender methodsFor: 'mail sending' stamp: 'sabineknoefel 9/3/2013 13:32'!
sendWalkbackMail
	self
		receiverName: 'Admin';
		receiverEmail: RKAConfiguration errorMailReceiverAddress.
	self sendMail! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 12:39'!
subject
	^ subject! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/21/2013 12:39'!
subject: anObject
	subject := anObject! !

!RKAMailSender methodsFor: 'formatting' stamp: 'sabineknoefel 8/22/2013 17:17'!
textPart 
	self toDoTranslation.
	^  '{3}

{4}
{5}
{6}

{7}
{8}

Ihre Benutzerdaten:
Name: {2}
E-Mail: {1}

Einloggen: {9}
Forum besuchen: {10}
Facebook: {12}

Sie bekommen diese Benachrichtigung, weil Sie oder jemand, der Zugang zu Ihrer E-Mail-Adresse ({1}) hat, sich bei Spesenfuchs angemeldet hat. Spesenfuchs wird stndig weiter entwickelt. Wenn Ihnen eine bestimmte Funktionalitt fehlt oder Sie Fragen zur Benutzung haben, schreiben Sie uns bitte auch im {10}.
'   format: {self receiverEmail. self  receiverName. self subject. self  mailHeading. self  mailText1. self  mailText2 . self mailNewsHeading. self mailNewsText. self loginUrl. self forumUrl. self homepageUrl. self facebookUrl }! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 9/2/2013 15:21'!
translator
	translator ifNil: [  self translator: RKATranslator defaultTranslator].
	^ translator! !

!RKAMailSender methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 17:11'!
translator: anObject
	translator := anObject! !

Object subclass: #RKAOIDGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

RKAOIDGenerator class
	instanceVariableNames: 'currentOID'!

RKAOIDGenerator class
	instanceVariableNames: 'currentOID'!

!RKAOIDGenerator class methodsFor: 'accessing' stamp: 'sabineknoefel 8/31/2013 10:02'!
currentOID
	currentOID ifNil: [ self currentOID: Time primMillisecondClock ].
	^ currentOID! !

!RKAOIDGenerator class methodsFor: 'accessing' stamp: 'sabineknoefel 8/31/2013 10:02'!
currentOID: anObject
	currentOID := anObject! !

!RKAOIDGenerator class methodsFor: 'accessing' stamp: 'sabineknoefel 8/31/2013 10:03'!
getNextOID
	self increaseOID.
	^self currentOID ! !

!RKAOIDGenerator class methodsFor: 'accessing' stamp: 'sabineknoefel 8/31/2013 10:03'!
increaseOID
	self currentOID: self currentOID +1! !

Object subclass: #RKAPDFWriter
	instanceVariableNames: 'session pdfdoc currentPage currentAccountingTrip currentPageIndex currentReportType vehicleTripsByVehicleKind position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAPDFWriter class methodsFor: 'constants' stamp: 'sabineknoefel 9/4/2013 16:22'!
distanceLeft
	^ 10 mm! !

!RKAPDFWriter class methodsFor: 'constants' stamp: 'sabineknoefel 9/4/2013 16:22'!
fontHeading
	^ self fontType new
		fontSize: 28 pt;
		bold: true! !

!RKAPDFWriter class methodsFor: 'constants' stamp: 'sabineknoefel 9/4/2013 16:22'!
fontSubHeading
	^ self fontType new fontSize: 16 pt! !

!RKAPDFWriter class methodsFor: 'constants' stamp: 'sabineknoefel 9/4/2013 16:22'!
fontType
	^ PDFHelveticaFont! !

!RKAPDFWriter class methodsFor: 'report filenames' stamp: 'sabineknoefel 9/4/2013 16:22'!
reportsBasePath
	^ RKAConfiguration isProductive
		ifTrue: [ self reportsBasePathApache ]
		ifFalse: [ self reportsBasePathIIS ]! !

!RKAPDFWriter class methodsFor: 'report filenames' stamp: 'sabineknoefel 9/4/2013 16:22'!
reportsBasePathApache
	"^'C:\\Program Files (x86)\\Apache Group\\Apache2\\htdocs\\reports\\'"
	^'C:\\Program Files (x86)\\Apache Software Foundation\\Apache2.2\\htdocs\\reports\\'! !

!RKAPDFWriter class methodsFor: 'report filenames' stamp: 'sabineknoefel 9/4/2013 16:22'!
reportsBasePathIIS
	^ 'C:\\inetpub\\wwwroot\\reports\\'! !

!RKAPDFWriter methodsFor: 'reports - booking report' stamp: 'sabineknoefel 7/2/2013 16:22'!
addBookingReportAccountsTable: aCollection from: anYPosition
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self bookingReportTableColumns;
				data: aCollection;
				dimension: (self defaultDimension: aCollection size +1);
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self
								customizationBlockSizes: #(18 70 40 19 14 14 19)
								alignment: #(#left #left #left #right #right #right #right  ));
				margin: self tableMargin;
				from: self distanceLeft @ anYPosition)! !

!RKAPDFWriter methodsFor: 'header sub' stamp: 'sabineknoefel 7/11/2013 16:00'!
addBookingReportSubHeading 
	self
		addSubHeadingText:
			('{1}: {2}, {3}, {4} (Tester: Buchungen noch unvollstndig)'
				format:
					{(self translator labelCreditor).
					(self currentPerson creditor accountName).
					(self currentPerson tableOfAccounts).
					(self currentPerson employmentStatusString: self translator)})
	 ! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 6/11/2013 18:30'!
addCostReportDaysSumTable
	| theData |
	theData := self costReportDaysTableDataSum.
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self costReportDaysTableColumnsSum;
				data: theData;
				dimension: (self defaultDimension: theData size + 1);
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self customizationBlockSizes: #(21 91 19 19 19 21) alignment: #(#left #left #right #right #right #right));
				margin: self tableMargin;
				from: self position).
	self position: self distanceLeft @ (6 * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'sabineknoefel 6/26/2013 11:17'!
addCostReportDaysTable
	| theData |
	theData := self costReportDaysTableData.
	self currentPage 
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self costReportDaysTableColumns;
				data: theData;
				dimension: (self defaultDimension: theData size + 1);
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self customizationBlockSizes: #(18 94 19 19 19 21) alignment: #(#left #left #right #right #right #right));
				margin: self tableMargin;
				from: self position).
	self position: self distanceLeft @ (theData size * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'sabineknoefel 6/26/2013 11:30'!
addCostReportReceiptsTable
	| theData |
	self currentAccountingTrip receipts isEmpty
		ifTrue: [ 
			self position: 10 mm @ self y.
			^ 0 mm ].
	theData := self costReportReceiptsTableData.
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self costReportReceiptsTableColumns;
				data: theData;
				dimension: (self defaultDimension: theData size + 1);
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self
								customizationBlockSizes: #(18 6 46  33 18 13 17 18 21)
								alignment: #(#left #right #left #left #right #right #right #right #right));
				margin: self tableMargin;
				from: self distanceLeft @ self y).
	self position: self distanceLeft @ (theData size * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'header sub' stamp: 'SabineKnoefel 3/6/2013 08:37'!
addCostReportSubHeading 
	self addSubHeadingText: self currentAccountingTrip  tripNumberWithName ! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 6/11/2013 19:54'!
addCostReportVehicleTripsTable
	| theData |
	self currentAccountingTrip vehicleTrips isEmpty
		ifTrue: [ ^ self ].
	theData := self costReportVehicleTripsTableData.
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self costReportVehicleTripsTableColumns;
				data: theData;
				dimension: (self defaultDimension: theData size + 1);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(18 51 78 22 21) alignment: #(#left #left #left #right #right));
				margin: self tableMargin;
				from: self position).
	self position: self distanceLeft @ (theData size * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'header sub' stamp: 'SabineKnoefel 1/10/2013 16:03'!
addMonthReportSubHeading 
	self
		addSubHeadingText:
			('{1} {2}'
				format:
					{(self currentAccountingMonthName).
					(self currentAccountingYear printString)})
		 ! !

!RKAPDFWriter methodsFor: 'reports - month report' stamp: 'SabineKnoefel 6/11/2013 19:40'!
addMonthReportTripsTable
	| theData |
	theData := self monthReportTripsTableData.
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self monthReportTripsTableColumns;
				data: theData;
				dimension: (self defaultDimension: theData size);
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self
								customizationBlockSizes: #(17 9 30 45 8 8 17 13 13 16 17)
								alignment: #(#left #right #left #left #right #right #right #right #right #right #right));
				margin: self tableMargin;
				margin: 1 mm;
				from: self distanceLeft @ 40 mm).
	self position: self distanceLeft @ (31 * self defaultYDimension)! !

!RKAPDFWriter methodsFor: 'data - person' stamp: 'SabineKnoefel 6/11/2013 16:05'!
addPersonTables
	self currentPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: self personOverview1TableColumns;
				data: self personOverview1TableData;
				dimension: 90 mm @ (self defaultYDimension * 4);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(21 77) alignment: #(#left #left));
				margin: self tableMargin;
				from: self distanceLeft @ self y).
	self currentPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: self personOverview2TableColumns;
				data: self personOverview2TableData;
				dimension: 90 mm @ (self defaultYDimension * 4);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(17 73) alignment: #(#left #left) x: 110);
				margin: self tableMargin;
				from: 110 mm @ self y).
	self position: self distanceLeft @ (3 * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'reports - receipt report' stamp: 'sabineknoefel 8/20/2013 14:15'!
addReceiptReportTable: aCollection from: anYPosition
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self receiptReportTableColumns;
				data: aCollection;
				dimension: (self defaultDimension: aCollection size +1 );
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self
								customizationBlockSizes: #(18 6 32 25 17 17 14 9 22 16 18)
								alignment: #(#left #right #left #left #right #right #right #right #right #right #left));
				margin: self tableMargin;
				from: self distanceLeft @ anYPosition).
	self position: self distanceLeft @ (aCollection size * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'header sub' stamp: 'SabineKnoefel 1/10/2013 16:50'!
addReceiptsReportSubHeading
	self
		addSubHeadingText:
			('{1} {2}'
				format:
					{(self currentAccountingMonthName).
					(self currentAccountingYear printString)})! !

!RKAPDFWriter methodsFor: 'attributes' stamp: 'SabineKnoefel 6/6/2013 14:18'!
addReportAttributesTo: aPdfdoc
	"aPdfdoc
		title: self reportAttributeTitle;
		subject: self reportAttributeSubject;
		author: self reportAttributeAuthor;
		keywords: self reportAttributeKeywords;
		creator: self reportAttributeCreator"
		
	self toDo! !

!RKAPDFWriter methodsFor: 'footer' stamp: 'SabineKnoefel 6/11/2013 19:34'!
addReportFooter
	self currentPage
		add:
			(PDFTextElement new
				from: self distanceLeft @ 290 mm;
				text:
						('{1} {2}: {3} {4} {5} - {6}'
								format:
									{(self translator labelPage).
									(self currentPageIndex printString).
									(self reportTypeName).
									(self currentAccountingMonthName).
									(self currentAccountingYear printString).
									(self currentPerson footerString)})).
	self currentPage add: (PDFJpegElement from: 166 mm @ 285 mm wh: 36 mm @ 9 mm fromStream: RKALibrary sflJpg readStream)! !

!RKAPDFWriter methodsFor: 'header' stamp: 'SabineKnoefel 6/11/2013 19:32'!
addReportHeading
	self addReportHeading: self reportTypeName.
! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 6/7/2013 08:55'!
addReportHeading: aString 
	self currentPage
		add:
			(PDFTextElement new
				from: self reportHeadingPosition;
				text: aString;
				font: self fontHeading)! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 6/7/2013 08:56'!
addSubHeadingText: aString 
	self currentPage 
		add:
			(PDFTextElement new
				from: self reportSubHeadingPosition ;
				text: aString;
				font: self fontSubHeading)! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 6/11/2013 18:28'!
addSummaryTables
	 
	self currentPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: self tripOverviewTableColumns;
				data: self tripOverviewTableData;
				dimension: 45 mm @ (self defaultYDimension * 4);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(21 30) alignment: #(#left #left));
				margin: self tableMargin;
				from: 10 mm @ self y).
	self currentPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: self personBankDataTableColumns;
				data: self personBankDataTableData;
				dimension: 45 mm @ (self defaultYDimension * 4);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(15 30) alignment: #(#left #left) x: 63);
				margin: self tableMargin;
				from: 63 mm @ self y).
	self currentPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: self summary1TableColumns;
				data: self summary1TableData;
				dimension: 45 mm @ (self defaultYDimension * 4);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(27 21) alignment: #(#left #right) x: 110);
				margin: self tableMargin;
				from: (110 mm) @ self y).
	self currentPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: self summary2TableColumns;
				data: self summary2TableData;
				dimension: 45 mm @ (self defaultYDimension * 4);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(22 18) alignment: #(#left #right) x: 160);
				margin: self tableMargin;
				from: (160 mm) @ self y).
	self position: self distanceLeft @ (3 * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 6/7/2013 08:57'!
addTextNoElement: aString 
	self currentPage 
		add:
			(PDFTextElement new
				from: self textNoElementPosition;
				text: aString)! !

!RKAPDFWriter methodsFor: 'header sub' stamp: 'SabineKnoefel 1/10/2013 16:03'!
addVehicleReportSubHeading 
	self
		addSubHeadingText:
			('{1} {2}  '
				format:
					{(self currentAccountingMonthName).
					(self currentAccountingYear printString).
					 })
	 ! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'SabineKnoefel 6/11/2013 18:42'!
addVehicleReportSumTable: aCollection from: anYPosition
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self vehicleReportTableColumnsSum;
				data: aCollection;
				dimension: (self defaultDimension: aCollection size + 1);
				style: #dataTableWithColoredCaption;
				customizationBlock: (self customizationBlockSizes: #(139 24 24) alignment: #(#left #right #right));
				margin: self tableMargin;
				from: self distanceLeft @ anYPosition)! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'sabineknoefel 7/11/2013 16:02'!
addVehicleReportTable: aCollection from: anYPosition
	self currentPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: self vehicleReportTableColumns;
				data: aCollection;
				dimension: (self defaultDimension: aCollection size +1);
				style: #dataTableWithColoredCaption;
				customizationBlock:
						(self customizationBlockSizes: #(19 15 61 44 24 24) alignment: #(#left #right #left #left #right #right));
				margin: self tableMargin;
				from: self distanceLeft @ anYPosition).
	self position: self distanceLeft @ (aCollection size * self defaultYDimension + self y + self tableDistance)! !

!RKAPDFWriter methodsFor: 'reports - booking report' stamp: 'SabineKnoefel 1/22/2013 09:53'!
bookingReportCollection
	^ self paginagedReportCollection: self bookingReportTableData! !

!RKAPDFWriter methodsFor: 'reports - booking report' stamp: 'sabineknoefel 7/2/2013 16:22'!
bookingReportTableColumns
	^ {(self translator labelDate).
	(self translator labelAccount).
	(self translator labelText).
	(self translator labelAmount).
	(self translator labelDebit).
	(self translator labelCredit).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - booking report' stamp: 'sabineknoefel 7/2/2013 16:36'!
bookingReportTableData
	| theData theDebitAmount theCreditAmount |
	theData := OrderedCollection new.
	theDebitAmount := 0 eur.
	theCreditAmount := 0 eur.
	self currentAccountingTrips
		do: [ :eachTrip | 
			eachTrip computeAccountingRecords: self translator.
			eachTrip accountingRecords
				do: [ :eachRecord | 
					eachRecord addBookingReportBookingsCollectionTo: theData translator: self translator.
					theDebitAmount := theDebitAmount + eachRecord debitAmount.
					 eachRecord creditAmount isNil
						ifFalse: [ theCreditAmount := theCreditAmount + eachRecord creditAmount ] ] ].
	theData
		add:
			(OrderedCollection new
				add: '';
				add: '';
				add: '';
				add: theDebitAmount asGermanTwoDecimalsEuroString;
				add: '';
				add: '';
				add: theCreditAmount asGermanTwoDecimalsEuroString;
				yourself).
	^ theData! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 12/19/2012 16:24'!
captionColor
	^ PDFColor new setGreyLevel: 192! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/21/2013 11:07'!
costReportDaysTableColumns
	^ {(self translator labelDate).
	(self translator labelExpensesCountry).
	(self translator labelBreakfast).
	(self translator labelLunch).
	(self translator labelDinner).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/21/2013 11:08'!
costReportDaysTableColumnsSum
	^ {(self translator labelSums).
	''.
	''.
	''.
	''.
	''}! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/21/2013 11:07'!
costReportDaysTableData
	^ self currentAccountingTrip days
		inject: OrderedCollection new
		into: [ :oc :eachDay | 
			eachDay addCostReportDayPerDiemCollectionTo: oc translator: self translator.
			eachDay addCostReportNightPerDiemCollectionTo: oc translator: self translator.
			eachDay addCostReportPaymentInKindCollectionTo: oc translator: self translator.
			eachDay addCostReportReductionCollectionTo: oc translator: self translator.
			oc ]! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/21/2013 12:06'!
costReportDaysTableDataSum
	| theData |
	theData := OrderedCollection new.
	self currentAccountingTrip addCostReportReductionsSumCollectionTo: theData translator: self translator.
	self currentAccountingTrip addCostReportPaymentInKindsSumCollectionTo: theData translator: self translator.
	^ theData! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'sabineknoefel 6/26/2013 11:29'!
costReportReceiptsTableColumns
	^ {(self translator labelDate).
	(self translator labelNumberShort).
	(self translator labelReceiptKind).
	(self translator labelName).
	(self translator labelCurrency).
	(self translator labelExchangeRate).
	(self translator labelNetAmountShort).
	(self translator labelVatAmountShort).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/15/2013 17:19'!
costReportReceiptsTableData
	| theData |
	theData := OrderedCollection new.
	self currentAccountingTrip receipts
		do: [ :eachReceipt | eachReceipt addCostReportReceiptsCollectionTo: theData translator: self translator ].
	self currentAccountingTrip addCostReportReceiptsSumCollectionTo: theData translator: self translator.
	^ theData! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'sabine 10/24/2012 12:16'!
costReportVehicleTripsTableColumns
	^ {(self translator labelDate).
	(self translator labelVehicleKind).
	(self translator labelDescription).
	(self translator labelKilometers).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/16/2013 16:47'!
costReportVehicleTripsTableData
	| theData |
	theData := OrderedCollection new.
	 self currentAccountingTrip vehicleTrips
		do: [ :eachVehicleTrip | eachVehicleTrip addCostReportVehicleTripCollectionTo: theData translator: self translator ]. 
	self currentAccountingTrip addCostReportVehicleTripSumCollectionTo: theData translator: self translator.
	^ theData! !

!RKAPDFWriter methodsFor: 'reports - booking report' stamp: 'SabineKnoefel 6/7/2013 09:33'!
createBookingReport: aSession
	| theCollection |
	self currentReportType: #BookingReport.
	self preConfigReport: aSession.
	self
		addReportFooter;
		addReportHeading;
		addBookingReportSubHeading.
	theCollection := self bookingReportCollection.
	theCollection
		doWithIndex: [ :each :index | 
			self
				addBookingReportAccountsTable: each
				from:
					(index = 1
						ifTrue: [ 40 mm]
						ifFalse: [ 20 mm ]).
			index ~= theCollection size
				ifTrue: [ self createNewCurrentPage ] ].
	self exportToFile! !

!RKAPDFWriter methodsFor: 'reports - cost report' stamp: 'SabineKnoefel 1/28/2013 08:58'!
createCostReport: aSession
	| theCollection |   
	self currentReportType: #CostReport.
	self preConfigReport: aSession.
	theCollection := self currentAccountingTrips.
	theCollection
		doWithIndex: [ :eachTrip :index | 
			| theNumberOfReceiptsLines theNumberOfVehicleTripLines thePageBreaksAfterReceipts thePageBreaksAfterVehicleTrip theMaxNumberOfDaysLines |
			self currentAccountingTrip: eachTrip.
			theNumberOfReceiptsLines := eachTrip receipts size.
			theNumberOfVehicleTripLines := eachTrip vehicleTrips size.
			theMaxNumberOfDaysLines := eachTrip days size * 3.
			thePageBreaksAfterReceipts := (theNumberOfReceiptsLines + theNumberOfVehicleTripLines )> 22.
			thePageBreaksAfterVehicleTrip := thePageBreaksAfterReceipts
				ifTrue: [ (theNumberOfVehicleTripLines + theMaxNumberOfDaysLines )> 37 ]
				ifFalse: [ (theNumberOfReceiptsLines + theNumberOfVehicleTripLines + theMaxNumberOfDaysLines) > 22 ].
			self
				addReportFooter;
				addReportHeading;
				addCostReportSubHeading;
				addPersonTables;
				addSummaryTables.
			self addCostReportReceiptsTable.
			thePageBreaksAfterReceipts
				ifTrue: [ self createNewCurrentPage ].
			self addCostReportVehicleTripsTable.
			thePageBreaksAfterVehicleTrip
				ifTrue: [ self createNewCurrentPage ].
			self addCostReportDaysTable.
			self addCostReportDaysSumTable.
			index ~= theCollection size
				ifTrue:[self createNewCurrentPage ]].
	self exportToFile! !

!RKAPDFWriter methodsFor: 'reports - month report' stamp: 'sabineknoefel 9/4/2013 16:25'!
createMonthReport: aSession
	self currentReportType: #MonthReport.  
	self preConfigReport: aSession.
	self
		addReportFooter;
		addReportHeading;
		addMonthReportSubHeading;
		addMonthReportTripsTable.
	self exportToFile! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 6/7/2013 09:25'!
createNewCurrentPage
	self currentPage: PDFPage new.
	self pdfdoc add: self currentPage.
	self position: self startPagePosition.
	self increaseCurrentPageIndex.
	self addReportFooter ! !

!RKAPDFWriter methodsFor: 'reports - receipt report' stamp: 'SabineKnoefel 6/7/2013 09:35'!
createReceiptReport: aSession
	| theCollection |
	self currentReportType: #ReceiptsReport.
	self preConfigReport: aSession.
	self
		addReportHeading;
		addReceiptsReportSubHeading.
	theCollection := self receiptReportCollection.
	 theCollection isEmpty  
		ifTrue: [ self addTextNoElement: self translator labelNoReceipts ]
		ifFalse: [ 
			theCollection
				doWithIndex: [ :each :index | 
					self
						addReceiptReportTable: each
						from:
							(index = 1
								ifTrue: [ 40 mm ]
								ifFalse: [ 20 mm ]).
					index ~= theCollection size
						ifTrue: [ self createNewCurrentPage ] ] ].
	self exportToFile! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'SabineKnoefel 6/7/2013 11:17'!
createVehicleReport: aSession
	| theCollection |
	self currentReportType: #VehicleReport.
	self preConfigReport: aSession.
	self
		addReportFooter;
		addReportHeading;
		addVehicleReportSubHeading.
	theCollection := self vehicleReportCollection .
	 theCollection isEmpty  
		ifTrue: [ self addTextNoElement: self translator labelNoVehicleTrips ]
		ifFalse: [ 
			theCollection
				doWithIndex: [ :each :index | 
					self
						addVehicleReportTable: each
						from:
							(index = 1
								ifTrue: [ 40 mm ]
								ifFalse: [ 20 mm ]).
					index ~= theCollection size
						ifTrue: [ self createNewCurrentPage ] ].
			self addVehicleReportSumTable: self vehicleTripsByVehicleKind from: self y ].
	self exportToFile! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/9/2013 14:51'!
currentAccountingMonth
	^ self session currentAccountingMonth! !

!RKAPDFWriter methodsFor: 'toDo' stamp: 'sabineknoefel 9/18/2013 08:41'!
currentAccountingMonthName
	^ self translator
		getTranslationFor: ('labelMonthName' , (Month nameOfMonth: self currentAccountingMonth)  )  ! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 15:40'!
currentAccountingTrip
	^ currentAccountingTrip! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 15:40'!
currentAccountingTrip: anObject
	currentAccountingTrip := anObject! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/9/2013 14:50'!
currentAccountingTrips
	^ self session currentAccountingTrips! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/9/2013 14:51'!
currentAccountingYear
	^ self session currentAccountingYear! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 15:05'!
currentPage
	^ currentPage! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 15:05'!
currentPage: anObject
	currentPage := anObject! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 16:12'!
currentPageIndex
	currentPageIndex ifNil: [ self currentPageIndex: 0 ].
	^ currentPageIndex! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 16:11'!
currentPageIndex: anObject
	currentPageIndex := anObject! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'sabine 10/8/2012 15:11'!
currentPerson
	^ self session currentPerson! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 16:22'!
currentReportType
	^ currentReportType! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/10/2013 16:22'!
currentReportType: anObject
	currentReportType := anObject! !

!RKAPDFWriter methodsFor: 'toDo' stamp: 'sabine 10/29/2012 13:57'!
currentTrips
	^ self session currentPerson trips! !

!RKAPDFWriter methodsFor: 'customizationBlock' stamp: 'SabineKnoefel 6/11/2013 16:01'!
customizationBlockSizes: tableColumnWidthArray alignment: tableColumnAlignArray
	^ self 
		customizationBlockSizes: tableColumnWidthArray 
		alignment: tableColumnAlignArray 
		x: self distanceLeft value! !

!RKAPDFWriter methodsFor: 'customizationBlock' stamp: 'SabineKnoefel 6/11/2013 16:00'!
customizationBlockSizes: tableColumnWidthArray alignment: tableColumnAlignArray x: xPosition
	^ [ :cell :x :y :data | 
	| theSizes theX theSizesSum |
	theSizes := tableColumnWidthArray.
	theSizesSum := theSizes
		inject: (OrderedCollection with: xPosition)
		into: [ :oc :ele | 
			oc add: ele + oc last.
			oc ].	
	cell style: (tableColumnAlignArray at: x).
	cell from: (theSizesSum at: x) mm @ cell from y.
	theX := (theSizesSum at: x + 1) - (theSizesSum at: x).
	cell dimension: theX mm @ self defaultYDimension ]! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/7/2013 15:49'!
defaultDimension
	^ self defaultXDimension @ self defaultYDimension! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/7/2013 15:52'!
defaultDimension: anInteger
	^ self defaultXDimension @ (self defaultYDimension * anInteger )! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/7/2013 16:01'!
defaultXDimension
	^ 190 mm! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/8/2013 21:12'!
defaultYDimension
	^ 5 mm! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/7/2013 08:51'!
distanceLeft
	^ self class distanceLeft! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 6/7/2013 09:41'!
exportToFile
	| theStream |
	theStream := self streamNamed: self reportFilename.
	pdfdoc exportTo: theStream.
	theStream close! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'sabineknoefel 7/3/2013 17:02'!
filenameKey
 ^'{2}{1}'
		format:
			{(self session key copyFrom: 5 to: 15).
			(Time now hhmm24)
			 } 

"
 Nothing more expected ->^ (RKASystemConfiguration random nextInt: 10000 ) printString


	^ '{2}{1}'
		format:
			{(self session key copyFrom: 5 to: 15).
			(Time now hhmm24)
			(RKASystemConfiguration random nextInt: 10000 ) print End of block expected ->String}"! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'sabine 10/25/2012 09:41'!
fontHeading
	^ self class fontHeading! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 12/20/2012 13:21'!
fontSubHeading
	^ self class fontSubHeading! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'sabine 10/25/2012 09:41'!
fontType
	^ self class fontType! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 1/10/2013 16:16'!
increaseCurrentPageIndex
	self currentPageIndex:  self currentPageIndex + 1! !

!RKAPDFWriter methodsFor: 'reports - month report' stamp: 'SabineKnoefel 1/10/2013 13:35'!
monthReportTripsTableColumns
	^ {(self translator labelDate).
	(self translator labelDuration).
	(self translator labelEndPlace).
	(self translator labelTrip).
	(self translator labelDay).
	(self translator labelNight).
	(self translator labelReceipts).
	(self translator labelVehicleTrips).
	(self translator labelReduction).
	(self translator labelPaymentInKind).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - month report' stamp: 'sabineknoefel 8/19/2013 11:39'!
monthReportTripsTableData
	| theCollection theDaysDict theDays theReceipts theVehicleTrips theAllDayFlatRateSum theAllNightFlatRateSum theAllReceiptsSum theAllVehicleTripsSum theAllReductionSum theAllPaymentInKindSum theSum |
	theCollection := OrderedCollection new.
	theDaysDict := OrderPreservingDictionary new.
	theDays := self currentAccountingTrips
		inject: OrderedCollection new
		into: [ :oc :ele | 
			oc addAll: ele days.
			oc ].
	theReceipts := self currentAccountingTrips
		inject: OrderedCollection new
		into: [ :oc :ele | 
			oc addAll: ele receipts.
			oc ].
	theVehicleTrips := self currentAccountingTrips
		inject: OrderedCollection new
		into: [ :oc :ele | 
			oc addAll: ele vehicleTrips.
			oc ].
	theAllDayFlatRateSum := 0.
	theAllNightFlatRateSum := 0.
	theAllReceiptsSum := 0 eur.
	theAllVehicleTripsSum := 0.
	theAllReductionSum := 0.
	theAllPaymentInKindSum := 0.
	theSum := 0.
	(Month month: self currentAccountingMonth year: self currentAccountingYear)
		datesDo: [ :eachDate | 
			| theDaysReceipts theDaysVehicleTrips theDaysDays theCurrentDayData theReceiptsSum theVehicleTripsSum theReductionSum thePaymentInKindSum theDayFlatRateSum theNightFlatRateSum theDaySum theEndPlaceString theStartTimesString theEndTimesString theDurationsString theTripsNamesString |
			theDaysReceipts := theReceipts select: [ :each | each date = eachDate ].
			theDaysVehicleTrips := theVehicleTrips select: [ :each | each date = eachDate ].
			theDaysDays := theDays select: [ :each | each date = eachDate ].
			theCurrentDayData := theDaysDict at: eachDate put: Dictionary new.
			theReceiptsSum := theDaysReceipts inject: 0 into: [ :int :ele | int + ele grossAmountEUR ].
			theVehicleTripsSum := theDaysVehicleTrips inject: 0 into: [ :int :ele | int + ele sum ].
			theReductionSum := (theDaysDays inject: 0 into: [ :int :ele | int + ele sumReduction ]) negated.
			thePaymentInKindSum := (theDaysDays
				inject: 0
				into: [ :int :ele | 
					int
						+
							(ele subtractPaymentInKind
								ifTrue: [ ele sumPaymentInKind ]
								ifFalse: [ 0 ]) ]) negated. "derzeit nur anzeigen der sachbezge, die abgezogen werden, ansonsten weitere spalte oder hnliches"
			theDayFlatRateSum := theDaysDays inject: 0 into: [ :int :ele | int + ele dayFlatRate ].
			theNightFlatRateSum := theDaysDays inject: 0 into: [ :int :ele | int + ele nightFlatRate ].
			theAllDayFlatRateSum := theAllDayFlatRateSum + theDayFlatRateSum.
			theAllNightFlatRateSum := theAllNightFlatRateSum + theNightFlatRateSum.
			theAllReceiptsSum := theAllReceiptsSum + theReceiptsSum.
			theAllVehicleTripsSum := theAllVehicleTripsSum + theVehicleTripsSum.
			theAllReductionSum := theAllReductionSum + theReductionSum.
			theAllPaymentInKindSum := theAllPaymentInKindSum + thePaymentInKindSum.
			theDaySum := theReceiptsSum + theDayFlatRateSum eur + theNightFlatRateSum eur + thePaymentInKindSum eur
				+ theReductionSum eur.
			theSum := theSum + theDaySum.
			theEndPlaceString := (theDaysDays
				inject: OrderedCollection new
				into: [ :oc :ele | 
					oc add: ele trip endPlace.
					oc ]) asCommaString.
			theStartTimesString := ((theDaysDays
				inject: OrderedCollection new
				into: [ :oc :ele | 
					oc add: ele reportStartTime.
					oc ]) copyWithout: '') asCommaString.
			theEndTimesString := ((theDaysDays
				inject: OrderedCollection new
				into: [ :oc :ele | 
					oc add: ele reportEndTime.
					oc ]) copyWithout: '') asCommaString.
			theTripsNamesString := (theDaysDays
				inject: OrderedCollection new
				into: [ :oc :ele | 
					oc add: ele trip tripName.
					oc ]) asCommaString.
			theDurationsString := (theDaysDays inject: Duration zero into: [ :int :ele | int + ele reportDuration ])
				printStringHours.
			theCurrentDayData at: #number put: theDaysDays size.
			theCurrentDayData at: #tripsNames put: (theTripsNamesString truncateTo: 40).
			theCurrentDayData at: #duration put: theDurationsString.
			theCurrentDayData at: #endPlace put: (theEndPlaceString truncateTo: 40).
			theCurrentDayData at: #dayPerDiem put: theDayFlatRateSum.
			theCurrentDayData at: #nightPerDiem put: theNightFlatRateSum.
			theCurrentDayData at: #receiptsSum put: theReceiptsSum.
			theCurrentDayData at: #vehicleTripsSum put: theVehicleTripsSum.
			theCurrentDayData at: #reductionSum put: theReductionSum.
			theCurrentDayData at: #paymentInKindSum put: thePaymentInKindSum.
			theCurrentDayData at: #sum put: theDaySum ].
	theDaysDict
		keysAndValuesDo: [ :eachDay :eachDict | 
			theCollection
				add:
					(OrderedCollection new
						add: eachDay asGermanDateString;
						add: (eachDict at: #duration ifAbsent: [ '' ]);
						add: (eachDict at: #endPlace ifAbsent: [ '' ]);
						add: (eachDict at: #tripsNames ifAbsent: [ '' ]);
						add: (eachDict at: #dayPerDiem ifAbsent: [ 0 ]) asGermanNoDecimalsEuroString;
						add: (eachDict at: #nightPerDiem ifAbsent: [ 0 ]) asGermanNoDecimalsEuroString;
						add: (eachDict at: #receiptsSum ifAbsent: [ 0 eur ]) asGermanTwoDecimalsEuroString;
						add: (eachDict at: #vehicleTripsSum ifAbsent: [ 0 ]) asGermanTwoDecimalsEuroString;
						add: (eachDict at: #reductionSum ifAbsent: [ 0 ]) asGermanTwoDecimalsEuroString;
						add: (eachDict at: #paymentInKindSum ifAbsent: [ 0 ]) asGermanTwoDecimalsEuroString;
						add: (eachDict at: #sum ifAbsent: [ 0 eur ]) asGermanTwoDecimalsEuroString;
						yourself) ].
	theCollection
		add:
			(OrderedCollection new
				add: self translator labelSum;
				add: '';
				add: '';
				add: '';
				add: theAllDayFlatRateSum asGermanNoDecimalsEuroString;
				add: theAllNightFlatRateSum asGermanNoDecimalsEuroString;
				add: theAllReceiptsSum asGermanTwoDecimalsEuroString;
				add: theAllVehicleTripsSum asGermanTwoDecimalsEuroString;
				add: theAllReductionSum asGermanTwoDecimalsEuroString;
				add: theAllPaymentInKindSum asGermanTwoDecimalsEuroString;
				add: theSum asGermanTwoDecimalsEuroString;
				yourself).
	^ theCollection  ! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 1/28/2013 09:10'!
paginagedReportCollection: aCollection
	"Return a collection of collections for creating page breaks"

	| theSubCollections theCurrentSubCollection |
	aCollection isEmpty
		ifTrue: [ ^ aCollection ].
	theSubCollections := OrderedCollection new.
	theCurrentSubCollection := OrderedCollection new.
	theSubCollections add: theCurrentSubCollection.
	aCollection
		doWithIndex: [ :ele :index | 
			theCurrentSubCollection add: ele.
			index \\ 46 = 0
				ifTrue: [ 
					theCurrentSubCollection := OrderedCollection new.
					theSubCollections add: theCurrentSubCollection ] ].
	^ theSubCollections! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'sabine 10/26/2012 13:18'!
pdfdoc
	^ pdfdoc! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'sabine 10/26/2012 13:18'!
pdfdoc: anObject
	pdfdoc := anObject! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 6/11/2013 20:20'!
personBankDataTableColumns
	^ {(self translator labelBankNameShort).
	'IBAN'.
	'BIC'.
	(self translator labelCreditor)}! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 6/11/2013 20:16'!
personBankDataTableData
	| theData |
	theData := OrderedCollection new.
	theData
		add:
				(OrderedCollection new
						add: self currentPerson bankName;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson iban ;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson bic;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson creditor accountName ;
						yourself);
		yourself.
	^ theData! !

!RKAPDFWriter methodsFor: 'data - person' stamp: 'sabine 10/24/2012 09:25'!
personOverview1TableColumns
	^ {(self translator labelName).
	(self translator labelStreet).
	(self translator labelPlace).
	(self translator labelPersonnelNumberShort)}! !

!RKAPDFWriter methodsFor: 'data - person' stamp: 'sabine 10/23/2012 15:24'!
personOverview1TableData
	| theData |
	theData := OrderedCollection new.
	theData
		add:
				(OrderedCollection new
						add: self currentPerson wholeNameString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson street;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson plzPlaceString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson personnelNumber;
						yourself);
		yourself.
	^ theData! !

!RKAPDFWriter methodsFor: 'data - person' stamp: 'sabine 10/23/2012 15:18'!
personOverview2TableColumns
	^ {(self translator labelEmail).
	(self translator labelPhone).
	(self translator labelMobile).
	(self translator labelFax)}! !

!RKAPDFWriter methodsFor: 'data - person' stamp: 'sabine 10/23/2012 15:18'!
personOverview2TableData
	| theData |
	theData := OrderedCollection new.
	theData
		add:
				(OrderedCollection new
						add: self currentPerson email;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson phone;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson mobile;
						yourself);
		add:
				(OrderedCollection new
						add: self currentPerson fax;
						yourself);
		yourself.
	^ theData! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 6/7/2013 09:24'!
position
	^ position! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 6/7/2013 09:24'!
position: anObject
	position := anObject! !

!RKAPDFWriter methodsFor: 'abstract' stamp: 'SabineKnoefel 1/22/2013 09:32'!
preConfigReport: aSession
	"Things to be done at beginning for all reports"

	self session: aSession.
	self pdfdoc: PDFDocument new.
	self pdfdoc setFormat: PDFA4Format new.
	self setStylesheet.
	self addReportAttributesTo: self pdfdoc.
	self createNewCurrentPage! !

!RKAPDFWriter methodsFor: 'reports - receipt report' stamp: 'SabineKnoefel 1/22/2013 09:53'!
receiptReportCollection
	^ self paginagedReportCollection: self receiptReportTableData! !

!RKAPDFWriter methodsFor: 'reports - receipt report' stamp: 'sabineknoefel 8/19/2013 16:06'!
receiptReportTableColumns
	^ {(self translator labelDate).
	(self translator labelNumberShort).
	(self translator labelReceiptKind).
	(self translator labelName).
	(self translator labelGrossAmountShort).
	(self translator labelNetAmountShort).
	(self translator labelVatAmountShort).
	(self translator labelVatPercentageShort).
	(self translator labelCurrency).
	(self translator labelExchangeRate).
	(self translator labelExchangeRateDate)}! !

!RKAPDFWriter methodsFor: 'reports - receipt report' stamp: 'sabineknoefel 8/19/2013 16:07'!
receiptReportTableData
	| theData theGrossSum theNetSum theVatSum |  
	theData := OrderedCollection new.
	theGrossSum := 0 eur.
	theNetSum := 0 eur.
	theVatSum := 0 eur.
	self currentAccountingTrips  
		do: [ :eachTrip | 
			eachTrip receipts
				do: [ :eachReceipt | 
					eachReceipt addReceiptsReportReceiptsCollectionTo: theData translator: self translator.
					theGrossSum := theGrossSum + eachReceipt grossAmountEUR.
					theNetSum := theNetSum + eachReceipt netAmountEUR.
					theVatSum := theVatSum + eachReceipt vatAmountEUR ] ].
	theData isEmpty ifTrue: [^OrderedCollection new.].
	"Sum line only needed if there is any data"
	theData
		add:
		(OrderedCollection new
				add: '';
				add: '';
				add: '';
				add: '';
				add: theGrossSum asGermanTwoDecimalsEuroString;
				add: theNetSum asGermanTwoDecimalsEuroString;
				add: theVatSum asGermanTwoDecimalsEuroString;
				add: '';
				add: '';
				add: '';
				add: '';
				yourself)  .
	^ theData! !

!RKAPDFWriter methodsFor: 'attributes' stamp: 'SabineKnoefel 1/21/2013 15:01'!
reportAttributeAuthor
	^ self session currentPerson pdfAuthorString! !

!RKAPDFWriter methodsFor: 'attributes' stamp: 'SabineKnoefel 1/21/2013 14:53'!
reportAttributeCreator
	^ RKAView applicationName! !

!RKAPDFWriter methodsFor: 'attributes' stamp: 'SabineKnoefel 1/21/2013 15:01'!
reportAttributeKeywords
	^ ''! !

!RKAPDFWriter methodsFor: 'attributes' stamp: 'SabineKnoefel 1/21/2013 15:01'!
reportAttributeSubject
	^ ''! !

!RKAPDFWriter methodsFor: 'attributes' stamp: 'SabineKnoefel 1/21/2013 15:02'!
reportAttributeTitle
	^ self reportTypeName! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'SabineKnoefel 1/10/2013 16:41'!
reportFilename
	" ^'C:\\Program Files (x86)\\Apache Software Foundation\\Apache2.2\\www\\RKA\\reports\\monthreport{1}.pdf'  format: {(self session key)}  "

	^ '{2}{3}{1}.pdf'
		format:
			{(self filenameKey).
			(self reportsBasePath).
			(self currentReportType asString)}! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'SabineKnoefel 1/10/2013 16:41'!
reportFilenameUrl
	"^ 'C:/Program Files (x86)/Apache Software Foundation/Apache2.2/www/RKA/reports/vehiclereport{1}.pdf' format: {(self session key)}	"

	^ '{2}{3}{1}.pdf'
		format:
			{(self filenameKey).
			(self reportsBaseUrl).
			(self currentReportType asString)}! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/11/2013 15:38'!
reportHeadingPosition
	^ self distanceLeft  @ 20 mm! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/11/2013 15:38'!
reportSubHeadingPosition
	^  self distanceLeft  @ 32 mm! !

!RKAPDFWriter methodsFor: 'printing' stamp: 'SabineKnoefel 1/10/2013 17:23'!
reportTypeBaseName
	^   ('labelTravelExpenses' , self currentReportType) asSymbol! !

!RKAPDFWriter methodsFor: 'printing' stamp: 'SabineKnoefel 1/25/2013 16:16'!
reportTypeName
	^ self translator getTranslationFor: self reportTypeBaseName! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'sabineknoefel 7/18/2013 11:53'!
reportsBasePath 
	^self class reportsBasePath! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'sabineknoefel 8/31/2013 11:59'!
reportsBaseUrl
	^ RKAConfiguration isProductive
		ifTrue: [ self reportsBaseUrlApache ]
		ifFalse: [ self reportsBaseUrlIIS ]! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'SabineKnoefel 4/4/2013 07:43'!
reportsBaseUrlApache
	"^ 'C:/Program Files (x86)/Apache Group/Apache2/htdocs/repossrts/' "
	"^ 'C:\Program Files (x86)\Apache Group\Apache2\htdocs\reports\'"
	
	^'reports/'
	 ! !

!RKAPDFWriter methodsFor: 'reports-filenames' stamp: 'SabineKnoefel 11/6/2012 16:24'!
reportsBaseUrlIIS
	^ 'http://localhost/reports/'! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 7/17/2012 12:27'!
session
	^ session! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 7/17/2012 12:27'!
session: anObject
	session := anObject! !

!RKAPDFWriter methodsFor: 'style' stamp: 'SabineKnoefel 6/11/2013 12:34'!
setStylesheet
	self pdfdoc styleSheet
		textColor: ( PDFColor r: 0 g: 0 b: 0);
		fillColor: (PDFColor new setGreyLevel: 255);
		font: (RKAPDFWriter fontType new fontSize: 8 pt);
		drawColor: (  PDFColor r: 0 g: 0 b: 0);
		dotted:
				(PDFDotted new
						length: 0.2 mm;
						space: 0.2 mm).
						
	self pdfdoc styleSheet > #dataTableWithColoredCaption > #caption
		fillColor: (PDFColor r: 178 g: 178 b: 178);
		drawColor: (PDFColor r: 0 g: 0 b: 0).
	self pdfdoc styleSheet > #dataTableWithColoredCaption margin: 4 pt.
	self pdfdoc styleSheet > #dataTableWithColoredCaption > #even fillColor: (PDFColor r: 75 g: 75 b: 230).
	self pdfdoc styleSheet > #dataTableWithColoredCaption > #right alignment: (PDFAlignment right).
	self pdfdoc styleSheet > #dataTableWithColoredCaption > #left alignment: (PDFAlignment left).! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/11/2013 15:38'!
startPagePosition
	^  self distanceLeft  @ 40 mm! !

!RKAPDFWriter methodsFor: 'stream' stamp: 'SabineKnoefel 6/7/2013 09:15'!
streamNamed: aString
	| thePath |
	thePath := self reportsBasePath asFileReference.
	thePath exists
		ifFalse: [ thePath createDirectory ].
	^ FileStream fileNamed: aString! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 1/15/2013 12:58'!
summary1TableColumns
	^ {(self translator labelPerDiemsDay).
	(self translator labelPerDiemsNightShort).
	(self translator labelReceipts).
	(self translator labelVehicleTrips)}! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 1/10/2013 16:04'!
summary1TableData 
	| theData |
	theData := OrderedCollection new.
	theData
		add:
				(OrderedCollection new
						add: self currentAccountingTrip dayFlatRateSumString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip nightFlatRateSumString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip receiptsSumString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip vehicleTripsSumString;
						yourself);
		yourself.
	^ theData! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 1/15/2013 12:57'!
summary2TableColumns
	^ {(self translator labelTotalAmount).
	(self translator labelReductions).
	(self translator labelPaymentsInKind).
	(self translator labelPaymentSum)}! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 1/10/2013 16:04'!
summary2TableData 
	| theData |
	theData := OrderedCollection new.
	theData
		add:
				(OrderedCollection new
						add: self currentAccountingTrip overallSumString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip reductionSumString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip paymentInKindSumString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip paymentSumString;
						yourself);
		yourself.
	^ theData! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/9/2013 08:29'!
tableDistance
	^ 15 mm! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/7/2013 09:29'!
tableMargin
	^ 2 mm! !

!RKAPDFWriter methodsFor: 'constants' stamp: 'SabineKnoefel 6/11/2013 15:38'!
textNoElementPosition
	^  self distanceLeft  @ 40 mm! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 7/17/2012 12:31'!
translator
	^ self session translator! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'sabine 10/25/2012 12:58'!
tripOverviewTableColumns
	^ {(self translator labelStartDate).
	(self translator labelEndDate).
	(self translator labelStartPlace).
	(self translator labelEndPlace)}! !

!RKAPDFWriter methodsFor: 'data - summary' stamp: 'SabineKnoefel 1/10/2013 15:59'!
tripOverviewTableData 
	| theData |
	theData := OrderedCollection new.
	theData
		add:
				(OrderedCollection new
						add: self currentAccountingTrip startDateAndTimeString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip  endDateAndTimeString;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip  startPlace;
						yourself);
		add:
				(OrderedCollection new
						add: self currentAccountingTrip  endPlace;
						yourself);
		yourself.
	^ theData! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'SabineKnoefel 1/22/2013 09:52'!
vehicleReportCollection
	^ self paginagedReportCollection: self vehicleReportTableData! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'SabineKnoefel 1/21/2013 10:42'!
vehicleReportTableColumns
	^ {(self translator labelDate).
	(self translator labelTripNumberShort).
	(self translator labelVehicleKind).
	(self translator labelDescription).
	(self translator labelKilometers).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'SabineKnoefel 1/21/2013 11:35'!
vehicleReportTableColumnsSum
	^ {(self translator labelVehicleKind).
	(self translator labelKilometers).
	(self translator labelSum)}! !

!RKAPDFWriter methodsFor: 'reports - vehicle report' stamp: 'SabineKnoefel 1/28/2013 09:12'!
vehicleReportTableData
	| theData theAmount theKmSum theVehicleKindSums |
	theData := OrderedCollection new.
	theAmount := 0.
	theKmSum := 0.
	theVehicleKindSums := Dictionary new.
	self currentAccountingTrips
		do: [ :eachTrip | 
			eachTrip vehicleTrips
				do: [ :eachVehicleTrip | 
					eachVehicleTrip addVehicleReportVehicleTripsCollectionTo: theData translator: self translator.
					(theVehicleKindSums at: eachVehicleTrip vehicleType ifAbsentPut: [ OrderedCollection new ]) add: eachVehicleTrip.
					theAmount := theAmount + eachVehicleTrip sum.
					theKmSum := theKmSum + eachVehicleTrip kilometers ] ].
	self
		vehicleTripsByVehicleKind:
			(theVehicleKindSums
				inject: OrderedCollection new
				into: [ :oc :ele | 
					oc
						add:
							(OrderedCollection new
								add: (ele first printStringVehicleKind: self translator);
								add: (ele inject: 0 into: [ :km :each1 | km + each1 kilometers ]) asKilometersString;
								add: (ele inject: 0 into: [ :km :each2 | km + each2 sum ]) asGermanTwoDecimalsEuroString;
								yourself).
					oc ]).
	self vehicleTripsByVehicleKind
		add:
			(OrderedCollection new
				add: self translator labelSum;
				add: theKmSum asKilometersString;
				add: theAmount asGermanTwoDecimalsEuroString;
				yourself).
	"Sum line only needed if there is any data"
	theData isEmpty
		ifTrue: [ ^ OrderedCollection new ].	
	theData
		add:
			(OrderedCollection new
				add: self translator labelSum;
				add: '';
				add: '';
				add: '';
				add: theKmSum asKilometersString;
				add: theAmount asGermanTwoDecimalsEuroString;
				yourself).
	^ theData! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/21/2013 11:21'!
vehicleTripsByVehicleKind
	^ vehicleTripsByVehicleKind! !

!RKAPDFWriter methodsFor: 'accessing' stamp: 'SabineKnoefel 1/21/2013 11:21'!
vehicleTripsByVehicleKind: anObject
	vehicleTripsByVehicleKind := anObject! !

!RKAPDFWriter methodsFor: 'toDo' stamp: 'SabineKnoefel 6/7/2013 11:18'!
x
	^ self position x! !

!RKAPDFWriter methodsFor: 'toDo' stamp: 'SabineKnoefel 6/7/2013 11:18'!
y
	^ self position y! !

Object subclass: #RKAScheduler
	instanceVariableNames: 'scheduler id schedulerName'
	classVariableNames: 'deleteReportsScheduler getExchangeRatesScheduler'
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 8/12/2013 12:45'!
allTasks
	^ OrderedCollection 
		with: self getExchangeRatesScheduler 
		with: self deleteReportsScheduler! !

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 7/19/2013 10:38'!
defaultRunTimeDeleteReports
	^'10:40am'! !

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 7/19/2013 10:38'!
defaultRunTimeGetExchangeRates
	^'10:39am'! !

!RKAScheduler class methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 16:26'!
deleteReportsScheduler
	^ deleteReportsScheduler! !

!RKAScheduler class methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:45'!
deleteReportsScheduler: aRKAScheduler
	deleteReportsScheduler := aRKAScheduler! !

!RKAScheduler class methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 16:26'!
getExchangeRatesScheduler
	^ getExchangeRatesScheduler! !

!RKAScheduler class methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:45'!
getExchangeRatesScheduler: aRKAScheduler
	getExchangeRatesScheduler := aRKAScheduler! !

!RKAScheduler class methodsFor: 'initialize' stamp: 'sabineknoefel 7/18/2013 11:33'!
initializeSchedulers
	self stopAllSchedulers.
	self deleteReportsScheduler: self newDeleteReportsScheduler.
	self getExchangeRatesScheduler: self newGetExchangeRatesScheduler.! !

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 8/19/2013 11:02'!
newDeleteReportsScheduler
	"self initializeSchedulers  "

	| theScheduler |
	theScheduler := TaskScheduler new.
	theScheduler start.
	theScheduler
		do: [ |theFilesToDelete|  
					(RKALogEntry new
						kind: #schedulerDeleteReports;
						text: 'scheduler started - deleteReports') saveLogEntry.
			theFilesToDelete := RKAPDFWriter reportsBasePath asFileReference entries select: [ :each | each modificationTime < DateAndTime yesterday ].
			theFilesToDelete do: [ :each | each asFileReference delete ].
					(RKALogEntry new
						kind: #schedulerDeleteReports;
						text: ('scheduler ended - deleteReports ({1})' format: {theFilesToDelete size printString})) saveLogEntry ]
		at: self defaultRunTimeDeleteReports.
	^ self new
		id: 2;
		scheduler: theScheduler;
		schedulerName: 'Delete reports'! !

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 8/19/2013 11:02'!
newGetExchangeRatesScheduler
	"self initializeSchedulers  "

	| theScheduler |
	theScheduler := TaskScheduler new.
	theScheduler start.
	theScheduler
		do: [  
 
					(RKALogEntry new
						kind: #schedulerExchangeRates;
						text: 'scheduler started - exchangerates') saveLogEntry.
			RKACurrency setCurrencyRatesDaily.
 
					(RKALogEntry new
						kind: #schedulerExchangeRates;
						text: 'scheduler ended - exchangerates') saveLogEntry. ]
		at: self defaultRunTimeGetExchangeRates.
	^ self new
		id: 1;
		scheduler: theScheduler;
		schedulerName: 'Exchange rates'! !

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 8/19/2013 11:02'!
restartAllSchedulers
	(RKALogEntry new
		kind: #schedulerStopped;
		text: 'all schedulers restarted') saveLogEntry.
	self initializeSchedulers! !

!RKAScheduler class methodsFor: 'new schedulers' stamp: 'sabineknoefel 8/19/2013 11:02'!
stopAllSchedulers
	(RKALogEntry new
		kind: #schedulerStopped;
		text: 'all schedulers stopped') saveLogEntry.
	TaskScheduler allInstances do: [ :each | each stop ]! !

!RKAScheduler methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:27'!
id
	^ id! !

!RKAScheduler methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:44'!
id: aInteger
	id := aInteger! !

!RKAScheduler methodsFor: 'table' stamp: 'sabineknoefel 7/17/2013 17:27'!
jGridTableId
	^ self id! !

!RKAScheduler methodsFor: 'printing' stamp: 'sabineknoefel 7/19/2013 11:00'!
lastRunString
	 |theTask|
	theTask := self scheduler taskAt: 1.
	theTask isRunning ifTrue: [^'CURRENTLY RUNNING !!!!'].
	theTask isSuspended ifTrue: [^' (suspended)'].
	^theTask runHistory isEmpty 
			ifTrue: ['<never run>']
			ifFalse: [theTask runHistory last printYMDHMS]
! !

!RKAScheduler methodsFor: 'printing' stamp: 'sabineknoefel 7/19/2013 10:56'!
nextRunString
 
	^ (self scheduler taskAt: 1) nextRunTime printYMDHMS! !

!RKAScheduler methodsFor: 'printing' stamp: 'sabineknoefel 7/19/2013 10:02'!
runString
 
	^ (self scheduler taskAt: 1) printString! !

!RKAScheduler methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:27'!
scheduler
	^ scheduler! !

!RKAScheduler methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:45'!
scheduler: aTaskScheduler
	scheduler := aTaskScheduler! !

!RKAScheduler methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:30'!
schedulerName
	^ schedulerName! !

!RKAScheduler methodsFor: 'accessing' stamp: 'sabineknoefel 7/17/2013 17:45'!
schedulerName: aString
	schedulerName := aString! !

!RKAScheduler methodsFor: 'printing' stamp: 'sabineknoefel 7/17/2013 17:38'!
statusString
	^ self scheduler printString! !

Object subclass: #RKAValidator
	instanceVariableNames: 'errors warnings translator session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

RKAValidator subclass: #RKAChangePasswordValidator
	instanceVariableNames: 'password password2 oldPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAChangePasswordValidator methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 10:09'!
oldPassword
	^ oldPassword! !

!RKAChangePasswordValidator methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 10:09'!
oldPassword: anObject
	oldPassword := anObject! !

!RKAChangePasswordValidator methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 10:08'!
password
	^ password! !

!RKAChangePasswordValidator methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 10:08'!
password2
	^ password2! !

!RKAChangePasswordValidator methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 10:08'!
password2: anObject
	password2 := anObject! !

!RKAChangePasswordValidator methodsFor: 'accessing' stamp: 'sabineknoefel 8/22/2013 10:08'!
password: anObject
	password := anObject! !

!RKAChangePasswordValidator methodsFor: 'validate' stamp: 'sabineknoefel 8/31/2013 11:59'!
validate
	"If the person came from facebook login, he did not have a password"
	self toDoTranslation.
	self currentPerson password = ''
		ifFalse: [ 
			self currentPerson password = (RKAConfiguration hashPassword: self oldPassword)
				ifFalse: [ self addError: 'Das alte Passwort ist falsch' ] ].
	self password ~= self password2
		ifTrue: [ self addError: 'Die neuen Passwrter, stimmen nicht berein' ].
	self password size < 8
		ifTrue: [ self addError: 'Ungltiges Passwort, mindestens 8 Zeichen' ].
	^ self errors isEmpty! !

RKAValidator subclass: #RKADaysValidator
	instanceVariableNames: 'days expensesCountryDay expensesCountryNight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKADaysValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:09'!
days
	^ days! !

!RKADaysValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:09'!
days: anObject
	days := anObject! !

!RKADaysValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:08'!
expensesCountryDay
	^ expensesCountryDay! !

!RKADaysValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:08'!
expensesCountryDay: anObject
	expensesCountryDay := anObject! !

!RKADaysValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:08'!
expensesCountryNight
	^ expensesCountryNight! !

!RKADaysValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:08'!
expensesCountryNight: anObject
	expensesCountryNight := anObject! !

!RKADaysValidator methodsFor: 'validate' stamp: 'sabineknoefel 8/22/2013 17:18'!
validate
	self toDoTranslation.
	self days
		do: [ :eachDay | 
			self expensesCountryDay isNil
				ifTrue: [ 
					eachDay receipts
						do: [ :eachReceipt | 
							(eachReceipt isHotelReceiptKind and: [ eachReceipt hasBusinessPackage ])
								ifTrue: [ 
									self
										addError:
											('Fr die Ermittlung des Frhstcksabzugs beim Business Package wird die Angabe eines Landes am {1} bentigt.'
												format: {(eachDay date asGermanDateString)}) ] ] ] ].
	^ self errors isEmpty! !

RKAValidator subclass: #RKAMealsValidator
	instanceVariableNames: 'days expensesCountryDay expensesCountryNight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAMealsValidator methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 12:28'!
days
	^ days! !

!RKAMealsValidator methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 12:28'!
days: anObject
	days := anObject! !

!RKAMealsValidator methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 12:28'!
expensesCountryDay
	^ expensesCountryDay! !

!RKAMealsValidator methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 12:28'!
expensesCountryDay: anObject
	expensesCountryDay := anObject! !

!RKAMealsValidator methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 12:28'!
expensesCountryNight
	^ expensesCountryNight! !

!RKAMealsValidator methodsFor: 'accessing' stamp: 'sabineknoefel 9/16/2013 12:28'!
expensesCountryNight: anObject
	expensesCountryNight := anObject! !

!RKAMealsValidator methodsFor: 'validate' stamp: 'sabineknoefel 9/16/2013 12:28'!
validate
	self toDoTranslation.
	self days
		do: [ :eachDay | 
			self expensesCountryDay isNil
				ifTrue: [ 
					eachDay receipts
						do: [ :eachReceipt | 
							(eachReceipt isHotelReceiptKind and: [ eachReceipt hasBusinessPackage ])
								ifTrue: [ 
									self
										addError:
											('Fr die Ermittlung des Frhstcksabzugs beim Business Package wird die Angabe eines Landes am {1} bentigt.'
												format: {(eachDay date asGermanDateString)}) ] ] ] ].
	^ self errors isEmpty! !

RKAValidator subclass: #RKAReceiptValidator
	instanceVariableNames: 'receipt date endDate exchangeRate persons place reason receiptDescription receiptKind grossAmountFC currency vat vatAmountEUR netAmountEUR hasBusinessPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAReceiptValidator class methodsFor: 'startup/shutdown' stamp: 'sabineknoefel 8/29/2013 14:50'!
shutDown
	 ! !

!RKAReceiptValidator class methodsFor: 'startup/shutdown' stamp: 'sabineknoefel 8/29/2013 14:50'!
startUp
	 ! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
currency
	^ currency! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
currency: anObject
	currency := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
date
	^ date! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
date: anObject
	date := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
endDate
	^ endDate! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
endDate: anObject
	endDate := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
exchangeRate
	^ exchangeRate! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
exchangeRate: anObject
	exchangeRate := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
grossAmountFC
	^ grossAmountFC! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
grossAmountFC: anObject
	grossAmountFC := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'sabineknoefel 7/24/2013 10:52'!
hasBusinessPackage
	^ hasBusinessPackage! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'sabineknoefel 7/24/2013 10:52'!
hasBusinessPackage: anObject
	hasBusinessPackage := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
netAmountEUR
	^ netAmountEUR! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
netAmountEUR: anObject
	netAmountEUR := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
persons
	^ persons! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
persons: anObject
	persons := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
place
	^ place! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
place: anObject
	place := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
reason
	^ reason! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
reason: anObject
	reason := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
receipt
	^ receipt! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
receipt: anObject
	receipt := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
receiptDescription
	^ receiptDescription! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
receiptDescription: anObject
	receiptDescription := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
receiptKind
	^ receiptKind! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
receiptKind: anObject
	receiptKind := anObject! !

!RKAReceiptValidator methodsFor: 'validate' stamp: 'sabineknoefel 9/18/2013 08:46'!
validate
	self toDoTranslation.
	self trip isNil not
		ifTrue: [ 
			(self date < self trip startDate or: [ self date > self trip endDate ])
				ifTrue: [ 
					self
						addWarning:
							('Belegdatum {1} liegt ausserhalb des Reisezeitraumes {2}'
								format:
									{(self date asGermanDateString).
									(self trip startAndEndDateString)}) ] ].
	self trip isNil not
		ifTrue: [ 
			(self receiptKind isHotelReceiptKind
				and: [ self endDate > self trip endDate or: [ self endDate < self trip startDate ] ])
				ifTrue: [ 
					self
						addWarning:
							('Belegdatum {1} liegt ausserhalb des Reisezeitraumes {2}'
								format:
									{(self endDate asGermanDateString).
									(self trip startAndEndDateString)}) ] ].
	(self grossAmountFC isNil or: [ self grossAmountFC isZero ])
		ifTrue: [ self addWarning: 'Gesamtbetrag ist Null' ].
		

				
	self receiptKind isBusinessEntertainmentReceiptKind
		ifTrue: [ 
			(self persons isNil or: [ self persons isEmpty ])
				ifTrue: [ self addWarning: 'Personen fr die Bewirtung felht' ] ].
	self receiptKind isBusinessEntertainmentReceiptKind
		ifTrue: [ 
			(self place isNil or: [ self place isEmpty ])
				ifTrue: [ self addWarning: 'Ort fr die Bewirtung fehlt' ] ].
	self receiptKind isBusinessEntertainmentReceiptKind
		ifTrue: [ 
			(self reason isNil or: [ self reason isEmpty ])
				ifTrue: [ self addWarning: 'Anlass fr die Bewirtung fehlt' ] ].
	self receiptKind isHotelReceiptKind
		ifTrue: [ 
			self endDate < self date
				ifTrue: [ self addWarning: 'Das Endedatum liegt vor dem Beginndatum' ] ].
	self receiptDescription isEmpty
		ifTrue: [ self addWarning: 'Name fr Beleg fehlt' ].
	(self netAmountEUR isNil not and: [ self netAmountEUR > 30000 eur ])
		ifTrue: [ self addError: 'Nettobetrag des Belegs ist grsser als 30.000 Euro' ].		
	self exchangeRate isNil
		ifTrue: [ self addError: 'Kein Kurs fr Whrung/Datum vorhanden' ].		
	self trip isNil not
		ifTrue: [ 
			(self receiptKind isHotelReceiptKind and: [ self hasBusinessPackage ])
				and: [ 
					| theDay |
					theDay := self trip dayAt: self date.
					(theDay isNil or: [ theDay hasExpensesCountryDay not ])
						ifTrue: [ 
							self
								addError:
									('Fr die Ermittlung des Frhstcksabzugs beim Business Package wird unter ''Tage -> Land Tag'' die Angabe eines Landes am {1} bentigt.'
										format: {(self date asGermanDateString)}) ] ] ].
	^ self errors isEmpty! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
vat
	^ vat! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
vat: anObject
	vat := anObject! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
vatAmountEUR
	^ vatAmountEUR! !

!RKAReceiptValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:56'!
vatAmountEUR: anObject
	vatAmountEUR := anObject! !

RKAValidator subclass: #RKARegisterPersonValidator
	instanceVariableNames: 'password password2 email lastName firstName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
email
	^ email! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
email: anObject
	email := anObject! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
firstName
	^ firstName! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
firstName: anObject
	firstName := anObject! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
lastName
	^ lastName! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
lastName: anObject
	lastName := anObject! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
password
	^ password! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
password2
	^ password2! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
password2: anObject
	password2 := anObject! !

!RKARegisterPersonValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:42'!
password: anObject
	password := anObject! !

!RKARegisterPersonValidator methodsFor: 'validate' stamp: 'sabineknoefel 8/22/2013 17:18'!
validate
	| thePerson |
	self toDoTranslation.
	self email isValidEmailAdress
		ifFalse: [ self addError: 'Ungltige E-Mail Adresse' ].
	self password ~= self password2
		ifTrue: [ self addError: 'Die Passwrter, stimmen nicht berein' ].
	self password size < 8
		ifTrue: [ self addError: 'Ungltiges Passwort, mindestens 8 Zeichen' ].
	thePerson := RKAPerson findByEmail: self email.
	(self email isValidEmailAdress and: [ thePerson isNil not ])
		ifTrue: [ self addError: 'Die E-Mail Adresse existiert bereits. Bitte neu registrieren oder Passwort zusenden lassen.' ].
	^ self errors isEmpty! !

RKAValidator subclass: #RKATripValidator
	instanceVariableNames: 'tripName startDate endDate startTime endTime startPlace endPlace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
endDate
	^ endDate! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
endDate: anObject
	endDate := anObject! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
endPlace
	^ endPlace! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
endPlace: anObject
	endPlace := anObject! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
endTime
	^ endTime! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
endTime: anObject
	endTime := anObject! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
startDate
	^ startDate! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
startDate: anObject
	startDate := anObject! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
startPlace
	^ startPlace! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
startPlace: anObject
	startPlace := anObject! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
startTime
	^ startTime! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
startTime: anObject
	startTime := anObject! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
tripName
	^ tripName! !

!RKATripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:21'!
tripName: anObject
	tripName := anObject! !

!RKATripValidator methodsFor: 'validate' stamp: 'sabineknoefel 9/24/2013 11:00'!
validate
	self toDoTranslation.
	self startTime isTime not
		ifTrue: [ self addError: 'Startuhrzeit fehlt' ].
	self endTime isTime not
		ifTrue: [ self addError: 'Enduhrzeit fehlt' ].
	self startDate isZTimestamp not
		ifTrue: [ self addError: 'Startdatum fehlt' ].
	self endDate isZTimestamp not
		ifTrue: [ self addError: 'Enddatum fehlt' ].
	self startPlace isEmpty
		ifTrue: [ self addError: 'Startort fehlt' ].
	self endPlace isEmpty
		ifTrue: [ self addError: 'Zielort fehlt' ].
	(self endDate isNil not and: [ self startDate > self endDate ])
		ifTrue: [ self addError: 'Startdatum liegt hinter Enddatum' ].
	self tripName isEmpty
		ifTrue: [ self addError: 'Name fr die Reise fehlt' ].
	(self trip receipts detect: [ :each | each date < self startDate ] ifNone: []) isNil
		ifFalse:  [ self addWarning: 'Es gibt Belege ausserhalb des Reisedatums' ].
	(self trip receipts detect: [ :each | each isHotelReceiptKind and:[ each endDate > self endDate] ] ifNone: []) isNil
		ifFalse:  [ self addWarning: 'Es gibt Belege ausserhalb des Reisedatums' ].		
	(self trip vehicleTrips  detect: [ :each | each date < self startDate ] ifNone: []) isNil
		ifFalse:  [ self addWarning: 'Es gibt Fahrten ausserhalb des Reisedatums' ].		
	self startDate isDate
		ifTrue: [ 
			self startDate < RKAExpensesCountry firstValidDate
				ifTrue: [ 
					self
						addError:
							('Reisen vor dem {1} knnen nicht abgerechnet werden' format: {(RKAExpensesCountry firstValidDateString)}) ] ].
	self endDate isDate
		ifTrue: [ 
			self endDate > RKAExpensesCountry lastValidDate
				ifTrue: [ 
					self
						addError:
							('Reisen nach dem {1} knnen nicht abgerechnet werden' format: {(RKAExpensesCountry lastValidDateString)}) ] ].
	^ self errors isEmpty! !

!RKAValidator methodsFor: 'internal' stamp: 'SabineKnoefel 4/20/2013 14:57'!
addError: aString
	self errors add: aString! !

!RKAValidator methodsFor: 'internal' stamp: 'SabineKnoefel 4/20/2013 17:00'!
addWarning: aString
	self warnings add: aString! !

!RKAValidator methodsFor: 'internal' stamp: 'sabineknoefel 8/22/2013 10:11'!
currentPerson
	^self session currentPerson ! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:28'!
errors
	^ errors! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:28'!
errors: anObject
	errors := anObject! !

!RKAValidator methodsFor: 'testing' stamp: 'SabineKnoefel 4/20/2013 14:37'!
hasErrors
	^ self errors isEmpty not! !

!RKAValidator methodsFor: 'testing' stamp: 'SabineKnoefel 4/20/2013 17:00'!
hasWarnings
	^ self warnings isEmpty not! !

!RKAValidator methodsFor: 'initialize' stamp: 'SabineKnoefel 4/20/2013 14:28'!
initialize
	super initialize.
	self errors: OrderedCollection new.
	self warnings: OrderedCollection new! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:48'!
session
	^ session! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:48'!
session: anObject
	session := anObject! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:38'!
translator
	^ translator! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:38'!
translator: anObject
	translator := anObject! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 5/8/2013 11:48'!
trip
	^ self session currentTrip ! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:28'!
warnings
	^ warnings! !

!RKAValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 14:28'!
warnings: anObject
	warnings := anObject! !

RKAValidator subclass: #RKAVehicleTripValidator
	instanceVariableNames: 'vehicleTrip day vehicleKind kilometers description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RKA24-System'!

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
day
	^ day! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
day: anObject
	day := anObject! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
description
	^ description! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
description: anObject
	description := anObject! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
kilometers
	^ kilometers! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
kilometers: anObject
	kilometers := anObject! !

!RKAVehicleTripValidator methodsFor: 'validate' stamp: 'sabineknoefel 8/22/2013 17:18'!
validate
	self toDoTranslation.
	self kilometers isNil
		ifTrue: [ self addError: 'Kilometer fehlen' ].	 
	self description isNil
		ifTrue: [ self addWarning: 'Beschreibung fehlt' ].
	^ self errors isEmpty! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
vehicleKind
	^ vehicleKind! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
vehicleKind: anObject
	vehicleKind := anObject! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
vehicleTrip
	^ vehicleTrip! !

!RKAVehicleTripValidator methodsFor: 'accessing' stamp: 'SabineKnoefel 4/20/2013 15:05'!
vehicleTrip: anObject
	vehicleTrip := anObject! !
